
$(function () {

    // TODO 单选的时候直接调用callback,将数据传出去
    // TODO config可以增加获取头像类型的参数，不显示头像的参数

    amGloble.empSelect = {
        init: function () {
            var self = this;

			document.addEventListener("backbutton", function() {
				self.hide();
			}, false);

            self.$ = $("#c-empSelect").vclick(function() {
                // self.hide();
            });
            self.scrollview = new $.am.ScrollView({
                $wrap: self.$.children(".c-empSelect-inner"),
                $inner: self.$.find(".c-empSelect-inner .scrollInner"),
                direction: [0, 1]
            });

            self.$empList = self.$.find(".empList").on("vclick", "li", function() {
                var $li = $(this);
                var config = self.params.config;
                if (config.multiple) {
                    var selected = $li.hasClass("selected");
                    if (selected) {
                        $li.removeClass("selected");
                    } else {
                        $li.addClass('selected')
                    }
                } else {
                    self.$empList.find("li").removeClass("selected");
                    $li.addClass('selected');
                    self.params.callback && self.params.callback();
                }
            });
        },
        render: function (data) {
            var self = this;
            self.$empList.empty();

            $.each(data, function(i, subItem) {
                var $index = $('<div class="index">' + subItem.indexName + '</div>');
                var $ul = $('<ul class="subList"></ul>');

                $.each(subItem.children, function(index, listItem) {
                    var $li = $('<li class="am-clickable"><div class="subList-logo"></div><p class="subList-name">' + (listItem.name || "--") + '</p></li>');

                    $li.find(".subList-logo").html(amGloble.photoManager.createImage("artisan", {
                        parentShopId: amGloble.metadata.userInfo.parentShopId,
                        updateTs: ""
                    }, listItem.id + ".jpg", "s"));

                    if (self.isSelectEmp(listItem.id)) {
                        $li.addClass("selected");
                    }
                    if (listItem.sex == 'F') {
                        $li.find('.subList-logo').addClass('male');
                    }

                    $li.data("item", listItem);
                    $ul.append($li);
                })

                self.$empList.append($index).append($ul);
            })

            self.$.slideDown(200);
            self.scrollview.refresh();
        },
        isSelectEmp: function(id) {
            var config = this.params.config;
            return config.defaultSelectdKeys && (config.defaultSelectdKeys.indexOf(id) != -1);
        },
        getCurrentEmps: function() {
            var currentEmp = [];
            this.$empList.find("li").each(function() {
                if ($(this).hasClass("selected")) {
                    currentEmp.push($(this).data("item"))
                }
            })

            return currentEmp;
        },
        selectAll: function () {
            var config = this.params.config;

            if (config.multiple) {
                this.$empList.find("li").each(function() {
                    if (!$(this).hasClass("selected")) {
                        $(this).addClass("selected");
                    }
                })
            }
        },
        show: function (params) {
            /**
             * params
             * 
             * {Function} callback 回调方法
             * {Array} data 渲染数据， example：[{indexName: "", children: [{ name: "", id: "" }]}] 
             * {Object} config 配置参数， example: { multiple: true, defaultSelectdKeys: [] }
             */

            this.params = params;
            this.render(params.data);
        },
        hide: function () {
            this.$.slideUp(200);
        },
        reset: function () {
            this.params = {};
        }
    };


});
