$(function(){
    var self = amGloble.page.goodsSelect = new $.am.Page({
        id: "page_goodsSelect",
        backButtonOnclick: function() {
            $.am.page.back("slidedown");
        },
        init: function() {
            this.callback = undefined;
            this.MallItemCategory = undefined;
            this.GoodsList = undefined;
            this.mallCategoryMap = {};
            this.operateId = 0;
            this.selectedGoodsList = [];
            this.$count = this.$.find(".hasChoosedCount");
            this.$.on("vclick", '.slide_menu .item', function() {
                var $this = $(this);
                var data = $this.data();
                $this.addClass("active").siblings().removeClass("active");
                self.renderByCategory(data);
            }).on("vclick", '.goods_list .item', function() {
                var $this = $(this);
                var $list = self.$.find(".goods_list .item.active");
                if($this.hasClass("active")) {
                    $this.removeClass("active");
                    // 去掉勾选
                    var id = $this.data("id");
                    for(var i = 0; i < self.selectedGoodsList.length; i++) {
                        if(self.selectedGoodsList[i].id == id) {
                            self.selectedGoodsList.splice(i, 1);
                        }
                    }
                } else {
                    if(self.selectedGoodsList.length >= self.maxCount) {
                        amGloble.msg("最多选择"+ self.maxCount +"项");
                        return;
                    }
                    // 勾选
                    self.selectedGoodsList.push($this.data());
                    $this.addClass("active");
                }
                if(self.selectedGoodsList.length) {
                    self.$count.show();
                    self.$count.find("span").html(self.selectedGoodsList.length);
                } else {
                    self.$count.hide();
                }
            }).on("vclick", '.submit', function() {
                self.submit();
            });
            this.categoryScrollView = new $.am.ScrollView({
                $wrap: this.$.find(".slide_menu"),
                $inner: this.$.find(".slide_menu .slide_menu_inner"),
                direction: [1, 0]
            })
            this.listScroll = new $.am.ScrollView({
                $wrap: this.$.find(".goods_list_outer"),
                $inner: this.$.find(".goods_list_outer .goods_list"),
                direction: [0, 1]
            })
            this.listScroll.bubble = true;
        },
        renderByCategory: function(data) {
            this.renderMallItem( data.subCategoryId ? this.mallCategoryMap[data.subCategoryId] : this.GoodsList );
        },
        getGoodsList: function(callback) {
            if(this.GoodsList && this.operateId == amGloble.metadata.userInfo.userId) {
                callback && callback();
                return;
            }
            var opt={
                categories: [1, 2],
                includeZeroCampaignMoney: true,
                newFlag: 1
            }
            this.setStatus("pageLoading", "查询中,请稍候...", {top: 105})
            amGloble.api.queryMallItem.exec(opt, function (ret) {
                self.setStatus("normal");
                if (ret.code == 0) {
                    var result = ret.content;
                    if(self.filter) {
                        result = self.filter(result);
                    }
                    self.GoodsList = result;
                    callback && callback();
                } else {
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                }
            });
        },
        formatMallCategory: function () {
            if(!this.GoodsList) {
                this.getGoodsList();
                return;
            }
            this.mallCategoryMap = {}
            for(var i = 0; i < this.GoodsList.length; i++) {
                var item = this.GoodsList[i];
                if(!this.mallCategoryMap[item.subcategory]) {
                    this.mallCategoryMap[item.subcategory] = []
                }
                this.mallCategoryMap[item.subcategory].push(item);
            }
        },
        renderMallItem: function(list) {
            var $parent = this.$.find(".goods_list").empty();
            if(list && list.length) {
                this.$.find(".empty").hide();
            } else {
                this.$.find(".empty").show();
                return;
            }
            for(var i = 0; i < list.length; i++) {
                var item = list[i];
                var $dom = $('<div class="item am-clickable">'+
                    '<div class="checkbox">'+
                        '<i class="iconfont icon-xuanzhong"></i>'+
                    '</div>'+
                    '<div class="content">'+
                        '<div class="photo">'+
                        // '<img src="" alt="">'+
                        '</div>'+
                        '<div class="info">'+
                            '<p class="title">' + item.name + '</p>'+
                            '<p class="price">售价 ￥' + item.price + '</p>'+
                            '<p class="income">推广收益 ￥' + item.campaignmoney + '</p>'+
                        '</div>'+
                    '</div>' +
                '</div>').data(item);
                if(this.selectedGoodsList.length) {
                    var nowSelectedIds = this.selectedGoodsList.map(item => item.id);
                }
                if(this.data.indexOf(item.id) != -1 || (nowSelectedIds && nowSelectedIds.indexOf(item.id) != -1)) {
                    $dom.addClass('active');
                    if(this.selectedGoodsList.filter(it => it.id == item.id).length == 0) {
                        this.selectedGoodsList.push(item);
                    }
                }
                if((item.goodsType=='2' || item.goodsType=='4') && (item.images==null || item.images.indexOf("minipro")!='-1' ) ){
                    var $img = $('<img src="' + config.filesMgr+item.images + '">').show();
                    $img.load(function() {
                        $img.show();
                    });

                }else{
                    var $img = amGloble.photoManager.createImage("mall", { //"goods"改为"mall"
                        parentShopId: amGloble.metadata.userInfo.parentShopId
                    }, item.images.split(",")[0], "s"); /*增加 split(",")[0] 代码片段——取数组，前第一个图片*/
                }
                $dom.find(".content .photo").html($img);
                $parent.append($dom);
            }
            if(this.selectedGoodsList.length) {
                this.$count.find("span").html(this.selectedGoodsList.length);
                this.$count.show();
            }
            this.listScroll.scrollTo("top");
            this.listScroll.refresh();
        },
        queryMallItemCategory: function (refresh) { //查询商品分类
            var _this = this;
            this.setStatus("pageLoading", "查询中,请稍候...", {top: 105})
            if(this.MallItemCategory && !refresh && this.operateId == amGloble.metadata.userInfo.userId) {
                _this.setStatus("normal");
                self.renderCategory(this.MallItemCategory);
                return;
            }
            amGloble.api.queryMallItemCategory.exec({}, function (ret) {
                _this.setStatus("normal");
                if (ret.code == 0) {
                    _this.MallItemCategory = ret.content;
                    console.log(ret.content);
                    self.renderCategory(ret.content);
                } else {
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                }
            });
            
        },
        renderCategory: function(content) {
            var $parent = this.$.find(".slide_menu .slide_menu_inner").html("");
            $parent.append($("<div class='item active am-clickable' data-id='0'>全部</div>"));
            var width = 53;
            for(var i = 0; i < content.length; i++) {
                var item = content[i];
                if(!this.mallCategoryMap[item.subCategoryId]) {
                    continue;
                }
                var $i = $("<div class='item am-clickable' data-id="+item.subCategoryId+">"+ item.subCategoryName +"</div>").data(item);
                $parent.append($i);
                width += $i.width() + 20;
            }
            $parent.css("width", width);
            this.categoryScrollView.refresh();
        },
        beforeShow: function(params) {
            if(params.cb) {
                this.callback = params.cb;
            } else {
                console.error("缺少回调函数");
            }
            this.selectedGoodsList = [];
            this.$count.hide();
            this.data = params.opt && params.opt.data;
            this.maxCount = params.opt && params.opt.maxCount;
            this.minCount = params.opt && params.opt.minCount;
            this.filter = params.opt && params.opt.filter;
            this.getGoodsList(function() {
                self.formatMallCategory()
                self.queryMallItemCategory()
                self.renderMallItem(self.GoodsList);
                self.operateId = amGloble.metadata.userInfo.userId;
            });
            if(window.device.platform == "iOS") {
                this.$.find(".goods_list_outer").css({"height": 'calc(100% - ' + (94 + 15) + 'px'})
            }
        },
        afterShow: function() {

        },
        submit: function() {
            if(this.selectedGoodsList.length < this.minCount && this.minCount != 0) {
                if(this.maxCount) {
                    amGloble.msg("请选择 " + this.minCount + " - " + this.maxCount + " 个商品");    
                    return;
                }
                amGloble.msg("请选择至少 " + this.minCount + " 个商品");
                return;
            }
            this.callback && this.callback(this.selectedGoodsList);
            $.am.page.back("slidedown");
        }

    })
    amGloble.goodsSelect = {
        show: function(opt, callback) {
            console.log(opt);
            amGloble.page.goodsSelect.changeToMe("slideup", {opt, cb:callback})
        }
    }
})