
(function() {
    var mgjVersionTextMap = {
        "1": "盛传版",
        "2": "风尚版",
        "3": "尊享版",
        "4": "青春版",
        "5": "营销版",
        "6": "电商版"
	};

    window.amGloble = {
        getShareRoot: function() {
            var url = window.config.shareRoot;
            if (amGloble.metadata.configs.httpsEnable == 1) {
                url = url.replace('http:','https:');
            }
            if(amGloble.metadata.userInfo.webDomainFlag == 1 && amGloble.metadata.userInfo.webDomain){
                url = url.replace('m.meiguanjia.net', amGloble.metadata.userInfo.webDomain + '.meiguanjia.net');
            }
            return url;
        },
        hideEducation:true,// 隐藏学堂
        page: {

        },
        popup: {

        },
        hash: {
            get: function(isSearch) {
                var str = isSearch ? location.search : location.hash;
                var kvs = str.substring(1).split("&");
                var ret = {};
                for (var i = 0; i < kvs.length; i++) {
                    var item = kvs[i].split("=");
                    if (item[1] == null) {
                        continue;
                    }
                    ret[item[0]] = item[1];
                }
                return ret;
            },
            set: function(data, isSearch) {
                location.href = "#" + $.param(data);
            },

            add: function(data) {
                this.set($.extend(this.get(), data));
            },
            remove: function(keys) {
                var data = this.get();
                for (var i = 0; i < keys.length; i++) {
                    delete data[keys[i]];
                }
                this.set(data);
            }
        },
        confirm: function(caption, description, okCaption, cancelCaption, scb, fcb) {
            atMobile.nativeUIWidget.confirm({
                caption: caption,
                description: description,
                okCaption: okCaption,
                cancelCaption: cancelCaption
            }, scb, fcb);
        },
        showInfo: function(caption, description, okCaption, cancelCaption, scb, fcb) {
            atMobile.nativeUIWidget.showInfo({
                caption: caption,
                description: description,
                okCaption: okCaption,
                cancelCaption: cancelCaption
            }, scb, fcb);
        },
        messageBox: function(caption, description, scb, fcb) {
            atMobile.nativeUIWidget.showMessageBox({
                title: caption,
                content: description
            }, scb, fcb);
        },
        msg: function(msg, duration) {
            $.am.instanceMessage.show(msg, duration);
        },
        realLength: function(str) {
            return str.replace(/[^\x00-\xff]/g, "**").length;
        },
        cutString: function(value, count) {
            if (!value) return '';
            var maxLength = Math.floor(count / 2);
            for (var i = maxLength; i < value.length; i++) {
                if (amGloble.realLength(value.substr(0, i)) >= count) {
                    return value.substr(0, i) + "...";
                }
            }
            return value;
        },
        isNumber: function(num) {
            if (typeof num === 'number') {
                return num - num === 0;
            }
            if (typeof num === 'string' && num.trim() !== '') {
                return Number.isFinite ? Number.isFinite(+num) : isFinite(+num);
            }
            return false;
        },
        loading: {
            setPos:function(top,right,bottom,left){
                $.am.modalLoading.$.find(">div").css({
                    top:top+"px",
                    right:right+"px",
                    bottom:bottom+"px",
                    left:left+"px"
                })
            },
            show: function(e, hiddenMode) {
                if (hiddenMode) {
                    $.am.modalLoadingHidden.show();
                } else {
                    $.am.modalLoading.show(e);
                }
            },
            hide: function(hiddenMode) {
                if (hiddenMode) {
                    $.am.modalLoadingHidden.hide();
                } else {
                    $.am.modalLoading.hide();
                }
            }
        },
        //amGloble.popupMenu("请选择客户级别", [{name:"普通用户"}, {name:"高级用户"}], function (ret) {_this.$level.find("p.text").text(ret.name);})
        popupMenu: function(title, items, cb, keyName, cancel) {
            var itemsText = [];
            for (var i = 0; i < items.length; i++) {
                itemsText.push(items[i][keyName || "name"]);
            }
            atMobile.nativeUIWidget.showPopupMenu({
                title: title,
                items: itemsText,
                cancel: cancel,
            }, function(idx) {
                if (idx < items.length) {
                    cb && cb(items[idx]);
                }
            });
        },
        reMail: /^(?:[a-z\d]+[_\-\+\.]?)*[a-z\d]+@(?:([a-z\d]+\-?)*[a-z\d]+\.)+([a-z]{2,})+$/i,
        //手机，座机
        rePhone: /((\d{11})|^((\d{7,8})|(\d{4}|\d{3})-(\d{7,8})|(\d{4}|\d{3})-(\d{7,8})-(\d{4}|\d{3}|\d{2}|\d{1})|(\d{7,8})-(\d{4}|\d{3}|\d{2}|\d{1}))$)/,
        // reCellphone: /^0?(17[0-9]|13[0-9]|15[012356789]|18[0-9]|14[57])[0-9]{8}$/,
        reCellphone: /^\d{1,}$/,
        //数组转换成map
        arr2obj: function(data) {
            var ret = {};
            $.each(data, function(i, item) {
                ret[item.configKey] = item.configValue;
            });
            return ret;
        },
        reverse:function(arr){
            if(Array.isArray(arr)){
                var res=[];
                for(var i=arr.length-1;i>-1;i--){
                    res.push(arr[i]);
                }
                return res;
            }else{
                return arr;
            }
        },
        //时间转换成字符串
        time2str: function(publishTime) {
            var d_minutes,
                d_hours,
                d_days;
            var timeNow = parseInt(new Date().getTime() / 1000);
            var d;
            d = timeNow - publishTime;
            d_days = parseInt(d / 86400);
            d_hours = parseInt(d / 3600);
            d_minutes = parseInt(d / 60);
            if (d_days > 30) {
                return new Date(publishTime * 1000).format("yyyy-mm-dd");
            } else if (d_days > 0) {
                return d_days + "天前";
            } else if (d_days <= 0 && d_hours > 0) {
                return d_hours + "小时前";
            } else if (d_hours <= 0 && d_minutes > 0) {
                return d_minutes + "分钟前";
            } else {
                return "刚刚";
            }
        },
        now: function() {
            return new Date();
        },
        //来消息后设置红点
        setMessageDot: function(i) {
            if (i == 0) {
                this.page.dashboard.$user.removeClass("dot");
            } else {
                this.page.dashboard.$user.addClass("dot");
            }
        },
        //数组去重
        dedup: function(array, key) {
            var temp = {},
                ret = [];
            for (var i = 0; i < array.length; i++) {
                var item = array[i],
                    deKey;
                if (key) {
                    deKey = item[key];
                } else {
                    deKey = item;
                }
                temp[deKey] = item;
            }
            for (var i in temp) {
                if (temp.hasOwnProperty(i)) {
                    ret.push(temp[i]);
                }
            }
            return ret;
        },
        //分组
        groupBy: function(array, key) {
            var temp = {},
                ret = [];
            for (var i = 0; i < array.length; i++) {
                var item = array[i],
                    deKey;
                if (key) {
                    deKey = item[key];
                } else {
                    deKey = item;
                }
                if (!temp[deKey]) {
                    temp[deKey] = [];
                }
                temp[deKey].push(item);
            }
            for (var i in temp) {
                if (temp.hasOwnProperty(i)) {
                    var item = {};
                    item[key] = i;
                    item[data] = temp[i];
                }
            }
            return ret;
        },
        //处理角色数据
        getNewRole: function(metadata) {
            //处理metadata的role, 按小到大排序
            var roles = metadata.employeeRoles;
            if (roles && roles.length) {
                roles.sort(function(a, b) {
                    return a.id > b.id ? 1 : -1;
                })
            }

            // newRole 1操作员 2管理员 3老板 4第一工位员工 5第二工位员工 6第三工位员工
            // shopType 0总店 1单店 2直营 3附属
            // userType 0管理者 1员工
            // role 1操作员 2管理员 3老板 如果是员工则返回真实的role id


            var userInfo = metadata.userInfo;
            var userType = userInfo.userType;
            var shopType = userInfo.shopType;
            var role = userInfo.role;
            var ret = 0;

            if (userType == 1) {
                //员工
                for (var i = 0; i < roles.length; i++) {
                    var item = roles[i];
                    if (item.id == userInfo.role) {
                        ret = i + 4
                        break;
                    }
                }
            } else {
                //管理者
                if (role == 3 && (shopType == 2 || shopType == 3)) {
                    //如果是直属店或者附属店的老板，则角色是管理员
                    ret = 2;
                } else {
                    //否则老板仍然是老板
                    ret = role;
                }
            }
            return ret;
        },
        getStoresById: function (id, inAllShop) {
            var shops = this.metadata.shops;
            if (inAllShop) {
                shops = this.metadata.allShops;
            }
            var ret = shops.filter(function(item) {
                return item.shopId == id;
            });
            return ret[0] || {
                shopName: "其它门店",
                shopFullName: "其它门店",
                shopId: -1
            };
        },
        setLastMetadataCacheKey: function(cacheKey) {
            var key = cacheKey || amGloble.getMetaStorageKey();
            window.localStorage.setItem('Meta_lastCacheKey', key);
        },
        getLastMetadataCacheKey: function() {
            return window.localStorage.getItem('Meta_lastCacheKey');
        },
        getMetadataCacheKeyList: function() {
            var keyList = [];
            for(var key in window.localStorage) {
                if (window.localStorage.hasOwnProperty(key)) {
                    if (key.indexOf('Meta_') === 0) {
                        keyList.push(key);
                    }
                }
            }
            return keyList;
        },
        // 获取缓存metaData的key
        getMetaStorageKey:function(userInfo){
            var key='Meta_';
            var userInfo = userInfo || (amGloble.metadata ?  amGloble.metadata.userInfo : null);
            if(userInfo){
                key+=userInfo.userId+'_'+userInfo.userType;
            } else {
                var lastCacheKey = amGloble.getLastMetadataCacheKey();
                if (lastCacheKey) key = lastCacheKey;
            }
            return key;
        },
        //将数组中某个属性组成新的数组
        getKeyArr: function(jsonArray, key, forceArray, addQuote) {
            var ret = [];
            for (var i = 0; i < jsonArray.length; i++) {
                var item = jsonArray[i];
                if (addQuote) {
                    ret.push("'" + item[key] + "'");
                } else {
                    ret.push(item[key]);
                }
            }
            if (!forceArray && ret.length == 1) {
                return ret[0];
            } else {
                return ret;
            }
        },
        //处理很长的小数尾数的问题
        cashierRound: function(val, kept) {
            if (kept) {
                return Math.round(val * kept) / kept;
            }
            return Math.round(val * 100) / 100;
        },
        initCategory: function() {
            return new Promise(function(resolve, reject) {
                if (amGloble.metadata.category !== null) {
                    resolve();
                    return;
                }
                amGloble.api.getCategory.exec({
                    token: config.token,
                }, function(ret) {
                    if (ret.code === 0) {
                        resolve();
                        amGloble.metadata.category = ret.content;
                    } else {
                        reject();
                    }
                })
            })
        },
        initLuckyMoneyTemplate: function() {
            return new Promise(function(resolve, reject) {
                if (amGloble.metadata.luckyMoneyTemplate !== null) {
                    resolve();
                    return;
                }
                amGloble.api.getLuckyMoneyTemplate.exec({
                    parentShopId: config.parentShopId,
                    token: config.token,
                }, function(ret) {
                    if (ret.code === 0) {
                        resolve();
                        amGloble.metadata.luckyMoneyTemplate = ret.content;
                    } else {
                        reject();
                    }
                })
            })
        },
        initLuckyMoneyUnionConfig: function() {
            return new Promise(function(resolve, reject) {
                if (amGloble.metadata.luckyMoneyUnionConfig !== null) {
                    resolve();
                    return;
                }
                amGloble.api.getLuckyMoneyUnionConfig.exec({
                    parentShopId: config.parentShopId,
                    token: config.token,
                }, function(ret) {
                    if (ret.code === 0) {
                        resolve();
                        amGloble.metadata.luckyMoneyUnionConfig = ret.content;
                    } else {
                        reject();
                    }
                })
            })
        },
        initProductCategory: function() {
            return new Promise(function(resolve, reject) {
                if (amGloble.metadata.productCategory !== null) {
                    resolve();
                    return;
                }
                amGloble.api.getProductCategory.exec({
                    token: config.token,
                }, function(ret) {
                    if (ret.code === 0) {
                        var productCategory = ret.content;
                        var categoryCodeMap = {};
                        if (productCategory && productCategory.length) {
                            for (var i = 0; i < productCategory.length; i++) {
                                var sub = productCategory[i].depotList;
                                if(sub && sub.length){
                                    for (var j = 0; j < sub.length; j++) {
                                        sub[j].categoryName = productCategory[i].type;
                                        var subitem = {
                                            id:sub[j].id,
                                            name:sub[j].name,
                                            price:sub[j].saleprice*1,
                                            pinyin:sub[j].pinyin,
                                            mgjdepotlogo:sub[j].mgjdepotlogo,
                                            modifyEnable:sub[j].modifyEnable,
                                            minPrice:sub[j].minPrice,
                                            itemid:sub[j].no
                                        };
                                        categoryCodeMap[sub[j].no] = subitem;
                                    }
                                }
                            }
                        }
                        amGloble.metadata.productCategory = productCategory;
                        amGloble.metadata.categoryCodeMap = categoryCodeMap;
                        resolve();
                    } else {
                        reject();
                    }
                })
            })
        },
        initTpList: function() {
            return new Promise(function(resolve, reject) {
                if (amGloble.metadata.tpList !== null) {
                    resolve();
                    return;
                }
                amGloble.api.getTpList.exec({
                    parentShopId: config.parentShopId,
                    token: config.token,
                    tpListFlag: 0,
                }, function(ret) {
                    if (ret.code === 0) {
                        resolve();
                        amGloble.metadata.tpList = ret.content;
                    } else {
                        reject();
                    }
                })
            })
        },
        //处理metadata，启动时处理
        processMetadata: function(metadata) {
            //如果是员工，则需要去掉其他部门的角色
            if (metadata.userInfo.userType == 1) {
                metadata.employeeRoles = metadata.employeeRoles.filter(function(item, i) {
                    return item.depcode == metadata.userInfo.depcode;
                });
            }


            metadata.userInfo.newRole = amGloble.getNewRole(metadata);

            var allShopsByPinyin = {};
            if(metadata.allShops){
                for (var i = 0; i < metadata.allShops.length; i++) {
                    var item = metadata.allShops[i];
                    if(item.mgjversion!=1){
                        // item.shopFullName = item.shopName + (item.osName || "");
                        item.shopFullName = (item.osName==' ' || item.osName=='' || item.osName==null)?((item.shopName==' ' || item.shopName=='' || item.shopName==null)?'门店名称未设定':item.shopName):item.osName;
                        item.pinyin = codefans_net_CC2PY(item.shopFullName || '');
                        var py = item.pinyin.substr(0, 1).toUpperCase() || "#";
                        if (allShopsByPinyin[py]) {
                            allShopsByPinyin[py].push(item);
                        } else {
                            allShopsByPinyin[py] = [item];
                        }
                    }
                }
            }
            metadata.allShopsByPinyin = [];
            for (var key in allShopsByPinyin) {
                if (allShopsByPinyin.hasOwnProperty(key)) {
                    metadata.allShopsByPinyin.push({
                        key: key,
                        shops: allShopsByPinyin[key]
                    });
                }
            }
            metadata.allShopsByPinyin.sort(function(a, b) {
                return a.key.charCodeAt(0) > b.key.charCodeAt(0) ? 1 : -1;
            });

            metadata.shopMap = {};
            var userShops = [];
            var userShopIds = metadata.userInfo.shopids ? metadata.userInfo.shopids.split(',') : null;
            $.each(metadata.allShops,function(i,v){
                // 判断门店是否关闭
                if(v.status === "8" || v.signflag === "0" || v.invalidDate < amGloble.now().getTime()){
                    v.isInvalidShop = true;
                }else{
                    v.isInvalidShop = false;
                }
                metadata.shopMap[v.shopId]=v;
                if (v.softgenre !== 0 && ((!userShopIds || userShopIds.indexOf(String(v.shopId)) !== -1) && (metadata.userInfo.shopType === 0 || v.shopId === metadata.userInfo.shopId))) {
                    userShops.push(v);
                }
            });
            metadata.shops = userShops;

            //店名合并+店名拼音+店名临时分组
            var shopsGroupByPinyin = {};
            // for (var i = 0; i < metadata.allShops.length; i++) {
            for (var i = 0; i < metadata.shops.length; i++) {
                var item = metadata.shops[i];
                // item.shopFullName = item.shopName + (item.osName || "");
                item.shopFullName = (item.osName==' ' || item.osName=='' || item.osName==null)?((item.shopName==' ' || item.shopName=='' || item.shopName==null)?'门店名称未设定':item.shopName):item.osName;
                item.pinyin = codefans_net_CC2PY(item.shopFullName);
                var py = item.pinyin.substr(0, 1).toUpperCase() || "#";
                if (shopsGroupByPinyin[py]) {
                    shopsGroupByPinyin[py].push(item);
                } else {
                    shopsGroupByPinyin[py] = [item];
                }
            }
            //存入数组分组
            metadata.shopsGroupByPinyin = [];
            for (var key in shopsGroupByPinyin) {
                if (shopsGroupByPinyin.hasOwnProperty(key)) {
                    metadata.shopsGroupByPinyin.push({
                        key: key,
                        shops: shopsGroupByPinyin[key]
                    });
                }
            }
            //分组排序
            metadata.shopsGroupByPinyin.sort(function(a, b) {
                return a.key.charCodeAt(0) > b.key.charCodeAt(0) ? 1 : -1;
            });

            //处理configs
            metadata.configs = amGloble.arr2obj(metadata.configs);
            if(!metadata.configs.strategy){
                metadata.configs.strategy = 0;
            }
            //处理权限
            var findKey = function(array, value) {
                for (var i = 0; i < array.length; i++) {
                    if (array[i] == value) {
                        return true;
                    }
                }
                return false;
            }
            metadata.permissions = {};
            var newRole = metadata.userInfo.newRole;
            var role = metadata.userInfo.role;
            var shopType = metadata.userInfo.shopType;
            if (Number(newRole) === 2 && Number(role) === 3 && (Number(shopType) === 2 || Number(shopType) === 3)) {
                newRole = role;
            }
            var syb_allowphone = metadata.configs.syb_allowphone ? JSON.parse(metadata.configs.syb_allowphone) : [];
            metadata.permissions.allowphone = findKey(syb_allowphone, newRole);
            var syb_allowcard = metadata.configs.syb_allowcard ? JSON.parse(metadata.configs.syb_allowcard) : [];
            metadata.permissions.allowcard = findKey(syb_allowcard, newRole);

            amGloble.page.login.saveConfig({
                v4_tenantLogo: metadata.configs.v4_tenantLogo,
                phone: metadata.userInfo.mobile
            });

            //处理版本名字
            metadata.userInfo.mgjVersionText = mgjVersionTextMap[metadata.userInfo.mgjVersion];

            if(metadata.userInfo.userType==1 && metadata.userInfo.mgjVersion==1){
                //盛传版员工强制不显示业绩
                metadata.configs.hiddenPerformanceAmount = 'true';
            }

            this.renderTenantLogo();


	        if(amGloble.hideEducation || (metadata.configs.hideEducation === "true" && metadata.userInfo.password!=null)){
	            $("div.tab-main").hide();
	        }

	        if(window.defaultConfig && !window.MGJ_systip_jsonp_callback){
		        var tag = document.createElement('script');
		        tag.src = 'http://socket.meiguanjia.net:8038/data.js?ts='+new Date().getTime();
		        document.body.appendChild(tag);

		        window.MGJ_systip_jsonp_callback = function(data){
			        if(data && data.appPopLink){
				        var link = data.appPopLink.replace('${phone}',metadata.userInfo.mobile);
				        link = link.replace('${shopname}',metadata.userInfo.shopName);
				        link = link.replace('${shopid}',metadata.userInfo.shopId);
				        window.open(link, '_blank', 'location=no');
			        }
		        };
	        }

            return metadata;
        },
        renderTenantLogo: function() {

            //绘制租户logo
            if (config.v4_tenantLogo) {
                $(".v4_tenantLogo").each(function() {
                    $(this).html(amGloble.photoManager.createImage("tenantLogo", {
                        parentShopId: config.parentShopId
                    }, config.v4_tenantLogo));
                });
            } else {
                $(".v4_tenantLogo").each(function() {
                    $(this).empty();
                });
            }
        },
        checkVersion: function(forcePopup) {
            if (forcePopup || amGloble.metadata.userInfo.mgjVersion != 3) {
                this.confirm("请升级", '您购买的是美管加' + amGloble.metadata.userInfo.mgjVersionText + '，此功能暂不可使用，如需升级请点击下方按钮联系销售', "联系销售", "暂不升级", function() {
                    // $.am.debug.log("confirm");
                    setTimeout(function() {
                        window.open('https://m.meiguanjia.net/index.html#view=5&tenantId=840891', '_blank', 'location=no');
                    }, 100);
                }, function() {

                });
                return true;
            }
            return false;
        },
        share: function(opt) {
            var text = opt.title || opt.desc,
                photo = opt.imgUrl,
                url = opt.link,
                scb = opt.success,
                fcb = opt.fail,
                wxTimeline = opt.wxTimeline;

            if (!photo) {
                photo = "";
            }

            var str = "text: \n" + text + "\n\nphoto: \n" + photo + "\n\nurl: \n" + url;
            console.log(str);

            atMobile.social.shareTo(text, text, photo, url, function(ret) {
                // amGloble.msg("分享成功!");
                scb && scb(ret);
            }, function(ret) {
                amGloble.msg("分享失败!");
                fcb && fcb(ret);
            }, wxTimeline);
		},
        createShareBase: function(shareDom) {
            var canvas = document.createElement('canvas');
            var ctx = canvas.getContext('2d');
            canvas.width=shareDom.clientWidth*2;
            canvas.height=shareDom.clientHeight*2;
            ctx.scale(2,2);
            html2canvas(shareDom, {
                canvas: canvas,
                useCORS: true,
                onrendered: function (canvas) {
                    var context = canvas.getContext('2d');
                    context.mozImageSmoothingEnabled = false;
                    context.webkitImageSmoothingEnabled = false;
                    context.msImageSmoothingEnabled = false;
                    context.imageSmoothingEnabled = false;
                    var clientHeight=canvas.height;
                    var clientWith=canvas.width;
                    clientHeight=clientHeight*2;
                    clientWith=clientWith*2;
                    var img = Canvas2Image.convertToImage(canvas, clientWith, clientHeight);
                    console.log(img.src)
                    dataUrl = img.src.substring(22);
                    amGloble.loading.hide();
                    amGloble.shareImage({
                        title: '',
                        imageBase64: dataUrl,
                        success: function () {
                            $.am.debug.log('shareImage success');
                        },
                        fail: function () {
                            $.am.debug.log('shareImage fail');
                        }
                    })
                }
            });
        },
        saveImageByBase64: function(opt) {
            var defaultOpt = {
                prefix: 'businessapp_',
                format: 'JPG',
                quality: 100,
                mediaScanner: true
            };
            var params = $.extend(defaultOpt, opt);
            atMobile.saveBase64Image(params, opt.success, opt.fail);
        },
		shareImage: function(opt) {
			var title = opt.title || "",
				imgContent = opt.imageBase64,
				scb = opt.success,
				fcb = opt.fail;
			atMobile.social.shareImage(title, imgContent, scb, fcb);
		},
        shareText:function(opt){
            var text = opt.text,
                scb = opt.success,
                fcb = opt.fail;

            atMobile.social.shareText(text, function(ret) {
                // amGloble.msg("分享成功!");
                scb && scb(ret);
            }, function(ret) {
                amGloble.msg("分享失败!");
                fcb && fcb(ret);
            });
        },
        pswp: function(items, index) {
            var pswpElement = $("#pswp_dom")[0];
            var options = {
                tapToClose: true,
                shareEl: false,
                index: index || 0
			};
			// 初始化时创建监听事件
			if (!this.gallery) {
				document.addEventListener("backbutton", function() {
					this.gallery &&  this.gallery.close();
				}, false);
			}
            this.gallery = new PhotoSwipe(pswpElement, PhotoSwipeUI_Default, items, options);
			this.gallery.init();
        },
        rotate: function(lanscape, callback) {
            try {
                if (window.device.platform == "iOS") {
                    window.Keyboard && window.Keyboard.hide();
                }
				if (lanscape) {
					navigator.appplugin.rotateToLandscape();
					$.am.debug.log('rotate: lanscape-----------'+$('html').attr('class'));
					navigator.appplugin.rotateToLandscape();
					$('html').removeClass('portrait');
					$('html').addClass('landscape');
				} else {
					navigator.appplugin.rotateToPortrait();
					$.am.debug.log('rotate: portrait-------------------'+$('html').attr('class'));
					navigator.appplugin.rotateToPortrait();
					$('html').removeClass('landscape');
					$('html').addClass('portrait');

				}
			} catch (error) {
				$.am.debug.log('rotate error');
			}
            setTimeout(() => {
                $.am.getActivePage().refresh();
                callback && callback();
            }, 100)
            // setTimeout(function() {
            //     var bodyHeight = window.innerHeight;
            //     if($.am.checkScroll(true)>=11){
            //         // $("body").height(window.innerHeight + 20);
            //         $("body").height(bodyHeight);
            //     }else{
            //         $("body").height(bodyHeight);
            //     }
            //     $.am.getActivePage().refresh();
            //     $.am.checkScroll();
            //     callback && callback();
            // }, 100);
        },
        //判断值是否正常
        isNull: function(val) {
            if (val == null || val == undefined || val == "" || val == "NaN" || JSON.stringify(val) == "{}") {
                return true;
            }
            return false;
        },
        clearStorage: function() {
            var ignoreKeyList = ['isFirstSign','privacyAgreement', 'closePushToken'];
            var ignoreCacheData = {};
            ignoreKeyList.forEach(function(key) {
                var cacheData = window.localStorage.getItem(key);
                if (cacheData) {
                    ignoreCacheData[key] = cacheData;
                }
            })
            localStorage.clear();
            for(var key in ignoreCacheData) {
                window.localStorage.setItem(key, ignoreCacheData[key]);
            }
        },
        setTagShop: function(data) {
            this.tagShop = data;
        },
        getTagShop: function() {
            return this.tagShop || amGloble.metadata.shopMap[amGloble.metadata.userInfo.shopId];
        },
        canUseGetPictures: function() {
            // return window.imagePicker && window.imagePicker.getPictures;
            return window.imagePicker && window.imagePicker.getPictures && (window.device.platform != "iOS" || (amGloble.appInfo && amGloble.appInfo.version));
        },
        canUseGetVideo: function() {
            return window.imagePicker && window.imagePicker.getVideo;
        },
        TARGET_MANAGEMENT_CONFIG: {
            defaultArr: [
                {name: '现金业绩', key: 'cashAchiTarget', total: 'CASHACHITARGETTOTAL',  type: 1, icon: 'icon-xianjinyeji', placeholder: '输入金额'},
                {name: '劳动业绩', key: 'workAchiTarget', total: 'WORKACHITARGETTOTAL', type: 2, icon: 'icon-laodongyeji', placeholder: '输入金额'},
                {name: '个人业绩', key: 'workAndMallTarget', total: 'MALLANDORDERTARGETTOTAL', type: 3, icon: 'icon-gerenyeji', placeholder: '输入金额', tip: '劳动业绩+外卖业绩'},
                {name: '外卖业绩', key: 'goodsTarget', type: 4, total: 'GOODSTARGETTOTAL', icon: 'icon-waimaiyeji', placeholder: '输入金额'},
                {name: '客单价', key: 'atvTarget', type: 5, total: 'ATVTARGETTOTAL', icon: 'icon-kedanjia', placeholder: '输入金额'},
                {name: '总客数', key: 'customerNumTarget', type: 6, total: 'CUSTOMERNUMTARGETTOTAL', icon: 'icon-kezongshu', placeholder: '输入数量'},
                {name: '指定客数', key: 'pointCustomerTarget', type: 7, total: 'POINTCUSTOMERTARGETTOTAL', icon: 'icon-zhidingkeshu', placeholder: '输入数量'},
                {name: '办卡率', key: 'cardRateTarget', type: 8, total: 'CARDRATETARGETTOTAL', icon: 'icon-bankashuai', placeholder: '输入小数', tip: '开充卡单数/总单数'},
            ],
            defaultArrMap: {}
        },
        mergeServiceItems: function(items){
            var comboItems = {};
            var serviceItems = {};
            for (var j = 0; j < items.length; j++) {
                var _item = items[j];
                var itemId = (_item.itemId || _item.serviceItemName) + '_' + _item.price;
                if(_item.consumeType){
                    if(!comboItems[itemId]){
                        _item.num = 1;
                        _item.price = Number(_item.price);
                        comboItems[itemId] = _item;
                    }else {
                        comboItems[itemId].num ++;
                        comboItems[itemId].price += Number(_item.price)
                    }
                }else {
                    if(!serviceItems[itemId]){
                        _item.num = 1;
                        _item.price = Number(_item.price);
                        serviceItems[itemId] = _item;
                    }else {
                        serviceItems[itemId].num ++;
                        serviceItems[itemId].price += Number(_item.price)
                    }
                }
            }
            var _itemsArr = [];
            for(var itemKey in comboItems){
                _itemsArr.push(comboItems[itemKey]);
            }
            for(var itemKey in serviceItems){
                _itemsArr.push(serviceItems[itemKey]);
            }
            return _itemsArr;
        },
        getEmpListForDeduplicate: function() {
            if (amGloble.metadata.employeeListForDeduplicate !== undefined) {
                return amGloble.metadata.employeeListForDeduplicate;
            }
            var empList = amGloble.metadata.employees;
            var empMapData = {};
            var resultList = [];
            empList.forEach(function(empData) {
                var empId = empData.mgjrefld == -1 ? empData.empid : empData.mgjrefld;
                var oldEmpData = empMapData[empId];
                if (!oldEmpData || oldEmpData.workNum > empData.workNum) {
                    empMapData[empId] = empData;   
                }
            })
            for(var empId in empMapData) {
                resultList.push(empMapData[empId]);
            }
            amGloble.metadata.employeeListForDeduplicate = resultList;
            return resultList;
        }
    };
    amGloble.TARGET_MANAGEMENT_CONFIG.defaultArr.forEach(function(item) {
        amGloble.TARGET_MANAGEMENT_CONFIG.defaultArrMap[item.type] = item;
    })

    $(function() {
        // $.am.debug.enable = true;

    });

    //添加兼容安卓机 顶部titleBar 高度适配
    var initAndroidStyleByInfo = function() {
        // var deviceSetting = localStorage.getItem('deviceSetting');
        // $.am.debug.log("deviceSetting------------------------------------" + JSON.stringify(deviceSetting));
        var titleBarHeight = 0;
        // if(deviceSetting){
        //     deviceSetting = JSON.parse(deviceSetting);
        //     titleBarHeight = deviceSetting.titleBarHeight;
        //     $.am.debug.log("titleBarHeight 缓存中获取------------------------------------" + titleBarHeight);
        //     if(!titleBarHeight) return;
        //     androidBarSetting.set(titleBarHeight);
        //     setTimeout(function(){
        //         $.am.getActivePage().refresh();
        //         $.am.checkScroll();
        //     }, 100)
        // }else{
            setTimeout(function() {
                navigator.appplugin.getAppInfo(function(ret) {
                    $.am.debug.log("getAppInfo------------------------------------" + JSON.stringify(ret));
                    // localStorage.setItem('deviceSetting',JSON.stringify(ret));
                    var APPINFO = JSON.parse(ret);
                    amGloble.appInfo = APPINFO;
                    titleBarHeight = APPINFO.titleBarHeight;
                    $.am.debug.log("titleBarHeight 设备中获取------------------------------------" + titleBarHeight);
                    if(!titleBarHeight) return;
                    androidBarSetting.set(titleBarHeight, function(){
                        $.am.debug.log('-----------------------------css 加載成功');
                        $.am.getActivePage().refresh();
                        $.am.checkScroll();
                    });
                });
            }, 100)
        // }
    };



    var appStart = function() {
        // debugger
        if (JSON.parse(localStorage.getItem('elf__Access-Token'))) {
            if(JSON.parse(localStorage.getItem('elf__User-Info')) && JSON.parse(localStorage.getItem('elf__User-Info')) !== '{}'){
                var info = JSON.stringify({
                    "elf__User-Info": JSON.parse(localStorage.getItem('elf__User-Info')),
                    "elf__Access-Token": JSON.parse(localStorage.getItem('elf__Access-Token'))
                })
                window.location.href = 'elf/index.html?info=' + info;
            }else {
                localStorage.removeItem('elf__Access-Token')
                appStart()
            }
            // debugger
            console.log('elf_start');
            console.log(info);
        } else {
            console.log('syb_start');
            themeSetting.set();
            initAndroidStyleByInfo();
            window.defaultConfig.commonUrl="http://common.reeli.cn";
            var configStr = localStorage.getItem("BusinessAppV2_config");
            if (!configStr) {
                window.config = $.extend({}, window.defaultConfig);
            } else {
                window.config = $.extend({}, window.defaultConfig, JSON.parse(configStr));
            }

            // 给 html 添加机型标识的 className
            var model = device.model;
            if (model) {
                var iPhoneXModelList = [
                    'iPhone11,6',
                    'iPhone11,8',
                    'iPhone12,1', // iPhone 11
                    'iPhone12,5', // iPhone 11 max pro
                    'iPhone13,1',
                    'iPhone13,2',
                    'iPhone13,3',
                    'iPhone13,4',
                ]; // 与 iPhone X 一致的刘海屏手机型号
                // 为了样式的兼容，将所有刘海屏手机赋值同一个 className，以 iPhone 11 的为标准
                var modelClassName = iPhoneXModelList.indexOf(model) !== -1 ? 'iPhone12,1' : model;
                // iPhone model 含有逗号
                if (model.indexOf(',') !== -1) {
                    modelClassName = model.split(',').join('_');
                }
                // 安卓 model 含有空格
                if (model.indexOf(' ') !== -1) {
                    modelClassName = model.split(' ').join('_');
                }
                var oldClassName = document.documentElement.className;
                $.am.debug.log('modelClassName: ' + modelClassName);
                var newClassName = oldClassName + ' ' + modelClassName;
                document.documentElement.className = newClassName;
                $.am.debug.log('new html name: ' + newClassName);
            }

            $.am.debug.log("设备device: " + JSON.stringify(device));
            $.am.debug.log(JSON.stringify(defaultConfig));
            //
            // $.am.changePage(amGloble.page.customerClockAdd);
            // return;
            //获取容器相关信息
            amGloble.renderTenantLogo();
            atMobile.getMetadata({}, function(ret, error) {
                $.am.debug.log("设备meta: " + JSON.stringify(ret));
                $.am.debug.log("pushToken: " + ret.token);
                config.pushToken = ret.token;


                var hash = amGloble.hash.get();

                if (config.token&&config.isCheckin){
                    amGloble.page.login.getChickinDetail(function(userInfo){
                        $.am.changePage(amGloble.page.userinfo, "slideleft", {
                            userInfo: userInfo
                        });
                    })
                } else if (config.token&&config.parentShopId) {
                    if (hash.type == "logout") {
                        //如果强制登出
                        amGloble.hash.remove(["type"]);
                        if (amGloble.hideEducation) {
                            $.am.changePage(amGloble.page.login);
                        } else {
                            $.am.changePage(amGloble.page.education);
                        }
                        // $.am.changePage(amGloble.page.education);
                    } else {
                        amGloble.page.login.getMetadata(function() {
                            if(amGloble.hideEducation || amGloble.metadata.configs.hideEducation === "true"){
                                if (amGloble.metadata.userInfo.mgjVersion === 5) {
                                    window.RouterUtils.push({ name: 'marketingDashboard' })
                                    $.am.changePage(amGloble.page.vueApp, "slideleft");
                                } else {
                                    $.am.changePage(amGloble.page.dashboard, "slideleft");
                                }
                            } else {
                                // 不会再进
                                $.am.changePage(amGloble.page.education);
                            }
                        });
                    }
                } else {
                    //如果没有userinfo和toke，则登录
                    if (amGloble.hideEducation) {
                        $.am.changePage(amGloble.page.login);
                    } else {
                        $.am.changePage(amGloble.page.education);
                    }
            }

            });

            // 监听 pushToken 更新
            window.addEventListener('notificationTokenUpdated', function(data) {
                $.am.debug.log('notificationTokenUpdated：pushToken 更新' + JSON.stringify(data));
                if (data && data.token) {
                    window.config.pushToken = data.token;
                }
            }, false);

            //$.am.changePage(amGloble.page.organizationList);
        }
    };
    $.am.init = function(){
        if(localStorage.getItem('BusinessAppV2_config')){
            atMobile.loadFile("Info.txt", function(ret) {
                $.am.debug.log("1111"+JSON.stringify(ret));
                // $.am.debug.log(JSON.stringify(ret));
                if(ret.id.indexOf('test')!=-1 || ret.id.indexOf('develop')!=-1){
                    window.serverClusterConfig = {};
                } else if (ret.id.indexOf('fyd') != -1) {
					window.serverClusterConfig = {};
				}else if(ret.id.indexOf('staging')!=-1){
                    window.serverClusterConfig = serverClusterConfigStaging;
                }
                $(".app_version").text("v" + ret.version);
            });
            appStart();
        }else{
            atMobile.loadFile("Info.txt", function(ret) {
                $.am.debug.log("2222"+JSON.stringify(ret));
                if(ret.id !== 'n_shengyibao'){
                    var c = window[ret.id.replace('n_shengyibao','defaultConfig').replace('shengyibao','defaultConfig')];
                    if(c){
                        window.defaultConfig = c;
                        if(ret.id.indexOf('test')!=-1 || ret.id.indexOf('develop')!=-1){
                            window.serverClusterConfig = {};
                        } else if (ret.id.indexOf('fyd') != -1) {
							window.serverClusterConfig = {};
						}else if(ret.id.indexOf('staging')!=-1){
                            window.serverClusterConfig = serverClusterConfigStaging;
                        }
                    }
                    $.am.debug.log("c=============="+JSON.stringify(c));
                }
                $(".app_version").text("v" + ret.version);
                appStart();
            }, function() {
                appStart();
            });
        }
    }
})();



/* setInterval(function(){
    if(navigator.connection){
        $.am.debug.log('navigator.connection.type'+navigator.connection.type);
    }else{
        $.am.debug.log('navigator.connection.type:unknow!~');
    }
},3000) */
