(function () {
    var self = amGloble.page.arrangeShifts = new $.am.Page({
        id: "page-arrangeShifts",
        backButtonOnclick: function () {
            if (self.$setShiftsDiv.is(':visible')) {
                self.$setShiftsDiv.find('.cancel-btn').trigger('vclick'); // 如果设置班次弹窗显示 则点击返回隐藏设置弹窗
            } else {
                try {
                    window.plugins.actionsheet.hide();
                    atMobile.nativeUIWidget.hidePopupMenu();
                } catch (e) {
                    $.am.debug.log(e.message);
                    atMobile.nativeUIWidget.hidePopupMenu();
                }
                if(self.$realMonthBtn&&self.$realMonthBtn.mobiscroll){
                    self.$realMonthBtn.mobiscroll('hide');
                }
                $.am.page.back();
            }
        },
        init: function () {
            var _this = this,
                startX = 0,
                moveX = 0,
                endX = 0,
                startY = 0,
                moveY = 0,
                endY = 0;
            this.windowWidth = $(window).width();
            this.leftMarginWidth = -($(window).width() - 65); // 左边页面位置
            this.shopSettingMap = {};
            this.timeController = $.am.timeController;
            this.$header = this.$.find('.am-header');
            this.$todayStats = this.$.find('.today-stats');
            this.$pageContent = this.$.find('.page-content'); //内容区
            this.$pageLeft = this.$pageContent.find('.page-left'); //统计区
            this.$leftRealTitle = this.$pageLeft.find('.left-real-title');
            this.$leftScrollWrap = this.$pageLeft.find('.left-scroll-wrap'); //统计区滚动盒子
            this.$titleMonth = this.$leftRealTitle.find('.month-num'); //统计区月份
            this.$ulStats = this.$leftScrollWrap.find('.ul-stats'); //统计主ul
            this.$pageRight = this.$pageContent.find(".page-right"); //数据区
            this.$realMonthBtn = this.$pageRight.find('.real-month-btn');
            this.$btnMonth = this.$realMonthBtn.find('.num'); //数据区月份
            this.$titleX = this.$pageRight.find('.title-x');
            this.$rightTitleXUl = this.$titleX.find('.ul-x');
            this.$titleY = this.$pageRight.find('.title-y');
            this.$nameUl = this.$titleY.find('.ul-y');
            this.$rightScrollWrap = this.$pageRight.find('.right-scroll-wrap'); //数据区滚动盒子
            this.$ulDetail = this.$rightScrollWrap.find('.ul-detail'); //数据主ul

            this.$header.find('.title').vclick(function(){
                if(amGloble.metadata.allShops.length==1 || amGloble.metadata.userInfo.shopType != 0){
                    return;
                }
                var manageShopIds = amGloble.metadata.userInfo.shopids;
                if (amGloble.metadata.userInfo.shopType == 0 && manageShopIds) {
                    manageShopIds = manageShopIds + ',' + amGloble.metadata.userInfo.realParentShopId;
                }
                var header = $(this);
                amGloble.allShops.show({
                    target: header,
                    showManaged : true,
                    activeShopId: self.shopId,
                    activeIcon: true,
                    manageShopIds: manageShopIds,
                    callback:function(data){
                        console.log('data', data);
                        if(self.shopId==data.shopId){
                            return;
						}
                        header.find('.text').html(data.shopFullName);
						self.shopId = data.shopId;
                        self.allowSetShift(); // 校验是否可以排班  设置班次后返回要重新渲染
                        self.getShiftsList(self.renderPage, true);
						// self.softgenre = data.softgenre
						// self.getDate();
                    }
                });
            });

            this.maskScroll = new $.am.ScrollView({
                $wrap: this.$pageLeft.find('.mask-left-div'),
                $inner: this.$pageLeft.find('.mask-left-div').find('ul'),
                direction: [0, 1],
                hasInput: false,
                onScroll: function(pos){
                    var x = self.scrollRight._currentPos[0];
                    self.scrollRight.scrollTo([0,pos[1]]);
                    self.scrollLeft.scrollTo([0,pos[1]]);
                    self.titleYScroll.scrollTo([0,pos[1]]);
                }
            });
            this.scrollLeft = new $.am.ScrollView({
                $wrap: this.$leftScrollWrap,
                $inner: this.$leftScrollWrap.children(),
                direction: [0, 1],
                hasInput: false,
                onScroll: function(pos){
                    var x = self.scrollRight._currentPos[0];
                    self.scrollRight.scrollTo([0,pos[1]]);
                    self.maskScroll.scrollTo([0,pos[1]]);
                    self.titleYScroll.scrollTo([0,pos[1]]);
                }
            });
            this.scrollRight = new $.am.ScrollView({
                $wrap: this.$rightScrollWrap,
                $inner: this.$rightScrollWrap.children(),
                direction: [1, 1],
                hasInput: true,
                onScroll: function(pos){
                    self.titleXScroll.scrollTo([pos[0],0]);
                    self.titleYScroll.scrollTo([0,pos[1]]);
                    self.scrollLeft.scrollTo([0,pos[1]]);
                    self.maskScroll.scrollTo([0,pos[1]]);
                }
            });
            this.titleXScroll = new $.am.ScrollView({
                $wrap: this.$titleX,
                $inner: this.$titleX.find('ul'),
                direction: [1, 0],
                hasInput: false,
                onScroll: function(pos){
                    var y = self.scrollRight._currentPos[1]
                    self.scrollRight.scrollTo([pos[0],y]);
                }
            });
            this.titleYScroll = new $.am.ScrollView({
                $wrap: this.$titleY,
                $inner: this.$titleY.find('ul'),
                direction: [0, 1],
                hasInput: false,
                onScroll: function(pos){
                    var x = self.scrollRight._currentPos[0];
                    self.scrollRight.scrollTo([x,pos[1]]);
                    self.scrollLeft.scrollTo([0,pos[1]]);
                    self.maskScroll.scrollTo([0,pos[1]]);
                }
            });
            this.scrollRight.onScrollStop = function () {
                if (self.$ulDetail.find('.li-item.today').length && self.$todayStats.text().trim().length > 0) {
                    self.$todayStats.show();
                } else {
                    self.$todayStats.hide();
                }
            };
            this.$titleY.on('vtouchstart', function (e, p) {
                startX = p.x;
                startY = p.y
            }).on('vtouchmove', function (e, p) {
                e.preventDefault();
                endX = p.x;
                endY = p.y;
                if(endX - startX > 0 && Math.abs(endY - startY)<5){
                    self.$pageRight.css("left", endX - startX + "px");
                    self.$pageLeft.css("left", (self.leftMarginWidth + endX - startX) + "px");
                }
            }).on('vtouchend', function (e, p) {
                moveX = p.x;
                if (moveX - startX > 120) {
                    self.$pageRight.animate({
                        left: self.windowWidth + 'px'
                    });
                    self.$pageLeft.animate({
                        left: '0px'
                    });
                    self.$todayStats.hide();
                    self.$nameUl.removeClass('isShow');
                    // 激活批量设置状态滑到统计页面时隐藏批量设置 取消选中
                    self.hideBatchPop();
                    self.empShiftsArr = [];
                    self.$ulDetail.find('.selected').removeClass('selected');
                } else {
                    self.$pageRight.animate({
                        left: '0px'
                    });
                    self.$pageLeft.animate({
                        left: self.leftMarginWidth + 'px'
                    });
                    self.$nameUl.addClass('isShow');
                }
                self.renderTodayStatsData();
            });
            this.$maskLeftDiv = this.$pageLeft.find('.mask-left-div').on('vtouchstart', function (e, p) {
                startX = p.x;
                startY = p.y;
            }).on('vtouchmove', function (e, p) {
                e.preventDefault();
                endX = p.x;
                endY = p.y;
                console.log(endX - startX)
                if(endX - startX < 0 && Math.abs(endY - startY)<5){
                    self.$pageRight.css("left", -self.leftMarginWidth - (startX - endX) + "px");
                    self.$pageLeft.css("left", -(startX - endX) + "px");
                }
            }).on('vtouchend', function (e, p) {
                moveX = p.x;
                if (startX - moveX > 120) {
                    self.$pageRight.animate({
                        left: '0px'
                    });
                    self.$pageLeft.animate({
                        left: self.leftMarginWidth + 'px'
                    });
                    self.$todayStats.show();
                    self.$nameUl.addClass('isShow');
                } else {
                    self.$pageRight.animate({
                        left: self.windowWidth + 'px'
                    });
                    self.$pageLeft.animate({
                        left: '0px'
                    });
                    self.$nameUl.removeClass('isShow');
                }
                self.renderTodayStatsData();
            });
            this.$maskUl = this.$maskLeftDiv.find('.mask-left-ul');
            // 滚动结束
            this.$menu_btn = this.$.find('.menu-btn').on('vclick', function () {
                $.am.changePage(amGloble.page.settingShift, "slideleft", {
                    shopId: self.shopId
                });
            });
            this.$tips_div = this.$.find('.tips-div').on('vclick', function () { //提示区
                localStorage.setItem('hideShiftTip', true);
                $(this).hide();
                self.initPage();
            });
            var maxDate = new Date(amGloble.now().setDate(amGloble.now().getDate() + 60));
            var dateOpt = {
                dateFormat: "yyyy-mm",
                display: 'bottom',
                animate: 'slideup',
                lang: "zh",
                mode: "scroller",
                max: maxDate,
                onSet: function (valueText, inst) {
                    //  self.gotoDate(valueText.valueText);
                    valueText = valueText.valueText;
                    self.dateTs = new Date(valueText).getTime();
                    self.initPage();
                    self.$btnMonth.text(parseInt(valueText.substring(valueText.indexOf('-') + 1)));
                    self.$titleMonth.text(parseInt(valueText.substring(valueText.indexOf('-') + 1)));
                    self.getShiftsList(self.renderPage);
                }
            };
            this.$leftRealTitle.mobiscroll().date(dateOpt).on('vclick', function () {
                self.$leftRealTitle.mobiscroll('show');
            });
            this.$realMonthBtn.mobiscroll().date(dateOpt).on('vclick', function () {
                self.$realMonthBtn.mobiscroll('show');
            });
            // 月份选择器结束
            // 弹窗
            this.$bgMask = this.$.find('.bg-mask'); // 黑色背景遮罩
            this.$setShiftsDiv = this.$.find('.set-shift-div').on('vclick', 'li', function (e) {
                e.stopPropagation();
                // alert('排班')
                var value = $(this).data('shiftItem').id;
                self.saveOrUpdateShifts(self.empShiftsArr, value);
            }).on('vclick', '.vacation-btn', function (e) {
                // alert('休假')
                e.stopPropagation();
                self.saveOrUpdateShifts(self.empShiftsArr, '-1');
            }).on('vclick', '.cancel-btn', function (e) {
                // alert('取消')
                e.stopPropagation();
                self.hideSetPop();
                self.empShiftsArr = [];
            }).on('vclick', '.delete-btn', function (e) {
                // self.hideSetPop();
                e.stopPropagation();
                self.delShifts(self.empShiftsArr);
            });
            this.$delShiftBtn = this.$setShiftsDiv.find('.delete-btn'); // 取消排班按钮
            this.$ulShifts = this.$setShiftsDiv.find('.ul-shifts');
            // 跳到该员工考勤详情页面
            this.$nameUl.on('vclick', 'li', function (e) {
                e.stopPropagation();
                var emp = $(this).data('emp');
                $.am.changePage(amGloble.page.attendanceRecord, "slideleft", {
                    shopId: emp.shopId,
                    employeeId: emp.employeeId,
                    isManage: true,
                    name: emp.employeeName,
                    pushToken: emp.pushToken,
                    roleType: emp.roleType,
                    date: self.year + self.month
                });
            });
            this.$maskUl.on('vclick', 'li', function (e) {
                e.stopPropagation();
                var emp = $(this).data('emp');
                $.am.changePage(amGloble.page.attendanceRecord, "slideleft", {
                    shopId: emp.shopId,
                    employeeId: emp.employeeId,
                    isManage: true,
                    name: emp.employeeName,
                    pushToken: emp.pushToken,
                    roleType: emp.roleType,
                    date: self.year + self.month
                });

            });
            // 修改考勤框
            this.attendanceOperate = new amGloble.attendanceOperate({
                target: this.$,
                success: function () {
                    self.getShiftsList(self.renderPage);
                    self.renderTodayStatsData(); // 单独修改未重刷页面 单调 重新统计当日信息
                }
            });
            this.currentDate = self.getCurrentDate(); // 当前日期 2019-01-01
            this.empShiftsArr = []; //存放所有选中的员工信息 然后拼成保存的参数 然后清空
            this.$ulDetail.on('vclick', 'li', function (e) {
                e.stopPropagation();
                var $this = $(this);
                var shiftInfo = $this.data('shiftInfo');
                if ($this.hasClass('past') || $this.hasClass('today')) { // 过去和今天的点击 则为修改考勤弹窗显示
                    if (!_this.checkIsAllow()) {
                        amGloble.msg("您没有权限修改考勤记录！");
                        return;
                    }
                    shiftInfo.name = shiftInfo.employeeName;
                    shiftInfo.searchTime = new Date(shiftInfo.shiftDate).getTime();
                    shiftInfo.msName = shiftInfo.shiftName;
                    console.log('考勤数据',shiftInfo);
                    setTimeout(function () { // 解决点击位置相同的点穿问题
                        self.attendanceOperate.show(shiftInfo);
                    }, 300);
                } else {
                    // 是否有修改排班权限
                    // var userInfo = amGloble.metadata.userInfo;
                    // if (userInfo.shopType == 0 && (userInfo.newRole == 2 || userInfo.newRole == 3)) {
                    //     // 没有修改排班的权限
                    //     amGloble.msg("您没有权限设置或修改班次");
                    // } else {
                        // 未过的时间点击则为设置排班
                        if ($this.hasClass('selected')) {
                            $this.removeClass('selected');
                            self.removeSelected(shiftInfo.employeeId, shiftInfo.shiftDate)
                        } else {
                            var obj = $this.data('obj');
                            if (obj) {
                                obj.employeeName = shiftInfo.employeeName;
                                self.empShiftsArr.push(obj);
                            } else {
                                self.empShiftsArr.push(shiftInfo);
                            }
                            console.log(self.empShiftsArr);
                            $this.addClass('selected');
                            if (!self.$batchDiv.is(':visible')) { // 如果不是批量设置不可见则显示单独设置
                                self.showSetPop();
                            } else {
                                if (!self.$batch_set.hasClass('active')) {
                                    self.$batch_set.addClass('active');
                                }
                            }
                        }
                    // }
                }
            }).on('vhold', 'li', function (e) {
                e.stopPropagation();
                var $this = $(this);
                // 只能为未来设置和修改排班
                if ($this.hasClass('past') || $this.hasClass('today')) {
                    // 现在和过去不能修改和设置排班
                    // amGloble.msg("仅能为未来设置排班");
                } else {
                    // 是否有修改排班权限
                    // var userInfo = amGloble.metadata.userInfo;
                    // if (userInfo.shopType == 0 && (userInfo.newRole == 2 || userInfo.newRole == 3)) {
                    //     // 没有修改排班的权限
                    //     amGloble.msg("您没有权限设置或修改班次");
                    // } else {
                        if ($this.hasClass('selected')) {
                            $this.removeClass('selected');
                        } else {
                            $(this).addClass('selected')
                            self.showBatchPop();
                            var shiftInfo = $this.data('shiftInfo');
                            var obj = $this.data('obj');
                            if (obj) {
                                obj.employeeName = shiftInfo.employeeName;
                                self.empShiftsArr.push(obj);
                            } else {
                                self.empShiftsArr.push(shiftInfo);
                            }
                        }
                    // }
                }
            });
            this.$batchDiv = this.$.find('.batch-div').on('vclick', '.batch-cancel', function (e) {
                e.stopPropagation();
                // alert('取消批量');
                self.hideBatchPop();
                self.$ulDetail.find('.selected').removeClass('selected');
                self.empShiftsArr = [];
            }).on('vclick', '.active', function (e) {
                e.stopPropagation();
                // alert('设置批量');
                self.hideBatchPop();
                self.showSetPop();
                // self.hideSetPop();
            });
            this.$batch_set = this.$batchDiv.find('.batch-set');
        },
        getCurrentDate: function () {
            var tsNow = new Date(),
                Y = tsNow.getFullYear() + '-',
                M = tsNow.getMonth() + 1 < 10 ? '0' + (tsNow.getMonth() + 1) + '-' : tsNow.getMonth() + 1 + '-',
                D = tsNow.getDate() < 10 ? '0' + (tsNow.getDate()) : tsNow.getDate();
            return Y + M + D;
        },
        showSetPop: function () {
            self.$bgMask.show();
            self.$setShiftsDiv.show();
            console.log(self.empShiftsArr);
            var isAdd = 0;
            $.each(self.empShiftsArr, function (i, v) {
                if (v.id) {
                    // && v.id!=0 休假id为0 也能设置后直接取消排班
                } else {
                    isAdd = 1;
                    return false;
                }
            });
            if (isAdd) {
                // 添加 不显取消排班按钮
                this.$delShiftBtn.hide();
            } else {
                this.$delShiftBtn.show()
            }
        },
        hideSetPop: function () {
            self.$ulDetail.find('.selected').removeClass('selected');
            self.$bgMask.hide();
            self.$setShiftsDiv.hide();
        },
        removeSelected: function (employeeId, shiftDate) {
            var arr = self.empShiftsArr;
            for (var i = 0, len = arr.length; i < len; i++) {
                var item = arr[i],
                    date = item.shiftDate,
                    empId = item.employeeId;
                if (employeeId == empId && date == shiftDate) {
                    arr.splice(i, 1);
                    break;
                }
            }
        },
        showBatchPop: function () {
            self.$batchDiv.css('display', 'flex');
        },
        hideBatchPop: function () {
            self.$bgMask.hide();
            self.$batchDiv.hide();
            self.$batch_set.removeClass('active');
        },
        delShifts: function (arr) {
            var parasArr = [];
            for (var i = 0, len = arr.length; i < len; i++) {
                var item = arr[i],
                    obj = {};
                if (item && item.id) {
                    obj.shopId = item.shopId;
                    obj.mobile = item.mobile;
                    obj.shiftDate = item.shiftDate;
                    parasArr.push(obj)
                }
            }
            amGloble.loading.show("正在删除,请稍候...");
            amGloble.api.shiftsDelete.exec({
                content: parasArr
            }, function (ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    if (arr && arr.length == 1) {
                        // 仅删除一个排班 不重绘当前页 重绘统计
                        if (!arr[0].scheduleShiftList) {
                            var $liItem = self.$ulDetail.find('.selected');
                            if($liItem.data('obj') && $liItem.data('obj').id){
                                delete $liItem.data('obj').id;
                            }
                            if($liItem.data('shiftInfo') && $liItem.data('shiftInfo').id){
                                delete $liItem.data('shiftInfo').id;
                            }
                            var $prefixShift = $liItem.find('.prefix-shift').text('');
                            if ($prefixShift.hasClass('orange')) {
                                // 如果是休假 去掉背景圆圈
                                $prefixShift.removeClass('orange');
                            }
                            self.getShiftsList(self.renderStatsPage);
                            self.empShiftsArr = [];
                        }
                    } else {
                        self.getShiftsList(self.renderPage);
                    }
                    // self.getShiftsList(self.renderPage);
                    self.empShiftsArr = [];
                    self.hideSetPop();
                    // self.$batch_set.removeClass('active');
                } else {
                    amGloble.msg("哎呀，出错了！");
                    self.hideSetPop();
                    self.empShiftsArr = [];
                    self.getShiftsList(self.renderPage);
                }
            });

		},
		// 批量修改排班数据
		// batchModifyDetail: function(shiftIdMaps, resultList) {
		// 	var shiftList = amGloble.metadata.shiftSettingList.shiftSetting;
		// 	var shiftSettingNameMaps = {
		// 		'-1': '休假'
		// 	};
		// 	$.each(shiftList, function(index, shift) {
		// 		shiftSettingNameMaps[shift.id] = shift.name;
		// 	})
		// 	var empIndexMaps = {}
		// 	$.each(self.$nameUl.find('.am-clickable'), function(index, nameItem) {
		// 		var empData = $(nameItem).data('emp');
		// 		empIndexMaps[empData.employeeId] = index;
		// 	});
		// 	resultList.forEach(item => {
		// 		var id = item.id;
		// 		var shiftId = shiftIdMaps[item.employeeId + '-' + item.date];
		// 		var shiftName = shiftSettingNameMaps[shiftId];
		// 		var day = item.date.split('-')[2];
		// 		var empIndex = empIndexMaps[item.employeeId];
		// 		var $li = self.$ulDetail.find('.li-y').eq(empIndex).find('.li-item').eq(day);
		// 		var $prefixShift = $li.find('.prefix-shift').text(shiftName).show();
		// 		if (shiftName == '休假') {
		// 			$prefixShift.removeClass().addClass('orange prefix-shift'); // 单独设置休假加圈显示
		// 		} else {
		// 			$prefixShift.removeClass().addClass('prefix-shift');
		// 		}
		// 		$.extend($li.data('shiftInfo'), {
		// 			id: id
		// 		});
		// 		$.extend($li.data('obj'), {
		// 			id: id
		// 		});
		// 	})
		// },
        modifyDetail: function (data, id) {
            // 单个设置不刷新页面
            var shiftList = amGloble.metadata.shiftSettingList.shiftSetting;
            shiftList.push('休假');
            var shiftName = '';
            for (var i = 0, len = shiftList.length; i < len; i++) {
                if (shiftList[i].id == data[0].scheduleShiftList[0].shiftId) {
                    shiftName = shiftList[i].name;
                    break;
                }
                if (data[0].scheduleShiftList[0].shiftId == '-1') {
                    shiftName = '休假';
                    break;
                }
            }
            var $li = self.$ulDetail.find('.selected');
            var $prefixShift = $li.find('.prefix-shift').text(shiftName.substring(0, 1)).show();
            if (shiftName == '休假') {
                $prefixShift.removeClass().addClass('orange prefix-shift'); // 单独设置休假加圈显示
            } else {
                $prefixShift.removeClass().addClass('prefix-shift');
            }
            $.extend($li.data('shiftInfo'), {
                id: id
            });
            $.extend($li.data('obj'), {
                id: id
            });

        },
        saveOrUpdateShifts: function (arr, value) {
            var contentsTemp = [];
            for (var i = 0, len = arr.length; i < len; i++) {
                var item = arr[i],
                    obj = {
                        employeeId: item.employeeId,
                        employeeName: item.employeeName,
                        parentShopId: item.parentShopId,
                        shopId: item.shopId,
                        mobile: item.mobile
                    };
                obj.scheduleShiftList = [];
                obj.scheduleShiftList.push({
                    employeeId: item.employeeId,
                    parentShopId: item.parentShopId,
                    shopId: item.shopId,
                    shiftId: value,
                    shiftDate: item.shiftDate,
                    id: item.id
                })
                contentsTemp.push(obj);
            }
            console.log('--------------------', contentsTemp);
            amGloble.loading.show("正在加载,请稍候...");
            amGloble.api.shiftsSave.exec({
                content: contentsTemp
            }, function (ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    if (contentsTemp && contentsTemp.length == 1) {
                        self.getShiftsList(self.renderStatsPage); // 单独设置 不重绘页面
						// 将该单元格信息修改 不刷新当前页面
						if (ret.content.length > 0) {
							self.modifyDetail(contentsTemp, ret.content[0].id);
						}
                        // self.modifyDetail(contentsTemp)
                    } else {
						self.getShiftsList(self.renderPage);
						// var shiftIdMaps = {};
						// $.each(contentsTemp, function(index, item) {
						// 	var shiftItem = item.scheduleShiftList[0];
						// 	var key = item.employeeId + '-' + shiftItem.shiftDate;
						// 	shiftIdMaps[key] = shiftItem.shiftId;
						// })
						// self.batchModifyDetail(shiftIdMaps, ret.content);
                    }
                    self.hideSetPop();
                    self.empShiftsArr = [];
                    self.$batch_set.removeClass('active');
                } else {
                    amGloble.msg("哎呀，出错了！");
                    self.empShiftsArr = [];
                    self.getShiftsList(self.renderPage);
                }
            });
        },
        getShiftsList: function (cb, init) {
            amGloble.loading.show("正在加载,请稍候...");
            // self.resetPage();
            self.getCurrentShop(); // 获取当前门店 将全局门店ShopId 重新赋值
            var ts = self.dateTs ? self.dateTs : new Date().getTime(),
                Y = new Date(ts).getFullYear() + '-',
                M = new Date(ts).getMonth() + 1 < 10 ? '0' + (new Date(ts).getMonth() + 1) : new Date(ts).getMonth() + 1;
            self.year = Y;
            self.month = M;
            var opt = {
                shopId: self.shopId,
                parentShopId: self.parentShopId,
                period: Y + M
            };
            amGloble.api.shiftsList.exec(opt, function (ret) {
                // amGloble.loading.hide();
                if (ret.code == 0) {
                    amGloble.loading.hide();
                    // 为总部时过滤掉员工信息，只统计
                    var resultData = [];
                    var hasTenant = amGloble.metadata.shopMap[self.shopId] && amGloble.metadata.shopMap[self.shopId].softgenre == 0;

                    $.each(ret.content, function(index, item) {
                        // 当为总部门店的时候会过滤角色为老板和管理员的数据
                        if (!hasTenant || (item.roleType == 0 && [2, 3].indexOf(Number(item.role)) != -1)) {
                            resultData.push(item);
                        }
                    })
                    cb && cb(resultData, init);
                    // self.renderPage(ret.content);
                } else {
                    amGloble.loading.hide();
                    // amGloble.msg("哎呀，出错了！");
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.getShiftsList(cb);
                    }, function() {
                        $.am.changePage(amGloble.page.dashboard,'slidedown');
                    });
                    // _this.setStatus("error");
                }
            });
        },
        getRightWidth: function (daysLen) {
            return (45 * daysLen + 63) + 'px';
        },
        arr2New: function (arr) {
            var newArr = [];
            newArr.length = self.daysArr.length;
            for (var i = 0, len = arr.length; i < len; i++) {
                var str = arr[i].shiftDate;
                if (str) {
                    var s = parseInt(str.substring(8));
                    newArr[s - 1] = arr[i];
                } else {
                    var index = new Date(arr[i].employeeGoWorkTime || arr[i].employeeOutWorkTime).getDate();
                    newArr[index - 1] = arr[i];
                }

            }
            return newArr;
        },
        renderStatsPage: function (data) {
            self.$ulStats.empty();
            var statsDoms = [],
                statsTitleLi = '<li class="stats-title-li"></li>',
                statsLiArr = [];
            statsLiArr.push(statsTitleLi);
            for (var i = 0, len = data.length; i < len; i++) {
                var item = data[i],
                    statsLiItemArr = [],
                    liItemS = '<li class="stats-li-x"><ul class="stats-ul-x">',
                    liItemUlE = '</ul>';
                statsLiItemArr.push(liItemS);
                $.each(item.statsArr, function (index, v) {
                    var liItem = '';
                    if (index == 0) {
                        if (v['未排班']) {
                            liItem = '<li class="stats-li-item"><div class="div-item"><div class="prefix-shift absent">未</div><span class="day-num">' +
                                v['未排班'] +
                                '</span><span class="day-text">天</span></div></li>';
                        }
                    } else if (index == 2) {
                        if (v['休假']) {
                            liItem = '<li class="stats-li-item"><div class="div-item"><div class="prefix-shift rest">休</div><span class="day-num">' +
                                v['休假'] +
                                '</span><span class="day-text">天</span></div></li>';
                        }
                    } else if (index == 1) {
                        // 数据有误 将统计信息放在了第二个 所以不渲染它
                    } else {
                        for (var key in v) {
                            if (v[key]) {
                                liItem = '<li class="stats-li-item"><div class="div-item"><div class="prefix-shift shift">' +
                                    key.substring(0, 1) +
                                    '</div><span class="day-num">' +
                                    v[key] +
                                    '</span><span class="day-text">天</span></div></li>';
                            }
                        }
                    }
                    statsLiItemArr.push(liItem);
                });
                statsLiItemArr.push(liItemUlE);
                var absentCount=item.statsArr[1] && item.statsArr[1]['未出勤'];
                var lateStr = item.late ? '迟到' + item.late + '次，' : '',
                    earlyStr = item.early ? '早退' + item.early + '次，' : '',
                    absentStr = absentCount>0 ? '未出勤' + absentCount + '次，' : '',
                    unUsualStr = item.unUsual ? '异常打卡' + item.unUsual + '次' : '';
                if (lateStr || earlyStr || absentStr || unUsualStr) {
                    // 去掉末尾的，
                    var resStr = (lateStr || "") + (earlyStr || "") + (absentStr || '') + (unUsualStr || ""),
                        strIndex = resStr.length - 1;
                    if (resStr.lastIndexOf('，') == strIndex) {
                        resStr = resStr.substring(0, strIndex)
                    }
                    liItemDiv = '<div class="stats-item-div">' + resStr + '</div></li>'
                    statsLiItemArr.push(liItemDiv);
                }
                var tempStr = statsLiItemArr.join("")
                statsDoms.push(tempStr)
            }
            statsLiArr.push(statsDoms.join(""));
            self.$ulStats.html(statsLiArr);
            amGloble.loading.hide();
        },
        renderPage: function (data, init) {
			// 渲染月份
			self.$realMonthBtn.show();
            self.resetPage();
            var month = new Date(self.dateTs || new Date().getTime()).getMonth() + 1;
            self.$titleMonth.text(month);
            self.$btnMonth.text(month);
            // 渲染数据title-x
            var $liMonthBtn = $('<li class="month-btn"></li>'),
                $weeksArr = [];
            $weeksArr.push($liMonthBtn);
            $.each(self.daysArr, function (index, item) {
                var $liDay = $('<li><span class="week">星期' +
                    item.realWeek +
                    '</span><span class="day">' +
                    item.number +
                    '</span></li>');
                var dayStr = index + 1 < 10 ? '0' + (index + 1) : index + 1;
                var dateTS = new Date(self.year + self.month + '-' + dayStr).getTime();
                var nowTs = new Date(self.currentDate).getTime();
                if (dateTS < nowTs) {
                    $liDay.addClass('past');
                } else if (dateTS == nowTs) {
                    $liDay.addClass('today');
                    $liDay.find('.day').text('今');
                }

                $weeksArr.push($liDay);
            });
            self.$rightTitleXUl.append($weeksArr);
            // stats-titlle li
            var statsTitleLi = '<li class="stats-title-li"></li>',
                statsLiArr = [];
            statsLiArr.push(statsTitleLi);
            // mask
            var $maskTitleLi = $('<li class="mask-title-li"></li>'),
                $maskLiArr = [];
            $maskLiArr.push($maskTitleLi);
            var statsDoms = [];
            var $titleYLiS = $('<li></li>'),
                $titleYLiArr = [];
            $titleYLiArr.push($titleYLiS);
            for (var i = 0, dataLen = data.length; i < dataLen; i++) {
                var item = data[i],
                    emp = {
                        employeeId: item.employeeId,
                        employeeName: item.employeeName,
                        pushToken: item.pushToken,
                        roleType: item.roleType,
                        shopId: self.shopId,
                        parentShopId: self.parentShopId,
                        mobile: item.mobile,
                        username: item.username
                    };
                var statsLiItemArr = [],
                    liItemS = '<li class="stats-li-x"><ul class="stats-ul-x">',
                    liItemUlE = '</ul>';
                statsLiItemArr.push(liItemS);
                $.each(item.statsArr, function (index, v) {
                    var liItem = '';
                    if (index == 0) {
                        if (v['未排班']) {
                            liItem = '<li class="stats-li-item"><div class="div-item"><div class="prefix-shift absent">未</div><span class="day-num">' +
                                v['未排班'] +
                                '</span><span class="day-text">天</span></div></li>';
                        }
                    } else if (index == 2) {
                        if (v['休假']) {
                            liItem = '<li class="stats-li-item"><div class="div-item"><div class="prefix-shift rest">休</div><span class="day-num">' +
                                v['休假'] +
                                '</span><span class="day-text">天</span></div></li>';
                        }
                    } else if (index == 1) {
                        // 后台数据有错误 将返回的统计数据放在了数组的第二个位置
                    } else {
                        for (var key in v) {
                            if (v[key]) {
                                liItem = '<li class="stats-li-item"><div class="div-item"><div class="prefix-shift shift">' +
                                    key.substring(0, 1) +
                                    '</div><span class="day-num">' +
                                    v[key] +
                                    '</span><span class="day-text">天</span></div></li>';
                            }
                        }
                    }
                    statsLiItemArr.push(liItem);
                });
                statsLiItemArr.push(liItemUlE);
                var absentCount=item.statsArr[1] && item.statsArr[1]['未出勤'];
                var lateStr = item.late ? '迟到' + item.late + '次，' : '',
                    earlyStr = item.early ? '早退' + item.early + '次，' : '',
                    absentStr = absentCount>0 ? '未出勤' + absentCount + '次，' : '',
                    unUsualStr = item.unUsual ? '异常打卡' + item.unUsual + '次' : '';
                if (lateStr || earlyStr || absentStr || unUsualStr) {
                    // 去掉末尾的，
                    var resStr = (lateStr || "") + (earlyStr || "") + (absentStr || '') + (unUsualStr || ""),
                        strIndex = resStr.length - 1;
                    if (resStr.lastIndexOf('，') == strIndex) {
                        resStr = resStr.substring(0, strIndex)
                    }
                    liItemDiv = '<div class="stats-item-div">' + resStr + '</div></li>'
                    statsLiItemArr.push(liItemDiv);
                }
                var tempStr = statsLiItemArr.join("");
                statsDoms.push(tempStr)
                // 将员工信息加在mask上
                var $maskLi = $('<li class="mask-li am-clickable">' +
                    '<div class="div-item"><span class="name">' + item.employeeName +
                    '</span><i class="iconfont icon-xiangyouq"></i></div></li>').attr('data-emp', JSON.stringify(emp));
                $maskLiArr.push($maskLi);
                self.$maskUl.append($maskLiArr);
                // 渲染数据detail
                var $headEmptyLi = $('<li class="li-y"><ul class="content-x"><li class="li-item"></li>');
                self.$ulDetail.append($headEmptyLi);
                var $contentX = $headEmptyLi.find('.content-x');
                var shifts = self.arr2New(item.scheduleShift);
                var $liItemArr = [];
                for (var j = 0, shiftsLen = shifts.length; j < shiftsLen; j++) {
                    var obj = shifts[j],
                        shiftName = '',
                        workStatus = '',
                        status = '',
                        employeeGoWorkTime = '',
                        employeeOutWorkTime = '';
                    var shiftInfo = {};
                    $.extend(shiftInfo, emp);
                    var index = j + 1,
                        day = index < 10 ? '0' + index : index,
                        shiftDate = self.year + self.month + '-' + day;
                    var isEmpty = true;
                    if (obj) {
                        isEmpty = false;
                        $.extend(obj, {
                            mobile: item.mobile
                        })
                        $.extend(shiftInfo, obj);
                        shiftName = obj.shiftName || '';
                        // "status": 1,  //异常状态 0：正常 1：异常,2 未出勤,3：只有原因
                        // "workStatus": 1, //工作状态 0：正常 1：迟到 2：早退 3:迟到早退 
                        if (!obj.status) {
                            employeeGoWorkTime = obj.employeeGoWorkTime ? new Date(obj.employeeGoWorkTime).format('HH:MM') : '',
                                employeeOutWorkTime = obj.employeeOutWorkTime ? new Date(obj.employeeOutWorkTime).format('HH:MM') : '';
                            switch (obj.status) {
                                case 0:
                                    status = "";
                                    break;
                                case 1:
                                    status = "异常";
                                    break;
                                    // case 3:
                                    // 执行代码块 2
                                    // break;
                                default:
                                    status = "";
                            }

                            switch (obj.workStatus) {
                                case 0:
                                    workStatus = "";
                                    break;
                                case 1:
                                    workStatus = "迟到";
                                    break;
                                case 2:
                                    workStatus = "早退";
                                    break;
                                case 3:
                                    workStatus = "迟到早退";
                                    break;
                                default:
                                    status = "";
                            }
                        } else if (obj.status === 1) {
                            status = "异常";
                            workStatus = "";
                        } else {
                            status = "未出勤";
                            workStatus = "";
                        }
                    } else {
                        $.extend(shiftInfo, {
                            shiftDate: shiftDate
                        });
                    }
                    var $liItem = $('<li class="li-item am-clickable"><span class="iconfont icon-gou"></span><div class="item"><div class="note"><i class="iconfont icon-xinxi"></i></div><div class="prefix-shift">' +
                        shiftName.substring(0, 1) +
                        '</div><div class="work-status">' +
                        workStatus +
                        '</div><div class="status">' +
                        status +
                        '</div><div class="goWorkTime">' +
                        employeeGoWorkTime +
                        '</div><div class="outWorkTime">' +
                        employeeOutWorkTime +
                        '</div></div></li>').data('shiftInfo', shiftInfo).data('obj', obj);
                    if (new Date(self.currentDate).getTime() > new Date(shiftDate).getTime()) {
                        $liItem.addClass('past')
                    } else if (new Date(self.currentDate).getTime() == new Date(shiftDate).getTime()) {
                        $liItem.addClass('today')
                    } else {
                        $liItem.addClass('future')
                    }
                    var $note = $liItem.find('.note'),
                        $prefixShift = $liItem.find('.prefix-shift');
                    if (isEmpty) {
                        $note.hide();
                        $prefixShift.hide()
                    } else {
                        if (obj && obj.remark.length > 0) {
                            $note.show(); // 有备注的员工考勤不显示未出勤
                            if ($liItem.find('.status').text() == '未出勤') {
                                $liItem.find('.status').addClass('orange');
                            }
                        } else {
                            $note.hide();
                        }
                        $prefixShift.show()
                    }
                    // 按照对应颜色显示
                    var $workStatus = $liItem.find('.work-status'),
                        $status = $liItem.find('.status'),
                        $goTime = $liItem.find('.goWorkTime'),
                        $outTime = $liItem.find('.outWorkTime');
                    if (obj && obj.workStatus !== 0) {
                        $workStatus.addClass('blue');
                        $prefixShift.addClass('blue');
                        $liItem.find('.goWorkTime').html('');
                        $liItem.find('.outWorkTime').html('');
                    } else if (obj && (obj.workStatus == 0) && (obj.status == 0) && $liItem.hasClass('past')) {
                        $prefixShift.addClass('normal');
                        //过去的正常状态只显示班次
                        $goTime.html('');
                        $outTime.html('');
                    } else if (obj && (obj.workStatus == 0) && (obj.status == 0) && $liItem.hasClass('today')) {
                        $goTime.html(employeeGoWorkTime);
                        $outTime.html(employeeOutWorkTime || '-:-');
                    } else {
                        $workStatus.addClass('green');
                        $prefixShift.addClass('blue');
                    }

                    if (obj && obj.status === 1) {
                        $status.addClass('red');
                        $prefixShift.removeClass('blue').removeClass('orange').addClass('red');
                        $liItem.find('.goWorkTime').html('');
                        $liItem.find('.outWorkTime').html('');
                    }
                    if ($liItem.hasClass('future')) {
                        $status.text('');
                        $prefixShift.removeClass().addClass('prefix-shift');
                    }
                    if (!shiftName) {
                        $prefixShift.removeClass().addClass('prefix-shift');
                    }

                    if ($liItem.hasClass('today') && ($status.text() == '未出勤')) {
                        $status.text('');
                    }
                    if ($liItem.hasClass('past') && ($status.text() == '未出勤')) {
                        $prefixShift.addClass('orange')
                        $status.addClass('orange');
                    }
                    if ($liItem.hasClass('today') && obj && obj.shiftName && (obj.employeeGoWorkTime == 0)) {
                        $prefixShift.removeClass().addClass('prefix-shift noRecord');
                    } else if ($liItem.hasClass('today') && obj && obj.shiftName && (obj.status == 0) && (obj.workStatus == 0)) {
                        $prefixShift.removeClass().addClass('prefix-shift green');
                    } else if ($liItem.hasClass('today') && obj && obj.shiftName && (obj.status == 0) && (obj.workStatus == 1)) {
                        $prefixShift.removeClass().addClass('prefix-shift blue');
                        $goTime.html(employeeGoWorkTime || '-:-').addClass('blue');
                        $outTime.html(employeeOutWorkTime || '-:-');
                        $workStatus.html('');
                        $status.html('');
                    } else if ($liItem.hasClass('today') && obj && obj.shiftName && (obj.status == 0) && (obj.workStatus == 2)) {
                        $prefixShift.removeClass().addClass('prefix-shift blue');
                        $goTime.html(employeeGoWorkTime || '-:-');
                        $outTime.html(employeeOutWorkTime || '-:-').addClass('blue');
                        $workStatus.html('');
                        $status.html('');
                    } else if ($liItem.hasClass('today') && obj && obj.shiftName && (obj.status == 0) && (obj.workStatus == 3)) {
                        $prefixShift.removeClass().addClass('prefix-shift blue');
                        $goTime.html(employeeGoWorkTime || '-:-').addClass('blue');
                        $outTime.html(employeeOutWorkTime || '-:-').addClass('blue');
                        $workStatus.html('');
                        $status.html('');
                    }
                    if ($liItem.find('.prefix-shift').text().indexOf('休') > -1) {
                        $prefixShift.removeClass().addClass('prefix-shift orange');
                        // 休 的情况下不显示任何内容
                        $workStatus.text('');
                        $status.text('');
                    }
                    $liItemArr.push($liItem);
                }
                $contentX.append($liItemArr);
                var $titleYLi = $('<li class="am-clickable"><span class="name">' +
                    item.employeeName + '</span><i class="iconfont icon-xiangyouq"></i></li>').data('emp', emp);
                $titleYLiArr.push($titleYLi);
                // self.$nameUl.append($titleYLi);
            }
            statsLiArr.push(statsDoms.join(""));
            self.$ulStats.html(statsLiArr);
            // 空白占位下 解决批量设置遮盖数据问题 start
            var $footEmptyLi = $('<li class="li-y"><ul class="content-x"><li class="li-item"></li>');
            self.$ulDetail.append($footEmptyLi);
            $titleYLiArr.push($('<li></li>'));
            self.$nameUl.append($titleYLiArr);
            self.$maskUl.append($('<li class="mask-li"></li>'));
            self.$ulStats.append($('<li class="stats-li-x"></li>'))
            // 空白占位下 解决批量设置遮盖数据问题 end

            // 直接滚到今天
            var $titleToday = $('.title-x').find('.today')
            if ($titleToday.length && self.$realMonthBtn.is(':visible')) {
                console.log(self.$titleX.offset())
                var x = -(($titleToday.index() - 1) * 45);
                self.scrollRight.refresh();
                setTimeout(function () {
					if (init === true) {
						self.scrollRight.scrollTo([x, 0]);
						self.titleXScroll.scrollTo([x, 0]);
						self.titleYScroll.scrollTo('top');
						self.maskScroll.scrollTo('top');
						self.scrollLeft.scrollTo('top');
					}
                    setTimeout(function () {
                        if (self.$ulDetail.find('.li-item.today').length && self.$todayStats.text().trim().length > 0) {
                            self.$todayStats.show();
                        } else {
                            self.$todayStats.hide();
                        }
                    }, 0);
                }, 200);
            } else {
				self.scrollRight.refresh();
				if (init === true) {
					self.scrollRight.scrollTo('top');
					self.titleXScroll.scrollTo([x, 0]);
					self.titleYScroll.scrollTo('top');
					self.maskScroll.scrollTo('top');
					self.scrollLeft.scrollTo('top');
				}
            }

            self.titleXScroll.refresh();
            // self.titleXScroll.scrollTo('top');

            self.titleYScroll.refresh();
            // self.titleYScroll.scrollTo('top');

            self.maskScroll.refresh();
            // self.maskScroll.scrollTo('top');

            self.scrollLeft.refresh();
            // self.scrollLeft.scrollTo('top');
            self.renderTodayStatsData();
            setTimeout(function () {
                amGloble.loading.hide();
            }, 300);
        },
        renderTodayStatsData: function () {
            // self.$todayStats.text('').show();
            var arr = self.$ulDetail.find('.li-item.today').find('.prefix-shift').text().split('');
            if (self.$nameUl.hasClass('isShow') && arr.length > 0 && self.shiftNames && self.shiftNames.length > 0) {
                var obj = {};
                for (var i = 0; i < arr.length; i++) { // 将今天的班次前缀统计出来 前缀为key
                    var temp = arr[i],
                        count = 0;
                    for (var j = 0; j < arr.length; j++) {
                        if (arr[j] == temp) {
                            count++;
                            arr[j] = -1;
                        }
                    }
                    if (temp != -1) {
                        obj[temp] = count;
                    }
                }
                self.shiftNames.push('休息')
                var shiftNames = self.shiftNames;
                var statsStr = '';
                $.each(shiftNames, function (i, v) {
                    var prefix = v.substring(0, 1);
                    for (var key in obj) {
                        if (key === prefix) {
                            statsStr += v + obj[key] + '人' + '，'
                        }
                    }
                });
                shiftNames.pop();
                console.log(statsStr)
                statsStr = '今日排班：' + statsStr.substring(0, statsStr.length - 1);
                self.$todayStats.text(statsStr).show();
            } else {
                self.$todayStats.text('').hide();
            }
        },
        initPage: function () {
            self.daysArr = self.timeController.getTimeList(self.dateTs || new Date().getTime());
            var widthRight = self.getRightWidth(self.daysArr.length);
            self.$rightTitleXUl.css('width', widthRight); // right title-x
            self.$ulDetail.css('width', widthRight); // right emp detail
            // var pageContentHeight = $(window).height() - 84; // 窗口高度-header高度
            var pageContentHeight = $(window).height() - self.$header.outerHeight(); // 窗口高度-header高度
            if (!(localStorage.getItem('hideShiftTip') === 'true')) {
                pageContentHeight = pageContentHeight - 39; // 如果没有关闭提示则再减去提示高度
            }
            var heightAttr = pageContentHeight + 'px';
            self.$pageContent.css('height', heightAttr);
            self.$pageLeft.css('height', heightAttr);
            self.$pageRight.css('height', heightAttr);
            self.$leftScrollWrap.css('height', heightAttr);
            self.$rightScrollWrap.css('height', heightAttr);
        },
        resetPage: function () {
            self.$ulStats.empty();
            self.$maskUl.empty();
            self.$rightTitleXUl.empty();
            self.$nameUl.empty();
            self.$ulDetail.empty().append('<li class="li-y-title"><ul class="content-x"><li class="li-item"></li></ul></li>');
        },
        checkIsAllow: function () { // 是否具有修改考勤权限
            var optstr = amGloble.metadata.userInfo.operatestr;
            if (optstr) {
                if (optstr.indexOf("V2") != -1) {
                    return false;
                } else {
                    return true;
                }
            } else {
                return true;
            }
        },
        getShiftList: function (list) { // 获取排班类别
            var res = [];
            if (list && list.length) {
                for (var i = 0; i < list.length; i++) {
                    if (list[i].status == 0) {
                        res.push(list[i]);
                    }
                }
            }
            return res;
        },
        renderUlShifts: function () {
            self.$ulShifts.empty();
            var shiftSettingList = self.getShiftList(amGloble.metadata.shiftSettingList.shiftSetting);
            var $shiftLiArr = [],
                shiftNames = [];
            for (var i = 0, len = shiftSettingList.length; i < len; i++) {
                var item = shiftSettingList[i];
                if (item.status == 1) {
                    //已经删除的班次
                } else {
                    var $shiftLi = $('<li class="am-clickable">' +
                        item.name + ' ' + item.goWorkTime + '~' + item.outWorkTime +
                        '</li>').data('shiftItem', item);
                    $shiftLiArr.push($shiftLi);
                    shiftNames.push(item.name);
                }

            }
            self.$ulShifts.append($shiftLiArr);
            self.shiftNames = shiftNames;
        },
        beforeShow: function (paras) {
            if (self.nowUserId != amGloble.metadata.userInfo.userId) {
                self.shopId = '';
                amGloble.allShops.refresh();
                self.nowUserId = amGloble.metadata.userInfo.userId;
            }
            
			if (!self.daysArr) {
				self.$realMonthBtn.hide();
			}
			self.modifiedBack=false;
            if(paras && (paras == 'back'||paras.modified==false)){
                return;
            }else if(paras && (paras=='forceRefresh' ||paras.modified)){
                // 首次进入 拉去数据
				self.modifiedBack=true;
			}
            // self.$ulShifts.empty();
            // if (paras && (paras == 'back' || paras.modified)) {
            //     if(paras.modified){
            //         self.modifiedBack=true;
            //         // self.renderUlShifts();
            //     }
                
            //     return;
            // }
            amGloble.loading.show("正在加载,请稍候...");
            self.initPage();
            self.parentShopId = amGloble.metadata.userInfo.parentShopId;
            // 隐藏tips
            if (localStorage.getItem('hideShiftTip') === 'true') {
                this.$tips_div.hide();
            } else {
                this.$tips_div.show();
            }
        },

        afterShow: function (paras) {
            // amGloble.storeSelect.onShopChange = function (shops) {
            //     self.getCurrentShop(); // 获取当前门店的id
            //     self.allowSetShift(); // 校验是否可以排班  设置班次后返回要重新渲染
            //     self.getShiftsList(self.renderPage, true);
            // };
            // 门店改变需要重新调用以下两个方法获取数据
            if(self.modifiedBack){
                self.getShiftsList(self.renderPage, (paras && paras.modified) ? false : true); // 获取数据
            }
            self.allowSetShift(); // 校验是否可以排班  设置班次后返回要重新渲染
            // self.renderUlShifts();// 渲染班次

        },
        afterHide: function () {
            // self.$ulShifts.empty(); // 初始化牌班次列表
        },
        allowSetShift: function () {
            // 获取排班信息 成功后渲染排班列表
            // 是否有权限设置排班
            // newRole 1操作员 2管理员 3老板 4第一工位员工 5第二工位员工 6第三工位员工
            // shopType 0总店 1单店 2直营 3附属
            var userInfo = amGloble.metadata.userInfo;
            if (userInfo.shopType == 0 && (userInfo.newRole == 2 || userInfo.newRole == 3)) { //总部
                this.$.find(".menu-btn").show();
                //总部要去拿门店班次
                this.getShopShiftSetting(function (settingShift) {
                    if (settingShift) {
                        amGloble.metadata.shiftSettingList = settingShift;
                        self.renderUlShifts(); // 渲染班次
                    }
                });
            } else {
                this.$.find(".menu-btn").hide();
            }
            if (userInfo.shopType > 0) {
                // self.renderUlShifts(); // 渲染班次
                this.$.find(".menu-btn").show();
                this.getShopShiftSetting(function (settingShift) {
                    if (settingShift) {
                        amGloble.metadata.shiftSettingList = settingShift;
                        self.renderUlShifts(); // 渲染班次
                    }
                });
            } 
            // 放开总店的班次
            // else {
            //     this.$.find(".menu-btn").hide();
            // }
        },
        getShiftData: function (data, cb) { // 获取门店班次数据
            var _this = this;
            //amGloble.loading.show("正在加载,请稍候...");
            amGloble.api['shiftList'].exec(data, function (ret) {
                // amGloble.loading.hide();
                if (ret.code == 0) {
                    // _this.setStatus("normal");
                    cb && cb(ret);
                } else {
                    // amGloble.msg("哎呀，出错了！");
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.getShiftData(data,cb);
                    }, function() {
                        $.am.changePage(amGloble.page.dashboard,'slidedown');
                    });
                    // _this.setStatus("error");
                }
            });
        },
        getShopShiftSetting: function (cb) { // 获取门店班次设置信息
            var _this = this;
            var shopid = self.shopId;
            var map = this.shopSettingMap;
            this.getShiftData({
                shopId: shopid
            }, function (ret) {
                _this.shopSettingMap[shopid] = ret.content;
                cb && cb(ret.content);
            });
            // if (map[shopid]) {
            //     cb && cb(map[shopid]);
            // } else {
            //     this.getShiftData({
            //         shopId: shopid
            //     }, function (ret) {
            //         _this.shopSettingMap[shopid] = ret.content;
            //         cb && cb(ret.content);
            //     });
            // }
        },
        getCurrentShop: function () { // 通过门店选择器获取门店信息
            // var shop = amGloble.storeSelect.getCurrentShops();
            var shop = self.shopId;
            if (!shop) {
                //如果当前没有选择问题
                shop = amGloble.metadata.userInfo.shopId;
                var shopMap = amGloble.metadata.shopMap;
                var shopName = shopMap[shop] ? shopMap[shop].shopFullName : '';

                this.$header.find('.title').removeClass("disable-icon");
                if(amGloble.metadata.allShops.length==1 || amGloble.metadata.userInfo.shopType != 0){
                    this.$header.find('.title').addClass("disable-icon");
                }

                this.$header.find('.title .text').html(shopName)
            }
            if (shop) {
                //单个门店
                shop = [{shopId: shop}];
            } else {
				//多门店
				var filterShopList = [];
				$.each(amGloble.metadata.shops, function(index, item) {
					if (item.mgjversion == 3) {
						filterShopList.push(item);
					}
				})
				shop = filterShopList;
                // shop = amGloble.metadata.shops.filter(function (item) {
                //     return item.mgjversion == 3;
                // });
            };
            self.shopId = shop[0].shopId;
        }
    });
})();