(function () {
    var timeController=$.am.timeController = {
        getRoundTime:function(time){
            //获取某一天内的随机时间
            var t1 = new Date(time);
            var t2 = new Date(time);
            t1.setHours(this.getNumber(24));
            t1.setMinutes(this.getNumber(60));
            t1.setSeconds(this.getNumber(60));
            t2.setHours(this.getNumber(24));
            t2.setMinutes(this.getNumber(60));
            t2.setSeconds(this.getNumber(60));
            var res = [new Date(t1).getTime(),new Date(t2).getTime()];
            res.sort(function(a,b){
                return a-b
            });
            return res;
        },
        getNormalTime:function(time,t1,t2,status,workStatus){
            var d = new Date(time);
            var s1,s2,t3,t4;
            s1 = t1.split(":");
            s2 = t2.split(":");
            t3 = new Date(time);
            t4 = new Date(time);
            if(workStatus==0){
                t3.setHours(Number(s1[0])-1);
                t4.setHours(Number(s2[0])+1);
            }else if(workStatus==1){//迟到
                t3.setHours(Number(s1[0])+1);
                t4.setHours(Number(s2[0])+1);
            }else if(workStatus==2){//早退
                t3.setHours(s1[0]-1);
                t4.setHours(s2[0]-1);
            }else{//迟到+早退
                t3.setHours(Number(s1[0])+1);
                t4.setHours(s2[0]-1);
            }
            t3.setMinutes(this.getNumber(60));
            t3.setSeconds(this.getNumber(60));
            t4.setMinutes(this.getNumber(60));
            t4.setSeconds(this.getNumber(60));
            if(status==1){//异常
                t4.setHours(s2[0]+10);
            }
            var res = [new Date(t3).getTime(),new Date(t4).getTime()];
            res.sort(function(a,b){
                return a-b
            });
            return res;
        },
        getNumber:function(number){
            return Math.floor(Math.random()*number);
        },
        getRoundData:function(time){
            //获取随机数据
            var msName = ["早班","中班","晚班"];
            var times  = this.getRoundTime(time); 
            var res = {
                "employeeId": 16890,
                "name": "刀男",
            };
            res.msName = msName[this.getNumber(3)];
            res.employeeGoWorkTime = times[0];
            res.employeeOutWorkTime = times[1];
            res.status = this.getNumber(2);
            if(res.status==1){
                res.workStatus = this.getNumber(2);
            }else{
                res.workStatus = this.getNumber(4);
            }
            res.workTime = Math.floor(res.employeeOutWorkTime-res.employeeGoWorkTime)/(1000*60*60);
            res.remark   = (Math.random()-0.5)?"测试说明" + Math.random():"";
            return res;
        },
        getNormalData:function(time){
            //获取正常数据
            //Mock三个班次信息
            var shiftConfig = [{
                name:"早班",
                goWorkTime:"08:00",
                outWorkTime:"16:00"
            },{
                name:"中班",
                goWorkTime:"10:00",
                outWorkTime:"20:00"
            },{
                name:"晚班",
                goWorkTime:"15:00",
                outWorkTime:"23:00"
            }];
            var res = {
                "employeeId": 16890,
                "name": "刀男"
            };
            res.status = (Math.random()-0.8)>0?"1":"0";
            if(res.status==1){//异常
                res.workStatus = this.getNumber(2);
            }else{
                res.workStatus = this.getNumber(4);
            }
            var shift  = shiftConfig[this.getNumber(3)];
            var times  = this.getNormalTime(time,shift.goWorkTime,shift.outWorkTime,res.status,res.workStatus);
            res.msName = shift.name;
            res.employeeGoWorkTime = times[0];
            res.employeeOutWorkTime = times[1];
            
            res.workTime = Math.floor(res.employeeOutWorkTime-res.employeeGoWorkTime)/(1000*60*60);
            res.remark   = Math.random()>0.5?((Math.random()-0.5)?"测试说明" + Math.random():""):"";
            return res;
        },
        spliceArr:function(list){
            var temp = list;
            var num = this.getNumber(10);
            for(var i=0;i<num;i++){
                temp.splice(this.getNumber(temp.length),1);
            }
            return temp;
        },
        getMockData: function (time,isNormal) {
            var res = [];
            var list = this.getTimeList(time);
            //随机剔除几个 造成未出勤
            list = this.spliceArr(list);
            //生成一个月的随机数据
            for(var i = 0;i<list.length;i++){
                if(isNormal){//正常数据
                    res.push(this.getNormalData(list[i].date));
                }else{//随机数据
                    res.push(this.getRoundData(list[i].date));
                }
            }
            return res;
        },
        getTotalDate: function (date) {
            var date = new Date(date);
            var year = date.getFullYear();
            var month = date.getMonth() + 1;
            var d = new Date(year, month, 0);
            return d.getDate();
        },
        complte: function (list) {
            var l = list.length;
            if (list && l) {
                var p1 = list.slice(0, 1);
                var p2 = list.slice(-1);
                Array.prototype.unshift.apply(list, new Array(p1[0].week));
                if (p2[0].week == 6 && l < 28) {
                    Array.prototype.push.apply(list, new Array(6));
                } else {
                    Array.prototype.push.apply(list, new Array(6 - p2[0].week));
                }
            }
            return list;
        },
        getTimeList: function (date) {//一个月的数据
            var res = [];
            var total = this.getTotalDate(date);
            for (var i = 1; i <= total; i++) {
                var ret = {};
                var d = new Date(new Date(date).setDate(i));
                ret.number = i;
                ret.week = d.getDay();
                ret.date = d.getTime();
                var weeks=['日','一','二','三','四','五','六'];
                ret.realWeek=weeks[ret.week];
                res.push(ret);
            }
            return res;
        }
    }
    amGloble.page.attendanceRecord = new $.am.Page({
        id: "page-attendanceRecord",
        backButtonOnclick : function() {
            try{
                window.plugins.actionsheet.hide();
                atMobile.nativeUIWidget.hidePopupMenu();
            }catch(e){
                $.am.debug.log(e.message);
                atMobile.nativeUIWidget.hidePopupMenu();
            }
            var _this=this;
            if(_this.modified){
                $.am.page.back("slideright",{modified:_this.modified});
            }else{
                $.am.page.back();
            }
		},
        init: function () {
            var _this = this;

            this.showEmployeeMap = {};

            this.isMock = false;//是否开启mock数据

            this.$recordMain = this.$.find(".recordMain");
            this.$recordcontent = this.$.find(".recordcontent");
            this.$item = this.$recordcontent.find(".item:first").remove();
            this.reportFilter = new amGloble.ReportFilter({
                $: this.$.find(".am-body-wrap"), //选择器的dom将插入到此节点后面
                onchange: function () { //条件修改时触发
                    var val = new Date(_this.reportFilter.getDate());
                    _this.getData(function (content) {
                        _this.render(content);
                    });
                },
                refreshEmp:function(){
                    _this.getEmps(function(emp){
                        _this.reportFilter.refreshEmps(emp);
                    });
                    
                }
            });

            this.attendanceOperate = new amGloble.attendanceOperate({
                target: this.$,
                success:function(){
                    _this.getData(function (content) {
                        _this.render(content);
                        _this.modified=true;
                    });
                },
                close:function(){
                    _this.$recordcontent.find(".item").removeClass("active");
                }
            });
            this.$recordcontent.on("vclick", ".item:not(.visibility)", function (e) {
				e.preventDefault();
				var data = $(this).data("item");
                data = _this.addParams(data);
				if(data.isEmpty) return;//空格子 以及还没到的日子
                if(data && data.status != undefined && data.status!=3){
                    if (!$(this).hasClass("unoperate")) {
                        if (_this.paras && _this.paras.isManage) {
                            if(!_this.checkIsAllow()){
                                amGloble.msg("您没有权限修改考勤记录！");
                                return;
                            }
                            $(this).addClass("active");
                            _this.attendanceOperate.show(data);
                        } else {
                            $.am.changePage(amGloble.page.editException, "slideleft", data);
                        }
                    }
                }else{//未出勤
                    if (_this.paras && _this.paras.isManage) {
                        if(!_this.checkIsAllow()){
                            amGloble.msg("您没有权限修改考勤记录！");
                            return;
                        }
                        $(this).addClass("active");
                        _this.attendanceOperate.show(data);
                    }else{//员工未出勤
                        if(!data.isEmpty){
                            data.status = 3;
                            data.workStatus = 0; 
                            $.am.changePage(amGloble.page.editException, "slideleft", data);
                        }
                        
                    }
                }
            });
            this.$.on("vclick", ".am-page-error .button-common", function () {
                window.offlineAttendance.syncData(function() {
                    _this.getData(function (content) {
                        _this.render(content);
                    });
                })
            }).on("vclick",".unbundling",function(){
                amGloble.confirm("提示", "此操作将会解绑员工账号与设备的绑定，确定要解绑吗？", "确定", "取消", function() {
                    _this.unbundling({
                        shopId:_this.paras.shopId,   
						pushToken:_this.paras.pushToken,
						mobile: _this.mobileNumber,
                    },function(){
                        $("#page-attendanceRecord .am-header .unbundling").hide();
                        amGloble.msg("操作成功！");
                    });
                }, function() {});
            }).on("vclick",".sign",function(){
                try{
                    cordova.plugins.barcodeScanner.scan(function (result) {
                        $.am.debug.log("扫码结果：" + JSON.stringify(result));
                        $.am.debug.log("扫码text：" + result.text);
                        var text = result.text;
                        if (text) {
                            try {
                                text = JSON.parse(text);
                            } catch (e) {
                                $.am.debug.log("error：" + e.message);
                            }
                        }
                        if(typeof text == 'string'){
                            var arr = text.split('_');
                            if(arr[0]=='*'){
                                var obj = {
                                    type: 'attendance',
                                    createTime: arr[1],
                                    shopId: arr[2],
                                    timeDifference: arr[3]
                                }
                                $.am.debug.log("进入考勤逻辑！");
                                amGloble.page.dashboard.userAttendance(obj,function(){
                                    _this.getData(function (content) {
                                        _this.render(content);
                                        _this.modified=true;
                                    });
                                });
                            }
                        }else if ($.isPlainObject(text) && text.type == "attendance") {
                            $.am.debug.log("进入考勤逻辑！");
                            amGloble.page.dashboard.userAttendance(text,function(){
                                _this.getData(function (content) {
                                    _this.render(content);
                                    _this.modified=true;
                                });
                            });
                        }else{
                            amGloble.msg("请扫描考勤二维码！");
                        }
                    });
                }catch(e){

                }
            });
        },
        unbundling:function(data,cb){
            amGloble.loading.show("正在加载,请稍候...");
            amGloble.api['cleanPushToken'].exec(data, function (ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    cb && cb(ret.content);
                } else {
                    amGloble.msg(ret.message || "网络请求出错，请稍后重试！");
                }

            });
        },
        checkIsAllow:function(){
            var optstr = amGloble.metadata.userInfo.operatestr;
            if(optstr){
                if(optstr.indexOf("V2")!=-1){
                    return false;
                }else{
                    return true;
                }
            }else{
                return true;
            }
            
        },
        getDutyName:function(dutyId){
            var employeeLevels = amGloble.metadata.employeeLevels;
            for(var i=0;i<employeeLevels.length;i++){
              var item = employeeLevels[i];
              if(item.dutyId==dutyId){
                return item.name;
              }
            }
            return "";
        },
        getEmps:function(cb){
            var _this  = this;
            var shopId = this.getCurrentShopId();
            var realParentShopId = amGloble.metadata.userInfo.realParentShopId;
            if(!this.showEmployeeMap[shopId]){
                this.getlistEmployee(shopId,function(list){
                    var res = [];
                    for(var i=0;i<list.length;i++){
                        var item = list[i];
                        var ret  = {};
                        ret.name = item.name;

                        if (shopId == realParentShopId && [2, 3].indexOf(Number(item.roleType)) == -1) {
                            continue;
                        }

                        if(item.dutyId || item.roleType){
                            var dutyName = _this.getDutyName(item.dutyId);
                            if (item.roleType && item.roleType<4) {
                                ret.roleType = 0
                            } else {
                                ret.roleType = 1
                            }
                            if(dutyName){
                                ret.vname = dutyName + " - " + item.name;
                            }else{
                                var nameMap = ['','操作员 - ','管理员 - ','老板 - '];
                                if(item.roleType && item.roleType<4){
                                    ret.vname= nameMap[item.roleType] + item.name;
                                } else{
                                    ret.vname= item.name;
                                }
                            }
                        }else{
                            ret.vname= item.name;
                        }
                        ret.empid= item.employeeId;
                        res.push(ret);
                    }
                    _this.showEmployeeMap[shopId] = res;
                    cb && cb(res); 
                });
            }else{
                cb && cb(this.showEmployeeMap[shopId]);
            }
        },
        addParams:function(data){//弹框需要新加数据过去
            var res = data;
            if(this.paras && this.paras.isManage){
                var empdata = this.reportFilter.getEmp();
                
                if (empdata) {
                    res.employeeId = empdata.employeeId || empdata.empid;
                    res.name       = empdata.name || empdata.empname;
                } else {
                    res.employeeId = this.paras.employeeId;
                    res.name       = this.paras.name;
                }
                res.searchTime = this.getSearchTime(data);
                res.shopId     = this.paras.shopId;
                res.roleType = empdata.roleType
                
            }else{//编辑备注
                res.employeeId = amGloble.metadata.userInfo.userId;
                res.shopId     = amGloble.metadata.userInfo.shopId;
                res.name       = amGloble.metadata.userInfo.userName;
				res.remark     = data.remark;
                res.roleType   = amGloble.metadata.userInfo.userType;
                if(data.isEmpty){
                    res.isEmpty = data.isEmpty;
                }
            }
            return res;
        },
        getSearchTime:function(data){
            //获取点击的块的时间
            var number = data.number;
            var filter = this.reportFilter.getValue();
            var range = filter.range;
            var period = this.getPeriod(range);
            var t = period.split("_");
            var d = new Date(Number(t[0]));
            d.setDate(number);
            return d.getTime();
        },
        beforeShow:function (paras) {
            this.modified=false;
            if(paras && paras=='back'){
                return;
            }
            this.$recordcontent.empty();
            if(paras.isManage && paras.pushToken){
                this.$.find(".unbundling").show();
            }else{
                this.$.find(".unbundling").hide();
            }
            if(paras.isManage){
                this.$header.find(".text").html(paras.name + "的考勤记录");
                this.$header.find(".sign").hide();
            }else{
                this.$header.find(".text").html("考勤记录");
                this.$header.find(".sign").show();
            }
            this.paras = paras;
            var _this = this;
            var opt = {
                datePickerType: 'ym',
                showEmployeeLevel:true
            };
            if (paras && paras.employeeId) {
                opt.enableEmp = true;
            }else{
                opt.enableEmp = false;
            }
            if(paras.date){
                // 排班进来渲染对应员工对应月份的考勤信息
                opt.start = new Date(paras.date);
                opt.end = paras.date;
			}
            this.reportFilter.setOpt(opt);
            if (paras && paras.employeeId) {
                this.reportFilter.setEmp(paras);
            }else{
                window.offlineAttendance.syncData(function() {
                    _this.getData(function (content) {
                        _this.render(content);
                    });
                });
            }
            
        },
        getCurrentShopId:function(){
            var shopId = amGloble.metadata.userInfo.shopId;
            if(this.paras && this.paras.shopId){
                shopId = this.paras.shopId;
            }
            return shopId;
        },
        afterShow: function () {
            //this.getlistEmployee();
        },
        beforeHide: function () { },
        getlistEmployee:function(shopId,cb){
            var _this=this;
            //amGloble.loading.show("正在加载,请稍候...");
            amGloble.api['listEmployee'].exec({
                shopId:shopId
            }, function (ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    _this.setStatus("normal");
                    cb && cb(ret.content);
                } else {
                    _this.setStatus("error");
                }

            });
        },
        getRenderStatus:function(item){
            //获取render状态
            var res = {
                _class:"",//最终class
                status:null,//左上角标
                remark:0,//0不显示 1灰色 2亮色 右上角标
                fontColor:[null,null],//blue orange red 下方时间的颜色
                isEmpty:true//是否是空格子
            }
            if(!item){
                res.isEmpty = true;
            }else{
                res.isEmpty = false;
                var data    = item.data;
                var isToDay = new Date(item.date).format("yyyy/mm/dd") === new Date().format("yyyy/mm/dd");
                if(data){//有考勤数据
                    //if(data.status!="0" || data.workStatus!="0") 
                    if(data.remark) res.remark = 2;
                }else{//没有考勤数据

                }
            }

        },
        renderShift: function (arr) {
			var _this=this;
            if(arr && arr.length>0){
                var obj = {};
                $.each(arr, function (i, v) {
                    if(v.shiftName){
                        obj[parseInt(v.shiftDate.substring(8))] = v.shiftName.substring(0, 1);
                    }
                });
                var $p = $('.recordcontent').find('.p1');
                $.each($p,function(i,v){
                    var $p2=$(v).next('.p2');
                    var $item=$(v).parents('.item');
                    var $p3=$item.find('.p3'),
                        $p4=$item.find('.p4');
                    if(obj[$(v).text()]){
                        // 有排班
                        $p2.text(obj[$(v).text()]).show().css('color','#222'); // 渲染班次

                        if($item.hasClass('selected')){
                            // 今日 
                            if(obj[$(v).text()]=='休'){ // 休 白字黄底
                                $p2.addClass('selected orange');
                                $(v).addClass('orange');
                            }else{
                                // 其他班次白色显示
                                $p2.addClass('selected');
                            }
                        }else if($item.hasClass('past')){
                            // 以前
                            if(!$item.find('.p3').find('span').text() && !$item.find('.p4').find('span').text() && ($item.find('.p2').text()!='休') ){
                                // 未出勤
                                $item.addClass('absent');
                                $item.find('.p3').find('span').text('未出勤');
                            }else{
                                // $item.removeClass('absent');
                                // $item.find('.p3').find('span').text('')
                            }
                        }else {
                            // 以后
                        }
                        if($p2.text()=='休' && (!$item.hasClass('selected'))){
                            $p2.addClass('orange');
                            $(v).addClass('orange');
                        }else{
                            // 其他排班
                        }
                    }else{
                        // 未排班
                    }
                    //未排班  休 
                    if(!$p2.text()||($p2.text()=='休')){
                        $item.find('.item-operate.icon-bianji1').hide();
                    }
                    // 今天 未打卡
                    if($item.hasClass('selected')&&!$p3.text().trim()&&!$p4.text().trim()){
                        $item.find('.item-operate.icon-bianji1').hide();
                    }
                    if(_this.paras.isManage){
                    // 管理者进来
                    }else{
                        if($item.hasClass('absent')){
                            $item.find('.item-operate.icon-bianji1').show();
                        }
                    }
				});
            }else{
				this.$recordcontent.children('.item').find('.item-status, .item-operate').hide({
					duration: 0
				});
			}
			_this.setStatus('normal');
        },
        // 调排班接口 渲染排班信息
        getShiftInfo:function(cb){
            var _this=this;
            var data=_this.getSearchData();
            var period=new Date(parseInt(data.period.split('_')[0])).format('yyyy-mm');
            var opt={
                period:period,
                shopId:data.shopId,
                parentShopId:amGloble.metadata.userInfo.parentShopId,
                employeeIds:[data.employeeId]
            };
            amGloble.api.shiftsList.exec(opt, function (ret) {
                    amGloble.loading.hide();
                    if (ret.code == 0 && ret.content) {
						_this.mobileNumber = ret.content[0].mobile;
                        _this.renderShift(ret.content[0] && ret.content[0].scheduleShift);
                    } else {
                        // _this.setStatus("error");
                    }
            });
        },
        render: function (list) {
			this.setStatus('loading');
            this.$recordcontent.empty();
            var timeList = timeController.getTimeList(this.reportFilter.getDate());
            timeList = this.extendData(timeList, list);//补全dom数据
            timeList = timeController.complte(timeList);//补全空格
            var searchData = this.getSearchData();
            
            if(this.$header.find(".text").html().length>4) {
                this.$header.find(".text").html($('.emps').text() + "的考勤记录");
            }else {}
         
            for (var i = 0; i < timeList.length; i++) {
                var item = timeList[i],
                    $item = this.$item.clone(true, true);
                var isEmpty = false;
                //var renderStatus = this.getRenderStatus();
                
                if (!item) {//为null的空格子
                    // $item.find(".item-status").hide();
                    // $item.find(".item-operate").hide();
                    // $item.find(".item-content").hide();
					// $item.css('visibility', 'hidden');
					$item.addClass('visibility');
                } else {

					var data = item.data;
                    var isToDay = new Date(item.date).format("yyyy/mm/dd") == new Date().format("yyyy/mm/dd");
                    if(data && data.remark){
                        $item.find(".item-operate").addClass("selected").removeClass('icon-bianji1').addClass('icon-xinxi');
                    }
                    $item.removeClass('visibility').find(".item-content .p1").html(item.number);
                    if (isToDay) {//今天
                        $item.addClass("selected");
                    }
                    var isPast = new Date(item.date).format("yyyy/mm/dd") < new Date().format("yyyy/mm/dd");
                    if (isPast) {//以前
                        $item.addClass("past");
                    }
                    var isFuture = new Date(item.date).format("yyyy/mm/dd") > new Date().format("yyyy/mm/dd");
                    if (isFuture) {//以后
                        $item.addClass("future");
                    }
                    if (item.data && data.employeeGoWorkTime) {//有考勤数据
                        //"status"   // 异常状态 0：正常 1：异常
                        //"workStatus // 工作状态 0：正常 1：迟到 2：早退
 
                        $item.find(".p2").html((data.msName && data.msName.substring(0,1))|| '');
                        if (data.status == 0 || data.status == 3) {//正常
                            $item.find(".item-status").hide();
                        } else {//异常
                            // $item.find(".item-status .item-status1").html("异常").addClass("red").show();
                            $item.find(".item-status .item-status2").hide();
                            $item.find(".item-operate").show();
                            $item.addClass('unUnsual');
                            $item.find(".p4").addClass("red");
                        }
                        if (data.workStatus == 0) {//工作状态
                            if (data.status == 0) {//并且非异常
                                $item.find(".item-status").hide();
                                $item.find(".item-operate").hide();
                            }
                        } else {//迟到或者早退
                            $item.find(".item-status").hide();// 拿掉迟到早退异常
                            $item.find(".item-status").show();
                            if (data.status != 0) {//异常 只能迟到
                                $item.addClass('late-early')
                                // $item.find(".item-status .item-status2").html("迟到").show();
                                $item.find(".p3").addClass("blue");
                            } else {//非异常
                                if (data.workStatus == 1) {
                                    $item.addClass('late-early')
                                    // $item.find(".item-status .item-status1").html("迟到").show();
                                    $item.find(".p3").addClass("blue");
                                }
                                if (data.workStatus == 2) {
                                    $item.addClass('late-early')
                                    // $item.find(".item-status .item-status1").html("早退").show();
                                    $item.find(".p4").addClass("blue");
                                }
                                if (data.workStatus == 3) {
                                    $item.addClass('late-early')
                                    // $item.find(".item-status .item-status1").html("早退").show();
                                    // $item.find(".item-status .item-status2").html("迟到").show();
                                    $item.find(".p3").addClass("blue");
                                    $item.find(".p4").addClass("blue");
                                }
                            }
                        }
                        if (data.offlineGoWork) {
                            $item.find(".p3").addClass('offline')
                        }
                        if (data.offlineOutWork) {
                            $item.find(".p4").addClass('offline')
                        }

                        if (data.employeeGoWorkTime) {
                            $item.find(".p3 span").html(new Date(data.employeeGoWorkTime).format("HH:MM"));
                        } else {
                            $item.find(".p3 span").html(" - : - ");
                        }
                        if (data.employeeOutWorkTime) {//打了下班卡
                            $item.find(".p4 span").html(new Date(data.employeeOutWorkTime).format("HH:MM"));
                        } else {//没打下班卡
                            if (new Date(item.date).format("yyyy/mm/dd") == new Date().format("yyyy/mm/dd")) {//今天 工作中
                                $item.find(".p4 span").html("工作中");
                            }
                            else{
                                $item.find(".p4 span").html("工作中");
                            }
                        }
                    } else {//没有考勤数据
						$item.find(".item-status").hide();
                        $item.find(".item-operate").hide();
                        if (item.date < new Date().getTime()) {//今天以前的
                            // $item.find(".p2").html("未出勤");
                            // $item.addClass('absent');
                            $item.find(".p3 span,.p4 span").html("");
                            $item.addClass("outwork");
                            $item.find(".item-operate").show();
                            if(item.data && data.status==3 && data.remark){
                                $item.find(".item-operate").addClass("selected").show();
                            }
                        } else {
                            var isEmpty = true;
                            
                            //$item.addClass("unoperate");
                            $item.find(".item-operate").hide();
                            $item.find(".p2,.p3,.p4").hide();
                        }
                    }
                    if(this.paras.isManage){//管理员不需要显示
                        var $noteIcon=$item.find(".item-operate");
                        if($noteIcon.hasClass('icon-bianji1')){
                            $noteIcon.hide();
                        }else{
                            $noteIcon.show();
                        }
                        // $item.find(".item-operate").hide();
                    }
                    $item.data("index",item.number);
                    var saveData = data || {};
                    saveData.number = item.number;
                    saveData.searchTime = searchData.period.split("_").shift();
                
                    if(isEmpty){
                        saveData.isEmpty = isEmpty;
                    }
                    $item.data("item", saveData);
                }
                this.$recordcontent.append($item);

            }

            this.getShiftInfo();
        },
        getSearchData: function () {
            var filter = this.reportFilter.getValue();
            var range = filter.range;
            var period = this.getPeriod(range);
            var res = {
                shopId: amGloble.metadata.userInfo.shopId,
                employeeId: amGloble.metadata.userInfo.userId,
				period: period,
				roleType: amGloble.metadata.userInfo.userType
            }
            if (this.paras && this.paras.shopId) {
                res.shopId = this.paras.shopId;
            }
            if (this.paras && this.paras.employeeId) {
                var empdata = this.reportFilter.getEmp();
                if (empdata) {
                    res.employeeId = empdata.employeeId || empdata.empid;
					res.roleType = empdata.roleType;
                } else {
                    res.employeeId = this.paras.employeeId;
					res.roleType = this.paras.roleType;
                }

            }
            return res;
            
        },
        getPeriod: function (range) {
            var date = new Date(range);
            var date1 = new Date(date.setDate(1));
            var date2 = new Date(date.setDate(timeController.getTotalDate(date)));
            date1.setHours(0);
            date1.setMinutes(0);
            date1.setSeconds(0);
            date2.setHours(0);
            date2.setMinutes(0);
            date2.setSeconds(0);
            return date1.getTime() + "_" + (date2.getTime() + 86400000 - 1);
        },
        extendData: function (data, list) {
            if (list && list.length) {
                for (var i = 0; i < list.length; i++) {
                    var item = list[i];
                    if (item.status!=3) {
						if(item.employeeGoWorkTime){
							var d = new Date(item.employeeGoWorkTime).getDate();
							data[d - 1].data = list[i];
						}
                    }else{
						var d = "";
						if(item.employeeGoWorkTime){
							d = new Date(item.employeeGoWorkTime).getDate();
						}else{
							d = new Date(item.workdate).getDate();
						}
                        if(data[d - 1].data){
                            if(list[i].remark){
                                data[d - 1].data.remark = list[i].remark;
                            }
                        }else {
                            data[d - 1].data = list[i];
                        }
					}
                }
            }
            return data;
        },
        getData: function (cb) {
            var _this = this;
			var data = this.getSearchData();
            //amGloble.loading.show("正在加载,请稍候...");
            _this.setStatus("loading");
            if (this.isMock) {
                _this.setStatus("normal");
                var filter = this.reportFilter.getValue();
                var range = filter.range;
                cb && cb(timeController.getMockData(range,true));
            } else {
                amGloble.api['employeeRecord'].exec(data, function (ret) { 
                    amGloble.loading.hide();
                    if (ret.code == 0) {
                        _this.setStatus("normal");
                        cb && cb(ret.content);
                    } else {
                        _this.setStatus("error");
                    }

                });
            }
        },
        setStatus:function(status){
            var $page=this.$.removeClass("am-status-loading am-status-error am-status-empty");
            switch(status) {
				case "loading":
					//amGloble.loading.show();
					$page.addClass("am-status-loading");
					break;
				case "error":
					amGloble.loading.hide();
					$page.addClass("am-status-error");
					break;
				case "empty":
					amGloble.loading.hide();
					$page.addClass("am-status-empty");
					break;
				case "normal":
					amGloble.loading.hide();
				default:

			}
        }
    });
})();
