(function(){
    var self = amGloble.page.audit = new $.am.Page({
        id: 'page-audit',
        init:function(){
            var self = this;
            this.$tab = this.$.find('.tab').on('vclick','li',function(){
                $(this).addClass('selected').siblings().removeClass('selected');
                self.type = $(this).data('type');
                self.getDate();
			});

			this.$header.find('.title').vclick(function(){
                if(amGloble.metadata.allShops.length==1){
                    return;
                }
                var _this = $(this);
                amGloble.allShops.show({
                    target: _this,
                    showManaged : true,
                    callback:function(data){
                        if(self.shopId==data.shopId){
                            return;
						}
                        _this.find('.text').html(data.shopFullName);
						self.shopId = data.shopId;
						self.softgenre = data.softgenre
						self.getDate();
                    }
                });
            });

            this.reportFilter = new amGloble.ReportFilter({
                $: this.$.find('.am-body-wrap'),
                onchange: function() {
                    self.getPeriod(self.reportFilter.getDate());
                    self.getDate();
                }
            });
            this.sv_tab = new $.am.ScrollView({
                $wrap: this.$tab,
                $inner: this.$tab.find('ul'),
                direction: [1, 0]
			});

			this.$tableLScroll = new $.am.ScrollView({
				$wrap: self.$.find('.table-l'),
				$inner: self.$.find('.table-l .wrapper'),
				direction: [1, 1],
				_onupdate: function (pos) {
					var x = pos[0];
					var y = pos[1];
					var y1 = y > 0 ? y : 0;
					var y2 = y > 0 ? 0 : y;
					self.$.find(".table-t").setTransformPos([x, y1], "xy", this.hasInput);
					self.$.find(".table-head .wrapper").setTransformPos([x, y1], "xy", this.hasInput);
					self.$.find('.form .wrapper').setTransformPos([x, y], "xy", this.hasInput);
					self.$.find(".table-l").setTransformPos([x, y1], "xy", this.hasInput);
					self.$.find(".table-l .wrapper").setTransformPos(y2, "y", this.hasInput);
				}
			});

			this.$formScroll = new $.am.ScrollView({
				$wrap: self.$.find('.form'),
				$inner: self.$.find('.form .wrapper'),
				direction: [1, 1],
				_onupdate: function (pos) {
					var x = pos[0];
					var y = pos[1];
					var x1 = x > 0 ? x : 0;
					var y1 = y > 0 ? y : 0;
					this.$inner.setTransformPos(pos, "xy", this.hasInput);
					//姓名
					self.$.find(".table-t").setTransformPos([x1, y1], "xy", this.hasInput);
					//姓名以外的头部
					self.$.find(".table-head .wrapper").setTransformPos([x, y1], "xy", this.hasInput);
					//左侧姓名td栏
					self.$.find(".table-l").setTransformPos(x1, "x", this.hasInput);
					//左侧姓名下td栏内部,固定跟随整体一起
					self.$.find(".table-l .wrapper").setTransformPos(y, "y", this.hasInput);
				}
			});

			this.$tableHScroll = new $.am.ScrollView({
				$wrap: self.$.find('.table-head'),
				$inner: self.$.find(".table-head .wrapper"),
				direction: [1, 1],
				_onupdate: function (pos) {
					var y = pos[1];
					this.$inner.setTransformPos(pos, "xy", this.hasInput);
					self.$.find(".table-t").setTransformPos(y, "y", this.hasInput);
					self.$.find(".table-l").setTransformPos(y, "y", this.hasInput);
					self.$.find('.form .wrapper').setTransformPos(pos, "xy", this.hasInput);
				}
			});

            this.loading = this.$.find('.loadingContent');
            this.empty = this.$.find('.error');
            this.reload = this.$.find('.reload').on('vclick','.button-common',function(){
                self.getDate();
            });
            this.$summary = this.$.find('.summary');
            this.$summaryItem = this.$summary.find('.wrap').remove();
			this.$form = this.$.find('.form .wrapper');
			this.$tableL = this.$.find(".table-l .wrapper");
        },
        backButtonOnclick:function(){
            $('.mbsc-fr-btn-c div').trigger('click');
            $.am.page.back();
        },
        checkUserRole: function () { 
            amGloble.page.rankinglist.checkUserRole.call(this);
        },
        checkTitleIcon: function(){
            if (this.userRole !== 0) {
                this.$header.find('.title').removeClass("am-clickable");
            } else { 
                this.$header.find('.title').addClass("am-clickable");
            }
        },
        beforeShow:function(paras){
            this.checkUserRole();
            this.checkTitleIcon();
            if (amGloble.metadata.userInfo.mgjVersion == 6) {
                this.$tab.find('li[data-type="invention"]').hide();
                this.$tab.find('li[data-type="topic"]').hide();
            }
            var user = amGloble.metadata.userInfo;
			if(!this.shopId || (user.newRole !== 3 && user.shopId !== this.shopId)){
                var name = (!user.osName || user.osName==' ' || user.osName=='')?user.shopName:user.osName;
                this.$header.find('.title .text').html(name);
				this.shopId = user.shopId;
				// 查看门店类型，接口需要在总部时多传递一个参数
				var allShops = amGloble.metadata.allShops;
				for (var i = 0; i < allShops.length; i++) {
					var currentShop = allShops[i];
					if (currentShop.shopId == this.shopId) {
						self.softgenre = currentShop.softgenre;
						break;
					}
				}
            }
            this.refresh = true;
            if(paras=='back'){
                this.refresh = false;
                return;
            }
            if(!this.hasSetTab){
                var ws = [0];
                var w = 0;
                var tabLis = this.$tab.find('li');
                for(var i=0;i<tabLis.length;i++){
                    ws.push($(tabLis[i]).outerWidth());
                    w += $(tabLis[i]).outerWidth();
                }
                for(var i=0;i<tabLis.length;i++){
                    var l = 0;
                    for(var j=0;j<=i;j++){
                        l += ws[j];
                    }
                    $(tabLis[i]).css('left',l+'px');
                }
                this.$tab.find('ul').css('width',w+'px');
                this.sv_tab.refresh();
                this.hasSetTab = 1;
            }

            amGloble.storeSelect.onShopChange = function (shops) {
                self.getDate();
            };
            var start;
            var now = new Date(),
				m = now.getMonth();
				d = now.getDate();

            if (amGloble.metadata.userInfo.newRole == 1) {
                now.setDate(d-1);
            } else {
				now.setMonth(m-1);
				if (m === 2 && d > 29) {
					now.setDate(1);
				}
			}
            start = now;
            this.reportFilter.setOpt({
                start: start,
                end: new Date(),
                refresh: self.refresh
			});

            this.getPeriod(this.reportFilter.getDate());

            this.$tab.find('.selected').trigger('vclick');
        },
        afterShow:function(){

        },
        beforeHide:function(){

        },
        afterHide:function(){

        },
        getPeriod:function(arr){
            var start = arr[0],end = arr[1];
            var period = new Date(start).format('yyyy-mm-dd')+'_'+new Date(end).format('yyyy-mm-dd');
            this.period = period;
        },
        getDate:function(){
            if(this.api){
                this.api.abort();
            }
            var self = this;
            if(!self.topLoading){
                self.loading.show();
			}
			this.$.find(".table-t").hide();
			this.$.find(".table-l").hide();
            self.empty.hide();
            self.reload.hide();
            self.$form.empty();
			self.$summary.empty();
			self.$.find(".table-head .wrapper").empty();

            // var shop = amGloble.storeSelect.getCurrentShops();
            // if(!shop){
            //     //如果当前没有选择问题，选择第一个
            //     amGloble.storeSelect.selectShop(0, true);
            //     shop = amGloble.storeSelect.getCurrentShops();
            // }
            // if (shop) {
            //     //单个门店
            //     shop = [shop];
            // } else {

            //     //多门店
            //     shop = amGloble.metadata.shops.filter(function (item) {
            //         return item.mgjversion == 3;
            //     });
            // };
			// this.shopId = shop[0].shopId;
			var postData = {
				shopid: self.shopId,
                period: self.period
			}
			if (self.softgenre === 0) {
				postData.status = 1;
			}
			// 接口 “/workingaudit/achives” 单独设置超时时间
			var ajaxTimeout = self.type === 'archives' ? 5 * 60 * 1000 : undefined;
            this.api = amGloble.api['audit_'+self.type].exec(postData, function (ret) {
                self.loading.hide();
                amGloble.loading.hide();
                self.closeTopLoading();
				self.topLoading = false;
				self.$.find(".table-t").show();
				self.$.find(".table-l").show();
                if (ret && ret.code == 0 && ret.content ) {
                    self.render(ret.content);
                }else {
                    self.reload.show();
                    self.$form.empty();
                    self.$summary.empty();
                }
			}, false, ajaxTimeout);
        },
        render:function(data){
			this.$tableL.html("");
            if(data.length){
				this.empty.hide();
				this.$.find(".table-t").show();
				this.$.find(".table").removeClass("act");
                if(this.type=='archives'){
					this.renderArchives(data);
				}else if(this.type=='todolist'){
                    this.renderTodolist(data);
					this.$.find(".table").addClass("act");
				}else if(this.type=='reservation'){
						this.renderReservation(data);
					this.$.find(".table").addClass("act");
				}else if(this.type=='invention'){
						this.renderInvention(data);
					this.$.find(".table").addClass("act");
				}else if(this.type=='topic'){
						this.renderTopic(data);
					this.$.find(".table").addClass("act");
				}
            }else {
                this.empty.show();
				this.$.find(".table-t").hide();
            }
		},
		scrollAll:function(){
			this.$formScroll.refresh();
			this.$formScroll.scrollTo("top");
			this.$tableLScroll.refresh();
			this.$tableLScroll.scrollTo("top");
			this.$tableHScroll.refresh();
			this.$tableHScroll.scrollTo("top");
		},
        renderArchives:function(data){
			var self = this;
			this.$tableL.show();
            var $header = $('<div class="item header">'+
                            '<div></div>'+
                            '<div>总管理客数</div>'+
                            '<div>消费周期完成数</div>'+
                            '<div>总档案数</div>'+
                            '<div>有档案客数</div>'+
                            '<div>期间服务客数</div>'+
                            '<div>期间新增档案数</div>'+
							'<div>期间顾客短信发送次数</div>'+
                            '<div>期间新增档案的顾客数</div>'+
                            '<div>期间设置闹钟数</div>' +
                        '</div>');
			this.$.find(".table-head .wrapper").css("width",700).html($header);

            var $list = $('<div class="list"></div>').on('vclick','.item .inacs',function(){
                var data = $(this).parent().data('data');
                data.shopId = self.shopId;
                data.time = self.reportFilter.getDate();
                $.am.changePage(amGloble.page.auditArchives,'slideleft',data);
            }).on('vclick','.item .smsnum',function(){
				var data = $(this).parent().data('data');
                data.shopId = data.SHOPID;
                data.time = self.reportFilter.getDate();
                $.am.changePage(amGloble.page.auditSms,'slideleft',data);
			});

            var CNT = 0,
            	MGJCONSUMEPERIOD = 0,
            	ACS = 0,
            	MEMAC = 0,
            	CST = 0,
            	INACS = 0,
				SMSNUM = 0,
                NMNUM = 0,
                WAKEUPCOUNT = 0;
			var h = data.length * 37 + 28;//计算滚动高度
            if ($('html').hasClass('iosX') || $('html').hasClass('iPhone12_1')) {
                h += 20;
            }
			this.$.find(".table").css("height",h);
			this.$form.css("width",700).append($list);

			var $name = $('<div class="list"></div>');
            this.$tableL.append($name);
            for (var i = 0; i < data.length; i++) {
            	var $item = $('<div class="item">' +
            		'<div></div>' +
            		'<div>' + (data[i].CNT || 0) + '</div>' +
            		'<div>' + (data[i].MGJCONSUMEPERIOD || 0) + '</div>' +
            		'<div>' + (data[i].ACS || 0) + '</div>' +
            		'<div>' + (data[i].MEMAC || 0) + '</div>' +
            		'<div>' + (data[i].CST || 0) + '</div>' +
            		'<div class="inacs am-clickable">' + (data[i].INACS || 0) + '</div>' +
					'<div class="smsnum am-clickable">' + (data[i].SMSNUM || 0) + '</div>' +
                    '<div>' + (data[i].NMNUM || 0) + '</div>' +
                    '<div>' + (data[i].WAKEUPCOUNT || 0) + '</div>'+
            		'</div>');
            	CNT += data[i].CNT;
            	MGJCONSUMEPERIOD += data[i].MGJCONSUMEPERIOD;
            	ACS += data[i].ACS;
            	MEMAC += data[i].MEMAC;
            	CST += data[i].CST;
            	INACS += data[i].INACS;
				SMSNUM += data[i].SMSNUM;
                NMNUM += data[i].NMNUM;
                WAKEUPCOUNT += data[i].WAKEUPCOUNT;
				$list.append($item.data('data', data[i]));
				$name.append('<div class="item"><div>'+(data[i].NAME || "")+'</div></div>');
			}

			//上方信息列
            var $CNT = this.$summaryItem.clone();
            $CNT.find('.num').html(CNT).end().find('.tip').html('总管理客数(总)').end().find('.icon').addClass('archives_CNT');
            this.$summary.append($CNT);

            var $MGJCONSUMEPERIOD = this.$summaryItem.clone();
            $MGJCONSUMEPERIOD.find('.num').html(MGJCONSUMEPERIOD).end().find('.tip').html('消费周期完成数(总)').end().find('.icon').addClass('MGJCONSUMEPERIOD');
			this.$summary.append($MGJCONSUMEPERIOD);

			var $ACS = this.$summaryItem.clone();
            $ACS.find('.num').html(ACS).end().find('.tip').html('总档案数(总)').end().find('.icon').addClass('archives_ACS');
			this.$summary.append($ACS);

			var $MEMAC = this.$summaryItem.clone();
            $MEMAC.find('.num').html(MEMAC).end().find('.tip').html('有档案客数(总)').end().find('.icon').addClass('archives_MEMAC');
			this.$summary.append($MEMAC);

			var $CST = this.$summaryItem.clone();
            $CST.find('.num').html(CST).end().find('.tip').html('期间服务客数(总)').end().find('.icon').addClass('archives_CST');
			this.$summary.append($CST);

			var $INACS = this.$summaryItem.clone();
            $INACS.find('.num').html(INACS).end().find('.tip').html('期间新增档案数(总)').end().find('.icon').addClass('archives_INACS');
			this.$summary.append($INACS);

			var $SMSNUM = this.$summaryItem.clone();
            $SMSNUM.find('.num').html(SMSNUM).end().find('.tip').html('期间顾客短信(总)').end().find('.icon').addClass('archives_SMSNUM');
			this.$summary.append($SMSNUM);

			var $NMNUM = this.$summaryItem.clone();
            $NMNUM.find('.num').html(NMNUM).end().find('.tip').html('期间新增档案的顾客数(总)').end().find('.icon').addClass('archives_CST');
            this.$summary.append($NMNUM);

            var $WAKEUPCOUNT = this.$summaryItem.clone();
            $WAKEUPCOUNT.find('.num').html(WAKEUPCOUNT || 0).end().find('.tip').html('期间设置顾客闹钟数(总)').end().find('.icon').addClass('MGJCONSUMEPERIOD');
            this.$summary.append($WAKEUPCOUNT);

			//计算页面剩余的高度,赋值给table
			var h = $("body").outerHeight()-this.$.find(".c-reportFilter").outerHeight()-this.$.find(".summary").outerHeight()-this.$.find(".am-header").outerHeight()-42-10;
			this.$.find(".form").css("height",h);
			this.$.find(".table-l").css("height",h);
			this.scrollAll();
        },
        renderTodolist:function(data){
            data.sort(function(a,b){
                return (b.ED_CNT+b.UN_CNT) - (a.ED_CNT+a.UN_CNT);
			});
            var $header = $('<div class="item header">'+
                            '<div></div>'+
                            '<div>已处理</div>'+
                            '<div>未处理</div>'+
                            '<div>总计</div>'+
                        '</div>');
			this.$.find(".table-head .wrapper").css("width",375).html($header);
			this.$form.css("width",375);

			var ED_CNT = 0, UN_CNT = 0;
			var h = data.length * 37 + 28;//计算高度
            if ($('html').hasClass('iosX') || $('html').hasClass('iPhone12_1')) {
                h += 20;
            }
			this.$.find(".table").css("height",h);

			var $list = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.time = self.reportFilter.getDate();
                window.RouterUtils.push({
                    name: 'todoList',
                    params: {
                        empData: {
                            empId: data.EMPID,
                            empType: data.EMPTYPE,
                            shopId: data.SHOPID,
                        }
                    }
                })
                // $.am.changePage(amGloble.page.todoList,'slideleft',data);
			});
			this.$form.append($list);

			var $name = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.time = self.reportFilter.getDate();
                window.RouterUtils.push({
                    name: 'todoList',
                    params: {
                        empData: {
                            empId: data.EMPID,
                            empType: data.EMPTYPE,
                            shopId: data.SHOPID,
                        }
                    }
                })
                // $.am.changePage(amGloble.page.todoList,'slideleft',data);
			});
			this.$tableL.append($name);

            for(var i=0;i<data.length;i++){
                var $item = $('<div class="item am-clickable">'+
                '<div></div>'+
                '<div>'+data[i].ED_CNT+'</div>'+
                '<div>'+data[i].UN_CNT+'</div>'+
                '<div>'+(data[i].ED_CNT+data[i].UN_CNT) +'</div>'+
                '</div>');
                ED_CNT += data[i].ED_CNT;
                UN_CNT += data[i].UN_CNT;
				$list.append($item.data('data',data[i]));
				$name.append($('<div class="item am-clickable"><div>'+(data[i].NAME || "")+'</div></div>').data('data',data[i]));
			}

            var $CNT = this.$summaryItem.clone();
            $CNT.find('.num').html(ED_CNT+UN_CNT).end().find('.tip').html('待办事项(总)').end().find('.icon').addClass('todolist_CNT');
            this.$summary.append($CNT);

            var $ED_CNT = this.$summaryItem.clone();
            $ED_CNT.find('.num').html(ED_CNT).end().find('.tip').html('已处理(总)').end().find('.icon').addClass('todolist_ED_CNT');
            this.$summary.append($ED_CNT);

            var $UN_CNT = this.$summaryItem.clone();
            $UN_CNT.find('.num').html(UN_CNT).end().find('.tip').html('未处理(总)').end().find('.icon').addClass('todolist_UN_CNT');
            this.$summary.append($UN_CNT);
			var h = $("body").outerHeight()-this.$.find(".c-reportFilter").outerHeight()-this.$.find(".summary").outerHeight()-this.$.find(".am-header").outerHeight()-42-10;
			this.$.find(".form").css("height",h);
			this.$.find(".table-l").css("height",h);
			this.scrollAll();
        },
        getEmpDataById: function(id) {
            if (amGloble.metadata.employees) {
                return amGloble.metadata.employees.find(function(empData) {
                    return empData.empid === id;
                })
            }
        },
        renderReservation:function(data){
            data.sort(function(a,b){
                return b.REV - a.REV;
			});
            var $header = $('<div class="item header">'+
                            '<div></div>'+
                            '<div>总预约次数</div>'+
														'<div>反预约次数</div>'+
														'<div>反预约到店次数</div>'+
                            '<div>到店次数</div>'+
														'<div>到店率</div>'+
                        '</div>');
			this.$form.css("width",450);
			this.$.find(".table-head .wrapper").css("width",450).html($header);

            var $list = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.eid = data.EMPID;
                data.shopId = self.shopId;
                var empData = self.getEmpDataById(data.EMPID);
                data.emp = {
                    empid: data.EMPID,
                    empName: data.NAME,
                    shopId: self.shopId,
                    barberId: data.EMPID,
                    dutyid: empData ? empData.dutyid : '',
                }
                $.am.changePage(amGloble.page.reservation,'slideleft',data);
            });
			this.$form.append($list);

			var $name = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.eid = data.EMPID;
				data.shopId = self.shopId;
                var empData = self.getEmpDataById(data.EMPID);
                data.emp = {
                    empid: data.EMPID,
                    empName: data.NAME,
                    shopId: self.shopId,
                    barberId: data.EMPID,
                    dutyid: empData ? empData.dutyid : '',
                }
                $.am.changePage(amGloble.page.reservation,'slideleft',data);
            });
            this.$tableL.append($name);

			var CNT = 0, AVR = 0, REV = 0, REVAVR = 0;
			var h = data.length * 37 + 28;//计算高度
            if ($('html').hasClass('iosX') || $('html').hasClass('iPhone12_1')) {
                h += 20;
            }
			this.$.find(".table").css("height",h);
            for(var i=0;i<data.length;i++){
                var $item = $('<div class="item am-clickable">'+
                '<div></div>'+
                '<div>'+data[i].CNT+'</div>'+
								'<div>'+data[i].REV+'</div>'+
								'<div>'+data[i].REVAVR+'</div>'+
                '<div>'+data[i].AVR+'</div>'+
                '<div>'+((data[i].AVR/data[i].CNT)*100).toFixed(2)+'%'+'</div>'+
                '</div>');
                REV += data[i].REV;
                CNT += data[i].CNT;
				AVR += data[i].AVR;
				REVAVR += data[i].REVAVR;
                $list.append($item.data('data',data[i]));
				$name.append($('<div class="item am-clickable"><div>'+(data[i].NAME || "")+'</div></div>').data('data',data[i]));
            }

            var $CNT = this.$summaryItem.clone();
            $CNT.find('.num').html(CNT).end().find('.tip').html('总预约次数').end().find('.icon').addClass('reservation_CNT');
            this.$summary.append($CNT);

            var $REV = this.$summaryItem.clone();
            $REV.find('.num').html(REV).end().find('.tip').html('反预约次数(总)').end().find('.icon').addClass('reservation_CNT');
			this.$summary.append($REV);

			var $REVAVR = this.$summaryItem.clone();
			var REVAVR_number = (isNaN(REVAVR) || !REVAVR) ? 0 : REVAVR;
			$REVAVR.find('.num').text(REVAVR_number).end().find('.tip').text('反预约到店次数').end().find('.icon').addClass('reservation_AVR');
			this.$summary.append($REVAVR);

            var $AVR = this.$summaryItem.clone();
            $AVR.find('.num').html(AVR).end().find('.tip').html('到店次数(总)').end().find('.icon').addClass('reservation_AVR');
            this.$summary.append($AVR);

            var $RATE = this.$summaryItem.clone();
            $RATE.find('.num').html(((AVR/CNT)*100).toFixed(2)+'%').end().find('.tip').html('到店率(总)').end().find('.icon').addClass('reservation_RATE');
			this.$summary.append($RATE);

			var h = $("body").outerHeight()-this.$.find(".c-reportFilter").outerHeight()-this.$.find(".summary").outerHeight()-this.$.find(".am-header").outerHeight()-42-10;
			this.$.find(".form").css("height",h);
			this.$.find(".table-l").css("height",h);
			this.scrollAll();
        },
        renderInvention:function(data){
            data.sort(function(a,b){
                return b.CNT - a.CNT;
			});
            var $header = $('<div class="item header">'+
                            '<div></div>'+
                            '<div>作品数</div>'+
                            '<div>点赞数</div>'+
                            '<div>评论数</div>'+
                        '</div>');
			this.$.find(".table-head .wrapper").css("width",300).html($header);
			this.$form.css("width",300);

			var $name = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.shopId = self.shopId;
                data.time = self.reportFilter.getDate()
                $.am.changePage(amGloble.page.archiveList,'slideleft',data);
            });
            this.$tableL.append($name);
            var $list = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.shopId = self.shopId;
                data.time = self.reportFilter.getDate()
                $.am.changePage(amGloble.page.archiveList,'slideleft',data);
            });
			this.$form.append($list);

			var CNT = 0, LIKES = 0, CMT = 0;
			var h = data.length * 37 + 28;//计算高度
            if ($('html').hasClass('iosX') || $('html').hasClass('iPhone12_1')) {
                h += 20;
            }
			this.$.find(".table").css("height",h);
            for(var i=0;i<data.length;i++){
                var $item = $('<div class="item am-clickable">'+
                '<div></div>'+
                '<div>'+data[i].CNT+'</div>'+
                '<div>'+data[i].LIKES+'</div>'+
                '<div>'+data[i].CMT+'</div>'+
                '</div>');
                CNT += data[i].CNT;
                LIKES += data[i].LIKES;
                CMT += data[i].CMT;
                $list.append($item.data('data',data[i]));
				$name.append($('<div class="item am-clickable"><div>'+(data[i].EMPNAME || "")+'</div></div>').data('data',data[i]));
            }
            var $CNT = this.$summaryItem.clone();
            $CNT.find('.num').html(CNT).end().find('.tip').html('作品数(总)').end().find('.icon').addClass('invention_CNT');
            this.$summary.append($CNT);

            var $LIKES = this.$summaryItem.clone();
            $LIKES.find('.num').html(LIKES).end().find('.tip').html('点赞数(总)').end().find('.icon').addClass('invention_LIKES');
            this.$summary.append($LIKES);

            var $CMT = this.$summaryItem.clone();
            $CMT.find('.num').html(CMT).end().find('.tip').html('评论数(总)').end().find('.icon').addClass('invention_CMT');
			this.$summary.append($CMT);
			var h = $("body").outerHeight()-this.$.find(".c-reportFilter").outerHeight()-this.$.find(".summary").outerHeight()-this.$.find(".am-header").outerHeight()-42-10;
			this.$.find(".form").css("height",h);
			this.$.find(".table-l").css("height",h);
			this.scrollAll();
        },
        renderTopic:function(data){
            data.sort(function(a,b){
                return b.CNT - a.CNT;
			});
            var $header = $('<div class="item col5 header">'+
            '<div></div>'+
            '<div>记录数</div>'+
            '<div>精华数</div>'+
            '<div>点赞数</div>'+
            '<div>评论数</div>'+
            '</div>');
			this.$.find(".table-head .wrapper").css("width",400).html($header);
			this.$form.css("width",400);

			var $name = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.shopId = self.shopId;
                $.am.changePage(amGloble.page.community,'slideleft',data);
            });
			this.$tableL.append($name);

            var $list = $('<div class="list"></div>').on('vclick','.item',function(){
                var data = $(this).data('data');
                data.shopId = self.shopId;
                $.am.changePage(amGloble.page.community,'slideleft',data);
            });
			this.$form.append($list);

			var CNT = 0, ELITE = 0, SUPPORTNUM = 0, COMMENTNUM = 0;
			var h = data.length * 37 + 28;//计算高度
            if ($('html').hasClass('iosX') || $('html').hasClass('iPhone12_1')) {
                h += 20;
            }
			this.$.find(".table").css("height",h);
            for(var i=0;i<data.length;i++){
				var $item = $('<div class="item col5 am-clickable">'+
				'<div></div>'+
                '<div>'+data[i].CNT+'</div>'+
                '<div>'+data[i].ELITE+'</div>'+
                '<div>'+data[i].SUPPORTNUM+'</div>'+
                '<div>'+data[i].COMMENTNUM+'</div>'+
                '</div>');
                CNT += data[i].CNT;
                ELITE += data[i].ELITE;
                SUPPORTNUM += data[i].SUPPORTNUM;
                COMMENTNUM += data[i].COMMENTNUM;
                $list.append($item.data('data',data[i]));
				$name.append($('<div class="item am-clickable"><div>'+(data[i].NAME || "")+'</div></div>').data('data',data[i]));
            }
            var $CNT = this.$summaryItem.clone();
            $CNT.find('.num').html(CNT).end().find('.tip').html('记录数(总)').end().find('.icon').addClass('topic_CNT');
            this.$summary.append($CNT);

            var $ELITE = this.$summaryItem.clone();
            $ELITE.find('.num').html(ELITE).end().find('.tip').html('精华数(总)').end().find('.icon').addClass('topic_ELITE');
            this.$summary.append($ELITE);

            var $SUPPORTNUM = this.$summaryItem.clone();
            $SUPPORTNUM.find('.num').html(SUPPORTNUM).end().find('.tip').html('点赞数(总)').end().find('.icon').addClass('topic_SUPPORTNUM');
            this.$summary.append($SUPPORTNUM);

            var $COMMENTNUM = this.$summaryItem.clone();
            $COMMENTNUM.find('.num').html(COMMENTNUM).end().find('.tip').html('评论数(总)').end().find('.icon').addClass('topic_COMMENTNUM');
			this.$summary.append($COMMENTNUM);
			var h = $("body").outerHeight()-this.$.find(".c-reportFilter").outerHeight()-this.$.find(".summary").outerHeight()-this.$.find(".am-header").outerHeight()-42-10;
			this.$.find(".form").css("height",h);
			this.$.find(".table-l").css("height",h);
			this.scrollAll();
        },
        amDragTopTips: ["下拉刷新列表", "松开开始加载", "加载中..."],
        touchTop: function(){
            if(this.topLoading){
                return;
            }
            this.topLoading = true;
            self.type = this.$tab.find('.selected').data('type');
            self.getDate();
        },
    });
})();
