(function() {
	var reportPermission = {};
    var self = amGloble.page.brandRevenueOverview = new $.am.Page({
        id: "page-brandRevenueOverview",
        init: function() {
            var self = this;
            this.$main = this.$.find(".am-body-inner");

			this.reportFilter = new amGloble.ReportFilter({
                $: this.$.find(".am-body-wrap"), //选择器的dom将插入到此节点后面
                // enableDept: true, //是否启用部门选择器
                // enableLevel: true, //是否启用部门选择器
                onDatePickerClick: function() {
                    if (self.isLandscape) {
                        self.$right.trigger("vclick");
                    }
                },
                onchange: function() { //条件修改时触发
                    self.getData();
                }
            });
        },
        beforeShow: function(ret) {
			var self = this;
			reportPermission = JSON.parse(amGloble.metadata.configs.reportPermission)
			var opt = {
				parentShopIds: reportPermission.parentShopIds
			}
			self.reportFilter.setOpt({
				enableBrand: true,
				brandList: ret.content
			});
			amGloble.api.queryAcrossTenantList.exec(opt, function(ret) {
                if (ret.code == 0) {
					var brandList = [
						{name: '全部品牌', id: -1}
					]
					ret.content.forEach(function(item) {
						brandList.push({
							name: item.shopName,
							id: item.parentShopId
						})
					})
					self.reportFilter.setBrandList(brandList);
                } else {
                    amGloble.msg("数据加载失败,点击重试!");
                }
            });
        },
        afterShow: function(paras) {
            this.paras = paras;
            this.getData();
        },
        beforeHide: function() {},
        render: function(data) {
			var otherPayLabelMap = data[1];
			var cashPayData = data[0];
			var otherCashIcon = 'ico8';
			var payConfig = {
				cash: {
					label: '现金', icon: 'ico1'
				},
				unionpay: {
					label: '银联', icon: 'ico2'
				},
				cooperation: {
					label: '合作券', icon: 'ico3'
				},
				mall: {
					label: '商场卡', icon: 'ico4'
				},
				weixin: {
					label: '微信', icon: 'ico9'
				},
				pay: {
					label: '支付宝', icon: 'ico10'
				},
				dianpin: {
					label: '点评', icon: 'ico6',
				},
			}
			var contentHtmlStr = '';
			var total = 0;
			for(var key in cashPayData) {
				var currentLabel, currentIcon, currentValue = parseFloat(cashPayData[key]) || 0;
				// if (key.indexOf('otherfee') >= 0) {
				// 	currentLabel = otherPayLabelMap[key];
				// 	currentIcon = otherCashIcon;
				// } else {
				// 	var currentData = payConfig[key];
				// 	currentIcon = currentData.icon;
				// 	currentLabel = currentData.label;
				// }
				var currentData = payConfig[key];
					currentIcon = currentData.icon;
					currentLabel = currentData.label;
				var itemHtmlStr = '<li>'+
										'<span class="ico '+ currentIcon +'"></span>'+
										'<span class="key">'+ currentLabel +'</span>'+
										'<span class="value">'+ currentValue.toFixed(2) +'</span>'
									'</li>';
				contentHtmlStr += itemHtmlStr;
				total += parseFloat(currentValue);
			}
			this.$main.find('.listBox .clear').html(contentHtmlStr);
			this.$main.find('.circleCon .totalMoney').text(total.toFixed(2));
			this.refresh();
		},
        getData: function() {
            var self = this;
			var range = this.reportFilter.getValue().range;
			var brandData = this.reportFilter.getBrand();
            var opt = {
				startDateTime: range[0].format("yyyy-mm-dd"),
				endDateTime: range[1].format("yyyy-mm-dd"),
				parentShopId: brandData.id
			}
			if (opt.parentShopId == -1) {
				opt.parentShopIds = reportPermission.parentShopIds;
			}
            amGloble.loading.show("正在加载,请稍候...");
            amGloble.api.queryAcrossCashSum.exec(opt, function(ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    self.render(ret.content);
                } else {
                    amGloble.msg(ret.message);
                }
            });
        }
    });
})();
