(function() {

    var self = amGloble.page.customerSearch = new $.am.Page({
        id: "page-customerSearch",
        init: function() {
            var self = this;

            this.$key = this.$.find(".searchBox input").change(function() {
                self.resetList();
            });
            this.$searchBtn = this.$.find(".searchBox .searchBtn").vclick(function() {
                var val = self.$key.val();
                if (!$.trim(val)) {
                    amGloble.msg("请输入搜索关键字");
                    return;
                }
                self.getData();
            });

            //滚动加载

            this.$ul = this.$.find(".c-custList").on("vclick", "li", function() {
                var $this = $(this);
                var item = $this.data("item");
                if (self.paras && self.paras.callback) {
                    self.paras.callback(item);
                    return;
                }
                $.am.changePage(amGloble.page.customerDetail, "slideleft", {
                    custId: item.id,
                    shopid: item.shopid,
                    $li: $this
                });
            });
            this.$li = this.$ul.find(":first").remove();

            this.$customerShortcutKey = this.$.find(".customer-shortcut-key").on("vclick", ".shortcut-key-tab .tab-button", function() {
                $(this).addClass('actived').siblings().removeClass('actived');
                // TODO 目前的type可能不准，需要后端确认，然后修改
                self.changeShortcutKeyTab($(this).attr("tab-type"));
            }).on("vclick", ".shortcut-key-main .customer-item .customer-item-main", function() {
                var $this = $(this);
                var item = $this.data("item");
                if (self.paras && self.paras.callback) {
                    self.paras.callback(item);
                    return;
                }
                $.am.changePage(amGloble.page.customerDetail, "slideleft", {
                    custId: item.id,
                    shopid: item.shopid,
                    $li: $this
                });
            });
            this.$customerItem = this.$customerShortcutKey.find(".shortcut-key-main .customer-item");
            this.$shortcutKeyMain = this.$customerShortcutKey.find(".shortcut-key-main").empty();
        },

        beforeShow: function(paras) {
            if (paras == "back") {
                return false;
            }
            this.paras = paras;
            this.reseAll();
            this.$customerShortcutKey.find(".shortcut-key-tab .tab-button").eq(0).trigger('vclick');
            this.$customerShortcutKey.show();
        },

        afterShow: function(paras) {
            if (paras == "back") {
                return false;
            }
            this.$key.focus();
        },
        reseAll: function() {
            this.$key.val("");
            this.$ul.empty();
        },
        resetList: function() {
            this.$ul.empty();
        },
        filterCustomerData: function(data) {
            var empid = self.paras && self.paras.userId ? self.paras.userId : "";
            var filterData = [];
            if (empid) {
                data.forEach(function(customerItem) {
                    if (customerItem.empid) {
                        var empids = customerItem.empid.split(",");
                        var empidArr = [];
                        empids.forEach(function(id) {
                            empidArr.push(Number(id));
                        })

                        if (empidArr.indexOf(Number(empid)) != -1) {
                            filterData.push(customerItem);
                        }
                    } else {
                        filterData.push(customerItem);
                    }
                })
            } else {
                filterData = data;
            }
            return filterData;
        },
        getData: function(animation) {
            var self = this;

            var key = this.$key.val();

            if (this.$ul.is(":empty")) {
                this.setStatus("loading");
            }

            this.loading = true;

            var user = amGloble.metadata.userInfo;
            amGloble.api.customerQuerCusts.exec({
                "type": 0,
                "key": key,
                "empid":  user.userId,
                "shopIds": amGloble.getKeyArr(amGloble.metadata.shops, "shopId", true, true).join(","),
                "userType": user.userType, // 1 管理员 0 员工
                "pageNumber": 0,
                "searchAll": 1
                // "pageSize": 99
            }, function(ret) {
                self.loading = false;
                self.setStatus("normal");
                if (ret.code == 0) {
                    console.log(ret);
                    var data = ret.content;

                    self.render(self.filterCustomerData(data));
                    self.closeBottomLoading();
                } else {
                    amGloble.msg("数据加载失败,点击重试!");
                }

            });

        },
        changeShortcutKeyTab: function(type) {
            console.log(type);
            var self = this;
            var user = amGloble.metadata.userInfo;
            this.$shortcutKeyMain.empty();

            if (type == 2) {
                var recentViewCustomer = JSON.parse(localStorage.getItem("recentViewCustomer"));
                if (recentViewCustomer && recentViewCustomer.shopid == amGloble.metadata.userInfo.shopId && recentViewCustomer.data.length) {
                    var customerData = recentViewCustomer.data;
                    var customerIds = [];
                    customerData.forEach(function(item) {
                        customerIds.push(item.id);
                    })

                    this.setStatus("pageLoading", '', {top: 150});
                    this.loading = true;
                    amGloble.api.queryMemInfo.exec({
                        ids: customerIds
                    }, function(ret) {
                        console.log(ret);
                        self.loading = false;
                        self.setStatus("normal");
                        if (ret.code == 0) {
                            var data = ret.content || [];
                            var newData = [];
                            var updata = [];

                            customerData.forEach(function(oldCustomer) {
                                var find = undefined;
                                for (var i = 0; i < data.length; i++) {
                                    var customer = data[i];
                                    if (customer.id == oldCustomer.id) {
                                        find = customer;
                                        break;
                                    }
                                }
                                if (find) {
                                    find.recentViewTime = oldCustomer.recentViewTime;
                                    newData.push(find);
                                    updata.push(oldCustomer);
                                }
                            })

                            recentViewCustomer.data = updata;
                            localStorage.setItem("recentViewCustomer", JSON.stringify(recentViewCustomer));

                            var userId = self.paras && self.paras.userId ? self.paras.userId : user.userId;
                            var userType = self.paras && self.paras.userType ? self.paras.userType : user.userType;

                            if (userType && userType == 1 && userId) {
                                newData = newData.filter(function(customer) {
                                    var empids = customer.empid ? customer.empid.split(",") : [];
                                    var empidArr = [];

                                    empids.forEach(function(id) {
                                        empidArr.push(Number(id));
                                    })
                                    return empidArr.indexOf(Number(userId)) != -1
                                })
                            }


                            self.renderCustomerShortcutKey(newData, type)
                        } else {
                            amGloble.msg("数据加载失败,点击重试!");
                        }
                    });
                } else {
                    self.setStatus("empty");
                }
            } else {
                this.setStatus("pageLoading", '', {top: 150});
                this.loading = true;

                amGloble.api.customerQuerCusts.exec({
                    "type": 0,
                    "isReverse": 1,
                    "empid":  self.paras && self.paras.userId ? self.paras.userId : user.userId,
                    "orderByType": type,
                    "shopIds": amGloble.getKeyArr(amGloble.metadata.shops, "shopId", true, true).join(","),
                    "userType": self.paras && self.paras.userType ? self.paras.userType : user.userType, // 1 管理员 0 员工
                    "pageNumber": 0,
                    "pageSize": 6
                }, function(ret) {
                    self.loading = false;
                    self.setStatus("normal");
                    if (ret.code == 0) {
                        var data = ret.content;
                        self.renderCustomerShortcutKey(data, type)
                    } else {
                        amGloble.msg("数据加载失败,点击重试!");
                    }
    
                });
            }
        },
        renderCustomerShortcutKey: function(data, type) {
            var self = this;
            var typeMap = {
                0: "到店时间",
                2: "查看时间",
                4: "添加时间",
            };
            this.$shortcutKeyMain.empty();

            if (data && data.length) {
                var timeTextLabel = typeMap[type];

                $.each(data, function(i, item) {
                    var $customerItem = self.$customerItem.clone();
                    $customerItem.find(".header").html(amGloble.photoManager.createImage("customer", {
                        parentShopId: amGloble.metadata.userInfo.parentShopId,
                        updateTs: item.lastphotoupdatetime
                    }, item.id + ".jpg", "s"));
                    if (item.sex == "M") {
                        $customerItem.find(".header").addClass("male");
                    }
                    $customerItem.find(".customer-info .name").html(item.name);
    
                    var timeText = "";
                    if (type && type == 2) {
                        timeText = amGloble.time2str(item.recentViewTime / 1000);
                    } else {
                        var time = type == 4 ? item.registDate : item.lastconsumetime;
                        if (time && time > 631152000000) {
                            timeText = amGloble.time2str(time / 1000);
                        } else {
                            timeText = "--";
                        }
                    }
                    $customerItem.find(".customer-info .time").html(timeTextLabel + '：' + timeText);
    
                    $customerItem.find(".customer-item-main").data("item", item);
                    self.$shortcutKeyMain.append($customerItem);
                })
            } else {
                self.setStatus("empty");
            }
            self.refresh();
        },
        render: function(data) {
            var self = this;
            var $ul = this.$ul.empty();
            this.$customerShortcutKey.hide();

            if (data && data.length) {
                $.each(data, function(i, item) {
                    $ul.append(amGloble.page.customerGrouping.createCustItem(item));
                });
            }

            if ($ul.is(":empty")) {
                this.setStatus("empty");
            }
            self.refresh();
        }
    });

})();
