(function () {

    // newRole 1操作员 2管理员(包括直属店和附属店老板) 3老板（总部老板） 4第一工位员工 5第二工位员工 6第三工位员工
    // shopType 0总店 1单店 2直营 3附属
    // userType 0管理者 1员工
    // role 1操作员 2管理员 3老板 如果是员工则返回真实的role id
    // permission 1盛传版 2风尚版 3尊享版 4青春版 5营销版 6电商版
    var authorities = {

        "1": ["appointment", "wheel", "report", "newReport", "invention", "ranking", "supOprateRep", "sourceBoard", "scan", "customer", "todolist", "service", "promotionbenefit", "paperless", "myk", "surveyActive", "luckymoneyMarketing", "operateApprove", "attendanceRecord", "community","audit"], //操作员
        "2": ["wheel", "appointment", "shopMall", "report", "newReport", "invention", "ranking", "supOprateRep", "sourceBoard", "scan", "customer", "todolist", "service", "promotionbenefit", "myk", "surveyActive", "luckymoneyMarketing", "operateApprove", "smsrecharge", "arrangeShifts", "shopGoal", "community","audit"], //管理员
        "3": ["wheel", "appointment", "shopMall", "marketing", "mall", "withDraw", "report", "newReport", "invention", "ranking", "supOprateRep", "sourceBoard", "scan", "customer", "todolist", "service", "promotionbenefit", "smsrecharge", "optimization", "myk", "surveyActive", "luckymoneyMarketing", "operateApprove", "arrangeShifts", "shopGoal", "community","audit"], //老板
        "4": ["wheel", "report", "newReport", "invention", "ranking", "scan", "customer", "todolist", "reservation", "service", "promotionbenefit", "exceptional", "paperless", "myk", "surveyActive", "luckymoneyMarketing", "attendanceRecord", "empGoal", "community"], //员工1
        "5": ["wheel", "report", "newReport", "invention", "ranking", "scan", "customer", "todolist", "reservation", "service", "promotionbenefit", "exceptional", "paperless", "myk", "surveyActive", "luckymoneyMarketing", "attendanceRecord", "empGoal", "community"], //员工2
        "6": ["wheel", "report", "newReport", "invention", "ranking", "scan", "customer", "todolist", "reservation", "service", "promotionbenefit", "exceptional", "paperless", "myk", "surveyActive", "luckymoneyMarketing", "attendanceRecord", "empGoal", "community"], //员工3

    };
    var module1 = {
        "reservation": {
            name: "预约",
            icon: "yuyue",
            page: "reservation",
            permission: "2,3,4,6"
        },
        "appointment": {
            name: "预约",
            icon: "yuyue",
            page: "appointmentView",
            permission: "2,3,4,6"
        },
        "customer": {
            name: "顾客",
            icon: "guke",
            page: "customerGrouping",
            permission: "3,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "wheel": {
            name: "轮牌",
            icon: "lunpai",
            page: "craftsmanWheel",
            permission: "3" //权限、"3,4"只允许尊享版和青春版使用
        },
        "todolist": {
            name: "待办事项",
            icon: "daibanshixiang",
            page: "todoList",
            pageType: 2,
            permission: "3, 6", //权限、"3,4"只允许尊享版和青春版使用
            validShow: function() {
                return amGloble.metadata.userInfo.shopType != 0;
            }
        },
        "invention": {
            name: "作品",
            icon: "zuopin",
            page: "archiveList",
            permission: "2,3,4"
        },
        "service": {
            name: "服务",
            icon: "dangriliushui",
            page: "serviceManagement",
            permission: "2,3,4,6"
        },
        "paperless": {
            name: "无纸化登录",
            icon: "wuzhihua",
            page: "paperlessCode",
            permission: "3,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "empGoal": { //员工目标 员工有权限
            name: "目标",
            icon: "mubiao",
            page: "empGoalCheck",
            permission: "3" //权限、"3"只允许尊享版使用
        },
        "shopGoal": { //门店目标 管理员 操作员 老板有权限
            name: "目标",
            icon: "mubiao",
            page: "shopGoal",
            permission: "3" //权限、"3"只允许尊享版使用
        },
        "attendanceRecord": {
            name: "考勤记录",
            icon: "kaoqin",
            page: "attendanceRecord",
            permission: "2,3,4" //权限、"3,4"只允许尊享版和青春版使用
        },
        "arrangeShifts": {
            name: "考勤管理",
            icon: "kaoqin",
            page: "arrangeShifts",
            permission: "2,3,4" //权限、"3,4"只允许尊享版和青春版使用
        },
        "community": {
            name: "工作社群",
            icon: "community",
            page: "community",
            permission: "2,3,4" //权限、"3,4"只允许尊享版和青春版使用
        },
        "audit": {
            name: "工作审计",
            icon: "audit",
            page: "audit",
            permission: "1,2,3,4,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "luckymoneyMarketing": {
            name: "领红包活动",
            icon: "hongbaoyingxiao",
            page: "luckymoneyMarketing",
            permission: "2,3,4", //权限、1只允许尊享版使用
            validShow: function(jurisdiction) {
                return jurisdiction['luckymoneyMarketing'] == 1 || [2, 3].indexOf(amGloble.metadata.userInfo.role) !== -1;
            }
        },
        "operateApprove": {
            name: '操作审批',
            icon: 'operateApprove',
            page: "operateApproveList",
            permission: "3",
            pageType:'2',
            validShow: function(jurisdiction) {
                return jurisdiction['operateApprove'] != 0 && [1, 2, 3].indexOf(amGloble.metadata.userInfo.role) !== -1;
            }
        }
    }
    var module2 = {
        "ranking": {
            name: "排行榜",
            icon: "paihangbang",
            page: "rankinglist",
            permission: "1,2,3,4,6"
        },
        "report": {
            name: "数据",
            icon: "baobiao",
            page: "reportList",
            permission: "1,2,3,4,6",
            autohide: true //缩账时隐藏
        },
        "supOprateRep": {
            name: "运营报表",
            icon: "cjbb_i",
            page: "supOprateRep",
            pageType:'2',//添加pageTYpe pageTYpe = 2为vue页面   区分vue页面和原JQ页面
            permission: "1,2,3,4,6" //权限、1只允许尊享版使用
        },
        "sourceBoard": {
            name: "数据看板",
            icon: "sjkb_i",
            page: "sourceBoard",
            pageType:'2',//添加pageTYpe pageTYpe = 2为vue页面   区分vue页面和原JQ页面
            permission: "1,2,3,4,6" //权限、1只允许尊享版使用
        },
        "mall": {
            name: "商城",
            icon: "shangcheng",
            page: "mallTotal",
            permission: "2,3,4,6" //权限、1只允许尊享版使用
        },
        "newReport": {
            name: "数据",
            icon: "baobiao",
            page: "dataBoard",
            pageType: 2,
            permission: "1,2,3,4,6", //权限、1只允许尊享版使用
            autohide: true
        },
        // "mallreport": {
        //     name: "商城报表",
        //     icon: "shangchengbaobiao",
        //     page: "",
        //     permission: ""
        // }
    }
    var module3 = {
        "exceptional": {
            name: "打赏",
            icon: "dashang",
            page: "exceptional",
            permission: "2,3,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "promotionbenefit": {
            name: "推广收益",
            icon: "shangchengtuiguang",
            page: "promotionbenefit",
            permission: "3,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        // "shopMall": {
        //     name: "美美汇",
        //     icon: "meimeihui",
        //     permission: "1,2,3,4" //权限、"3,4"只允许尊享版和青春版使用
        // },
        "myk": {
            name: "微主页",
            icon: "weizhuye",
            permission: "1,2,3,4,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "marketing": {
            name: "营销",
            icon: "hongbaoyingxiao",
            page: "marketing",
            permission: "3,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "surveyActive": {
            name: "调研活动",
            icon: "diaoyanhuodong",
            page: "surveyActive",
            permission: "1,3,4", //权限、"3,4"只允许尊享版和青春版使用
            validShow: function() {
                return amGloble.metadata.configs.mgjGroupbuyingOrderStatisticsEnable == "0"? false : true;
            }
        },
    }
    var module4 = {
        "optimization": {
            name: "财务优化",
            icon: "caiwuyouhua",
            page: "auxiliary",
            permission: "3,6" //权限、"3"只允许尊享版
        },
        "smsrecharge": {
            name: "门店管理",
            icon: "duanxinchongzhi",
            page: "msgDetail",
            permission: "1,2,3,4,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "scan": { //扫一扫iconClass 从"m4"改为"m16"
            name: "扫一扫",
            icon: "saoyisao",
            page: "scan",
            permission: "2,3,4,6" //权限、"3,4"只允许尊享版和青春版使用
        },
        "withDraw": {
            name: "代收代付",
            icon: "daishoudaifu",
            page: "withDraw",
            permission: "2,3,4,6"
        },
    }
    var plates = [{
        name: '日常工作',
        sub: module1
    }, {
        name: '业绩分析',
        sub: module2
    }, {
        name: '运营推广',
        sub: module3
    }, {
        name: '其他',
        sub: module4
    }];

    var CacheTimeUtil = function(options) {
        this.config = $.extend({
            expireTime: 5 * 60 * 1000,
        }, options);
        this.lastUpdateTime = null;
    }
    CacheTimeUtil.prototype.valid = function() {
        var currentTime = new Date().getTime();
        var lastUpdateTime = this.lastUpdateTime,
            expireTime = this.config.expireTime;
        if (lastUpdateTime && currentTime - lastUpdateTime < expireTime) {
            return true;
        }
        return false;
    }
    CacheTimeUtil.prototype.setLastTime = function(time) {
        this.lastUpdateTime = time || new Date().getTime();
    }
    CacheTimeUtil.prototype.setLastData = function(data) {
        this.lastUpdateData = data;
    }
    CacheTimeUtil.prototype.clear = function() {
        this.lastUpdateTime = null;
        this.lastUpdateData = null;
    }
    amGloble.page.dashboard = new $.am.Page({
        id: "page-dashboard",
        backButtonOnclick: function () {
            var self = this;
            $.am.debug.log("当前返回参数activePageType" + window.RouterUtils.activePageType);
            if (window.RouterUtils.activePageType !== 1) return;
            atMobile.nativeUIWidget.confirm({
                caption: "退出登录",
                description: "您将退出当前登录用户，是否继续？",
                okCaption: "是",
                cancelCaption: "否"
            }, function () {
                $.am.changePage(amGloble.page.login, "slideright", "logout");
            }, function () { });
        },

        init: function () {
            var self = this;

            self.dashboardCacheUtil = new CacheTimeUtil();
            self.promotionCacheUtil = new CacheTimeUtil();
            self.reservationCacheUtil = new CacheTimeUtil();
            self.otherCacheUtil = new CacheTimeUtil();
            this.versionInfoMap = {
                1: { name: "盛传版", no: 5 },
                2: { name: "风尚版", no: 6 },
                3: { name: "尊享版", no: 7 },
                4: { name: "青春版", no: 16 },
                5: { name: "营销版", no: 78 },
                6: { name: "电商版", no: 27 },
            };
            //返回
            //
            this.$user = this.$header.find(".right").vclick(function () {
                //$.am.changePage(amGloble.page.userinfo, "slideleft");
                var hasMessage = $(this).hasClass("dot")
                $.am.changePage(amGloble.page.message, "slideleft", hasMessage ? "forceRefresh" : null);
                $(this).removeClass("dot")
            });

            this.$arrearsTip = this.$.find(".arrears-tip").vclick(function() {
                var data = $(this).data("data");
                self.refreshData(function() {
                    var unpayedData = self.getUnpayedData();
                    if (unpayedData.length == 1 || data.unpayType) {
                        $.am.changePage(amGloble.page.msgRenew, "slideleft",data); // 单条 欠费/续费 跳转页面
                    } else {
                        window.RouterUtils.push({
                            name: 'unpayed',
                            animation: 'slideleft'
                        })
                        // $.am.changePage(amGloble.page.msgRecord, "slideleft",data); // TODO 跳转到支付列表页面
                    }
                });
            });
            this.$arrearsTip.find(".arrears-close").vclick(function(e) {
                e.stopPropagation();
                var day = 1;
                var parentData = $(this).parent().data("data");
                self.refreshData(function() {
                    if (parentData.unpayType == 1) {
                        self.setRenewCloseConfig(day);
                    }
                    self.$arrearsTip.hide();
                });
            })
            this.$title = this.$header.find(".title > .text");
            this.$userinfo = this.$.find(".userinfo").vclick(function () {
                $.am.changePage(amGloble.page.userinfo, "slideleft");
            });
            this.$activity = this.$.find(".activity").vclick(function (e) {
                if (self.isChangeLoading) return;
                self.isChangeLoading = true;
                var item = $(e.target).parent().data('data');
                if (item.isVote) {
                    window.RouterUtils.push({name:'voteActivity',params:{activityId:item.id},animation:'slideleft'})
                } else {
                    window.RouterUtils.push({name:'operationalActivities',params:{activityData: item},animation:'slideleft'})
                }
            });
            this.$activityContent = this.$activity.find('.activity_content-wrap').remove();
            this.$userinfo.find(".yuyue").vclick(function (e) {
                var userinfo = amGloble.metadata.userInfo;
                if (userinfo.mgjVersion != 1) {
                    $.am.changePage(amGloble.page.reservation, "slideleft");
                    e.stopPropagation()
                }
            });
            this.carrousel = new $.am.Carrousel({
                id: "activity_carrousel",
                height: 74,
                onchange: function (i) {
                    self.$carrouselCounter.find('span').eq(i).addClass('active').siblings().removeClass('active');
                }
            });
            this.$carrouselCounter = this.carrousel.$.find("div.count");
            this.$userinfo.find(".account").vclick(function (e) {
                if ($(this).hasClass('disabled')) {
                    return;
				}
                amGloble.page.login.chooseUser(self.accountList, function(ret) {
                    self.switchAccount(ret);
                }, { content: '' }, true)
                // amGloble.popupMenu("请选择帐号", self.accountList, function (ret) {
                //     console.log(ret)
                //     self.switchAccount(ret.id);
                // });
                e.stopPropagation();
                return false;
            })
            this.$photo = this.$userinfo.find(".photo");
            // .vclick(function () {
            //     $.am.changePage(amGloble.page.userinfo, "slideleft");
            // });
            this.$name = this.$userinfo.find(".t-name");
            this.$role = this.$userinfo.find(".line2");
            this.$workStatus = this.$userinfo.find(".icons");
            // this.$message = this.$.find(".userinfo .message").vclick(function() {
            //     $.am.changePage(amGloble.page.message, "slideleft", $(this).hasClass("dot") ? "forceRefresh" : null);
            // });

            this.$table = this.$.find(".moduleList");
            this.$table.on("vclick", "td", function () {
                var $this = $(this),
                    open = $this.attr("data")
                    url = $this.attr("href"),
                    pageType=$this.attr("pageType"),
                    page = $this.attr("page");
                    //



                if ($this.hasClass("disabled")) {
                    if (amGloble.checkVersion()) {
                        return;
                    };
                }
                if (page == 'scan') {
                    // self.userAttendance({
                    //     timeDifference: 40000,
                    //     createTime:new Date().getTime() - 10000,
                    //     shopId:'201611',
                    //     type:"attendance",
                    // });
                    // return;
                    // var userphone = window.config && window.config.phone
                    // var serverCluster = localStorage.getItem('CLUSTER') || ''
                    // amGloble.api.scan.exec({
                    //     codeId: '4C5197B8-5A6A-43A4-9183-6B6819919288',
                    //     cluster: serverCluster
                    // }, function (ret) {
                    //     if (ret.code == 0) { //成功
                    //         console.log(ret);
                    //     } else {
                    //         amGloble.msg(ret.message || "扫一扫失败,请重试!");
                    //     }
                    // });
                    // return;
                    cordova.plugins.barcodeScanner.scan(function (result) {
                        //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
                        $.am.debug.log("扫码结果：" + JSON.stringify(result));
                        $.am.debug.log("扫码text：" + result.text);
                        var text = result.text;
                        if (text) {
                            try {
                                text = JSON.parse(text);
                            } catch (e) {
                                $.am.debug.log("error：" + e.message);
                            }
                        }
                        if(typeof text == 'string'){
                            var arr = text.split('_');
                            if(arr[0]=='*'){
                                var obj = {
                                    type: 'attendance',
                                    createTime: arr[1],
                                    shopId: arr[2],
                                    timeDifference: arr[3]
                                }
                                $.am.debug.log("进入考勤逻辑！");
                                self.userAttendance(obj);
                            }
                        }else if ($.isPlainObject(text) && text.type == "attendance") {
                            $.am.debug.log("进入考勤逻辑！");
                            self.userAttendance(text);
                        } else {
                            var _uuid = $.isPlainObject(text) ? text._uuid : text;
                            // 保存集群信息
                            var serverCluster = localStorage.getItem('CLUSTER') || '';
                            if ($.isPlainObject(text) && text._uuid && amGloble.metadata.userInfo.userType == 1) {
                                amGloble.msg("请使用管理者账号扫码登录");
                                return;
                            }
                            amGloble.api.scan.exec({
                                codeId: _uuid,
                                cluster: serverCluster,
                                type: $.isPlainObject(text) ? text.from ? text.from : 0 : undefined
                            }, function (ret) {
                                $.am.debug.log(_uuid);
                                if (ret.code == 0) { //成功
                                    console.log(ret);
                                } else {
                                    amGloble.msg(ret.message || "扫一扫失败,请重试!");
                                }
                            });
                        }

                    }, function (error) {
                        $.am.debug.log("Scanning failed: " + error);
                        if(error.indexOf('camera')!==-1 && error.indexOf('enable')!==-1 && error.indexOf('Settings')!==-1){
                            error = '相机已被禁止使用，请在设置中启用后继续';
                        }
                        amGloble.msg(error);
                    });
                    return;
                }
                if (url && open != "openWindow") {
                    // location.href = url;
                    window.open(url, '_blank', 'location=no');
                } else if (open == "openWindow") {
                    window.location.href = url;
                } else if (page) {
                    if(page == 'community'){
                        self.communityClickCb();
                    }
                    else if (page == "auxiliary") {
                        window.RouterUtils.push({name:'squeeze',params:'',animation:'slideleft'})
                    }
                    else if (page == "promotionbenefit") {
                        window.RouterUtils.push({name:'promotionbenefit',params:'',animation:'slideleft'})
                    }
                    else if (page == "surveyActive") {
                        window.RouterUtils.push({name:'surveyList',params:'',animation:'slideleft'})
                    }
                    else if (page == "luckymoneyMarketing") {
                        window.RouterUtils.push({name:'luckymoneyMarketing',params:'',animation:'slideleft'})
                    }
                    else{
                        if(pageType&&pageType==2){
                            window.RouterUtils.push({name: page, params:'', animation:'slideleft'})
                        }else{
                            $.am.changePage(amGloble.page[page], "slideleft", "forceRefresh");
                        }
                    }
                }
            });
            this.$contact = this.$.find(".am-body-inner .contact-us");
            this.$contact.find("p").vclick(function(e){
                e.stopPropagation();
                window.RouterUtils.push({name: 'contactUs', params: "", animation:'slideleft'});
            })



            // this.$jokes = this.$.find(".jokes");
            // this.$arrowmore = this.$.find('.arrowmore');

            // console.log(this.scrollview);
            // var showbtn = true;
            this.scrollview._onupdate = function (pos) {
                this.$inner.setTransformPos(pos, "xy", this.hasInput);
                // console.log("onupdate",pos);
                // if (showbtn) {
                //     showbtn = false;
                //     localStorage.setItem('showArrow', true);
                //     // self.$arrowmore.hide();
                // }
            };

            //临时用途
            //log开关

            // var timeArr = [];

            // var compareTime = function (time1, time2) {
            //     return time2 / 1000 - time1 / 1000;
            // };

            // this.$name = this.$.find('.userinfo .line1').vclick(function() {

            //     var nowTime = new Date().getTime();
            //     timeArr.push(nowTime);
            //     var difference = compareTime(timeArr[0], nowTime);
            //     if (difference < 4) { //时差在3秒内
            //         if (timeArr.length > 3) { //点击了10次
            //             timeArr.length = 0;


            //             $.am.changePage(amGloble.page.videoDemo, "slideleft");


            //         }
            //     } else { //时差大于3秒
            //         timeArr.length = 0;
            //     }

            // });
            this.accountList = [];
            this.accountMap = {};
        },
        getProductSale: function(cb) {
            var _this = this;
            // 获取活动信息
            if(!this.productsMap) {
                amGloble.loading.show();
                amGloble.api.getProductConfig.exec({}, function(ret) {
                    amGloble.loading.hide();
                    if (ret && ret.code == 0) {
                        var products = ret.content.products;
                        var productSale = JSON.parse(ret.content.productSale);
						var productsMap = {};
                        var productSaleMap = {};
						products.forEach(function(product) {
							productsMap[product.no] = product;
						})
                        productSale.forEach(function(item) {
                            productSaleMap[item.buy] = item;
                        })
                        _this.productsMap = productsMap;
                        _this.productSaleMap = productSaleMap;
                        cb && cb();
                    } else {
                        atMobile.nativeUIWidget.confirm({
                            caption: '网络异常',
                            description: '数据读取失败，是否立即重试？',
                            okCaption: '重试',
                            cancelCaption: '取消'
                        }, function () {
                            _this.getProductSale(cb);
                        }, function () {

                        });
                    }
                })
            } else {
                cb && cb();
            }
        },
        setRenewCloseConfig: function(day) {
            var nowDate = new Date().getTime();
            var config = { day: day || 1, prevCloseTime: nowDate };
            localStorage.setItem('renewCloseConfig_' + amGloble.metadata.userInfo.shopId, JSON.stringify(config));
        },
        getRenewCloseVisible: function() {
            var visible = true;
            var closeConfig = localStorage.getItem('renewCloseConfig_' + amGloble.metadata.userInfo.shopId);
            if (closeConfig) {
                closeConfig = JSON.parse(closeConfig);
                var nowDate = new Date().getTime();
                var day = closeConfig.day;
                var prevCloseTime = closeConfig.prevCloseTime;
                var expireTime = new Date(new Date(Number(prevCloseTime + (day * 24 * 60 * 60 * 1000))).setHours(0, 0, 0, 0)).getTime();
                visible = expireTime < nowDate;
            }
            return visible;
        },
        refreshData: function(cb) {
            var _this = this;
            window.amGloble.page.login.getMetadata(function() {
                _this.getAllUnPayed(function() {
                    cb && cb();
                });
            }, true, true);
        },
        getAllUnPayed: function(cb) {
            var _this = this;
            // amGloble.loading.show();
            var shopId = amGloble.metadata.userInfo.shopId;
            var nowShop = amGloble.metadata.shopMap[shopId];
            amGloble.api.msgNopayment.exec({
                mgjversion: nowShop.mgjversion,
                version: nowShop.version,
                shopId: amGloble.metadata.userInfo.shopType == 0 ? "" : shopId,
                productNoAll: 1
            }, function (ret) {
                // amGloble.loading.hide();
                if (ret && ret.code == 0) {
                    if (ret.content) {
                        var filterData = [];
                        var productno = [];
                        var nowDate = new Date().getTime();
                        for (var i = 0; i< ret.content.length; i++) {
                            var item = ret.content[i];
                            var date = new Date(Number(item.consumetime)).getTime();
                            productno.push(Number(item.productno));

                            if ((nowDate - date) <= 90*24*3600*1000) {
                                item.shopId = item.shopid;

                                var find = "";
                                for (var j = 0; j < filterData.length; j++) {
                                    if (item.parentId && filterData[j].parentId == item.parentId) {
                                        find = filterData[j];
                                        break;
                                    }
                                }

                                if (find) {
                                    find.buyCount++;
                                    find.consumefee += item.consumefee;
                                    find.ids.push(item.id);
                                } else {
                                    item.buyCount = 1;
                                    item.ids = [item.id];
                                    filterData.push(item);
                                }
                            }
                        }

                        var numMap = {
                            1: "一",
                            2: "二",
                            3: "三",
                            4: "四",
                            5: "五",
                            6: "六",
                            7: "七",
                            8: "八",
                            9: "九"
                        };

                        filterData.forEach(function(item) {
                            var saleInfo = _this.productSaleMap[item.buyCount];
                            var shopInfo = amGloble.metadata.shopMap[item.shopid] || {};
                            item.consumetime = Number(item.consumetime);
                            item.totalYear = item.buyCount > 1 && saleInfo ? (saleInfo.buy + saleInfo.send) : 1;

                            if([7, 3, 6, 2, 5, 1, 22, 23, 16, 15, 27].indexOf(Number(item.productno)) != -1) {
                                if ([22, 23].indexOf(item.productno) != -1) {
                                    var nowDate = new Date().getTime();
                                    var diff = item.smallAppDueDate - nowDate;

                                    item.startDate = diff > 0 ? item.smallAppDueDate : nowDate;
                                } else {
                                    item.startDate = new Date(new Date(item.invalidDate).setFullYear(new Date(item.invalidDate).getFullYear() - item.totalYear)).getTime();
                                }
                            }
                            item.backName = "dashboard";
                            item.productName = item.buyCount > 1 && saleInfo ? "买" + numMap[saleInfo.buy] + "年送" + numMap[saleInfo.send] + "年（" + _this.versionInfoMap[shopInfo.mgjversion].name + "）" : item.productName;
                        })

                        _this.unpayedData = filterData.sort(function(a, b) {
                            return Number(a.consumetime) - Number(b.consumetime);
                        });

                        amGloble.metadata.shops.sort(function(a, b) {
                            return Number(a.invalidDate) - Number(b.invalidDate);
                        });
                        amGloble.metadata.shops.forEach(function(shop) {
                            if (shop.invalidDate && [2, 3].indexOf(Number(shop.mgjversion)) != -1 ) {
                                var shopItem = JSON.parse(JSON.stringify(shop));
                                var no = _this.versionInfoMap[shopItem.mgjversion].no;
                                var produce =  _this.productsMap[no];
                                var currentTime = new Date().setHours(23, 59, 59, 999);
                                var out = new Date(new Date(Number(shop.invalidDate)).setHours(23, 59, 59, 999)) - currentTime;
                                if (out <= 30*24*3600*1000 && productno.indexOf(no) == -1 && out >= -3*24*3600*1000) {
                                    // 存储自助续费的数据
                                    shopItem.unpayType = 1; // 欠款类型，0/生成的欠款 1/即将到期的自主续费
                                    shopItem.consumefee = produce.price;
                                    shopItem.price = produce.price;
                                    shopItem.productName = produce.name;
                                    shopItem.productno = produce.no;
                                    shopItem.shopid = shopItem.shopId;
                                    shopItem.osname = shopItem.osName;
                                    shopItem.outTime = out < 0 ? Math.floor(out / (24 * 3600 * 1000)) : parseInt(out / (24 * 3600 * 1000));
                                    shopItem.classid = 1;
                                    shopItem.backName = "dashboard";
                                    _this.unpayedData.push(shopItem);
                                }
                            }
                        })

                        var _unpayedData = [];
                        if([2, 3].indexOf(amGloble.metadata.userInfo.mgjVersion) != -1){
                            _unpayedData = _this.unpayedData;
                        }else {
                            _unpayedData = _this.getUnpayedData();
                        }

                        if (_unpayedData.length && [2, 3].indexOf(amGloble.metadata.userInfo.newRole) != -1) {
                            var text = "";
                            var tipData = _unpayedData[0];
                            var shopInfo = amGloble.metadata.shopMap[tipData.shopid] || {};

                            var stateText = "";
                            if (tipData.outTime > 0) {
                                stateText = "目前还可以使用" + Math.abs(tipData.outTime) + "天";
                            } else if (tipData.outTime == 0) {
                                stateText = "今天到期";
                            } else {
                                stateText = "目前已到期" + Math.abs(tipData.outTime) + "天";
                            }

                            if (amGloble.metadata.userInfo.shopType == 0) {
                                if (tipData.unpayType) {
                                    text = "您为" + shopInfo.shopFullName + "购买的" + _this.versionInfoMap[shopInfo.mgjversion].name + "系统到期日期是：" + new Date(Number(tipData.invalidDate)).format('yyyy-mm-dd') + "，" + stateText + "，为确保系统的正常使用，请及时续费。"
                                } else {
                                    text = "您为" + shopInfo.shopFullName + "购买的" + _this.versionInfoMap[shopInfo.mgjversion].name + "系统有" +  _this.getUnpayedData().length + "条待付款记录，为确保系统的正常使用，请及时清缴。"
                                }
                            } else {
                                if (tipData.unpayType) {
                                    text = "您的系统到期日期是：" + new Date(Number(tipData.invalidDate)).format('yyyy-mm-dd') + "，" + stateText + "，为确保系统的正常使用，请及时续费。";
                                } else {
                                    text = "您的系统有" +  _this.getUnpayedData().length + "待付款记录，为确保系统的正常使用，请及时清缴。"
                                }
                            }
                            _this.$arrearsTip.find(".tip-text").html(text);
                            _this.$arrearsTip.data("data", tipData);
                            if (tipData.unpayType != 1 || _this.getRenewCloseVisible()) {
                                _this.$arrearsTip.show();
                            } else {
                                _this.$arrearsTip.hide();
                            }
                            _this.scrollview.refresh()
                        } else {
                            _this.$arrearsTip.hide();
                        }
                    } else {
                        _this.$arrearsTip.hide();
                    }
                    cb && cb();
                } else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function () {
                        _this.getAllUnPayed();
                    }, function () {

                    });
                }
            });
        },
        getUnpayedData: function() {
            return this.unpayedData.filter(function(item) {
                return item.unpayType != 1;
            })
        },
        setShopInvaldate: function(shopId, year) {
            var shops = amGloble.metadata.shops;
            for (var i = 0; i < shops.length; i++) {
                var item = shops[i];
                if (item.shopId == shopId) {
                    var nowDate = new Date();
                    var shopInvaliDate = item.invalidDate ? new Date(Number(item.invalidDate)).getTime() : nowDate.getTime();
                    var outDate = shopInvaliDate - nowDate.getTime();
                    var invaliDate = "";

                    if (outDate < 0) {
                        invaliDate = new Date(nowDate.setFullYear(nowDate.getFullYear() + year + "")).getTime();
                    } else {
                        invaliDate = new Date(new Date(shopInvaliDate).setFullYear(new Date(shopInvaliDate).getFullYear() + year + "")).getTime();
                    }

                    item.invalidDate = invaliDate;
                    break;
                }
            }
            $.am.debug.log("metadatashops", shops);
        },
        saveCommunityRefreshTimeByUserId:function(){
            var userId = amGloble.metadata.userInfo.userId,
                now = new Date();
                localTime = this.getLocalTime();
            if (!localTime){
                localTime = {};
                localTime[userId] = now.getTime();
            }else{
                localTime[userId] = now.getTime();
            }
            // console.log('refresh timeStamp:'+new Date(localTime[userId]).format('yyyy-mm-dd HH:MM:ss'));
            this.setLocalTime(localTime);
        },
        sendTime:function(time){
            var module = this.getModuleEnable(module1,'community');
            if(!module){
                return;
            }
            // console.log('send timeStamp:'+new Date(time).format('yyyy-mm-dd HH:MM:ss'));
            var self = this;
            if (self.otherCacheUtil.valid()) return;
            var userInfo = amGloble.metadata.userInfo;
            amGloble.api.communityMsg.exec({
                "shopId": userInfo.shopId,  //门店id
                "publicUserId": userInfo.userId, //用户id
                "publicUserType": userInfo.userType, //用户类型
                "publicDate": time,  //日期
                "parentShopId": userInfo.parentShopId
            }, function (ret) {
                console.log(ret);
                if (ret.code == 0) {
                    self.otherCacheUtil.setLastTime();
                    // amGloble.msg("获取成功！");
                    if( ret.content ){
                        self.topicNum = Math.round( ret.content.NEWTOPICS );
                        self.detailNum = Math.round(ret.content.NEWCOMMENTS + ret.content.NEWSUPPORTS );
                        self.renderMsg(self.topicNum,self.detailNum,time);
                    }
                } else {
                    amGloble.msg(ret.message || "数据获取失败，请重试！", true);
                }
            });
        },
        communityInsertType:-1,
        renderMsg:function(topicNum,detailNum,time){
            var $dot = this.$.find('td[page="community"] .num');
            if(detailNum){
                $dot.show().text(detailNum).removeClass('dot');
                this.communityInsertType = 1;
                this.getNewTopic(time);
            }else{
                if(topicNum){
                    $dot.show().addClass('dot').text('');
                    this.communityInsertType = 2;
                }else{
                    $dot.hide().removeClass('dot').text('');
                    this.communityInsertType = -1;
                }
            }
        },
        communityClickCb:function(){
            var self = this;
            if(self.communityInsertType==-1){
                $.am.changePage(amGloble.page.community, "slideleft");
            }else if(self.communityInsertType==1){
                if(self.newTopicDetail){
                    atMobile.nativeUIWidget.confirm({
                        caption: '查看帖子详情页',
                        description: '有新消息，是否进入工作社群查看？',
                        okCaption: '是的',
                        cancelCaption: '取消'
                    }, function () {
                        $.am.changePage(amGloble.page.communityDetail, "slideleft", self.newTopicDetail);
                    }, function () {
                        $.am.changePage(amGloble.page.community, "slideleft");
                    });
                }else{
                    $.am.changePage(amGloble.page.community, "slideleft");
                }
            }else if(self.communityInsertType==2){
                $.am.changePage(amGloble.page.community, "slideleft");
            }
        },
        getNewTopic:function(time){
            var self = this;
            var userInfo = amGloble.metadata.userInfo;
            amGloble.api.getNewTopic.exec({
                "pageSize":8,
                "pageNumber":0,
                "shopId": userInfo.shopId,  //门店id
                "loginUserId": userInfo.userId, //用户id
                "loginUserType": userInfo.userType, //用户类型
                "publicUserId": userInfo.userId,
                "publicUserType": userInfo.userType,
                "publicDate": time , //日期
                "supportNum":30
            }, function (ret) {
                // console.log(ret);
                if (ret.code == 0) {
                    if( ret ){
                        self.newTopicDetail = ret.topic;
                    }
                } else {
                    amGloble.msg(ret.message || "数据获取失败，请重试！", true);
                }
            });
        },
        getLocalTime:function(){
            return JSON.parse(localStorage.getItem('communityTime'))||'';
        },
        setLocalTime:function(obj){
            var data = JSON.stringify(obj);
            localStorage.setItem('communityTime',data);
        },
        setUserSign:function(content){
            localStorage.setItem("lastSignTime", JSON.stringify({
                time: content.createTime,
                mobile: amGloble.metadata.userInfo.mobile,
            }));
        },
        getUserSign:function(){
            var cacheDataString = localStorage.getItem("lastSignTime");
            // 兼容新老数据
            if (cacheDataString && cacheDataString.indexOf('mobile')) {
                var cacheData = JSON.parse(cacheDataString);
                if (cacheData.mobile != amGloble.metadata.userInfo.mobile) {
                    return null;
                } else {
                    return cacheData.time;
                }
            } else {
                return cacheDataString;
            }
        },
        removeUserSign:function(){
            localStorage.removeItem("lastSignTime");
        },
        checkUserSign:function(times){
            var _time = times || 30;
            var lastTime = this.getUserSign();
            var now = new Date().getTime();
            var tips="";
            if(lastTime){
                var diffTime = (now-lastTime)/60000;
                var s = Math.floor(diffTime/60);
                var m = Math.floor(diffTime%60);
                if(s<1){
                    tips = m + "分钟";
                }else{
                    tips = s + "小时" + m + "分钟";
                }
                if(diffTime<30){
                    return {
                        flag:false,
                        tips:tips
                    };
                }
            }
            return {
                flag:true
            };
        },
        setLastAttendanceData: function(data) {
            $.am.debug.log('-------------------------------设置最后一次打卡记录');
            $.am.debug.log(JSON.stringify(data));
            if (data) {
                data.employeeGoWorkTime = data.goWorkTime;
                data.employeeOutWorkTime = data.outWorkTime;
                window.offlineAttendance.setLastData(data);
            }
        },
        userAttendance: function (content,cb) {
            var self = this;
            try{
                var _this = this;
                var isFirstSign = localStorage.getItem("isFirstSign");
                var res = { version: 1, };
                var userInfo = amGloble.metadata.userInfo;
                res.shopId = userInfo.shopId;
                res.date = content.createTime;
                res.mobile = userInfo.mobile;
                res.employeeId = userInfo.userId;
                res.timeDifference = content.timeDifference;
                res.pushToken = device.uuid;//设备ID

                if(content.shopId!=userInfo.shopId){
                    amGloble.msg("请扫本店的二维码打卡！");
                    return;
                }



                function userSign(){
                    amGloble.loading.show("获取数据中，请稍后...");
                    amGloble.api.attendanceSignin.exec(res, function (ret) {
                        amGloble.loading.hide();
                        if (ret.code == 0) { //成功
                            // 获取排班信息 如果已经排班了则不弹窗
                            var param={
                                period:new Date(parseInt(res.date)).format('yyyy-mm-dd'),// 兼容字符串
                                shopId: userInfo.shopId,
                                parentShopId:amGloble.metadata.userInfo.parentShopId,
                                employeeIds:[userInfo.userId]
                            };
                            var selectShiftAttendance = function() {
                                //需要选择
                                var shiftSetting = _this.getShiftList(amGloble.metadata.shiftSettingList.shiftSetting);
                                if (shiftSetting && shiftSetting.length) {
                                    amGloble.popupMenu("请选择班次", shiftSetting, function (con) {
                                        amGloble.loading.show("获取数据中，请稍后...");
                                        amGloble.api.attendanceUpdata.exec({
                                            employeeId: userInfo.userId,
                                            mobile: userInfo.mobile,
                                            shiftSetId: con.id,
                                            shiftName: con.name,
                                            shopId: userInfo.shopId,
                                            pushToken: device.uuid//设备ID
                                        }, function (ret) {
                                            amGloble.loading.hide();
                                            $.am.debug.log(JSON.stringify(ret));
                                            if(ret && ret.code==0){
                                                amGloble.msg("打卡上班成功！");
                                                _this.setUserSign(content);
                                                _this.$workStatus.removeClass("rest");
                                                cb && cb();
                                                self.setLastAttendanceData(ret.content)
                                            }else {
                                                amGloble.msg("打卡上班失败！");
                                            }
                                        });
                                    });
                                } else {
                                    amGloble.msg("请先联系管理员设置班次！");
                                }
                            }
                            amGloble.api.shiftsList.exec(param, function (ret) {
                                if (ret.code == 0 && ret.content) {
                                    var data=ret.content[0] && ret.content[0].scheduleShift&& ret.content[0].scheduleShift[0];
                                    if(data && data.id && data.shiftId){
                                        //  有排班
                                        if(data.shiftName.indexOf('休')>-1){
                                            // 排班休假
                                            amGloble.msg("您今天的排班是休假，不能打卡！");
                                            return;
                                        }else{
                                            amGloble.api.attendanceUpdata.exec({
                                                employeeId: userInfo.userId,
                                                mobile: userInfo.mobile,
                                                shiftSetId: data.shiftId,
                                                shiftName: data.shiftName,
                                                shopId: userInfo.shopId,
                                                pushToken: device.uuid//设备ID
                                            }, function (ret) {
                                                amGloble.loading.hide();
                                                $.am.debug.log(JSON.stringify(ret));
                                                if(ret && ret.code==0){
                                                    amGloble.msg("打卡上班成功！");
                                                    _this.setUserSign(content);
                                                    _this.$workStatus.removeClass("rest");
                                                    cb && cb();
                                                    self.setLastAttendanceData(ret.content)
                                                }else {
                                                    amGloble.msg("打卡上班失败！");
                                                }
                                            });
                                        }
                                    }else{
                                        selectShiftAttendance();
                                    }
                                } else if(ret.code === -1) {
                                    selectShiftAttendance();
                                    // _this.setStatus("error");
                                    // amGloble.msg("获取排班信息失败！");
                                }
                            });
                        } else if (ret.code == 300005) {
                            amGloble.msg("打卡下班成功！");
                            _this.$workStatus.addClass("rest");
                            _this.removeUserSign();
                            cb && cb();
                            self.setLastAttendanceData(ret.content)
                        } else if (ret.code == 300000) {
                            amGloble.msg(ret.message || "该二维码已经失效，请重新打卡!");
                        } else {
                            amGloble.msg(ret.message || "扫一扫失败,请重试!");
                        }
                    });

                }

                $.am.debug.log("isFirstSign:" + isFirstSign);
                if(isFirstSign!=1){
                    $.am.debug.log("进入confirm之前！！！！");
                    setTimeout(function(){//苹果机的bug  两次容器接口后必须异步调！！
                        amGloble.confirm("提示", "当前账号首次在本设备打卡考勤，继续操作将会绑定账号至本设备，是否继续？", "确定", "取消", function() {
                            localStorage.setItem("isFirstSign",1);
                            userSign();
                        },function() {
                            $.am.debug.log("进入confirm错误！！");
                        });
                    },100);
                }else{
                    //非第一次 判断是否要弹提示
                    var checks = _this.checkUserSign();
                    if(!checks.flag){
                        amGloble.confirm("提示", "工作时长较短：" +checks.tips+ "，确定要打卡下班吗？", "确定", "取消", function() {
                            userSign();
                        });
                    }else{
                        userSign();
                    }

                }

            }catch(e){
                $.am.debug.log(e.message);
            }
        },
        getShiftList: function (list) {
            var res = [];
            if (list && list.length) {
                for (var i = 0; i < list.length; i++) {
                    if (list[i].status == 0) {
                        res.push(list[i]);
                    }
                }
            }
            return res;
        },
        getQueryOperateActivity: function() {
            var statusMap = {
                1: '预热阶段，提前锁定意向顾客',
                2: '成交阶段，邀请顾客购买得收益',
                3: '活动已完美落幕',
            }
            var _this = this;
            amGloble.api.queryOperateActivity.exec({
            }, function(ret) {
                if (ret.code === 0 && ret.content && ret.content.length > 0) {
                    var data = ret.content[0];
                    var shopType = amGloble.metadata.userInfo.shopType;
                    var shopIdList = data.shopIds ? data.shopIds.split(',') : null;
                    var isTenantShop = shopType == 0,
                        isAllShop = !data.shopIds;
                    if (isTenantShop || isAllShop || (data.shopIds == '-1' && shopType == 2) || (shopIdList.indexOf(String(amGloble.metadata.userInfo.shopId)) !== -1)) {
                        var preEndTime = data.preEndTime,
                            activityEndTime = data.activityEndTime,
                            autoCloseDay = data.autoCloseDay == undefined ? 15 : data.autoCloseDay,
                            currentTime = new Date().getTime(),
                            status = 1;
                        if (currentTime < preEndTime) {
                            status = 1;
                        } else if (currentTime < activityEndTime) {
                            status = 2;
                        } else {
                            status = 3;
                        }
                        _this.activityData = data;
                        if(status == 3 && _this.hasPassedTheShowDay(activityEndTime, autoCloseDay)) {
                            return;
                        }
                        var appendText = status !== 3 ? ' 火热进行中~' : '';
                        var activityContent = _this.$activityContent.clone();
                        activityContent.find('.activity_left').addClass('is_operation-activity');
                        activityContent.find('.activity_title').text(data.name + appendText);
                        activityContent.find('.activity_join_time').text(statusMap[status]);
                        activityContent.find('.activity_vote_time').hide();
                        activityContent.data('data', data).show();
                        _this.$activity.find('.am-carrousel-inner').append(activityContent);
                        _this.$carrouselCounter.append("<span></span>");
                        _this.carrousel.refresh();
                        _this.$activity.show();
                        _this.scrollview.refresh()
                    }
                }
            })
        },
        getActiveList: function(callback) {
            var _this = this;
            var userInfo = amGloble.metadata.userInfo;
            this.$activity.hide()
            amGloble.loading.show();
            amGloble.api.getActiveList.exec({
                activityType: 1,
                pageNumber: 0,
                pageSize: 1,
                parentShopId: userInfo.parentShopId,
                shopId: userInfo.shopId,
                userId: userInfo.userId
            }, function (ret) {
                amGloble.loading.hide();
                if (ret && ret.code == 0) {
                    if (ret.content && ret.content.length) {
                        var activity = ret.content[0]
                        var hasActivePower = _this.hasActivePower(activity)
                        if (hasActivePower) {
                            _this.renderVoteActivity(activity)
                        }
                    }
                }
                callback && callback()
            });
        },
        hasActivePower: function(item) {
            var userInfo = amGloble.metadata.userInfo;
            var shopIds = item.shopIds
            if (userInfo.shopId == userInfo.parentShopId) {
                return true
            } else if (shopIds && shopIds.split(',').indexOf(userInfo.shopId+"") == -1) {
                return false
            } else {
                return true
            }
        },
        renderVoteActivity: function(item) {
            var competitionTimeEnds = new Date(item.competitionTimeEnd).format("yyyy.mm.dd");
            var competitionTimeStarts = new Date(item.competitionTimeStart).format("yyyy.mm.dd");
            var voteTimeEnds = new Date(item.voteTimeEnd).format("yyyy.mm.dd");
            var voteTimeStarts = new Date(item.voteTimeStart).format("yyyy.mm.dd");
            var activityContent = this.$activityContent.clone();
            activityContent.find('.activity_title').text(item.activityName)
            activityContent.find('.activity_join_time').text('参赛时间：'+competitionTimeStarts+ ' ~ ' +competitionTimeEnds)
            activityContent.find('.activity_vote_time').text('投票时间：'+voteTimeStarts+' ~ ' +voteTimeEnds).show();
            item.isVote = true;
            activityContent.data('data',item)
            this.$activity.find('.am-carrousel-inner').append(activityContent);
            this.$carrouselCounter.append("<span></span>");
            this.carrousel.refresh();
            this.$activity.show();
        },
        showNewVideoTip:function(){
            var isShow=$('#page-education .newestIcon').data('isShow'),
                $newestIcon=$('#page-dashboard .newestIcon');//视频上新小圆点
           return isShow?$newestIcon.show(): $newestIcon.hide();
        },
        beforeShow: function (ret) {
            if (amGloble.metadata.userInfo.shopType !== 0) {
                var shopData = amGloble.metadata.shopMap[amGloble.metadata.userInfo.shopId];
                if (shopData && shopData.invalidDate) {
                    var currentTime = new Date().getTime();
                    var diffTime = currentTime - shopData.invalidDate;
                    if (diffTime > 90 * 24 * 3600 * 1000) {
                        atMobile.nativeUIWidget.confirm({
                            caption: '门店到期',
                            description: '您的门店已到期，请续费后重新登录！',
                            okCaption: '确定',
                            cancelCaption: '退出登录'
                        }, function () {
                            $.am.changePage(amGloble.page.login, "slideright", "logout");
                        }, function () {
                            $.am.changePage(amGloble.page.login, "slideright", "logout");
                        });
                    }
                }
            }
            if (ret === 'back' && this.dashboardCacheUtil.valid()) return;
            window.offlineAttendance.validMember();
            this.activityData = null;
            this.$activity.find('.am-carrousel-inner').empty().siblings('.count').empty();
            this.carrousel.refresh();

            // 续费红点
            this.getRenewDod();

            this.showNewVideoTip();
            var userId = amGloble.metadata.userInfo.userId;
            var self = this;
            this.clear();
            this.getSmallAppInfo(function(){
                self.queryUserData(function() {
                    self.render();
                    self.getDashbordCount();
                })
            });
            this.getActiveList(function() {
                if (amGloble.metadata.configs.mgjGroupbuyingOrderStatisticsEnable == 1) {
                    self.getQueryOperateActivity()
                }
            });
            if (amGloble.metadata.userInfoList) {
                this.metaAccountList = amGloble.metadata.userInfoList;
                // this.transData(amGloble.metadata.userInfoList);
                this.accountList = amGloble.metadata.userInfoList.filter(function(accountData) {
                    return accountData.userId !== amGloble.metadata.userInfo.userId;
                })
                if (!this.accountList.length) {
                    this.$userinfo.find(".account").addClass('disabled');
                } else {
                    this.$userinfo.find(".account").removeClass('disabled');
                }
            }
            // this.isShowArrow();
            var communityTime = this.getLocalTime();
            if(!communityTime || !communityTime[userId]){
                this.saveCommunityRefreshTimeByUserId();
            }
			this.setStatus("normal");
			this.renderRedDot();
            window.offlineAttendance.syncData();

            var parentShopId = amGloble.metadata.userInfo.parentShopId;
            var themeConfigKey = amGloble.metadata.configs.themeConfigKey;
            if (!themeConfigKey && amGloble.metadata.userInfo.mgjVersion == '2') {
                themeConfigKey = 'themeColor5'; // 风尚版默认配色
            }
            themeSetting.getThemeConfig({ parentShopId: parentShopId, themeConfigKey: themeConfigKey }, function(config){
                if(config && (!config.themeConfigKey || config.themeConfigKey == 'themeColor1')) {
                    self.$contact.hide();
                } else {
                    self.$contact.show();
                }
            })
            amGloble.api.merchantList.exec({
                pageSize: 30,
                pageNumber: 0,
                shopId: amGloble.metadata.userInfo.shopId,
            }, function(ret) {
                if (ret.code == 0) {
                    if (ret.content.length > 0) {
                        $('.tab-main').show();
                    } else {
                        $('.tab-main').hide();
                    }
                    self.refresh()
                }
            })
        },
        queryUserData: function(cb) {
            var self = this;
            if (amGloble.enableNewReport == undefined) {
                var userinfo = amGloble.metadata.userInfo;
                amGloble.api.queryData.exec({
                    mobile: userinfo.mobile,
                    tableName: "SYB_enableNewReport",
                }, function(res) {
                    amGloble.enableNewReport = (res && res.code == 0 && res.content) ? JSON.parse(res.content.data) : undefined;
                    self.enableNewReport = amGloble.enableNewReport;
                    cb && cb();
                })
            } else {
                self.enableNewReport = amGloble.enableNewReport;
                cb && cb();
            }
        },
        transData: function (accountList) {
            var curUserId = amGloble.metadata.userInfo.userId;
            var self = this;
            self.accountList = [];
            $.each(accountList, function (i, item) {
                if (curUserId != item.userId) {
					var shopName = item.osName && item.osName != " " ? item.osName : item.shopName
                    var account = {
                        name: shopName + '-' + item.levelName + '-' + item.userName,
                        id: item.userId
                    };
                    self.accountList.push(account);
                }
                self.accountMap[item.userId] = item;
            })
        },
        getLoginImageCaptchaUrl: function(username) {
            return config.baseUrl + 'shengyibao/mobile/user/vc2?userKey='+username+'&ts='+new Date().getTime();
        },
        switchAccount: function (accountData) { //切换帐号逻辑
            this.unpayedData = [];
            amGloble.enableNewReport = undefined;
            this.login(accountData);
        },
        login:function(accountData){
            var self = this;
            amGloble.loading.show("正在登录,请稍候...");
            window.offlineAttendance.syncData(function() {
                accountData.switchAccount = true;
                amGloble.page.login.login(accountData.mobile, accountData.inputPassword, accountData.inputCode || '', accountData, function () {
                    self.dashboardCacheUtil.clear();
                    self.promotionCacheUtil.clear();
                    self.reservationCacheUtil.clear();
                    self.otherCacheUtil.clear();
                    self.beforeShow();
                    self.afterShow();
                    self.scrollview.scrollTo('top');
                    self.scrollview.refresh();
                }, function(ret) {
                    if (ret.code == 20190306 || ret.code == 200003) {
                        ret.code = 2022072501;
                        // ret.showImageCaptcha = true;
                    }
                    if (ret.code == 2022072501 || ret.code == 2022072502) {
                        amGloble.dialog.show({
                            className: 'choose_user_dialog',
                            confirmButtonText: ret.code == 2022072501 ? '登录' : '设置密码',
                            scb: function($dialog) {
                                if (ret.code == 2022072501) {
                                    var password = $dialog.find('.input_password').val();
                                    var $captcha = $dialog.find('.input_captcha');
                                    var code = $captcha.val();
                                    if (!$.trim(password)) {
                                        amGloble.msg('请输入密码');
                                        return;
                                    }
                                    if ($captcha.length && !$.trim(code)) {
                                        amGloble.msg('请输入图形验证码');
                                        return;
                                    }
                                    var newData = JSON.parse(JSON.stringify(accountData));
                                    newData.inputPassword = password;
                                    newData.inputCode = code;
                                    self.login(newData);
                                    amGloble.dialog.hide();
                                }
                                if (ret.code == 2022072502) {
                                    amGloble.dialog.hide();
                                    // $.am.changePage(amGloble.page.userinfoResetPwd, "slideleft", {
                                    //     phone: accountData.mobile,
                                    //     shopId: accountData.shopId,
                                    //     userId: accountData.userId,
                                    //     userType: accountData.userType,
                                    //     scb: function() {
                                    //         amGloble.msg('密码设置成功，请登录！');
                                    //         $.am.changePage(amGloble.page.login, "slideleft");
                                    //     }
                                    // });
                                    var params = {
                                        phone: accountData.mobile,
                                        shopId: accountData.shopId,
                                        userId: accountData.userId,
                                        userType: accountData.userType,
                                        scb: function() {
                                            $.am.changePage(amGloble.page.login, "slideright", "logout");
                                            setTimeout(function() { 
                                                location.reload();
                                            }, 500)
                                        }
                                    }
                                    window.RouterUtils.push({name:'validatePhoneNum',params:params,animation:'slideleft'})
                                }
                            },
                            renderContent: function($content) {
                                var type = accountData.userType == 1 ? "artisan" : "manager";
                                var genderClassNname = accountData.sex !== 'M' ? 'female' : '';
                                var inputString = '', 
                                    title = '',
                                    subtitle = '';
                                if (ret.code == 2022072501) {
                                    title = '请输入账号密码';
                                    subtitle = '密码不一致的账号无法直接切换登录，您需要重新验证此账号密码';
                                    inputString = '<input class="choose_user_dialog_input input_password" type="password" placeholder="请输入登录密码" /><span class="am-clickable forgort_password">忘记密码？</span>';
                                    if (ret.showImageCaptcha) {
                                        var imgSrc = self.getLoginImageCaptchaUrl(accountData.mobile);
                                        inputString += '<div class="image_captcha"><input class="choose_user_dialog_input input_captcha" type="text" placeholder="请输入图形验证码" /><img class="am-clickable" src="' + imgSrc + '" /></div>';
                                    }
                                } else {
                                    title = '请设置账号密码';
                                    subtitle = '密码不一致的账号无法直接切换登录，您需要设置此账号密码';
                                }
                                var shopName = accountData.tenantName == accountData.viewShopName ? accountData.viewShopName : accountData.tenantName + '<span class="shopname-point">·</span>' + accountData.viewShopName;
                                $content.html(
                                    '<p class="dialog_title">' + title + '</p>'+
                                    '<p class="dialog_subtitle">'+ subtitle +'</p>' +
                                    '<div class="userinfo">' +  
                                        '<div class="avatar ' + genderClassNname +'"></div>' +
                                        '<div class="content">' +
                                            '<div class="username">' + accountData.nickname + '<span>'+ accountData.levelName +'</span></div>' +
                                            '<div class="shopname">' + shopName + '</div>' +
                                        '</div>' +
                                    '</div>'+
                                    inputString
                                )
                                $content.find('.avatar').html(amGloble.photoManager.createImage(type, {
                                    parentShopId: accountData.parentShopId,
                                    updateTs: accountData.lastphotoupdatetime
                                }, accountData.userId + ".jpg", "s"))
                                $content.find('.forgort_password').vclick(function() {
                                    amGloble.dialog.hide();
                                    // $.am.changePage(amGloble.page.userinfoResetPwd, "slideleft", {
                                    //     phone: accountData.mobile,
                                    //     shopId: accountData.shopId,
                                    //     userId: accountData.userId,
                                    //     userType: accountData.userType,
                                    //     scb: function() {
                                    //         $.am.changePage(amGloble.page.login, "slideleft");
                                    //     }
                                    // });
                                    var params = {
                                        phone: accountData.mobile,
                                        shopId: accountData.shopId,
                                        userId: accountData.userId,
                                        userType: accountData.userType,
                                        modify: 2,
                                        scb: function() {
                                            $.am.changePage(amGloble.page.login, "slideright", "logout");
                                            setTimeout(function() { 
                                                location.reload();
                                             }, 500)
                                        }
                                    }
                                    window.RouterUtils.push({name:'validatePhoneNum',params:params,animation:'slideleft'})
                                })
                                $content.find('.image_captcha img').vclick(function() {
                                    var imgSrc = self.getLoginImageCaptchaUrl(accountData.mobile);
                                    $(this).attr('src', imgSrc);
                                })
                            }
                        })
                    } else {
                        amGloble.msg(ret.message || '切换账号失败！');
                    }
                });
            })
        },
        getRenewDod:function(){
            var module = this.getModuleEnable(module4,'smsrecharge');
            if(!module){
                return;
            }
            var self=this;
            var opts={}
            if(amGloble.metadata.userInfo.parentShopId==amGloble.metadata.userInfo.shopId){
                opts.parentShopId=amGloble.metadata.userInfo.parentShopId;
            }else{
                opts.parentShopId=amGloble.metadata.userInfo.parentShopId,
                opts.shopId=amGloble.metadata.userInfo.shopId;
            };
            amGloble.api.msgRenewlist.exec(opts, function (ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    if(ret.content && (ret.content.overDue==1)){
                        // 过期 需要红点提示充值
                        self.$table.find('td[page="msgDetail"] > span').addClass('red_dot');
                        self.$table.find('td[page="msgDetail"] > .num').show();
                    }
                    if(ret.content && (ret.content.overDue==0)){
                        // 没过期 不需要红点提示
                        self.$table.find('td[page="msgDetail"] > .num').hide();
                    }
                } else{
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                }
                self.closeTopLoading();
                self.closeBottomLoading();
            });
        },
        cacheTime: 5*60*1000,
        getSmallAppInfo: function(callback){
            if(this.lastGetSmallProTs && new Date().getTime() - this.lastGetSmallProTs <  this.cacheTime){
                callback && callback();
                return;
            }
            var self = this;
            amGloble.api.getSmallAppInfo.exec({
                id: amGloble.metadata.userInfo.parentShopId
            }, function (ret) {
                if( ret.code == 0 && ret.content && ret.content.isSmallPro){
                    self.isSmallPro = true
                } else {
                    self.isSmallPro = false
                }
                if( ret.code == 0){
                    self.lastGetSmallProTs = new Date().getTime();
                }else {
                    self.lastGetSmallProTs = 0;
                }
                callback && callback();
            })
        },
        afterShow: function () {
            var _this = this;
            var userId = amGloble.metadata.userInfo.userId;
            this.sendTime(this.getLocalTime()[userId]);
            this.isChangeLoading = false;
            this.scrollview.refresh();

            this.getProductSale(function() {
                _this.getAllUnPayed();
            });

        },
        beforeHide: function () { },
        afterHide: function () { },
        // isShowArrow: function() {
        //     if (localStorage.getItem('showArrow') == 'true') {
        //         this.$arrowmore.hide();
        //     }
        // },
        // randomJoke: function() {
        //     var jokes = window.jokes;
        //     var n = Math.floor(Math.random() * jokes.length + 1) - 1;
        //     var j = jokes[n];
        //     this.$jokes.find(".icon").html(j.title);
        //     this.$jokes.find("p").html(j.content);
        // },
        clear: function () {
            this.$title.empty();
            this.$name.empty();
            this.$role.empty();
            this.$photo.empty();
            this.$table.empty();
        },
        render: function () {
            var userinfo = amGloble.metadata.userInfo;
            //头像
            var type = userinfo.userType == 1 ? "artisan" : "manager";
            this.$photo.html(amGloble.photoManager.createImage(type, {
                parentShopId: userinfo.parentShopId,
                updateTs: userinfo.lastphotoupdatetime
            }, userinfo.userId + ".jpg", "s"));
            //性别
            if (userinfo.sex == "F") {
                this.$photo.addClass("female");
            } else {
                this.$photo.removeClass("female");
            }
            this.$name.text(userinfo.userName); //名字
            this.$role.text(userinfo.levelName); //角色
            this.$title.empty().text(userinfo.hqName); //租户名
            //功能块
            // 增加员工权限判断
            var staffFacilityData = amGloble.metadata.configs.staffFacility ? JSON.parse(amGloble.metadata.configs.staffFacility) : {};
            if (userinfo.newRole == 3 || userinfo.newRole == 2 || userinfo.newRole == 1 || staffFacilityData['reservation'] == 0) {
                this.$userinfo.find(".yuyue").hide();
            }else{
                this.$userinfo.find(".yuyue").show();
            }
            for (var key in plates) {
                var obj = plates[key];
                var $thead = "<thead><tr><td>" + obj.name + "</td></tr></thead>";
                if (JSON.stringify(obj.sub) != "{}") {
                    var i = 0;
                    var $tbody = $("<tbody></tbody>")
                    var $tr = $("<tr></tr>");
                    for (var k in obj.sub) {
                        var module = this.getModuleEnable(obj.sub,k);
                        if(!module){
                            continue;
                        }
                        var $td = $("<td></td>").addClass("am-clickable");
                        var $iconDiv = $("<div></div>").addClass("icon");
                        var $iconImg = $("<img />");
                        $iconImg.attr('src', "css/img/dashboard/" + module.icon + ".png");
                        $iconDiv.append($iconImg);
                        $td.append($iconDiv);
                        $td.append(module.name);
                        $td.append($("<span></span>").addClass("num").hide())
                        if (module.page != '') {
                            $td.attr("page", module.page);
                            if(module.pageType && module.pageType != ''){
                                $td.attr("pageType", module.pageType);
                            }
                        }
                        if (k == 'shopMall') {
                            var imgSrc = amGloble.photoManager.createImage(type, {
                                parentShopId: userinfo.parentShopId,
                                updateTs: userinfo.lastphotoupdatetime
                            }, userinfo.userId + ".jpg", "s")[0].src;
                            imgSrc = encodeURIComponent(imgSrc)
                            var sex = amGloble.metadata.userInfo.sex;
                            if (!sex)
                                sex = "1";
                            var url = imgSrc + "/" +
                                amGloble.metadata.userInfo.mobile + "/" + amGloble.metadata.userInfo.userName + "/" + sex;
                            $td.attr("href", "mall/index.html#/login/" + encodeURI(url));
                            $td.attr("data", "openWindow");
                        } else if (k == "myk") {
                            $td.attr("href", amGloble.getShareRoot() + $.param({
                                tenantId: amGloble.metadata.userInfo.parentShopId
                            }));
                        }
                        if (module.permission && module.permission.indexOf(amGloble.metadata.userInfo.mgjVersion) == -1) {
                            //风尚版 || 盛传版
                            $td.addClass("disabled");
                            if (amGloble.metadata.userInfo.mgjVersion == 6) {
                                continue;
                            }
                        } else {
                            $td.removeClass("disabled");
                        }
                        $tr.append($td);
                        i++;
                        if (i % 4 == 0) {
                            $tbody.append($tr)
                            $tr = $("<tr></tr>");
                        }

                    }
                    if (i % 4 != 0) {
                        for (var j = 0; j < 4 - i % 4; j++) {
                            $tr.append("<td></td>")
                        }
                        $tbody.append($tr)
                    }
                    if (i != 0) {
                        this.$table.append($thead);
                        this.$table.append($tbody);
                    }
                }
            }
            //资料不全给头部加红点
            if (userinfo.userType == 1 && (!userinfo.cutPrice || !userinfo.bio || !userinfo.tags)) {
                this.$user.addClass("dot");

            } else {
                this.$user.removeClass("dot");
            }
            this.scrollview.refresh()
        },
        getModuleEnable: function(sub,k){
            var self = this;
            var userinfo = amGloble.metadata.userInfo,
                authority = authorities[userinfo.newRole];
            var _configs = amGloble.metadata.configs;
            var sybPowerStr = userinfo.sybPowerStr;
            var mobileCreateTime = amGloble.metadata.mobileCreateTime;
            var sybNewReport = amGloble.metadata.sybNewReport;
            sybNewReport = new Date(sybNewReport).setHours(0, 0, 0, 0);
            if (userinfo.newRole == 3) {
                if (_configs && _configs.mgjFinancialOptimization == 1) {
                } else {
                    authority = authority.filter(function(item) {
                        return item != "optimization"
                    })
                }
            }
            var operatorFacility = _configs.operatorFacility ? JSON.parse(_configs.operatorFacility) : null;
            var jurisdiction = {};
            if (userinfo.newRole == 1) { //操作员 1
                if (_configs.operatorFacility) {
                    jurisdiction = JSON.parse(_configs.operatorFacility);
                }
            } else if (userinfo.newRole >= 4) { //员工
                if (_configs.staffFacility) {
                    jurisdiction = JSON.parse(_configs.staffFacility);
                }
            }
            var addflag = false;
            // 关闭老功能老板，管理员，操作员不显示数据，员工不变

            // if (userinfo.newRole == 1 || userinfo.newRole == 2 || userinfo.newRole == 3) {
            //     if (_configs && _configs.mgjOldFunctionEnable && _configs.mgjOldFunctionEnable == 1) {
            //         authority = authority.filter(function(item) {
            //             return item != "report"
            //         })
            //     }
            // }
            var hasSybPower = ((sybPowerStr && sybPowerStr.indexOf(k) != -1) || !sybPowerStr || sybPowerStr == ',,') || (sub[k] && sub[k].permission && sub[k].permission.indexOf(amGloble.metadata.userInfo.mgjVersion) == -1);
            if(['surveyActive','optimization'].indexOf(k) !== -1) {
                hasSybPower = true;
            }
            for (var i1 = 0; i1 < authority.length; i1++) {
                if (jurisdiction[authority[i1]] != 0 && k == authority[i1] && hasSybPower) {
                    addflag = true;
                    break;
                }
            }
            if (!addflag) {
                return false;
            }
            var module = sub[k];
            var reducescale = amGloble.metadata.shops[0].reducescale;

            if (module.autohide && reducescale && reducescale > 1) {
                return false;
            };

            if (k == 'shopMall' && _configs.hideWxmall == 'true') {
                return false;
            }
            if (k == 'surveyActive' && !this.isSmallPro) {
                return false;
            }
            if (userinfo.newRole == 1 && k == 'appointment' && operatorFacility && operatorFacility.reservation == 0) {
                return false;
            }
            if ((userinfo.newRole == 1 || userinfo.newRole == 4 || userinfo.newRole == 5 || userinfo.newRole == 6) && k == 'wheel' && operatorFacility && operatorFacility.rotate == 0) {
                return false;
            }
            if(k == 'ranking' && (sybPowerStr || sybPowerStr == ',,') && !sybPowerStr.includes(",ranking,")) {
                return false;
            }
            else if (!sybPowerStr && userinfo.operatestr && userinfo.operatestr.indexOf('MGJR2') > 0 && k == 'ranking') {
                return false;
            }
            //基础系统铭感数据添加超级报表权限配置
            if(k == 'supOprateRep' && (sybPowerStr || sybPowerStr == ',,') && !sybPowerStr.includes(",supOprateRep,")) {
                return false;
            }
            else if(k == 'supOprateRep' && !sybPowerStr && (!userinfo.operatestr || (userinfo.operatestr && userinfo.operatestr.indexOf('MGJS1')))===-1){
                return false;
            }
            //基础系统铭感数据添加数据看板限配置
            if(k == 'sourceBoard' && (sybPowerStr || sybPowerStr == ',,') && !sybPowerStr.includes(",sourceBoard,")) {
                return false;
            }
            else if(k == 'sourceBoard' && !sybPowerStr && (!userinfo.operatestr || userinfo.operatestr.indexOf('MGJSDB'))===-1){
                return false;
            }
            if ((['supOprateRep', 'sourceBoard', 'mall', 'report'].indexOf(k) != -1)) {
                if (self.enableNewReport == undefined) {
                    if (mobileCreateTime && (mobileCreateTime > sybNewReport)) {
                        return false;
                    }
                } else {
                    if (self.enableNewReport) {
                        return false;
                    }
                }
            }
            
            if (k == 'newReport') {
                if (self.enableNewReport == undefined) {
                    if (!mobileCreateTime || (mobileCreateTime < sybNewReport)) {
                        return false;
                    }
                } else {
                    if (self.enableNewReport == false) {
                        return false;
                    }
                }
            }
            if (sub[k].validShow && sub[k].validShow(jurisdiction) === false) {
                return false;
            }
            return sub[k];
        },
		getEmpGoalCheckNum: function(user){
            var module_shopGoal = this.getModuleEnable(module1,'shopGoal');
            var module_empGoalCheck = this.getModuleEnable(module1,'empGoalCheck');
            if(!module_shopGoal && !module_empGoalCheck){
                return;
            }
            var self = this;
            amGloble.api.targetTip.exec({
                shopId: user.shopId,
                parentShopId: user.parentShopId,
                empId: user.userId,
                type: user.userType,
            }, function (ret) {
                if (ret.code == 0) {
				   //目标管理
					if (ret.content && ret.content.type == undefined || amGloble.metadata.userInfo.newRole == 3) {
                        self.$table.find('td[page="shopGoal"] > .num,td[page="empGoalCheck"] > .num').hide();
                    } else {
						var tomorrow = localStorage['tomorrow_' + amGloble.metadata.userInfo.userId];
						if(tomorrow == undefined || tomorrow && (new Date().getTime() > tomorrow)){
							self.$table.find('td[page="shopGoal"] > .num,td[page="empGoalCheck"] > .num').show().css({
								padding: 0,
								width: 8,
								height: 8,
								right: 25,
								borderRadius:"50%"
							});
						}
					}
				} else {
                    amGloble.msg(ret.message || "数据获取失败，请重试！", true);
                }
            });
		},
        getDashbordCount: function () {
            var user = amGloble.metadata.userInfo;
            var self = this;
			this.getEmpGoalCheckNum(user);
            // amGloble.loading.show("正在获取,请稍候...");
            if (!self.dashboardCacheUtil.valid()) {
                amGloble.api.dashboard.exec({
                    shopid: user.shopId,
                    empid: user.userId,
                    userType: user.userType,
                    appUserId: user.appUserId
                }, function (ret) {
                    // amGloble.loading.hide();
                    if (ret.code == 0) {
                        self.renderDashbordDot(ret.content);
                    } else {
                        amGloble.msg(ret.message || "数据获取失败，请重试！", true);
                    }
                });
            }else if(self.dashboardCacheUtil.lastUpdateData){
                self.renderDashbordDot(self.dashboardCacheUtil.lastUpdateData);
            }
            var module = this.getModuleEnable(module1,'reservation');
            if (module && user.newRole != 3 && user.newRole != 2 && user.newRole != 1) {
                console.log(user.userId)
                if (!self.reservationCacheUtil.valid()) {
                    amGloble.api.reservationCount.exec({
                        shopId: user.shopId,
                        barberId: user.userId
                    }, function (ret) {
                        // amGloble.loading.hide();
                        if (ret.code == 0) {
                            self.reservationCacheUtil.setLastTime();
                            self.$userinfo.find(".yuyue span").text(ret.content)
                        } else {
                            amGloble.msg(ret.message || "数据获取失败，请重试！", true);
                        }
                    });
                }
            }
            // user.appUserId = null;
            //如果拿到了pushToken,但是此设备没有注册
            if (config.pushToken && !user.appUserId) {
                var closePushToken = window.localStorage.getItem('closePushToken');
                $.am.debug.log('重新注册设备');
                amGloble.api.registerDevice.exec({
                    "parentShopId": user && user.parentShopId,
                    "userId": user && user.userId,
                    "userName": user && user.mobile,
                    "userType": user && user.userType,
                    "deviceType": device.platform != "Android" ? 1 : 2,
                    "deviceId": device.uuid,
                    "sysInfo": "",
                    "pushToken": config.pushToken,
                    active: Number(closePushToken) === 1 ? 0 : 1,
                }, function (ret) {
                    console.log(ret);
                    if (ret.code == 0) {
                        amGloble.api.metadata.exec({
                            parentShopId: config.parentShopId,
                            token: config.token
                        }, function (ret, isLocal) {
                            // amGloble.loading.hide();
                            if (ret.code == 0 && ret.content) {
                                amGloble.metadata = amGloble.processMetadata($.extend(true, {}, ret.content));
                                //初始化下拉菜单
                                amGloble.storeSelect.init();
                                amGloble.empSelect.init();
                            }
                        }, 1);
                    } else {
                        amGloble.msg(ret.message || "数据获取失败，请重试！", true);
                    }
                });
            }
		},
        getOperateApproveCount: function() {
            return this.$table.find('td[page="operateApproveList"] > .num').text();
        },
        setOperateApproveCount: function(num) {
            if (num) {
                this.$table.find('td[page="operateApproveList"] > .num').show().text(num);
            } else {
                this.$table.find('td[page="operateApproveList"] > .num').hide();
            }
        },
        renderDashbordDot: function(data){
            var self = this;
            self.dashboardCacheUtil.setLastTime();
            self.dashboardCacheUtil.setLastData(data);
            // ret.content.reservationNum = 12;
            if (data.reservationNum) {
                self.$table.find('td[page="reservation"] > .num').show().text(data.reservationNum);
            } else {
                self.$table.find('td[page="reservation"] > .num').hide();
            }
            if (data.currentServiceNum) {
                self.$table.find('td[page="serviceManagement"] > .num').show().text(data.currentServiceNum);
            } else {
                self.$table.find('td[page="serviceManagement"] > .num').hide();
            }
            if (data.todoListNum) {
                self.$table.find('td[page="todoList"] > .num').show().text(data.todoListNum);
            } else {
                self.$table.find('td[page="todoList"] > .num').hide();
            }
            self.setOperateApproveCount(data.auditNum);
            if (data.workStatus == 0) { //休息
                self.$workStatus.addClass("rest");
            } else { //工作中
                self.$workStatus.removeClass("rest");
            }
            amGloble.setMessageDot(data.pushMessageNum);
            self.setLastAttendanceData(data.employeeCheck)
        },
		// 处理打赏、收益红点
		renderRedDot: function() {
            var module_promotionbenefit = this.getModuleEnable(module3,'promotionbenefit');
            var module_exceptional = this.getModuleEnable(module3,'exceptional');
            if(!module_promotionbenefit && !module_exceptional){
                return;
            }
			var self = this;
            if (self.promotionCacheUtil.valid()) return;
			amGloble.api.queryDashboardRedDot.exec({}, function(ret) {
				if (ret.code == 0) {
                    self.promotionCacheUtil.setLastTime();
					var userId = amGloble.metadata.userInfo.userId;
					var lsPromotionKey = userId + '_promotionbenefit_dot_data';
					var lSexceptionalKey = userId + '_exceptional_dot_data';
					var promotionbenefitData = ret.content.promotionbenefit;
					var exceptionalData = ret.content.exceptional;
					var oldPromotionbenefitData = JSON.parse(localStorage.getItem(lsPromotionKey)) || {time: 0};
					var oldExceptionalData = JSON.parse(localStorage.getItem(lSexceptionalKey)) || {time: 0};
					if ((oldPromotionbenefitData.id != promotionbenefitData.id) && (promotionbenefitData.time > oldPromotionbenefitData.time)) {
						self.$.find('td[page="promotionbenefit"]').addClass('red_dot').one('vclick', function() {
							localStorage.setItem(lsPromotionKey, JSON.stringify(promotionbenefitData));
						});
					}

					if (oldExceptionalData.id != exceptionalData.id && exceptionalData.time > oldExceptionalData.time) {
						self.$.find('td[page="exceptional"]').addClass('red_dot').one('vclick', function() {
							localStorage.setItem(lSexceptionalKey, JSON.stringify(exceptionalData));
						});
					}

				} else {
					amGloble.msg(ret.message || "数据获取失败，请重试！", true);
				}
			})
		},
        hasPassedTheShowDay: function(endDay, days) {
            var targetDay = endDay + (days*86400000);
            var today = new Date().getTime();
            return today > targetDay;
        }
    });

})();



//
