(function(){
    var self = amGloble.page.delTagManage = new $.am.Page({
        id: 'page-delTagManage',
        init: function(){
            this.$header.find('.left').vclick(function() {
                $.am.page.back('slidedown');
            });

            this.$header.find('.right').vclick(function(){
                self.$.find(".tagname").addClass("selected")
            });
            this.$delBox = this.$.find('.delBox').on("vclick",".cancel",function(){
                self.$delBox.hide()
                self.$mask.hide()
            }).on("vclick",".confirm",function(){
                self.$delBox.hide()
                self.$mask.hide()
                self.toDelTags($(this).data("data"))
            })
            this.$mask = this.$.find(".mask").vclick(function(){
                self.$delBox.hide()
                self.$mask.hide()
            })

            this.$tagGroupItem = this.$.find('.tagGroupItem');
            this.$tagGroupList = this.$.find('.tagGroupList')
            this.$item = this.$tagGroupItem.find('li').remove();

            this.$.on("vclick", ".tagname", function(){
                var isSelected = $(this).hasClass("selected")
                if(isSelected){
                    $(this).removeClass("selected")
                }else{
                    $(this).addClass("selected")
                }
            }).on("vclick", ".toDelTag", function(){
                var lis = self.$tagGroupList.find('.selected');
                if(lis.length){
                    var tagArr = [];
                    for(var i=0;i<lis.length;i++){
                        tagArr.push($(lis[i]).data('data'));
                    }
                    self.showDelBox(tagArr)
                    // atMobile.nativeUIWidget.confirm({
                    //     caption: '确认删除',
                    //     description: '是否删除选中标签？',
                    //     okCaption: '确定',
                    //     cancelCaption: '取消'
                    // }, function() {
                    //     self.toDelTags(tagArr)
                    // }, function() {
                    // });
                }else {
                    amGloble.msg("请选择标签")
                }

            }).on("vclick", ".tagManageShopButton", function(e){
                var shopids = amGloble.metadata.userInfo.shopids;
                var manageShopIds = String(amGloble.metadata.userInfo.shopId) + ',' + shopids;
                amGloble.allShops.show({
                    showManaged: shopids ? true : false,
                    manageShopIds: manageShopIds,
                    callback: function(shopData) {
                        amGloble.setTagShop(shopData);
                        self.$.find('.tagManageShopButton .text').text(shopData.shopFullName);
                        self.getTagList();
                    }
                })
            })


            self.mainScroll = new $.am.ScrollView({
                $wrap: self.$.find(".tagScroll"),
                $inner: self.$.find(".tagGroupList"),
                direction: [0, 1]
            });
            if($.am.checkScroll(true)<11){
                // this.$mask.remove();
            }
        },
        beforeShow: function(params){
			if (params === 'back') return;
            this.$.find('.wrapper').hide();
            var shop = amGloble.metadata.shopMap[amGloble.metadata.userInfo.shopId];
            amGloble.setTagShop(shop);
            this.$.find('.tagManageShopButton .text').text(shop.shopFullName);
            if (amGloble.metadata.userInfo.shopType == 0) {
                this.$.find('.toManageDelTag').show();
            } else {
                this.$.find('.toManageDelTag').hide();
            }
        },
        afterShow: function(params){
			if (params === 'back') return;
            this.getTagList();
        },
        beforeHide: function(){
        },
        afterHide: function(){
		},
        showDelBox: function(arr){
            var ids = arr.map(function(item){
                return item.id
            })
            var userInfo = amGloble.metadata.userInfo;
            amGloble.api.queryCustomerTagNums.exec({
                parentShopId: userInfo.parentShopId,
                shopId: userInfo.shopId,
                ids: ids
            },function(ret){
                if(ret && ret.code==0){
                    var count = 0
                    for (var index = 0; index < ret.content.length; index++) {
                        var item = ret.content[index];
                        count += item.count
                    }
                    if(count){
                        self.$mask.show()
                        self.$delBox.find(".num").text(count)
                        .end().find(".tag").text(arr[0].tagName)
                        .end().find(".confirm").data("data", arr)
                        .end().show()
                        if(arr.length > 1){
                            self.$delBox.find(".length").text("等"+arr.length+"个标签")
                        }else{
                            self.$delBox.find(".length").text("")
                        }
                    }else{
                        atMobile.nativeUIWidget.confirm({
                            caption: '删除标签',
                            description: '是否彻底删除标签？',
                            okCaption: '取消',
                            cancelCaption: '确定'
                        }, function() {

                        }, function() {
                            self.toDelTags(arr)
                        });
                    }
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.showDelBox();
                    }, function() {
                    });
                }
            })

        },
        toDelTags: function(delList){
            var userInfo = amGloble.metadata.userInfo;
            amGloble.loading.show();
            var ids = delList.map(function(item){
                return item.id
            })
            amGloble.api.delTag.exec({
                parentShopId: userInfo.parentShopId,
                ids: ids,
                tagMode: 2
            },function(ret){
                amGloble.loading.hide();
                if(ret && ret.code==0){
                    amGloble.msg('删除成功');
                    self.getTagList()

                    var customer = amGloble.page.addTag.customer.tags || []
                    for (var i = 0; i < customer.length; i++) {
                        if(ids.indexOf(customer[i].id) >= 0){
                            customer.splice(i, 1)
                        }
                    }
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.toDelTags();
                    }, function() {
                    });
                }
            })
        },
        getTagList: function(cb){
            self.setStatus('pageLoading');
            var userInfo = amGloble.metadata.userInfo;
            var shop = amGloble.getTagShop();
            amGloble.api.queryTags.exec({
                parentShopId: userInfo.parentShopId,
                shopIds: [userInfo.parentShopId, shop.shopId],
                status: 1,
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.setStatus('normal');
                    var shopTagList = ret.content.filter(function(item){
                        return shop.shopId == item.shopId
                    })
                    self.render(shopTagList, shop.shopId);
                    cb && cb(shopTagList)
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.getTagList();
                    }, function() {
                    });
                }
            })
        },
        render:function(data, shopId){
            this.$tagGroupList.find(".wrapper").remove()
            var userInfo = amGloble.metadata.userInfo
            var parentShopId = amGloble.metadata.userInfo.parentShopId
			var listdata = self.tagList = processData(data);
            for (var index = 0; index < listdata.length; index++) {
                var group = listdata[index];
                var $group = this.$tagGroupItem.clone()
                $group.data("data", group)
                $group.find('.type').text(group.groupName)
                if(group.parentShopId !== parentShopId){
                    $group.find('.title').addClass("shop")
                }
                for (var i = 0; i < group.children.length; i++) {
                    var tag = group.children[i];
                    if(tag.shopId == shopId){
                        if(userInfo.userType == 1 && tag.empId != userInfo.userId){
                            continue
                        }
                        var $li = this.$item.clone();
                        $li.find('p').html(tag.tagName).data("data", tag);
                        $li.data('data',tag);
                        if(tag.parentShopId !== parentShopId){
                            $li.find('p').addClass("shop")
                        }
                        $group.find("ul").append($li);
                    }
                }
                if ($group.find("ul").children('li').length === 0) {
                    continue;
                }
                this.$tagGroupList.append($group)
            }
            if(this.$tagGroupList.find(".wrapper").length == 0){
                this.$tagGroupList.hide().siblings(".empty").show()
            }else{
                this.$tagGroupList.show().siblings(".empty").hide()
            }
            this.$.find('.wrapper').show();
            this.mainScroll.refresh();
            this.mainScroll.scrollTo('top');
        },
    });
})();
