(function () {
    var self = amGloble.page.delayBenefit = new $.am.Page({
		id: "page-delayBenefit",
		noticeMarquee: null,
        init: function () {
            var self = this;
            this.$delay_benefit_box = this.$.find(".delay_benefit_box");
        },
        beforeShow: function () {
            this.queryCampaignList();
        },
        afterShow: function () {
        },
        beforeHide: function () {},
        render: function(data) {
            var self = this;
            var html = '';
            var unFreezeTime = 0;
            self.$delay_benefit_box.empty();
            for(var i = 0; i < data.length; i++) {
                if(data[i].unFreezeTime > 0) {
                    unFreezeTime = Math.floor((data[i].unFreezeTime - new Date().getTime()) / (1000 * 60 * 60 * 24));
                } 
                html = '<div class="delay_benefit_list">' +
                            '<div class="top">' +
                                '<span class="title_name">' + data[i].serviceName + '</span>' +
                                '<span class="price">¥ ' + data[i].campaignMoney + '</span>' +
                            '</div>' +
                            '<div class="bottom">' +
                                '<span class="benefit_origin">收益来自顾客：' + data[i].customName + '</span>' +
                                '<span class="account_time">' + (unFreezeTime >= 1? (unFreezeTime + '天后入账') : ((unFreezeTime + 1) + '天内入账')) + '</span>' +
                            '</div>' +
                        '</div>';
                self.$delay_benefit_box.append(html);
            }
        },
        queryCampaignList: function () { //查询收益列表
            var self = this;
            var metadata = amGloble.metadata.userInfo;
            amGloble.api.queryCampaignList.exec({
                "parentShopId": metadata.parentShopId,
                "shopId": metadata.shopId,
                "pageNumber": 1,
                "pageSize": 9999,
                "userId": metadata.userId,
                "isFreeze":"1", // null 全部  1 冻结的订单  0 没有冻结的订单
                "userType": metadata.userType
            }, function (ret) {
				amGloble.loading.hide();
                if (ret.code == 0) {
                    self.render(ret.content.data);
                } else {
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                }
            });
        },
    });
})();