(function(){
    var replaceTemple=function(str,data,rule) {
        return str.replace(/\{(.*?)\}/g,function(a,b){
            return (rule && rule[b])?rule[b].call(null,b):data[b]
        })
    }
    var getAdminImageUrl = function(key) {
        var type = 'l';
        if(!key){
            return "";
        }
        var url="{openUrl}{space}{key}?imageMogr2/crop/!{w}x{h}a{x}a{y}|imageMogr2/thumbnail/{sw}x{sh}!";
        var arrurl=key.split(".");
        var item = {
            "dir": "merchantCover/",
            "size": [1024, 1024],
            "variations": {
                "l":"1024x1024",
                "m":"480x480",
                "s":"256x256"
            }
        }
        var _url=arrurl.slice(0),
            _pos=_url[0].split("_"),
            pos=_pos.slice(1,5),
            replaceData={//替换data
                openUrl: 'https://edu.meiguanjia.net/',
                space:item.dir,
                key:key,
                x:pos[0],
                y:pos[1],
                w:pos[2],
                h:pos[3]
            };
        if(item.variations[type]){
            replaceData.sw=item.variations[type].split("x").slice(0,1).join(",");
            replaceData.sh=item.variations[type].split("x").slice(1).join(",");
        }else if(type=="n"){
            url="{openUrl}{space}{key}";
        }else{
            url="{openUrl}{space}{key}?imageMogr2/crop/!{w}x{h}a{x}a{y}";
        }
        return replaceTemple(url,replaceData);
    }
    var self = amGloble.page.merchant = new $.am.Page({
        id: 'page-merchant',
        init: function(){
            this.$list = this.$.find('.merchant_list');
            this.$list.on('vclick', '.product_conver', function() {
                var data = $(this).closest('.merchant_item').data('item');
                window.RouterUtils.push({
                    name: 'merchantProductDetail',
                    params: {
                        id: data.productId,
                        merchantData: data,
                    }
                })
            })
            this.$list.on('vclick', '.product_button, .merchant_conver', function() {
                var data = $(this).closest('.merchant_item').data('item');
                window.RouterUtils.push({
                    name: 'merchantDetail',
                    params: {
                        id: data.id,
                    }
                })
            })
            this.$item = this.$list.find('.merchant_item').remove();
            this.$.find(".am-page-error .button-common").vclick(function () {
                self.refreshPage();
            });
        },
        refreshPage: function() {
            this.setStatus("pageLoading");
            self.$list.empty();
            amGloble.api.merchantList.exec({
                pageSize: 30,
                pageNumber: 0,
                shopId: amGloble.metadata.userInfo.shopId,
            }, function(ret) {
                if (ret.code == 0) {
                    self.setStatus("normal");
                    $.each(ret.content, function(index, data) {
                        var $item = self.$item.clone();
                        var merchantImgSrc = getAdminImageUrl(data.merchantLogo);
                        $item.find('.merchant_conver img').attr('src', merchantImgSrc);
                        var merchantImg = new Image();
                        merchantImg.onload = function() {
                            self.scrollview && self.scrollview.refresh();
                        }
                        merchantImg.src = merchantImgSrc;
                        if (data.productLogo) {
                            var productImgSrc = getAdminImageUrl(data.productLogo);
                            $item.find('.product_conver img').attr('src', productImgSrc);
                            var productImg = new Image();
                            productImg.onload = function() {
                                self.scrollview && self.scrollview.refresh();
                            }
                            productImg.src = productImgSrc;
                        } else {
                            $item.find('.product_conver').remove();
                        }
                        $item.data('item', data);
                        self.$list.append($item);
                        self.scrollview && self.scrollview.refresh();
                    })
                } else {
                    self.setStatus("error");
                }
            })
        },
        beforeShow: function(params){
            if (params === 'back') return;
            self.refreshPage();
        },
    });
})();
