(function() {

    var self = amGloble.page.message = new $.am.Page({
        id: "page-message",
        init: function() {
            var self = this;
            //
            //列表页相关逻辑

            this.$ul = this.$.find(".messageList");
            this.$li = this.$ul.find(":first").remove();
            this.$ul.empty();
            this.$ul.on("vclick", "li", function() {
                self.takeAction($(this).data('actionData'));
            }).on("vclick", ".button_left", function(e) {
                e.stopPropagation()
                self.takeAction($(this).closest('li').data('actionData'));
            }).on("vclick", ".button_right", function(e) {
                e.stopPropagation()
                self.takeShareAction($(this).closest('li').data('actionData'));
            });

            //error

            this.$error = this.$.find("div.am-page-error");
            this.$error.find(".button-common").vclick(function() {
                self.scrollview.touchTop(3);
            });

            this.$empty = this.$.find("div.am-page-empty");
            this.$empty.find(".button-common").vclick(function() {
                self.scrollview.touchTop(3);
            });
        },
        beforeShow: function(ret) {
            if (ret == "back") {
                return;
            }
            // this.render();
        },
        afterShow: function(paras) {

            if (paras == "forceRefresh" || new Date().getTime() - this.refreshTime > 300000) {
                this.scrollview.touchTop(3);
            }
        },
        beforeHide: function() {},

        //列表加载逻辑
        refreshTime: 0,

        refreshPage: function(callback) {
            this.getOnePage(true,callback);
        },
        getOnePage: function(clear,callback) {

            var self = this;

            opt = {
                currentId: clear ? null : this.currentId,
                pageSize: this.pageSize,
            };
            this.getData(opt, function(data) {

                if (data.code == 0) {

                    var list = data.content;
                    //刷新时的处理
                    if (clear) {

                        //当前页最后一条id
                        self.currentId = null;
                        self.refreshTime = new Date().getTime();
                        self.$ul.empty();
                        //self.scrollview.scrollTo("top");

                    }

                    if (list.length) {
                        self.currentId = list[list.length - 1].id;
                    }
                    if (self.pageSize > list.length) {
                        self.scrollview.pauseTouchBottom = true;
                    } else {
                        self.scrollview.pauseTouchBottom = false;
                    }

                    self.appendList(list);
                    callback && callback(list);
                } else {
                    callback && callback();
                }

                self.closeTopLoading();
                self.closeBottomLoading();
            });
        },
        amDragTopTips: ["下拉刷新列表", "松开开始加载", "加载中..."],
        amDragBottomTips: ["上拉加载更多", "松开开始加载", "加载中..."],
        touchTop: function() {
            this.refreshPage();
        },
        touchBottom: function() {
            this.getOnePage();
        },

        //私有逻辑
        pageSize: 10,
        clearDom: function() {
            this.$ul.empty();
        },
        appendList: function(list) {
            var self = this;
            var $ul = this.$ul;
            // list = [];
            if (list && list.length) {
                $.each(list, function(i, item) {
                    var $li = self.$li.clone(true, true);
                    //租户LOGO
                    $li.find(".photo").empty();
                    var moduleDiv = $li.find('.message_item__module').empty();

                    $li.find(".title").text(item.title);
                    $li.find(".line2").text(item.content);
                    $li.find(".time").text(amGloble.time2str(item.createtime / 1000));

                    //点击逻辑
                    try {
                        var actionData = JSON.parse(item.data);
                    } catch (err) {
                        var actionData = {};
                    }
                    $li.addClass('module_item_'+actionData.module);
                    moduleDiv.addClass('module_' + actionData.module);
                    if (actionData && (actionData.url || actionData.module)) {
                        actionData.title = item.title;
                        actionData.shopId = item.shopid;
                        $li.data("actionData", actionData);
                        switch (Number(actionData.module)) {
                            case 12:
                                switch (Number(actionData.typeId)) {
                                    case 7:
                                        $li.find(".photo").html('<img src="./css/img/message_icon__bad_comment.png" width="100%"/>')
                                        moduleDiv.hide();
                                        break;
                                    default:
                                        var todoCount = '<dl><dt>待处理顾客</dt><dd>'+ actionData.todoNum +'</dd></dl>';
                                        var todoTypeCount = '<dl><dt>待办类型</dt><dd>'+ actionData.typeNum +'</dd></dl>';
                                        if (!actionData.assigner) {
                                            moduleDiv.append(todoTypeCount + todoCount);
                                        } else {
                                            moduleDiv.hide();
                                        }
                                        $li.find(".photo").html('<img src="./css/img/message_icon__todo.png" width="100%"/>')
                                        break;
                                }
                                break;
                            case 14:
                                $li.removeClass('am-clickable');
                                break;
                            case 1001:
                                $li.removeClass('am-clickable');
                                moduleDiv.append('<div class="button_left am-clickable">点击查看详情</div><div class="button_right am-clickable">邀请顾客参与</div>')
                                break;
                            case 1005:
                                $li.find(".line2").text(actionData.description);
                                moduleDiv.append('<img width="100%" src="'+ actionData.cover +'" />')
                                break;
                            case 1006:
                                moduleDiv.append('<div class="renew_button_left">去付款 ></div>')
                                break;
                            case 1007:
                                moduleDiv.append('<img src="./css/img/miniprogram-update-notice.png" width="100%"/>')
                                break;
                            case 1009:
                                var contentData = JSON.parse(actionData.data);
                                if (contentData.detail) {
                                    var labelText = (contentData.status == 6 || contentData.status == 4) ? '操作内容' : '申请内容';
                                    $li.find(".line2").html('<dl><dt>'+ labelText +'：</dt><dd>' + contentData.detail + '</dd></dl>');
                                }
                                var auditInfo = contentData.auditInfo ? contentData.auditInfo.trim() : null;
                                if (auditInfo) {
                                    $li.find(".line2").after('<li class="line2"><dl><dt>申请原因：</dt><dd>'+ auditInfo +'</dd></dl></li>');
                                }
                                $li.find(".photo").html('<img src="./css/img/message_icon__operate_approve.png" width="100%"/>')
                                break;
                            case 1010:
                                var contentData = JSON.parse(actionData.data);
                                var keyList = ['shopName', 'expirationDate', 'renewalTerm'];
                                var textList = ['续费门店', '到期时间', '续费时长'];
                                if(contentData.expirationDate) {
                                    contentData.expirationDate = dateFormat(Number(contentData.expirationDate), 'yyyy-mm-dd');
                                }
                                if(contentData.renewalTerm) {
                                    contentData.renewalTerm = contentData.renewalTerm + '年';
                                }
                                $li.find(".line2").addClass("content_color");
                                for(var i = 0; i < keyList.length; i++) {
                                        if(contentData[keyList[i]]) {
                                            if(i == 0) {
                                                $li.find(".line2").html('<dl><dt>'+ textList[i] +'：</dt><dd>' + contentData[keyList[i]] + '</dd></dl>');
                                            } else {
                                                $li.find(".line2").append('<dl><dt>'+ textList[i] +'：</dt>'+'<dd>'+ contentData[keyList[i]] +'</dd></dl>');
                                            }
                                        }
                                }
                                break;
                            default:
                                break;
                        }
                    } else {
                        $li.removeClass('am-clickable');
                    }

                    $li.data("item", item);
                    $ul.append($li);
                });
            }

            if ($ul.is(":empty")) {
                //$ul.append("<li class='empty'>暂无内容</li>");
                self.setStatus("empty");
            } else {
                self.setStatus("normal");
            }

            self.refresh();
        },
        getData: function(opt, scb) {

            amGloble.api.messageList.exec($.extend({
                appUserId: window.config.isCheckin ? window.config.userInfo.appUserId : amGloble.metadata.userInfo.appUserId,
                parentShopId: window.config.isCheckin ? window.config.userInfo.parentShopId : undefined,
            }, opt), function(ret) {
                if (ret.code == 0) {
                    console.log('ret',ret);
                    amGloble.setMessageDot(0);
                    scb && scb(ret);
                } else {
                    if (self.$ul.children(":not(.empty)").length) {
                        amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                    } else {
                        self.setStatus("error");
                    }
                    scb && scb({
                        code: -1,
                        msg: ""
                    });
                }
            });
        },
        getSurveyList: function(id,callback) {
            amGloble.api.questionnaireList.exec({
                parentShopId: amGloble.metadata.userInfo.parentShopId,
                id: id
            }, function (ret) {
                if (ret.code == 0) { //成功
                    var activity = ret.content[0];
                    callback && callback(activity)
                } else {
                    amGloble.msg(ret.message || "网络连接失败,请重试!");
                }
            });
        },
        takeShareAction: function(data) {
            if (data.module == 1001) {
                this.getSurveyList(data.questionnaireId, function(activity){
                    window.amGloble.shareSurvey(activity);
                })
			}
        },
        takeAction: function(data) {
            //location.href = "m_custMgmt/index.html#type=reservation";
            //return;
            $.am.debug.log(JSON.stringify(data));
            if (data.url) {
                atMobile.nativeUIWidget.popupWebsite({
                    title: data.title,
                    url: data.url
                });
            } else if (parseInt(data.module) === 5) {
                //预约
                $.am.changePage(amGloble.page.reservation, "slideleft");
            } else if(parseInt(data.module) === 99){
	            $.am.changePage(amGloble.page.msgDetail, "slideleft");
            }else if(data.module == 97){
                $.am.changePage(amGloble.page.customerGrouping, "slideleft");
            }
            else if(data.module == 101){
                $.am.changePage(amGloble.page.empGoalCheck, "slideleft");
            }
            else if(data.module == 103){
                $.am.changePage(amGloble.page.shopGoal, "slideleft");
            }
            else if(data.module == 105){
                var now=new Date();
                var month=now.getMonth()<11?(now.getMonth()+2)+'':'01';
                if(month.length<2){
                    month='0'+month;
                }
                var year=now.getMonth()!=11?now.getFullYear():(now.getFullYear()+1);
                var nextM=year+"/"+month
                $.am.changePage(amGloble.page.shopGoal, "slideleft",{time:nextM});
            }else if(data.module == 888 || data.module == 15){
                if (data.module == 888 && data.type && data.type == "pay") {
                    var shopMap = amGloble.metadata.shopMap || {};
                    $.am.changePage(amGloble.page.msgRenewList, "slideleft", { shopId: data.shopId, osName: shopMap[data.shopId].osName, name: shopMap[data.shopId].shopName })
                } else {
                    $.am.changePage(amGloble.page.msgDetail, "slideleft","forceRefresh");
                }
            } else if(data.module == 1006) {
                var lastPage = window.RouterUtils.getLastRoute() || {};

                var unpayedData = amGloble.page.dashboard.getUnpayedData();
                if (unpayedData.length && (unpayedData.length == 1 || unpayedData[0].unpayType)) {
                    var unpayedDataItem = JSON.parse(JSON.stringify(unpayedData[0]));
                    unpayedDataItem.shopId = unpayedDataItem.shopid;
                    unpayedDataItem.unpayType = unpayedDataItem.unpayType || 0;
                    unpayedDataItem.unpayId = unpayedDataItem.ids;
                    $.am.changePage(amGloble.page.msgRenew, "slideleft", unpayedDataItem); // 单条 欠费/续费 跳转页面
                } else {
                    if (lastPage.name !== 'unpayed') {
                        window.RouterUtils.push({
                            name: 'unpayed',
                            animation: 'slideleft'
                        })
                    }
                }
            } else if (data.module == 1007) {
                var lastPage = window.RouterUtils.getLastRoute() || {};
                if (lastPage.name !== 'miniprogramUpdate' && data.id) {
                    window.RouterUtils.push({
                        name: 'miniprogramUpdate',
                        animation: 'slideleft',
                        params: {
                            id: data.id,
                        }
                    })
                }
            } else if (data.module == 999) {
                var lastPage = window.RouterUtils.getLastRoute() || {};
                $.am.debug.log('999------------------------------------');
                $.am.debug.log(JSON.stringify(lastPage));
                if (lastPage.name !== 'promotionbenefit') {
                    window.RouterUtils.push({name:'promotionbenefit',params:{tab:"Benefit"},animation:'slideleft'})
                } else {
                    window.RouterUtils.eventBus.$emit('onmessage', {
                        name: 'Benefit'
                    });
                }
			} else if (data.module == 1000) {
                var lastPage = window.RouterUtils.getLastRoute() || {};
                $.am.debug.log('1000------------------------------------');
                $.am.debug.log(JSON.stringify(lastPage));
                if (lastPage.name !== 'promotionbenefit') {
                    window.RouterUtils.push({name:'promotionbenefit',params:{tab:"Customer"},animation:'slideleft'})
                } else {
                    window.RouterUtils.eventBus.$emit('onmessage', {
                        name: 'Customer'
                    });
                }
			} else if (data.module == 1001) {
                this.getSurveyList(data.questionnaireId, function(activity){
                    var lastPage = window.RouterUtils.getLastRoute() || {};
                    if (lastPage.name !== 'surveyReport') {
                        window.RouterUtils.push({
                            name: "surveyReport",
                            animation: "slideleft",
                            params: {
                            activity: activity
                            }
                        });
                    }
                })
			} else if (data.module == 1002) {
                $.am.changePage(amGloble.page.archiveList, "slideleft", "forceRefresh");
			} else if (data.module == 1003) {
                $.am.changePage(amGloble.page.benefitsWithdrawalrecord, "slideleft");
			} else if (data.module == 1004) {
                var lastPage = window.RouterUtils.getLastRoute() || {};
                if (lastPage.name !== 'voteActivity') {
                    window.RouterUtils.push({name:'voteActivity',params:{activityId:data.activityId},animation:'slideleft'})
                }
			} else if (data.module == 12) {
                if (Number(data.typeId) === 7) {
                    window.RouterUtils.push({
                        name: 'todoDetail',
                        animation: 'slideleft',
                        params: {
                            id: data.todoId,
                            from: 'todo',
                            memberId: data.customerId,
                        }
                    })
                } else {
                    window.RouterUtils.push({
                        name: 'todoList',
                        animation: 'slideleft',
                    })
                }
            } else if (data.module == 1005) {
                var nameMap = { 3: 'customMessage' };
                window.RouterUtils.push({
                    name: nameMap[data.noticeType] || 'message',
                    animation: 'slideleft',
                    params: {id: data.productNoticeId}
                })
            } else if (data.module == 1009) {
                window.RouterUtils.push({
                    name: 'operateApproveDetail',
                    params: {
                        id: data.id,
                    }
                })
            } else if (data.module == 1010) {
                var detail = JSON.parse(data.data);
                $.am.changePage(amGloble.page.msgDetail, "slideright", {shopId: detail.shopId});
            }
        }
    });

})();









//
