(function() {
    var self = amGloble.page.msgRenew = new $.am.Page({
        id: "page-msg-renew",
        init: function() {
            //续费
            this.$checkRecord = this.$.find('.am-header .right').vclick(function(){
                $.am.changePage(amGloble.page.msgRenewList, "slideleft",self.$shop.data('data'));
            });

            //点击pay
            this.$charge = this.$.find('.charge').vclick(function(){
                if(!$(this).hasClass('active')){
                    return;
                }
                if(self.unPayedOrder){
                    //未支付继续支付
                    var data = self.$chargeList.find('li.selected').data('data');
                    self.alipayCharge(data);
                }else if(self.renewConfig){
                    //正常续费
                    self.alipayCharge();
                }
            });

            this.$promotion = this.$.find('.promotion');
            this.$chargeList = this.$.find('.list').on('vclick','li',function(){
                $(this).addClass('selected').siblings().removeClass('selected');
                self.$charge.addClass('active');
            });
            this.$li = this.$chargeList.find('li').eq(0);

            var numMap = {
                1: "一",
                2: "二",
                3: "三",
                4: "四",
                5: "五",
                6: "六",
                7: "七",
                8: "八",
                9: "九"
            };

            this.$shop = this.$.find('.normalRenew');
            this.$renewRadio = this.$shop.find(".renew-radio").on("vclick", ".renew-price", function() {
                console.log('data', $(this).data("data"));
                $(this).addClass('active').siblings().removeClass('active');
                var data = $(this).data("data");
                var name = self.renewConfig.name.replace(/(.*)(\-)(.*)/g, '$3');
                self.$shop.find('.cost').html('￥'+data.price);
                self.$shop.find(".get-product-name").html((data.type ? "买" + numMap[data.buy] + "送" + numMap[data.send] + "" : "续费") + "-" + name);

                var shopInvaldate = new Date(Number(self.shop.invalidDate)).getTime();
                var nowDate = new Date().getTime();
                var currentTime = new Date(shopInvaldate > nowDate ? shopInvaldate : nowDate);
                currentTime.setFullYear(currentTime.getFullYear()+ data.buy + data.send);
                self.$shop.find('.get-Endtime').html(new Date(shopInvaldate > nowDate ? shopInvaldate : nowDate).format('yyyy.mm.dd')+'-'+new Date(currentTime).format('yyyy.mm.dd'));

                self.renewConfig.startDate = shopInvaldate;
                self.renewConfig.productName = (data.type ? "买" + numMap[data.buy] + "送" + numMap[data.send] + "" : "续费") + "-" + name;
                self.renewConfig.price = data.price;
                self.renewConfig.typeId = data.type;
                self.renewConfig.totalYear = data.buy + data.send;
            });
            this.$renewPrice = this.$renewRadio.find(".renew-price");
            this.$shopList = this.$.find('.unnormalRenew');
        },
        beforeShow: function(para) {
            if(para=='back'){
                return;
            }
            // 获取活动信息
            var _this = this;
            this.getProductSale(function() {
                _this.$chargeList.empty();
                _this.$renewRadio.empty();
                _this.$shop.hide();
                _this.$shopList.hide();
                _this.$promotion.hide();

                _this.unPayedOrder = null;
                _this.renewCofig = null;
                _this.$charge.removeClass('active');
                if(para){
                    if(para.invaldate){
                        para.invalidDate = new Date(para.invaldate.replace(/\-/g,'/')).getTime();
                    }
                    _this.shop = para;
                    _this.getUnPayedOrder();
                }
            })
        },
        afterShow: function() {
        },
        beforeHide: function() {

        },
        afterHide:function(){
        },
        getProductSale: function(cb) {
            var _this = this;
            // 获取活动信息
            if(!this.saleVersionMap && !this.productSaleMap) {
                amGloble.loading.show();
                amGloble.api.getProductConfig.exec({}, function(ret) {
                    amGloble.loading.hide();
                    if (ret && ret.code == 0) {
                        var rawproductSale = JSON.parse(ret.content.productSale);
                        var saleVersionMap = {};
                        var productSaleMap = {};
                        rawproductSale.forEach(function(sale) {
                            productSaleMap[sale.id] = sale;
                            sale.shopVersion.forEach(function(version) {
                                // 将续费活动对应的版本号转换为版本对应有哪些活动id
                                if (saleVersionMap[version]) {
                                    saleVersionMap[version].push(sale.id)
                                } else {
                                    saleVersionMap[version] = [sale.id];
                                }
                            })
                        })
                        _this.saleVersionMap = saleVersionMap;
                        _this.productSaleMap = productSaleMap;
                        cb && cb();
                    } else {
                        atMobile.nativeUIWidget.confirm({
                            caption: '网络异常',
                            description: '数据读取失败，是否立即重试？',
                            okCaption: '重试',
                            cancelCaption: '取消'
                        }, function () {
                            self.getProductSale(cb);
                        }, function () {

                        });
                    }
                })
            } else {
                cb && cb();
            }
        },
        getUnPayedOrder: function () {
            if (this.shop && !self.shop.unpayType) {
                self.renderUnPayedOrder(this.shop)
            }else {
                self.startNormarlRenew();
            };
        },
        startNormarlRenew: function(){
            var v = this.getVersion(this.shop.shopId);
            if(!v) {
                amGloble.msg('信息获取失败');
                $.am.debug.log(this.shop.shopId);
                return;
            }
            $.am.debug.log(JSON.stringify(v));
            amGloble.loading.show();
            amGloble.api.msgGoods.exec({
                mgjversion: v.mgjversion,
                version: v.version,
                softgenre:v.softgenre
            }, function(ret) {
                amGloble.loading.hide();
                if(ret && ret.code==0 && ret.content){
                    self.renderNormarlRenew(ret.content);
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function(){
                        self.startNormarlRenew();
                    }, function(){

                    });
                }
            });
        },
        getVersion:function(data){
            var allShop=amGloble.metadata.shops;
            for(var i=0;i<allShop.length;i++){
                if(data===allShop[i].shopId){
                    return allShop[i];
                }
            }
        },
        renderNormarlRenew:function(data){
            if(this.shop.osName && this.shop.osName.replace(/(^\s*)|(\s*$)/g,'')){
                this.$shop.find('.get-shop').html(this.shop.osName);
            }else{
                // if(data[i].shopId==amGloble.metadata.userInfo.parentShopId){
                    if(this.shop.name && this.shop.name.replace(/(^\s*)|(\s*$)/g,'')){
                        this.$shop.find('.get-shop').html(this.shop.name);
                }else {
                        this.$shop.find('.get-shop').html('门店名称未设定');
                }
            }
            this.renewConfig = data;

            var _this = this;
            var v = this.getVersion(this.shop.shopId);
            var productSaleId = this.saleVersionMap ? this.saleVersionMap[Number(v.mgjversion)] : [];
            var renewPriceData = [{ id: 0, price: data.price, type: 0, buy: 1, send: 0 }];

            if (productSaleId && productSaleId.length) {
                productSaleId.forEach(function(id) {
                    var productSale = _this.productSaleMap[id]
                    var price = data.price * productSale.buy
                    renewPriceData.push({
                        id: productSale.id,
                        price: price,
                        type: 1, // 0/原价, 1/活动
                        buy: Number(productSale.buy),
                        send: Number(productSale.send)
                    })
                })
            }

            renewPriceData.forEach(function(item) {
                var $renewPrice = _this.$renewPrice.clone();
                $renewPrice.find(".price .text").html(item.price);
                $renewPrice.find(".year").html('/' + (item.buy + item.send) + '年');
                $renewPrice.find(".activity-text .text").html('买'+ item.buy + '年送' + item.send + '年');
                if (item.type) {
                    $renewPrice.find(".activity-badge").show();
                    $renewPrice.find(".activity-text").show();
                } else {
                    $renewPrice.find(".activity-badge").hide();
                    $renewPrice.find(".activity-text").hide();
                }
                $renewPrice.data("data", item);
                _this.$renewRadio.append($renewPrice)
            })
            this.$renewRadio.find('.renew-price').eq(0).trigger('vclick');

            this.$shop.find('.cost').html('￥'+data.price);
            this.$shop.find(".get-product-name").html("续费-" + this.renewConfig.name.replace(/(.*)(\-)(.*)/g, '$3'));
            var shopInvaldate = new Date(Number(this.shop.invalidDate)).getTime();
            var nowDate = new Date().getTime();
            var currentTime = new Date(shopInvaldate > nowDate ? shopInvaldate : nowDate);
            currentTime.setFullYear(currentTime.getFullYear()+1);
            this.$shop.find('.get-Endtime').html(new Date(shopInvaldate > nowDate ? shopInvaldate : nowDate).format('yyyy.mm.dd')+'-'+new Date(currentTime).format('yyyy.mm.dd'));
            this.$shop.show();
            this.$charge.addClass('active');
        },
        renderUnPayedOrder:function(unPayedData){
            var _this = this;
            this.unPayedOrder = unPayedData;
            var $li = this.$li.clone();
            $li.find(".no-pay-price .price").html('￥'+unPayedData.consumefee);

            if(unPayedData.osname && unPayedData.osname.replace(/(^\s*)|(\s*$)/g,'')){
                $li.find('.no-pay-info .shop .text').html(unPayedData.osname);
            }else{
                // if(unPayedData.shopId==amGloble.metadata.userInfo.parentShopId){
                if(unPayedData.name && unPayedData.name.replace(/(^\s*)|(\s*$)/g,'')){
                    $li.find('.no-pay-info .shop .text').html(unPayedData.name);
                }else {
                    $li.find('.no-pay-info .shop .text').html("门店名称未设定");
                }
            }
            var productno = unPayedData.productno;
            if (productno == 0) {
                $li.find('.no-pay-info .date .name').html("充值数量");
                $li.find('.no-pay-info .date .text').html(unPayedData.count + "条");
            } else if([7, 3, 6, 2, 5, 1, 22, 23, 16, 15, 27].indexOf(Number(productno)) != -1 && unPayedData.startDate) {
                $li.find('.no-pay-info .date .name').html("续期时间");
                $li.find('.no-pay-info .date .text').html(new Date(unPayedData.startDate).format('yyyy.mm.dd') + '-' + new Date(new Date(unPayedData.startDate).setFullYear(new Date(unPayedData.startDate).getFullYear() + unPayedData.totalYear)).format('yyyy.mm.dd'));
            } else {
                $li.find('.no-pay-info .date').hide();
            }

            $li.find('.no-pay-info .produce .text label').html(unPayedData.productName);
            $li.find('.no-pay-info .admin .admin-text').html(unPayedData.adminname);
            $li.find('.no-pay-info .time .text').html(new Date(Number(unPayedData.consumetime)).format('yyyy.mm.dd'));

            var $avtarImg = $('<img src=" ' + config.filesMgr + 'admin/empavator/' + unPayedData.avator + ' " />');
            $avtarImg.load(function () {
                $li.find('.no-pay-info .admin .avtar').html(this);
            }).error(function() {
            });

            if (unPayedData.buyCount > 1) {
                $li.find('.no-pay-info .produce .text .activty').show();
            } else {
                $li.find('.no-pay-info .produce .text .activty').hide();
            }
            $li.data('data',unPayedData);
            this.$chargeList.append($li);
            self.$charge.removeClass('active');
            this.$shopList.show();
            this.$promotion.show();
            this.$shopList.find('li').eq(0).trigger('vclick');
        },
        alipayCharge:function(data){
            var opt = {
                parentShopId: amGloble.metadata.userInfo.parentShopId,
            };
            var totalYear = 1;
            var productNo = "";
            if(data){
                opt.shopId = data.shopid;
                opt.type = 3;
                opt.price = data.consumefee;
                opt.itemIds = data.ids.join(",");
                productNo = data.productno;
            }else {
                opt.shopId = self.shop.shopId;
                opt.type = 2;
                opt.typeId = self.renewConfig.typeId;
                opt.price = self.renewConfig.price;
                opt.productNo = self.renewConfig.no;
                totalYear = self.renewConfig.totalYear;
                productNo = self.renewConfig.no;
                // opt.itemId = self.renewConfig.no;
            }

            // opt.price = 0.01;
            amGloble.loading.show();
            amGloble.api.msgAlipayCharge.exec(opt,function(ret){
                amGloble.loading.hide();
                if(ret && ret.code==0){
                    amGloble.loading.show();
                    setTimeout(function() {
                        amGloble.loading.hide();
                    }, 3000);
                    atMobile.payment.alipay(ret.content.payJson, function(msg) {
                        amGloble.loading.hide();
                        // 9000:订单支付成功
                        // *8000:正在处理中（"支付结果确认中"）  代表支付结果因为支付渠道原因或者系统原因还在等待支付结果确认，最终交易是否成功以服务端异步通知为准（小概率状态）
                        // *4000:订单支付失败
                        // *6001:用户中途取消
                        // *6002:网络连接出错
                        if (msg == "9000") {
                            var payData = ret.content;
                            amGloble.loading.show();
                            amGloble.api.msgCheckOrderStatus.exec({
                                parentShopId: amGloble.metadata.userInfo.parentShopId,
                                shopId: amGloble.metadata.userInfo.shopId,
                                orderId: payData.order.id,
                            }, function(ret) {
                                amGloble.loading.hide();
                                if(ret && ret.code == 0) {
                                    if (ret.content.status == 2) {
                                        amGloble.msg("续费成功");

                                        var params = {
                                            price: opt.price,
                                            payerName: amGloble.metadata.userInfo.userName,
                                            payerId:  amGloble.metadata.userInfo.userId,
                                            paytime: new Date().getTime(),
                                            backName: self.shop.backName,
                                            data: [{
                                                price: opt.price,
                                                consumefee: opt.price,
                                                productName: data ? data.productName : self.renewConfig.productName,
                                                osname: data ? data.osname : self.shop.osName,
                                                productno: data ? data.productno : self.renewConfig.no,
                                                count: data ? data.count : "",
                                                startDate: data ? data.startDate : self.renewConfig.startDate,
                                                totalYear: data ? data.totalYear : self.renewConfig.totalYear,
                                                shopid: data ? data.shopid : self.shop.shopId,
                                            }]
                                          };
                                          if ([5, 6, 7, 16].indexOf(productNo) != -1) {
                                            window.amGloble.page.dashboard.setShopInvaldate(opt.shopId, totalYear);
                                          }
                                          var refreshParams = data ? { shopId: self.shop.shopId } : "";
                                          window.RouterUtils.eventBus.$emit('unpayed-refresh', refreshParams);
                                          window.RouterUtils.push({
                                            name: "renewSuccess",
                                            animation: "slideright",
                                            params: params
                                          });

                                    } else {
                                        amGloble.msg("续费成功，服务器暂未收到消息!");
                                    }
                                    // var data=ret;
                                    // alert('renew success')
                                }else{
                                    amGloble.msg("数据获取失败,请检查网络!");
                                }
                            });
                        } else if (msg == "8000") {
                            amGloble.msg("正在处理中");
                        } else if (msg == "4000") {
                            amGloble.msg("订单支付失败");
                        } else if (msg == "6001") {
                            amGloble.msg("用户中途取消");
                        } else if (msg == "6002") {
                            amGloble.msg("网络连接出错");
                        } else {
                            amGloble.msg("支付失败");
                        }
                    }, function(msg) {
                        amGloble.loading.hide();
                        // *4000:订单支付失败
                        // *6001:用户中途取消
                        // *6002:网络连接出错
                        if (msg == "4000") {
                            amGloble.msg("订单支付失败");
                        } else if (msg == "6001") {
                            amGloble.msg("用户中途取消");
                        } else if (msg == "6001") {
                            amGloble.msg("网络连接出错");
                        } else {
                            amGloble.msg("支付失败");
                        }
                    });
                }else if(ret.code == 1060101) {

                }else{
                    amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                }
            })
        }
    });
})();
