(function() {
    var self = amGloble.page.msgRenewList = new $.am.Page({
        id: "page-msg-renewList",
        init: function() {
            this.$list = this.$.find('.list').on("vclick", "li", function() {
                var data = $(this).data("data");
                var params = {
                    price: data.consumefee,
                    payerName: data.payerName,
                    payerId: data.payerId,
                    paytime: Number(data.paytime),
                    data: data.data

                };
                window.RouterUtils.push({
                    name: 'renewInfo',
                    animation: 'slideleft',
                    params: params
                })
            });
            this.$li = this.$list.find('li').eq(0);
            this.$changeShop = this.$.find('.am-header .right').vclick(function(){
                var _this = $(this);
                _this.addClass('up');
                amGloble.page.treasure.getMsg(function(data){
                    var shops = amGloble.page.treasure.getControlShops(data);
                    amGloble.msgSelectShop({
                        data: shops,
                        target: _this,
                        type: 1,
                    },function(shop){
                        self.scrollview.scrollTo('top');
                        self.shopId = shop.shopId;
                        if(shop.osName && shop.osName.replace(/(^\s*)|(\s*$)/g,'')){
                            self.$changeShop.html(shop.osName);
                        }else {
                            // if(shop.shopId==amGloble.metadata.userInfo.parentShopId){
                                if(shop.name && shop.name.replace(/(^\s*)|(\s*$)/g,'')){
                                self.$changeShop.html(shop.name);
                            }else {
                                self.$changeShop.html('门店名称未设定');
                            }
                        }
                        self.getRecord();
                    });
                });
            });
            this.$empty = this.$.find('.empty');
        },
        beforeShow: function(para) {
            if (para == "back") {
                return;
            }
            this.$list.empty();
            if(amGloble.metadata.userInfo.shopType!=0){
                this.$changeShop.hide();
            }else {
                this.$changeShop.show();
            }
            console.log(para)
            if(para){
                if(para.osName && para.osName.replace(/(^\s*)|(\s*$)/g,'')){
                    this.$changeShop.html(para.osName);
                }else {
                    if(para.shopId==amGloble.metadata.userInfo.parentShopId){
                        this.$changeShop.html(para.name);
                    }else {
                        this.$changeShop.html('门店名称未设定');
                    }
                }
            }
        },
        afterShow: function(para) {
            if (para == "back") {
                return;
            }
            if(para){
                this.shopId = para.shopId;
                this.getRecord();
            }
        },
        beforeHide: function() {
        },
        getRecord:function(){
            amGloble.api.msgPayrenewList.exec({
                shopId: self.shopId
            },function(ret) {
                amGloble.loading.hide();
                if(ret && ret.code==0){
                    self.render(self.formatData(ret.content));
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function(){
                        self.getRecord();
                    }, function(){
                        
                    });
                }
            });
        },

        formatData: function(data) {
            var newData = [];
            var numMap = {
                1: "一",
                2: "二",
                3: "三",
                4: "四",
                5: "五",
                6: "六",
                7: "七",
                8: "八",
                9: "九"
            };

            for(var i=0; i<data.length; i++){
                var item = data[i];
                if (item.payflag != 0) {
                    var find = "";

                    for(var j=0; j < newData.length; j++) {
                        if (item.parentId && newData[j].parentId == item.parentId) {
                            find = newData[j];
                            break;
                        }
                    }

                    if (find) {
                        find.consumefee += item.consumefee;
                        find.data[0].totalYear++;
                        find.data[0].startDate = find.data[0].startDate && (!item.startDate || find.data[0].startDate < item.startDate) ? find.data[0].startDate : item.startDate;
                        if (item.payflag == 1) {
                            find.data[0].buy = find.data[0].buy + 1;
                        }
                        // find.data.push(item);
                    } else {
                        item.totalYear = 1;
                        item.data = [item];
                        item.buy = 0;
                        if (item.payflag == 1) {
                            item.buy = 1;
                        }
                        newData.push(item);
                    }
                }

            }

            newData.forEach(function(item) {
                item.data.forEach(function(node) {
                    node.productName = node.totalYear > 1 ? ("买" + numMap[node.buy] + "送" + numMap[(node.totalYear - node.buy)] + "-" + node.productName.replace(/(.*)(\-)(.*)/g, '$3')) : node.productName;
                })
            })

            return newData;
        },
       
        render:function(data){
            this.$list.empty();
            if(data.length){
                this.$empty.hide();
                for(var i=0;i<data.length;i++){
                    var $li = this.$li.clone();

                    if(data[i].osname && data[i].osname.replace(/(^\s*)|(\s*$)/g,'')){
                        $li.find('.top p:first-child').html(data[i].osname);
                    }else{
                        // if(data[i].shopId==amGloble.metadata.userInfo.parentShopId){
                            if(data[i].name && data[i].name.replace(/(^\s*)|(\s*$)/g,'')){
                                $li.find('.top p:first-child').html(data[i].name);
                        }else {
                                this.$shop.find('.top p:first-child').html('门店名称未设定');
                        }
                    }
                    $li.find('.top p:last-child').html('￥'+data[i].consumefee);
                    $li.find('.bottom p:first-child').html(new Date(Number(data[i].paytime)).format('yyyy.mm.dd') + (data[i].productName ? ("（" + data[i].productName + "）") : "")); 
                    if(data[i].auditflag){
                        $li.find('.bottom p:last-child').html('续费成功'); 
                    }
                    $li.data("data", data[i]);
                    this.$list.append($li);
                }
                self.scrollview.refresh();
            }else {
                this.$empty.show();
            }
        }
    });
})();