(function () {
	// 换肤颜色范围值
	var bgColorsArr = ['#63CBCD', '#77A8D9', '#68B4D9', '#F59EB1', '#97A8E6', '#76A0E6', '#56D5C5', '#F59E9F', '#E887AD', '#81D7A7', '#63CBCD', '#77A8D9', '#68B4D9', '#F59EB1', '#97A8E6', '#76A0E6', '#56D5C5', '#F59E9F', '#E887AD', '#81D7A7']

    var self = amGloble.page.rankinglist = new $.am.Page({
		id: "page-rankinglist",
		rankingDataCacheMap: {},
		isNotKpiData: false,
        init: function () {
			var self = this;
			// 上一次的 userId,用来控制缓存
			this.latestUserId = undefined;
			this.rankingListData = null;
			// 上一次的 realParentShopId （进入页面或在排行范围里切换门店时）
			this.latestRealParentShopId = undefined;
			// 存放排行数据（KPI）的 map,以 realParentShopId 作 key
			this.rankingDataMap = {};
			// 用户角色 0:总部管理员  1:直属店管理员  2:直属店员工  3:附属店管理员  4:附属店员工  5:单店管理员  6:单店员工
			this.userRole = undefined;
			// 默认管理员身份登录 (true: 员工 false: 管理员)
			this.isEmployee = false;
			// 区域信息
			this.areaList = null;
			// 当前选中的 KPI
			this.selectedKpiData = {}
			// 当前选中的 KPI 对应的员工级别类型
			this.employeeRolesByselectedKpi = []
			// 排行榜配置
			this.rankingConfigs = {}
			// 选择的门店
			this.selectedShopData = null
			// 选择的区域
			this.selectedAreaData = null
			// 门店管理员或员工所在的区域
			this.ownAreaData = null
			// 全企业
			this.isAll = null
			// 头部主展示区
			this.$thefirstWrap = this.$.find('.thefirst-wrap');
			// 头部主展示区头像
			this.$imgBox = this.$.find('.inner-top .thefirst-wrap .thefirstheader .imgBox');
			// 头部主展示区姓名
			this.$thefirstname = this.$.find('.inner-top .thefirst-wrap .thefirstname');
			// 头部主展示区排行数据
			this.$thefirstbottom = this.$.find('.inner-top .thefirst-wrap .thefirstbottom');
			// 总部无KIP
			this.$noKipBox = this.$.find('.am-body-inner .nokip-content');
			// 其他员工无KIP
			this.$empContent = this.$.find('.am-body-inner .nokip-empcontent');

			// 正文列表 ul
			this.$innerContUl = this.$.find('.inner-cont ul');
			// 导航区域
			this.$amHeader = this.$.find('.am-header');
			// 头部
			this.$innerTop = this.$.find('.inner-top');
			// 时间 Tab
            this.$monthwrap = this.$.find('.monthwrap');
			// 导航
			this.$headerTitle=this.$amHeader.find('.title');
			// 本月
			this.$thisMonth=this.$monthwrap.find('li.thismonth');
			// 今天
			this.$today=this.$monthwrap.find('li.today');
			// 总部管理员触发选择排行范围弹窗开关
			this.$headquartersSwitch = this.$.find('.am-header .ranking-range.headquarters')
			// 门店管理员或员工触发选择排行范围弹窗开关
			this.$empSwitch = this.$.find('.am-header .ranking-range.emp')

			this.$errorTips = this.$.find('.am-page-error');

			//重试
			this.$.find(".am-page-error .button-common").vclick(function () {
				self.beforeShow();
			});

			// 切换底部 KPI
            this.$.on('vclick', '.footTab span', function () {
				var $this=$(this);
				// 此 index 是为了取颜色值做背景换肤
				var index = $this.index()
                if ($this.hasClass("disabled")) {
                    if (self.checkVersion()) {
                        return;
                    };
                }
				$this.addClass('selected').siblings('span').removeClass('selected');
				var kpiData = $this.data('kpiData')
				self.selectedKpiData = kpiData
				self.employeeRolesByselectedKpi = self.generateEmpRoles(kpiData)
				if (!self.isEmployee) {
					self.setLevel(self.employeeRolesByselectedKpi[0])
				}
				self.handleChangeType(kpiData, index);
				self.hideIconForTC();
			});
			// 弹出 选择员工级别的 popupMenu
            this.$.on('vclick', '.am-header .roles', function (e) {
				e.stopPropagation();
                amGloble.popupMenu("请选择员工级别", self.employeeRolesByselectedKpi, function (ret) {
                    self.setLevel(ret, true);
                });
            });

			// （门店管理员或员工）弹出 选择排行范围 popupMenu
            this.$.on('vclick', '.am-header .ranking-range.emp', function (e) {
				var shopType = amGloble.metadata.userInfo.shopType
				var rankingRangeTypeArr = self.selectedKpiData.key==='TC_TC' ? ["1"] : self.rankingConfigs.rankingScope;
				if (rankingRangeTypeArr.length === 1 || shopType === 1 || shopType === 3) return
				var labelMap = {
					'1': '门店排行',
					'2': '区域排行',
					'3': '全企业排行'
				}
				var typeList = []
				for (var i=0; i<rankingRangeTypeArr.length; i++) {
					var type = rankingRangeTypeArr[i]
					typeList.push({
						id: Number(type),
						name: labelMap[type]
					})
				}
				amGloble.popupMenu("请选择排行范围", typeList, function (ret) {
					if (ret.id === 1) { // 按门店排行
						self.$today.show();
						var userInfo = amGloble.metadata.userInfo;
						var shopId = userInfo.shopId;
						var shopName = self.getShopName(userInfo)
                        self.selectedShopData = self.shopsMap[shopId]
						self.$headerTitle.find('.ranking-range').text(shopName);
						self.isAll = null
						self.ownAreaData = null
					} else if (ret.id === 2) { // 按区域排行
						if (self.$today.is(':visible')) {
							self.$today.hide();
							self.$thisMonth.addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');
						}
						self.getOwnAreaData()
						self.$headerTitle.find('.ranking-range').text(self.ownAreaData.AREANAME)
						self.isAll = null
						self.selectedShopData = null
					} else if (ret.id === 3) { // 按全企业排行
						if (self.$today.is(':visible')) {
							self.$today.hide();
							self.$thisMonth.addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');
						}
						self.$headerTitle.find('.ranking-range').text('全企业')
						self.isAll = 1
						self.selectedShopData = null
						self.ownAreaData = null
                    }
                    if (self.hasTcKpi) {
                        var parentShopId = amGloble.metadata.userInfo.parentShopId
                        self.getRankingDataAndRender(parentShopId)
                    } else {
                        self.getData()
                    }
                });
			});
			// （总部管理员）弹出 排行范围的遮罩
			this.$.on('vclick', '.am-header .ranking-range.headquarters', function () {
				if (self.rankingConfigs.rankingScope[0] === '3') return

				if (!self.hasSetHeight) {
					var rankingScope = self.rankingConfigs.rankingScope;
					rankingScope = self.selectedKpiData.key==='TC_TC' ? ["1"] : amGloble.reverse(rankingScope);
					var index = Number(rankingScope[0]) - 1;
					var height = self.rankingRangeByShopsHeight || self.rankingRangeByAreasHeight;
					self.$.find('.rankingRange_wrapper .content.isAll').css('height', height);
					self.$.find('.rankingRange_wrapper').css('height', self.$.find('.rankingRange_wrapper').outerHeight() + 'px');
					self.$.find('.rankingRange_wrapper .content').eq(index).removeClass('hidden').siblings('.content').addClass('hidden')
				}
				self.$.find('.rankingRange_mask').show()
				self.$.find('.rankingRange_wrapper').addClass('active')
				self.checkRankingRange();
				self.hasSetHeight = true;
			});

			// 关闭排行范围的遮罩
			self.$.find('.rankingRange_mask').vclick(function() {
				self.$.find('.rankingRange_mask').hide()
				self.$.find('.rankingRange_wrapper').removeClass('active')
			})
			// 切换排行范围 tab-bar
			this.$.on('vclick', '.rankingRange_wrapper .tab-bar li', function() {
				$(this).addClass('selected').siblings().removeClass('selected')
				var rankingRangeType = $(this).data('type')
				$('.rankingRange_wrapper .content').eq(rankingRangeType - 1).removeClass('hidden').siblings('.content').addClass('hidden')
				// 按全企业排行
				if (rankingRangeType === 3) {
					self.$.find('.rankingRange_mask').hide()
					self.$.find('.rankingRange_wrapper').removeClass('active')
					$(this).parent().siblings().find('li').removeClass('selected')
					if (self.$today.is(':visible')) {
						self.$today.hide();
						self.$thisMonth.addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');
					}
					self.$headerTitle.find('.ranking-range').text('全企业')
					self.isAll = 1
					self.selectedShopData = null
					self.selectedAreaData = null
					var parentShopId = amGloble.metadata.userInfo.parentShopId;
					self.getRankingDataAndRender(parentShopId)
				}
			})

			// 切换 门店排行里的门店
			this.$.on('vclick', '.rankingRange_wrapper .shop-ranking li', function() {
				var shopData = $(this).data('shopData')
				self.selectedShopData = shopData
				var shopName = self.getShopName(shopData)
				if(shopData.enabledNewBonusModel!=1 && self.selectedKpiData.key=='TC_TC'){
					amGloble.msg(shopName+'未开启新提成')
					return;
				}
				$(this).addClass('selected').siblings().removeClass('selected');
				$(this).parent().parent().siblings().find('li').removeClass('selected');
				self.$.find('.rankingRange_wrapper .area-ranking li').removeClass('selected')
				self.$.find('.rankingRange_mask').hide()
				self.$.find('.rankingRange_wrapper').removeClass('active')
				if(self.selectedKpiData.key !=='TC_TC'){
					self.$today.show();
				}
				self.$headerTitle.find('.ranking-range').text(shopName)
				self.selectedAreaData = null
				self.isAll = null
				self.getRankingDataAndRender(shopData.parentShopId,shopData)

			})
			// 切换区域排行里的区域
			this.$.on('vclick', '.rankingRange_wrapper .area-ranking li', function() {
				$(this).addClass('selected').siblings().removeClass('selected')
				self.$.find('.rankingRange_wrapper .shop-ranking li').removeClass('selected')
				self.$.find('.rankingRange_mask').hide()
				self.$.find('.rankingRange_wrapper').removeClass('active')
				if (self.$today.is(':visible')) {
					self.$today.hide();
					self.$thisMonth.addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');
				}
				var areaData = $(this).data('areaData')
				self.selectedAreaData = areaData
				self.$headerTitle.find('.ranking-range').text(areaData.AREANAME)
				self.selectedShopData = null
				self.isAll = null
				self.getRankingDataAndRender(areaData.SHOPID)
			})

			// 切换时间
            this.$.on('vclick', '.monthwrap li', function () {
                $(this).addClass("onmonth").css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');
                self.getData();
            });

            // 切换到 “作品” tab 时，点击作品 item，查看作品列表
            this.$.on('vclick', '.inner-cont li', function () {
				var kpiKey = self.selectedKpiData.key
                if (kpiKey == 'ZP_ZP') { //作品
                    var empId = $(this).data('item').empId;
                    var url = amGloble.getShareRoot() + $.param({
                        tenantId: amGloble.metadata.userInfo.parentShopId,
                        view: 15,
                        modelId: empId
                    });
                    window.open(url, '_blank', 'location=no');
                }
			});
			// 切换到 “作品” tab 时，点击头部主展示区，查看作品列表
            this.$thefirstWrap.vclick(function () {
				var kpiKey = self.selectedKpiData.key
                if (kpiKey == 'ZP_ZP') { //作品
                    if ($(this).data('item')) {
                        var empId = $(this).data('item').empId;
                        var url = amGloble.getShareRoot() + $.param({
                            tenantId: amGloble.metadata.userInfo.parentShopId,
                            view: 15,
                            modelId: empId
                        });
                        window.open(url, '_blank', 'location=no');
                    }
                }
			});
		},
		hideIconForTC:function(){
			var shopType = amGloble.metadata.userInfo.shopType
			var rankingRangeTypeArr = self.selectedKpiData.key==='TC_TC' ? ["1"] : self.rankingConfigs.rankingScope;
			var hideIcon = rankingRangeTypeArr.length === 1 || shopType === 1 || shopType === 3;
			var rankingScopeLength = self.rankingConfigs.rankingScope.length;
			if (!shopType) {
				self.$headerTitle.find('.ranking-range').addClass('hasIcon')
				if (((rankingScopeLength === 1 && self.rankingConfigs.rankingScope[0] === '3') || hideIcon) && self.userRole!==0) {
					self.$headerTitle.find('.ranking-range').removeClass('hasIcon')
				}
			} else if (shopType === 2) {
				if (rankingScopeLength === 1 || hideIcon) {
					self.$headerTitle.find('.ranking-range').removeClass('hasIcon')
				} else {
					self.$headerTitle.find('.ranking-range').addClass('hasIcon')
				}
			} else {
				self.$headerTitle.find('.ranking-range').removeClass('hasIcon')
			}
		},
		checkRankingRange:function(){
			if(self.selectedKpiData.key==='TC_TC'){
				var $tabs=self.$.find('.rankingRange_wrapper .tab-bar').children('li');
				for(var i=0,len=$tabs.length;i<len;i++){
					var type = $($tabs[i]).data('type');
					if(type!="1"){
						$($tabs[i]).hide();
					}else{
						$($tabs[i]).show();
					}
				}
			}else{
				self.$.find('.rankingRange_wrapper .tab-bar').children('li').show();
			}
		},
		checkUserRole:function() {
			// 用户角色 0:总部管理员  1:直属店管理员  2:直属店员工  3:附属店管理员  4:附属店员工  5:单店管理员  6:单店员工
			// key: 'userType + shopType'
			var userRoleMap = {
				'00': 0,
				'02': 1,
				'12': 2,
				'03': 3,
				'13': 4,
				'01': 5,
				'11': 6
			}
			var userInfo = amGloble.metadata.userInfo
			var userType = userInfo.userType
			var shopType = userInfo.shopType
			var key =  String(userType) + String(shopType)
			this.userRole = userRoleMap[key]
        },
        checkOnlyTCKpiScenes: function(kpiDataList, shopData) {
            var onlyTCKpi = self.checkOnlyTCKpi(kpiDataList);
            var notRankingByShop = self.rankingConfigs.rankingScope.indexOf('1') === -1;
            // 未开启新提成
            var disabledNewBonusModel = shopData ? shopData.enabledNewBonusModel !== '1' : false;
            return onlyTCKpi && (notRankingByShop || disabledNewBonusModel);
        },
		validKpiDataLength: function(kpiDataList,shopData) {
			var kpiList;
			if (kpiDataList.length > 0 && self.isEmployee) {
				kpiList = self.getKpiListByFilterDutyType(kpiDataList);
			} else {
				kpiList = kpiDataList;
            }
            var checkOnlyTCKpiScenesRes = self.checkOnlyTCKpiScenes(kpiList, shopData);
			if (kpiList.length == 0 || checkOnlyTCKpiScenesRes) {
				self.refresh();
				self.scrollview.scrollTo("top");
				self.rankingListData = null;
				self.isNotKpiData = true;
				// self.latestRealParentShopId = undefined;
				amGloble.loading.hide();
				self.closeTopLoading();
				self.closeBottomLoading();
				self.$thefirstWrap.find('.admin-view').hide();
				self.$thefirstWrap.find('.emp-view').hide();
				self.$.find('.footTab').hide()
				self.$monthwrap.hide();
				self.$headerTitle.addClass('hideEmp');
				self.$headerTitle.find('.noKpiTitle').show();
				self.$innerTop.hide();
				self.$innerTop.css('background', '');
				self.$amHeader.css('background', '')
				self.$innerContUl.hide();
				self.$.find('.rankdata_single_kpi').hide();
				if (self.userRole == 0) {
					self.$empContent.hide()
					self.$noKipBox.show()
				} else {
					self.$empContent.show()
					self.$noKipBox.hide()
					self.$empSwitch.addClass('hidden')
				}
			} else {
				self.isNotKpiData = false;
				self.$innerTop.show();
				self.$innerContUl.show();
				self.$errorTips.parent().removeClass('am-status-error');
				self.$headerTitle.find('.noKpiTitle').hide();
				self.$monthwrap.show();
				self.$empContent.hide();
				self.$noKipBox.hide();
				if (self.isEmployee) { //员工
					self.$thefirstWrap.find('.emp-view').show()
					self.$thefirstWrap.find('.admin-view').hide()
					self.$headerTitle.addClass('hideEmp');
				} else { //管理者
					self.$thefirstWrap.find('.admin-view').show()
					self.$thefirstWrap.find('.emp-view').hide()
					self.$headerTitle.removeClass('hideEmp');
				}
				self.setFootTabs(kpiList,shopData);
			}
        },
		// 获取租户配置的排行数据并渲染
		getRankingDataAndRender: function(currentRealParentShopId,shopData) {
			var self = this;
			if (currentRealParentShopId !== self.latestRealParentShopId || self.isNotKpiData) { // 租户发生改变，KPI 排行数据也会变
				var kpiDataList = [];
				self.latestRealParentShopId = currentRealParentShopId;
				if (!self.rankingDataMap[currentRealParentShopId]) { // 如果 map 里没有，则去请求
					this.setStatus("pageLoading");
					amGloble.api.getRankingData.exec({
						realParentShopId: currentRealParentShopId
					},function(ret) {
						self.setStatus("normal");
						if(ret.code==0) {
							self.$headerTitle.show();
							ret.content.forEach(function(kpiData) {
								var visible = kpiData.visible;
								var dutyTypesArr = kpiData.rankingPattern && JSON.parse(kpiData.rankingPattern).pattern;
								if (visible == 1 && dutyTypesArr.length > 0) {
									kpiDataList.push(kpiData);
								}
							})
							self.validKpiDataLength(kpiDataList,shopData);
							if (kpiDataList.length > 0) {
								self.rankingDataMap[currentRealParentShopId] = kpiDataList;
							}
						} else {
							self.latestRealParentShopId = undefined;
							amGloble.loading.hide();
							self.closeTopLoading();
							self.closeBottomLoading();
							self.$errorTips.parent().addClass('am-status-error');
							self.$headerTitle.hide();
							self.$monthwrap.hide();
						}
					});
				} else { // 如果 map 里有，则直接去 map 里取
					kpiDataList = self.rankingDataMap[currentRealParentShopId];
					self.validKpiDataLength(kpiDataList,shopData);
					// self.setFootTabs(kpiDataList);
				}
			} else { // 租户未发生改变
				var userId = amGloble.metadata.userInfo.userId;
                if (self.latestUserId == userId && self.withoutYJKpiByMgjVersionSCB) {
                    self.checkVersion()
                } else {
                    self.validKpiDataLength(self.rankingDataMap[currentRealParentShopId],shopData);
                }
			}
		},
		getSelectedAreaId:function(){
			var areaId = null;
			var shopType = amGloble.metadata.userInfo.shopType
			if (!shopType) { // 总部
				areaId = self.selectedAreaData ? self.selectedAreaData.ID : null
			} else if (shopType === 2) { // 直属
				areaId = self.ownAreaData ? self.ownAreaData.ID : null
			}
			return areaId;
		},
		getHideTCCriteria:function(shopData){
			var flag=false;
			var areaId= this.getSelectedAreaId();
			var enabledNewBonusModel = shopData ? shopData.enabledNewBonusModel : amGloble.metadata.configs.enabledNewBonusModel;
			var hideTCConfig=enabledNewBonusModel!=='1' || self.rankingConfigs.rankingScope.indexOf('1') < 0;
			var currentQuery=!shopData && (self.isAll || areaId)// 查企业或者区域

			if(currentQuery || hideTCConfig){
				// 企业 区域 未开启新提成 隐藏提成tab
				flag=true;
			}
			return flag;
		},
        setFootTabs:function(data,shopData){
			this.$.find(".scroll-x").empty();
			var kpiList;
			var mgjVersion = amGloble.metadata.userInfo.mgjVersion;
			if (mgjVersion == 1) {
				kpiList = this.getKpiListByJudgeMgjVersionSCB(data);
			} else {
				kpiList = data;
            }
            this.checkedKpiList=kpiList;
			var isOnlyTCkpi=self.checkOnlyTCKpi(kpiList);
			for (var i = 0; i < kpiList.length; i++) {
				var kpiItem = kpiList[i]
                // 提成 KPI 特殊处理
                if(kpiItem.key==='TC_TC'){
                    if (!isOnlyTCkpi && self.getHideTCCriteria(shopData)) {
                        continue;
                    } else {
                        self.hasTcKpi = true;
                    }
                }
				var spanDom = $('<span class="am-clickable">' + kpiItem.name + '</span>')
				if (mgjVersion == 1 && kpiItem.key !== 'YJ_YJ') {
					spanDom.addClass('disabled')
				}
				spanDom.data('kpiData', kpiItem)
				this.$.find(".scroll-x").append(spanDom)
			}
			var footTabEl = this.$.find('.footTab');
			var singleKpiEl = this.$.find('.rankdata_single_kpi');
			var kpiDomList = this.$.find(".scroll-x").width('auto').children();
			if (kpiDomList.length === 1) {
				footTabEl.hide();
				singleKpiEl.show();
				singleKpiEl.text(kpiDomList.eq(0).text());
			} else {
				singleKpiEl.hide();
				footTabEl.show();
			}
			this.refresh();
            // 进入页面，默认选中第一个 KPI 请求列表数据
            this.$.find(".scroll-x").find('.am-clickable').eq(0).trigger('vclick')
			var width = 0;
			var $tabs = this.$.find(".scroll-x").find('.am-clickable')
			for(var i = 0; i < $tabs.length; i++){
				width += $tabs.eq(i).outerWidth(true);
			}
			this.$.find(".scroll-x").css('width',width+5+'px');
			if (!this.$scrollXBox) {
				this.$scrollXBox=new $.am.ScrollView({
					$wrap: this.$.find(".footTab"),
					$inner: this.$.find(".scroll-x"),
					direction: [1, 0],
					onScrollStop:function(pos){
						var $icon=$('.footTab').find('.icon');
						if(pos[0]<=this._min[0]){
							var showValue=$icon.css('display');
							if(showValue=='block'){
								$icon.css('display','none')
							}
						}else{
							if($('.scroll-x span:last').hasClass('selected')){
								$icon.css('display','none')
							}
							var hideValue=$icon.css('display')
							if(hideValue=='none'){
								$icon.css('display','block')
							}}
					},
				});
			}
            this.$scrollXBox.scrollTo([0, 0]);
			this.$scrollXBox.refresh();
		},
		// 生成直营店、附属店、单店的数组
		generateShopArr: function() {
			var shopsArr = amGloble.metadata.shops;
			self.singleShopArr = [];
			self.directShopsArr = [];
			self.indirectShopsArr = [];
			for (var i=0; i<shopsArr.length; i++) {
				var shop = shopsArr[i];
				if (shop.softgenre === 1) {
					self.singleShopArr.push(shop)
				} else if (shop.softgenre === 2) {
					self.directShopsArr.push(shop)
				} else if (shop.softgenre === 3) {
					self.indirectShopsArr.push(shop)
				}
			}
		},
		// 生成员工级别类型的数组
		generateEmpRoles: function(kpiData) {
			var result = []
			var rankingPattern = kpiData.rankingPattern
			if (rankingPattern) {
				rankingPattern = JSON.parse(rankingPattern)
				result = rankingPattern.pattern
			}
			return result
		},
		// 获取排行榜配置
		getRankingConfigs: function() {
			var userInfo = amGloble.metadata.userInfo
            var configs = amGloble.metadata.configs
            var shopType = amGloble.metadata.userInfo.shopType
            var rankingScope = configs.rankingScope && JSON.parse(configs.rankingScope)
			var newRankingScope, 
				rankingView_isPart = configs.rankingView_isPart,
				rankingView_top = configs.rankingView_top,
				rankingView_next = configs.rankingView_next,
				rankingView_preview = configs.rankingView_preview;
			if (configs.rankingConfigVersion == 1) {
				switch (self.userRole) {
					// 总部管理员
					case 0:
						newRankingScope = userInfo.shopids ? rankingScope.area : rankingScope.tenant;
						rankingView_top = configs.rankingView_topForArea;
						rankingView_isPart = userInfo.shopids ? configs.rankingView_isPartForArea : 0;
						break;
					case 1:
						rankingView_top = configs.rankingView_topForShop;
						newRankingScope = rankingScope.shop;
						rankingView_isPart = configs.rankingView_isPartForShop;
						rankingView_next = '';
						rankingView_preview = '';
						break;
					// 员工
					case 2:
					case 4:
					case 6:
						newRankingScope = rankingScope.emp;
						rankingView_isPart = configs.rankingView_isPart;
						break;
					default:
						break;
				}
			} else {
				rankingView_isPart = userInfo.userType == 0 ? 0 : configs.rankingView_isPart;
				var rankingView_shop = Number(configs.rankingView_shop)
            	var newRankingScope = this.convertRankingScope(rankingScope, rankingView_shop)
			}
            // 附属店（加盟店）不参与区域 / 全企业排行
            if (shopType === 1 || shopType === 3) newRankingScope = ['1']
            if (!newRankingScope || newRankingScope.length === 0) return false;
			var result = {
				hiddenPerformanceAmount: configs.hiddenPerformanceAmount, // 隐藏业绩金额 true:隐藏  false:显示
				isPart: Number(rankingView_isPart), // 员工查看权限 0:全部显示  1:部分显示
				top: Number(rankingView_top), // 前几条
				preview: Number(rankingView_preview), // 相对该员工前几名
				next: Number(rankingView_next), // 相对该员工后几名
				rankingScope: newRankingScope // 排行范围 1:按门店排行 2:按区域排行 3:按全企业排行
             }
			return result
        },
        convertRankingScope: function(rankingScope, rankingView_shop) {
            var result = []
            if (rankingView_shop === 0) {
                return rankingScope
            } else if (rankingView_shop === 1) {
                if (self.userRole === 0) {
                    result = rankingScope
                } else {
                    if (rankingScope.indexOf('1') !== -1) {
                        result.push('1')
                    }
                }
            } else if (rankingView_shop === 2) {
                if (self.userRole === 0 || self.userRole === 1) {
                    result = rankingScope
                } else {
                    if (rankingScope.indexOf('1') !== -1) {
                        result.push('1')
                    }
                }
            }
            return result
		},
		showDefaultEmptyPage: function() {
			self.$thefirstWrap.find('.admin-view').hide();
			self.$thefirstWrap.find('.emp-view').hide();
			self.$.find('.footTab').hide()
			self.$monthwrap.hide();
			self.$headerTitle.addClass('hideEmp');
			self.$headerTitle.find('.noKpiTitle').show();
			self.$innerTop.hide();
			self.$innerTop.css('background', '');
			self.$amHeader.css('background', '')
			self.$innerContUl.hide();
			self.$.find('.rankdata_single_kpi').hide();
			self.$empContent.show()
			self.$noKipBox.hide()
			self.$empSwitch.addClass('hidden')
		},
        backButtonOnclick: function () {
            $('.nativeUIWidget-showPopupMenu .cancel').trigger('vclick');
            $.am.page.back();
        },
        beforeShow: function (ret) {
			var userInfo = amGloble.metadata.userInfo;
			var userId = userInfo.userId;
			var userType = userInfo.userType;
			// shopType 0:总部 1:单店 2:直属店 3:附属店
            var shopType = userInfo.shopType;
            var realParentShopId = amGloble.metadata.userInfo.realParentShopId;
            self.isEmployee = userType ? true : false;
            // 校验用户身份
            self.checkUserRole()
            self.rankingConfigs = self.getRankingConfigs()
            if (!self.rankingConfigs) {
				self.showDefaultEmptyPage()
				return
			}
			this.rankingDataCacheMap = {};

			// if (ret == "back" || (this.rankingListData && this.latestUserId == userId)) {
			if (ret == "back") {
                return;
			}
			if (self.latestRealParentShopId && self.isNotKpiData && this.latestUserId == userId) {
				self.getRankingDataAndRender(self.latestRealParentShopId, self.currentShop);
				return;
			}


			// 控制 排行范围 弹出开关，区分总部管理员和门店管理员或员工
			if (!self.userRole) { // 总部管理员
				self.$headquartersSwitch.removeClass('hidden')
				self.$empSwitch.addClass('hidden')
			} else { // 门店管理员或员工
				self.$empSwitch.removeClass('hidden')
				self.$headquartersSwitch.addClass('hidden')
			}
			// 获取区域数据
			if (!shopType) {
				self.getAreaData();
				self.$headerTitle.find('.ranking-range').addClass('hasIcon')
				if (self.rankingConfigs.rankingScope.length === 1 && self.rankingConfigs.rankingScope[0] === '3') {
					self.$headerTitle.find('.ranking-range').removeClass('hasIcon')
				}
			} else if (shopType === 2) {
				self.getAreaData();
				if (self.rankingConfigs.rankingScope.length === 1) {
					self.$headerTitle.find('.ranking-range').removeClass('hasIcon')
				} else {
					self.$headerTitle.find('.ranking-range').addClass('hasIcon')
				}
			} else {
				self.$headerTitle.find('.ranking-range').removeClass('hasIcon')
			}
			// 生成直营店和附属店的数组
			self.generateShopArr()
			// 生成门店 map
			self.generateShopsMap()
			var rankingScope = self.rankingConfigs.rankingScope;
			if (!self.userRole) rankingScope = amGloble.reverse(rankingScope);
			if (rankingScope.indexOf('1') !== -1) {
				self.$.find('.rankingRange_wrapper .content').eq(1).addClass('hidden')
			} else {
				self.$.find('.rankingRange_wrapper .content').eq(0).addClass('hidden')
			}
			if (rankingScope[0] === '1') {
				if (!self.userRole) {
					self.selectedShopData = self.directShopsArr[0] || self.indirectShopsArr[0] || self.singleShopArr[0];
                    var shopName = self.getShopName(self.selectedShopData);
                    // 特殊场景：总部登录，只配置了按门店排行，所管理的门店都是附属店，此时需要取附属店的 parentShopId
                    realParentShopId = self.selectedShopData.parentShopId;
				} else {
                    var shopId = userInfo.shopId;
                    var shopName = self.getShopName(userInfo);
                    self.selectedShopData = self.shopsMap[shopId];
                }
				self.$headerTitle.find('.ranking-range').text(shopName)
				self.$today.show().addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff')

				self.selectedAreaData = null
				self.isAll = null
				// self.$.find('.rankingRange_wrapper .content').eq(0).removeClass('hidden').siblings().addClass('hidden')
			} else if (rankingScope[0] === '2') {
				self.$today.hide();
				self.$thisMonth.addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');

				self.selectedShopData = null
				self.isAll = null
				self.getOwnAreaData()
				// self.$.find('.rankingRange_wrapper .content').eq(1).removeClass('hidden').siblings().addClass('hidden')
			} else if (rankingScope[0] === '3') {
				self.isAll = 1
				self.$headerTitle.find('.ranking-range').text('全企业')
				self.$today.hide();
				self.$thisMonth.addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');

				self.selectedShopData = null
				self.selectedAreaData = null
			}
			// 渲染 排行范围 tab-bar (这里无需缓存，因为点击头像切换账号时，会重新请求 metadata接口)
			if (!shopType) self.renderRankingTabBar()
			// 渲染 按门店排行对应的门店列表，区分直属和附属
			if (!shopType && rankingScope.indexOf('1') !== -1) self.renderRankingRangeByShops()

			if (self.isEmployee) { //员工
				self.$headerTitle.addClass('hideEmp');
				self.$thefirstWrap.find('.emp-view').show()
				self.$thefirstWrap.find('.admin-view').hide()
				self.$innerTop.addClass('empHeight')
				self.$headerTitle.find('.ranking-range').css('maxWidth', '120px')
			} else { //管理者
				self.$headerTitle.removeClass('hideEmp');
				self.setLevel(self.employeeRolesByselectedKpi[0])
				self.$thefirstWrap.find('.admin-view').show()
				self.$thefirstWrap.find('.emp-view').hide()
				self.$innerTop.removeClass('empHeight')
				self.$headerTitle.find('.ranking-range').css('maxWidth', '80px')
			}

			// 获取租户配置的排行数据
            self.currentShop = self.selectedShopData && self.shopsMap[self.selectedShopData.shopId];
			self.getRankingDataAndRender(realParentShopId, self.currentShop);
			this.latestUserId = userId;
        },
        afterShow: function (paras) {
			this.$scrollXBox && this.$scrollXBox.refresh();
        },
		amDragTopTips: ["下拉刷新列表", "松开开始加载", "加载中..."],
		touchTop: function() {
			self.rankingListData = null;
			var preParentShopId = self.latestRealParentShopId;
			if (preParentShopId && !self.rankingDataMap[preParentShopId]) {
				self.latestRealParentShopId = undefined;
				self.getRankingDataAndRender(preParentShopId);
			} else {
				self.getData(true);
			}
		},
		// 获取区域数据
		getAreaData: function() {
			var successCallBack = function() {
				var shopType = amGloble.metadata.userInfo.shopType,
					shopids = amGloble.metadata.userInfo.shopids;
				if (shopType == 0 && shopids) {
					var shopIdList = shopids.split(',');
					self.areaList = self.areaListForAll.filter(function(areaData) {
						var areaShopIdList = areaData.SHOPIDS ? areaData.SHOPIDS.split(',') : [];
						var valid = false;
						for(var i = 0; i < areaShopIdList.length; i ++) {
							if (shopIdList.indexOf(areaShopIdList[i]) !== -1) {
								valid = true;
								break;
							}
						}
						// 验证分管门店是否与区域下门店有交集
						return valid;
					})
				} else {
					self.areaList = self.areaListForAll;
				}
				if (!shopType) {
					if (self.rankingConfigs.rankingScope.indexOf('2') !== -1 && self.rankingConfigs.rankingScope.indexOf('3') === -1) {
						self.selectedAreaData = self.areaList[0]
						self.$headerTitle.find('.ranking-range').text(self.selectedAreaData.AREANAME)
					}
				} else if (shopType === 2) {
					if (self.rankingConfigs.rankingScope[0] === '2') {
						self.getOwnAreaData()
						self.$headerTitle.find('.ranking-range').text(self.ownAreaData.AREANAME)
					}
				}
				if (!shopType && self.rankingConfigs.rankingScope.indexOf('2') !== -1) self.renderRankingRangeByAreas(self.areaList)
			}
			if (self.areaListForAll) {
				successCallBack();
				return;
			}
			// amGloble.loading.show("正在获取,请稍候...");
			this.setStatus("pageLoading");
            amGloble.api.getAreaList.exec({
                parentShopId: amGloble.metadata.userInfo.parentShopId
            }, function (ret) {
				// amGloble.loading.hide();
				self.setStatus("normal");
                if (ret.code == 0) {
					self.areaListForAll = ret.content;
					successCallBack();
                } else {
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                }
            });
		},
		getOwnAreaData: function() {
			var shopId = amGloble.metadata.userInfo.shopId
			var areaList = self.areaList;
			if (!areaList) return;
			for (var i=0; i<areaList.length; i++) {
				var areaData = areaList[i]
				if (areaData.SHOPIDS.indexOf(shopId) !== -1) {
					self.ownAreaData = areaData
					break
				}
			}
		},
		// 渲染 排行范围 tab-bar
		renderRankingTabBar: function() {
			var rankingScope = JSON.parse(JSON.stringify(self.rankingConfigs.rankingScope));
			rankingScope = self.selectedKpiData.key==='TC_TC' ? ["1"] : amGloble.reverse(rankingScope);
			var $tabBarWrap = self.$.find('.rankingRange_wrapper .tab-bar')
			$tabBarWrap.empty()
			// ['3', '2', '1']  "3":按全企业排行  "2":按区域排行  "1":按门店排行
			var labelMap = {
				'3': '全企业',
				'2': '区域排行',
				'1': '门店排行',
			}
			var index = Number(rankingScope[0]) - 1;
			if (rankingScope.length === 1) {
				$tabBarWrap.hide()
				self.$.find('.rankingRange_wrapper .content').eq(index).find('.tip').removeClass('hidden')
			} else {
				$tabBarWrap.show()
				for (var i=0; i<rankingScope.length; i++) {
					var item = rankingScope[i]
					var $li = $('<li class="am-clickable" data-type="' + Number(item) + '">' +labelMap[item]+ '</li>')
					$tabBarWrap.append($li)
				}
				$tabBarWrap.find('li').eq(0).addClass('selected');
				var shopsLength = amGloble.metadata.allShops.length - 1;
				if (rankingScope.indexOf('3') !== -1) self.$.find('.rankingRange_wrapper .content.isAll .count').text(shopsLength);
			}
			if (self.hasSetHeight) self.$.find('.rankingRange_wrapper .content').eq(index).removeClass('hidden').siblings('.content').addClass('hidden')
		},
		// 渲染 按门店排行对应的门店列表，区分直属和附属
		renderRankingRangeByShops: function() {
			var shopsArr = amGloble.metadata.shops;
			if (!self.directShopsArr.length) self.$.find('.rankingRange_wrapper .direct-shop').hide()
			if (!self.indirectShopsArr.length) self.$.find('.rankingRange_wrapper .indirect-shop').hide()
			// 直营店 wrap
			var $directShopsWrap = self.$.find('.rankingRange_wrapper ul.direct-shops')
			// 附属店 wrap
			var $indirectShopWrap = self.$.find('.rankingRange_wrapper ul.indirect-shops')
			$directShopsWrap.empty();
			$indirectShopWrap.empty();
			for (var i = 0; i < shopsArr.length; i++) {
				var shopItem = shopsArr[i]
				var shopName = self.getShopName(shopItem);
				var $shopLi = $('<li class="am-clickable">' + shopName + '</li>')
				$shopLi.data('shopData', shopItem)
				if (shopItem.softgenre === 2) {
					$directShopsWrap.append($shopLi)
				} else if(shopItem.softgenre === 3) {
					$indirectShopWrap.append($shopLi)
				}
			}
			self.rankingRangeByShopsHeight = self.$.find('.rankingRange_wrapper .content.shop-ranking').outerHeight() + 'px';
			if (self.rankingConfigs.rankingScope.length === 1) self.$.find('.rankingRange_wrapper .content.shop-ranking li').eq(0).addClass('selected');

			self.shopListScrollView = new $.am.ScrollView({
				$wrap: self.$.find('.rankingRange_wrapper .content.shop-ranking'),
				$inner: self.$.find('.rankingRange_wrapper .content.shop-ranking .shop-ranking-inner')
			});

		},
		// 渲染 按区域排行对应的区域列表
		renderRankingRangeByAreas: function(data) {
			// 区域 wrap
			var $areaWrap = self.$.find('.rankingRange_wrapper ul.area-wrap')
			$areaWrap.empty()
			var areaList = data
			for (var i = 0; i < areaList.length; i++) {
				var areaItem = areaList[i]
				var $areaLi = $('<li class="am-clickable">' + areaItem.AREANAME + '</li>')
				$areaLi.data('areaData', areaItem)
				$areaWrap.append($areaLi)
			}
			self.rankingRangeByAreasHeight = self.$.find('.rankingRange_wrapper .content.area-ranking').outerHeight() + 'px';
			if (self.rankingConfigs.rankingScope.indexOf('3') === -1) self.$.find('.rankingRange_wrapper .content.area-ranking li').eq(0).addClass('selected');

			self.areaListScrollView = new $.am.ScrollView({
				$wrap: self.$.find('.rankingRange_wrapper .content.area-ranking'),
				$inner: self.$.find('.rankingRange_wrapper .content.area-ranking .area-ranking-inner')
			});
		},
		changeBgColor: function(index) {
			var bgColor = bgColorsArr[index]
			self.bgColor = bgColor
			self.$amHeader.css('background', bgColor)
			self.$monthwrap.css('background', bgColor)
			self.$monthwrap.find('.onmonth').css('color', bgColor)
			self.$innerTop.css('background', bgColor)
		},
		handleChangeType: function(kpiData, index) {
			var self = this;

			self.$thefirstWrap.data('item', null);
			var userType = amGloble.metadata.userInfo.userType;
			if (userType) { // 员工
				self.$headerTitle.addClass('hideEmp');
			} else if (kpiData.rankingType) { // 管理员且排行方式为分别排行
				self.$headerTitle.removeClass('hideEmp');
			} else {
				self.$headerTitle.addClass('hideEmp');
			}
			var rankingScope = JSON.parse(JSON.stringify(self.rankingConfigs.rankingScope));
			if(kpiData.key=='TC_TC'){
				self.$today.hide();
				self.$thisMonth.addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff');
			}else if(rankingScope[0] !== '2' && rankingScope[0] !== '3'){
				self.$today.show().addClass('onmonth').css('color', self.bgColor).siblings().removeClass('onmonth').css('color', '#fff')
			}
			self.changeBgColor(index)
			self.getData();
		},
        getPeriod: function () {
            if (new Date().getMonth() == 0) { //特殊处理
                return {
                    'today': new Date().getFullYear() + '-' + this.zeroFill(new Date().getMonth() + 1) + '-' + this.zeroFill(new Date().getDate()),
                    'thismonth': new Date().getFullYear() + '-' + this.zeroFill(new Date().getMonth() + 1), //本月
                    'lastmonth': (new Date().getFullYear() - 1) + '-' + 12 //上月
                };
            } else {
                return {
                    'today': new Date().getFullYear() + '-' + this.zeroFill(new Date().getMonth() + 1) + '-' + this.zeroFill(new Date().getDate()),
                    'thismonth': new Date().getFullYear() + '-' + this.zeroFill(new Date().getMonth() + 1), //本月
                    'lastmonth': new Date().getFullYear() + '-' + this.zeroFill(new Date().getMonth()) //上月
                };
            }
        },

		// 设置员工级别
        setLevel: function (data, refresh) {
            try {
                self.dutyType = data.id;
                this.$.find(".am-header .roles").html(data.name);
            } catch (e) {
                self.dutyType = null;
                this.$.find(".am-header .roles").html("请选择");
            }
            if (refresh) {
                this.getData();
            }

        },
        zeroFill: function (num) {
            var num = num + '';
            if (num.length == 1) {
                return '0' + num;
            } else {
                return num;
            }
		},
		buildRankingDataCacheKey: function(params) {
			return params.rankingId + '_' + params.period + '_' + params.dutyType + '_' + params.shopId + '_' + params.areaId + '_' + params.isAll + '_' + window.config.token;
		},
		getShopWithTC:function(){
			var $shops=this.$.find('.rankingRange_wrapper .shop-ranking li');
			var $targetShop,shopData;
			$.each($shops,function(shop,index){
				shopData=$(this).data('shopData');
				if(shopData && shopData.enabledNewBonusModel==='1'){
					$targetShop=$(this);
					return false
				}
			});
			if($targetShop){
				var shopName=self.getShopName(shopData);
                self.selectedShopData = self.shopsMap[shopData.shopId]
				self.$headerTitle.find('.ranking-range').text(shopName)
				self.selectedAreaData = null
				self.isAll = null
				$($targetShop).trigger('vclick');
				return true;
			}else{
				return false;
			}
		},
		checkOnlyTCKpi:function(checkedKpiList){
			return checkedKpiList && checkedKpiList.length==1 && checkedKpiList[0].key==='TC_TC';// 只开启提成kpi
		},
		needReGetPageTCData:function(){
			var areaId=self.getSelectedAreaId();
			var isAll=self.isAll;
			if(self.checkOnlyTCKpi(self.checkedKpiList) && (isAll || areaId)){
				// 只开启提成KPI 并且查区域或者企业
				return true;
			}else{
				return false;
			}
        },
		getWageDateRangeByDate: function(label){
			var currentWageDateRange = self.getCurrentWageDateRange();
			var startDate = currentWageDateRange[0];
			var endDate = currentWageDateRange[1];
			var result = {};
			var commissionStartTime,commissionEndTime;
			if (label === 'thismonth') { // 本月
				commissionStartTime = startDate.setHours(0, 0, 0, 0);
				commissionEndTime = endDate.setHours(23, 59, 59, 999);
			} else { // 上月
				var month = startDate.getMonth();
				var day = startDate.getDate();
				commissionStartTime = new Date(startDate).setMonth(month - 1);
				commissionStartTime = new Date(commissionStartTime).setHours(0, 0, 0, 0);
				commissionEndTime = new Date(startDate).setDate(day - 1);
				commissionEndTime = new Date(commissionEndTime).setHours(23, 59, 59, 999);
			}
			result.commissionStartTime = commissionStartTime;
			result.commissionEndTime = commissionEndTime;
			return result;
		},
		getCurrentWageDateRange: function() {
			var wageDay = self.selectedShopData.wageDay;
			wageDay = wageDay ? Number(wageDay) : 1;
			var currentDay = new Date().getDate();
			var currentMonth = new Date().getMonth();
			var startDate;
			if (currentDay >= wageDay) {
				startDate = new Date();
			} else {
				startDate = new Date(new Date().setMonth(currentMonth - 1));
			}
			var start = new Date(startDate.setDate(wageDay));
			var range = [start, new Date()];
			return range;
        },
        getData: function (refresh) {
			var self = this;
			self.scrollview.scrollTo("top");
			var _idx = self.$.find('.monthwrap li.onmonth').index();
			var _pre = ['today', 'thismonth', 'lastmonth'];
            var _period = self.getPeriod()[_pre[_idx]];
			var dutyType;
            if (self.isEmployee) { //员工
                var _isEmp = 1;
				dutyType = amGloble.metadata.userInfo.dutyType; //员工默认的级别
            } else { //管理者
				var _isEmp = 0;
				dutyType = self.dutyType;
            }
			var shopId = self.selectedShopData ? self.selectedShopData.shopId : null

			var areaId = null
			var shopIds = null

			var shopType = amGloble.metadata.userInfo.shopType
			if (!shopType) { // 总部
				areaId = self.selectedAreaData ? self.selectedAreaData.ID : null
				shopIds = self.selectedAreaData ? (self.selectedAreaData.SHOPIDS ? self.selectedAreaData.SHOPIDS.split(',') : null) : null
			} else if (shopType === 2) { // 直属
				areaId = self.ownAreaData ? self.ownAreaData.ID : null
				shopIds = self.ownAreaData ? self.ownAreaData.SHOPIDS.split(',') : null
			}
			var params = {
				'shopId': shopId,
				'period': _period,
				'areaId': areaId,
				'isAll': self.isAll,
				'kpiKey': self.selectedKpiData.key,
				'rankingId': self.selectedKpiData.id,
                'isEmp': _isEmp,
				'dutyType': dutyType,
				'rankingType': self.selectedKpiData.rankingType,
				'refresh': refresh ? 1 : 0,
				'realParentShopId': self.latestRealParentShopId,
				'shopIds': shopIds
			}
			if(params.kpiKey == 'TC_TC'){
				if(self.selectedShopData){
					params.shopName=self.selectedShopData.shopName;
					params.softgenre=self.selectedShopData.softgenre;
				}else{
					params.shopName=amGloble.metadata.userInfo.shopName;
					params.softgenre=shopType;
                }
				var timestampObj = self.getWageDateRangeByDate(_pre[_idx]);
                params.commissionStartTime = timestampObj.commissionStartTime;
                params.commissionEndTime = timestampObj.commissionEndTime;
			}
			var reGetFlag=self.needReGetPageTCData();
			if(reGetFlag){
				if(self.getShopWithTC()){
					return;
				}
			}
			var successCallbackFn = function(ret) {
				//过滤掉 value = 0 的数据
				var data = [];
				for(var i = 0; i < ret.content.data.length; i ++) {
					var item = ret.content.data[i];
					if (item.value != 0) {
						if (self.userRole === 0 && amGloble.metadata.userInfo.shopids) {
							var shopidsString = ',' + amGloble.metadata.userInfo.shopids;
							if (shopidsString.indexOf(',' + item.shopId) !== -1) {	
								data.push(item)
							}
						} else {
							data.push(item)
						}
					};
				}
				self.rankingListData = data;
				if (self.isEmployee) {
					self.renderForEmployee(data)
				} else {
					self.renderForAdmin(data)
				}
				self.renderCacheTime(ret.content.cacheTime, ret.content.serverTime);
			}
			var rankDataCacheKey = self.buildRankingDataCacheKey(params);
			var rankCacheData = self.rankingDataCacheMap[rankDataCacheKey];

			if (rankCacheData && !refresh) {
				var currentTime = new Date().getTime();
				var diffTime = currentTime - rankCacheData.cacheTimestamp;
				if (diffTime < 1000 * 60 * 30) {
					rankCacheData.ret.content.serverTime = new Date().getTime();
					successCallbackFn(rankCacheData.ret);
					return;
				}
			}

            // amGloble.loading.show("正在获取,请稍候...");
			this.setStatus('pageLoading');
            amGloble.api.getRankingList.exec(params, function (ret) {
				// amGloble.loading.hide();
				self.setStatus('normal');
				self.closeTopLoading();
                self.closeBottomLoading();
                if (ret.code == 0) {
					self.rankingDataCacheMap[rankDataCacheKey] = {
						ret: ret,
						cacheTimestamp: new Date().getTime()
					};
					successCallbackFn(ret);
                } else {
					self.rankingListData = null;
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                    self.clearInit();
                }
            });
		},
		renderCacheTime: function(refreshTime, currentTime) {
			var timeDOM = self.$.find('.rankdata_cache_time');
			var tipsText = '当前数据更新于 ';
            tipsText += amGloble.diffTimeToText(refreshTime,{ append: '前' })
			timeDOM.html(tipsText);
		},
		// 管理员 渲染
        renderForAdmin: function (data) {
            this.$innerContUl.empty();
            if (data.length == 0) {
                this.clearInit();
                return false;
			}
			var userInfo = amGloble.metadata.userInfo;
			var isAreaManager = userInfo.shopType == 0 && userInfo.shopids;
			var isShopManager = userInfo.shopType != 0 && userInfo.userType == 0;
			if (self.rankingConfigs.isPart == 1 && (( self.isAll && (isAreaManager || isShopManager) || (self.ownAreaData && isShopManager) ))) {
				data = data.splice(0, self.rankingConfigs.top)
			}
			this.$innerContUl.addClass('admin').removeClass('emp')
			var kpiKey = self.selectedKpiData.key
			var isUnit = self.selectedKpiData.unit === '%' ? true : false;
			this.renderFirst(data[0])
			data.shift()
            for (var i = 0; i < data.length; i++) {
				var $shopName = self.getShopNameDom(data[i]);
				var _shopNameClass = $shopName ? ' has_shopname' : '';
				var finalValue = isUnit ? Math.round(data[i].value * 100) : Math.round(data[i].value);
				var $li = $('<li class="am-clickable">' +
					'<div class="rank">' + (data[i].rankingIndex + 1) + '</div>' +
					'<div class="licont">' +
					'<div class="count">' + finalValue + '<i>' + self.selectedKpiData.unit + '</i><span class="' + this.getState(data[i].state).listarrow + '"></span></div>' +
					'<div class="imgwrap"></div>' +
					'<div class="licontcenter' + _shopNameClass + '">' +
					'<h2>' + data[i].name + '</h2>' +
					$shopName +
					'</div>' +
					'</div>' +
					'</li>');
				var _url = '';
				if (data[i].sex == "M") {
					_url = "css/img/bg-man.gif";
				} else {
					_url = "css/img/bg-woman.gif";
				}
				$li.find('.imgwrap').css({
					'background': 'url(' + _url + ') no-repeat center center',
					'background-size': 'contain'
				}).html(amGloble.photoManager.createImage("artisan", {
					parentShopId: amGloble.metadata.userInfo.parentShopId
				}, data[i].empId + ".jpg", "s"));
				$li.data('item', data[i]);
				this.$innerContUl.append($li);
            }
            self.refresh();
		},
		// 员工 渲染
		renderForEmployee: function (data) {
			this.$innerContUl.empty();
			var self = this;
			var _userInfo = amGloble.metadata.userInfo
			var inRankList; // 是否在排行榜中
			var ranking; // 名次
			var ownRankData; // 与自身相关的排行数据
            if (data.length == 0) {
				if (_userInfo.sex == "M") {
					_url = "css/img/bg-man.gif";
				} else {
					_url = "css/img/bg-woman.gif";
				}
				this.$thefirstWrap.find('.emp-view .right .icon').css({
					'background': 'url(' + _url + ') no-repeat center center',
					'background-size': 'contain'
				}).html(amGloble.photoManager.createImage("artisan", {
					parentShopId: amGloble.metadata.userInfo.parentShopId
				}, _userInfo.userId + ".jpg", "s"));
				this.$thefirstWrap.find('.emp-view .left .noRanking').show()
				this.$thefirstWrap.find('.emp-view .left .hasRanking').hide()
				this.$thefirstWrap.find('.emp-view .right .name').text(_userInfo.userName)
				this.$thefirstWrap.find('.emp-view .right .value').hide()
				this.$thefirstWrap.find('.emp-view .right .unit').hide()
                this.clearInit();
                return false;
			}
			this.$thefirstWrap.find('.admin-view').hide()
			this.$thefirstWrap.find('.emp-view').show()
			this.$innerTop.addClass('empHeight')
			// 之前已有的针对员工的逻辑，这一版待定 ???
			// var _newRole = amGloble.metadata.userInfo.newRole;
			// if (kpiKey == 0) { //只有业绩才过滤同工位的员工
			// 	var data = data.filter(function (d) {
			// 		return d.newRole == _newRole;
			// 	});
			// }
			var kpiKey = self.selectedKpiData.key;
			var isUnit = self.selectedKpiData.unit === '%' ? true : false;
			var _uid = _userInfo.userId;
			var currentUserIndex;
			var rankingView_isPart = self.rankingConfigs.isPart;
			for (var i = 0; i < data.length; i++) {
				if (_uid == data[i].empId) {
					currentUserIndex = i;
					inRankList = true;
					ranking = i + 1;
					ownRankData = data[i];
					break;
				}
			}
			if (rankingView_isPart === 1) {
				var originalLength = data.length;
				var topNumber = self.rankingConfigs.top;
				var previewNumber = self.rankingConfigs.preview;
				var nextNumber = self.rankingConfigs.next;
				var hasBoundary;
				var startIndex;
				var count;
				var latterPart;

				var frontPart = data.splice(0, topNumber)
				if (currentUserIndex !== undefined) {
					if ((currentUserIndex - previewNumber) > topNumber) {
						startIndex = currentUserIndex - topNumber - previewNumber
						count = previewNumber + 1 + nextNumber
						hasBoundary = true
					} else {
						startIndex = 0
						count = currentUserIndex - topNumber + 1 + nextNumber
					}
					latterPart = data.splice(startIndex, count)
					data = frontPart.concat(latterPart)
				} else {
					latterPart = previewNumber ? data.splice(0 - previewNumber) : []
					data = frontPart.concat(latterPart)
					hasBoundary = data.length < originalLength ? true : false
				}
			}

			var _ishide = self.rankingConfigs.hiddenPerformanceAmount == "true" ? true : false;
			this.$innerContUl.addClass('emp').removeClass('admin')
            for (var i = 0; i < data.length; i++) {
				var _isme;
				var $shopName;
				if (_uid == data[i].empId) {
					_isme = 'isme';
					$shopName = '';
				} else {
					_isme = '';
					$shopName = self.getShopNameDom(data[i]);
				}
				var _shopNameClass = $shopName ? ' has_shopname' : '';
				var finalValue = isUnit ? Math.round(data[i].value * 100) : Math.round(data[i].value);
				var $li = $('<li class="am-clickable ' + _isme + '">' +
					'<div class="rank">' + (data[i].rankingIndex + 1) + '</div>' +
					'<div class="licont">' +
					'<div class="count">' + ((_ishide && !_isme) ? '****' : finalValue) + '<i>' + self.selectedKpiData.unit + '</i><span class="' + this.getState(data[i].state).listarrow + '"></span></div>' +
					'<div class="imgwrap">' +
					'</div>' +
					'<div class="licontcenter' + _shopNameClass + '">' +
					'<h2>' + data[i].name + '</h2>' +
					$shopName +
					'</div>' +
					'</div>' +
					'</li>');

				var _url = '';
				if (data[i].sex == "M") {
					_url = "css/img/bg-man.gif";
				} else {
					_url = "css/img/bg-woman.gif";
				}
				$li.find('.imgwrap').css({
					'background': 'url(' + _url + ') no-repeat center center',
					'background-size': 'contain'
				}).html(amGloble.photoManager.createImage("artisan", {
					parentShopId: amGloble.metadata.userInfo.parentShopId
				}, data[i].empId + ".jpg", "s"));
				if (_isme == 'isme') {
					$li.find('.imgwrap').html('<img src="css/img/mebg.png" />');
				}
				$li.data('item', data[i]);

				var rankingIndex = data[i].rankingIndex;
				var $crown;
				if (!rankingIndex) {
					$crown = $('<img class="crown" src="css/img/first.png">')
					$li.find('.licont').append($crown)
				} else if (rankingIndex == 1) {
					$crown = $('<img class="crown" src="css/img/second.png">')
					$li.find('.licont').append($crown)
				} else if (rankingIndex === 2) {
					$crown = $('<img class="crown" src="css/img/third.png">')
					$li.find('.licont').append($crown)
				}
				this.$innerContUl.append($li);
            }


			if (rankingView_isPart === 1 && hasBoundary) {
				var boundaryEl = $('<div class="boundary">...</div>');
				boundaryEl.insertBefore(this.$innerContUl.find('li').eq(topNumber));
			}
			if (_userInfo.sex == "M") {
				_url = "css/img/bg-man.gif";
			} else {
				_url = "css/img/bg-woman.gif";
			}
			this.$thefirstWrap.find('.emp-view .right .icon').css({
				'background': 'url(' + _url + ') no-repeat center center',
				'background-size': 'contain'
			}).html(amGloble.photoManager.createImage("artisan", {
				parentShopId: amGloble.metadata.userInfo.parentShopId
			}, _userInfo.userId + ".jpg", "s"));

			if (inRankList) {
				var ownFinalValue = isUnit ? Math.round(ownRankData.value * 100) : Math.round(ownRankData.value);

				this.$thefirstWrap.find('.emp-view .left .hasRanking').show()
				this.$thefirstWrap.find('.emp-view .left .noRanking').hide()
				this.$thefirstWrap.find('.emp-view .left .rank').show().text(ranking)
				this.$thefirstWrap.find('.emp-view .right .name').text(ownRankData.name)
				// 业绩加密
				this.$thefirstWrap.find('.emp-view .right .value').show().text(ownFinalValue)
				this.$thefirstWrap.find('.emp-view .right .unit').show().text(self.selectedKpiData.unit)
				// 皇冠
				var $crown;
				if (ranking === 1) {
					$crown = $('<img class="crown" src="css/img/first.png">')
					this.$thefirstWrap.find('.emp-view .right .icon').append($crown)
				} else if (ranking === 2) {
					$crown = $('<img class="crown" src="css/img/second.png">')
					this.$thefirstWrap.find('.emp-view .right .icon').append($crown)
				} else if (ranking === 3) {
					$crown = $('<img class="crown" src="css/img/third.png">')
					this.$thefirstWrap.find('.emp-view .right .icon').append($crown)
				}
			} else {
				this.$thefirstWrap.find('.emp-view .left .noRanking').show()
				this.$thefirstWrap.find('.emp-view .left .hasRanking').hide()
				this.$thefirstWrap.find('.emp-view .right .name').text(_userInfo.userName)
				this.$thefirstWrap.find('.emp-view .right .value').hide()
				this.$thefirstWrap.find('.emp-view .right .unit').hide()
			}
            self.refresh();
		},
        renderFirst: function (data) {
            var _url = '';
            if (data.sex == "M") {
                _url = "css/img/bg-man.gif";
            } else {
                _url = "css/img/bg-woman.gif";
            }
            this.$imgBox.css({
                'background': 'url(' + _url + ') no-repeat center center',
                'background-size': 'contain'
            }).html(amGloble.photoManager.createImage("artisan", {
                parentShopId: amGloble.metadata.userInfo.parentShopId
			}, data.empId + ".jpg", "s"));
			var isUnit = self.selectedKpiData.unit === '%' ? true : false;
			var finalValue = isUnit ? Math.round(data.value * 100) : Math.round(data.value);
            var _theFirsthtml = '<span class="thefirstnamevalue">' + data.name + '</span><span class="thefirstvalue">' + finalValue + '</span><span class="thefirstunit ' + this.getState(data.state).firstarrow + '">'+self.selectedKpiData.unit+'</span>';
			this.$thefirstname.html(_theFirsthtml);

			var $shopName = self.getShopNameDom(data);
            this.$thefirstbottom.html($shopName);
			this.$thefirstbottom.find('.is_current_shop').css('color', self.bgColor)
            this.$thefirstWrap.data('item', data);
        },
        clearInit: function () {
            this.$imgBox.css('background', 'none').html('<img src="css/img/MYK/head_male.png" />');
            this.$thefirstname.html('');
            this.$thefirstbottom.html('');
            this.showEmpty();
        },
        showEmpty: function () {
            var _li = '<li class="emptyli">暂无数据~</li>';
            this.$innerContUl.html(_li);
            this.refresh();
        },
        getState: function (state) {
            var obj = {};
            if (state == -1) { //下降
                obj.firstarrow = 'arrow arrowdown'; //排名第一
                obj.listarrow = 'arrowred'; //排名第二及后面的
            } else if (state == 0) { //持平
                obj.firstarrow = '';
                obj.listarrow = '';
            } else if (state == 1) { //上升
                obj.firstarrow = 'arrow';
                obj.listarrow = 'arrowgreen';
            }
            return obj;
		},
		getShopNameDom: function(empData) {
			var el = '';
			if (this.isAll || this.selectedAreaData || this.ownAreaData) {
				var matchedShop = self.shopsMap[empData.shopId];
				var shopName = self.getShopName(matchedShop);
				var isCurrentShop = empData.shopId == amGloble.metadata.userInfo.shopId;
				var viewLabel = isCurrentShop ? '本店' : shopName;
				var className = isCurrentShop ? ' is_current_shop' : '';
				el = '<p class="rank_shopname'+ className +'">'+viewLabel+'</p>'
			}
			return el;
		},
		generateShopsMap: function() {
			var result = {};
			var allShops = amGloble.metadata.allShops;
			allShops.forEach(function(shop) {
				var shopId = shop.shopId;
				result[shopId] = shop;
			})
			self.shopsMap = result;
		},
		getShopName: function(obj) {
			var osName = obj.osName;
			var shopFullName = obj.shopFullName;
			var shopName = obj.shopName;
			var result = (osName && osName.trim()) || (shopFullName && shopFullName.trim()) || (shopName && shopName.trim());
			return result;
		},
		getKpiListByFilterDutyType: function(kpiDataList) {
			var result = [];
			var dutyType = amGloble.metadata.userInfo.dutyType;
			for (var i = 0; i < kpiDataList.length; i++) {
				var kpiItem = kpiDataList[i]
				var dutyTypesArr = kpiItem.rankingPattern && JSON.parse(kpiItem.rankingPattern).pattern;
				for (var j = 0; j < dutyTypesArr.length; j++) {
					var dutyTypeItem = dutyTypesArr[j]
					if (dutyTypeItem.id == dutyType) {
						result.push(kpiItem)
					}
				}
			}
			return result;
		},
		getKpiListByJudgeMgjVersionSCB: function(kpiDataList) {
			var kpiList = JSON.parse(JSON.stringify(kpiDataList));
			var index;
			for (var i=0; i<kpiList.length; i++) {
				var kpiItem = kpiList[i]
				if (kpiItem.key === 'YJ_YJ') {
					index = i;
					break;
				}
			}
			if (index === undefined) {
				self.withoutYJKpiByMgjVersionSCB = true;
			} else if (index > 0) {
				kpiList = kpiList.splice(index, 1).concat(kpiList)
			}
			return kpiList;
		},
		checkVersion: function(forcePopup) {
			if (forcePopup || amGloble.metadata.userInfo.mgjVersion != 3) {
				amGloble.confirm("请升级", '您购买的是美管加' + amGloble.metadata.userInfo.mgjVersionText + '，此功能暂不可使用，如需升级请点击下方按钮联系销售', "联系销售", "暂不升级", function() {
					if (self.withoutYJKpiByMgjVersionSCB) $.am.page.back();
					setTimeout(function() {
						window.open('https://m.meiguanjia.net/index.html#view=5&tenantId=840891', '_blank', 'location=no');
					}, 100);
				}, function() {
					if (self.withoutYJKpiByMgjVersionSCB) $.am.page.back();
				});
				return true;
			}
			return false;
		},
    });

})();
