'use strict';

amGloble.page.shopGoal=new $.am.Page({
    id: 'page-shopGoal',
    backButtonOnclick: function backButtonOnclick() {
        $.am.changePage(amGloble.page.dashboard,'slideright');
    },
    init: function init() {
        var self=this;
        this.reportFilter=new amGloble.ReportFilter({
            $: this.$.find('.am-body-wrap'), //选择器的dom将插入到此节点后面
            enableShop: true,
            //enableDept: true, //是否启用部门选择器
            // enableLevel: true, //是否启用部门选择器
            onDatePickerClick: function onDatePickerClick() {},
            onchange: function onchange() {
                //条件修改时触发
				self.resetData();
				var val = new Date(self.reportFilter.getDate());
				if(val.getMonth() != new Date().getMonth()){
					self.$.find(".tipList ul").hide();
				}else{
					self.$.find(".tipList ul").show();
				}
            }
        });
        this.$wrap=this.$.find('.am-body-wrap');
        this.$.on('vclick','.am-body-wrap .jump_btn',function() {
            //查看员工列表
            var shop=self.reportFilter.getShop(); //得到选择的店铺
            var targetCalendar=self.reportFilter.getDate();
            var targetYear=targetCalendar.format('yyyy');
            var targetMonth=targetCalendar.format('mm');
            $.am.changePage(amGloble.page.empGoalsList,'slideup',{id: self.id,targetTypes: self.targetTypes,targets: self.targets,empRoles: self.empRoles,empLevels: self.empLevels,empTargets: self.empTargets,shop: shop,time: targetYear+'/'+targetMonth});
        }).on('vclick','.am-header .right.button',function() {
            //编辑
            var shop=self.reportFilter.getShop(); //得到选择的店铺
            var targetCalendar=self.reportFilter.getDate();
            var targetYear=targetCalendar.format('yyyy');
            var targetMonth=targetCalendar.format('mm');
            $.am.changePage(amGloble.page.setShopGoal,'slideup',{id: self.id,targetTypes: self.targetTypes,targets: self.targets,empRoles: self.empRoles,empLevels: self.empLevels,empTargets: self.empTargets,shop: shop,time: targetYear+'/'+targetMonth});
        }).on('vclick','.goal_notset .set_goalbtn',function() {
            //编辑
            var shop=self.reportFilter.getShop(); //得到选择的店铺
            var targetCalendar=self.reportFilter.getDate();
            var targetYear=targetCalendar.format('yyyy');
            var targetMonth=targetCalendar.format('mm');
            $.am.changePage(amGloble.page.setShopGoal,'slideup',{id: self.id,targetTypes: self.targetTypes,targets: self.targets,empRoles: self.empRoles,empLevels: self.empLevels,empTargets: self.empTargets,shop: shop,time: targetYear+'/'+targetMonth});
        }).on('vclick','.icon-guanbi',function(e){
			e.stopPropagation();
			localStorage['tomorrow_' + amGloble.metadata.userInfo.userId] = new Date(new Date().toLocaleDateString()).getTime()+86400000;
			$(this).parent("li").remove();
		}).on('vclick','.tipList ul li',function(){
			var type = $(this).data("type");
			//查看员工列表
            var shop=self.reportFilter.getShop(); //得到选择的店铺
			var targetCalendar=self.reportFilter.getDate();
            var targetYear=targetCalendar.format('yyyy');
			var targetMonth=targetCalendar.format('mm');
			var reset = false;
			if(type == 4 || type == 3 || type == 2){//代表要跳转到下个月
				reset = true;
				targetMonth++;
				if(targetMonth > 12){
					targetYear++;
					targetMonth = "01";
                }
                if(targetMonth < 10){
                    targetMonth = '0' + targetMonth;
                }
			}
			$(this).parent("ul").hide();
			if(type == 2){
				self.reportFilter.setDate(targetYear + "/" + targetMonth,null,true);
				self.getData();
				return false;
			}
			$.am.changePage(amGloble.page.empGoalsList,'slideup',{id: self.id,reset:reset,targetTypes: self.targetTypes,targets: self.targets,empRoles: self.empRoles,empLevels: self.empLevels,empTargets: self.empTargets,shop: shop,time: targetYear+'/'+targetMonth});
		}).on('vclick', '.indicate_left', function() {
            var indicateIndex = self.indicateIndex;
            var currentIndex = indicateIndex - 2;
            // if(currentIndex < 0) return;
            self.refreshChart(currentIndex);
        }).on('vclick', '.indicate_right', function() {
            var indicateIndex = self.indicateIndex;
            var currentIndex = indicateIndex + 2;
            // if(currentIndex > self.maxIndicateIndex) return;
            self.refreshChart(currentIndex);
        });
        this.$goal_notset=this.$.find('.goal_notset');
        this.$content_wrap=this.$.find('.content_wrap');
        this.$jump_btn=this.$.find('.am-body-wrap .jump_btn');
        // this.$scroll=new $.am.ScrollView({
        //     $wrap: this.$.find('.am-body-wrap'),
        //     $inner: this.$.find('.content_wrap'),
        //     direction: [0,1]
        // });
        // this.$scroll.touchEnd = function (pos) {
        //   if (pos[1] < -50) {
        //     $.am.changePage(amGloble.page.empGoalsList, "slideup");
        //   }
        // }

        this.$goalChatContentWarp=this.$.find('.content_wrap');
        this.$goalChartWrapper=this.$.find('.goal-chart-wrapper');
        this.$goalChartContainer=this.$goalChartWrapper.find('.goal-chart-container').clone().remove();

        this.$chartScroll = new $.am.ScrollView({
            $wrap: this.$goalChatContentWarp,
            $inner: this.$goalChartWrapper,
            direction: [1, 0],
        });

        this.initData();
    },
    // 初始化数据
    initData: function() {
        var self = this;
        var targetManagementConfig = amGloble.TARGET_MANAGEMENT_CONFIG;
        this.defaultArr = targetManagementConfig.defaultArr;
        this.$indicateLeft  =this.$.find('.indicate_left').hide();
        this.$indicateRight  =this.$.find('.indicate_right').hide();


        var defaultArrMap = targetManagementConfig.defaultArrMap;
        this.defaultArrMap = defaultArrMap;
        this.indicateIndex = 0;
        this.maxIndicateIndex = 0;
        this.ChartContainerWidth = ($(window).width() - 30) / 2;
        this.$chartScroll.onScrollStop = function(currentPos, status) {
            if(status === 'done') {
                var ChartContainerWidth = self.ChartContainerWidth;
                var x = Math.abs(currentPos[0]);
                var indicateIndex = Math.round(x / ChartContainerWidth);

                self.refreshChart(indicateIndex, true);
            }
        }
    },
    refreshChart: function(indicateIndex, scrollDisable) {
        var self = this;
        self.indicateIndex = indicateIndex;
        var ChartContainerWidth = this.ChartContainerWidth;
        var pos = [-indicateIndex * ChartContainerWidth, 0]
        !scrollDisable && self.$chartScroll.scrollTo(pos);
        if(indicateIndex > 0) {
            self.$indicateLeft.fadeIn();
        } else {
            self.$indicateLeft.fadeOut();
        }
        if (indicateIndex >= self.maxIndicateIndex) {
            self.$indicateRight.fadeOut();
        } else {
            self.$indicateRight.fadeIn();
        }
    },
    beforeShow: function beforeShow(ret) {
		this.$.find(".tipList ul").html("");
        var shopType=amGloble.metadata.userInfo.shopType;
        var opt={
            enableDept: false,
            enableLevel: false,
            disableFilter: false,
            enableCategory: false,
            selectTime: false,
            enableShop: shopType==0,
            enableEmp: false,
            shopRole: '3,',
			datePickerType: 'ym',
            time:(ret=='back'||ret=="change"?this.reportFilter.getDate():null)
        };
        this.reportFilter.setOpt(opt);
        if(ret=='back') {
            return;
        }
        if(ret&&ret.time) {
            this.reportFilter.setDate(ret.time,null,true);
        }
        if(ret&&ret.targets) {
            this.empLevels=ret.empLevels;
            this.empRoles=ret.empRoles;
            this.empTargets=ret.empTargets;
            this.targets=ret.targets;
            this.targetTypes=ret.targetTypes;
            this.id=ret.id;
            this.reportFilter.setShop(ret.shop,true);
            this.renderData();
        } else {
            this.resetData();
		}
		//目标提醒
		var shop=this.reportFilter.getShop();
		var tomorrow = localStorage['tomorrow_' + amGloble.metadata.userInfo.userId];
		if(tomorrow == undefined || tomorrow && (new Date().getTime() > tomorrow)){
			this.getTip({
				'shopId': shop.shopId,
				'parentShopId': shop.parentShopId,
				"empId": amGloble.metadata.userInfo.userId,
				"type": amGloble.metadata.userInfo.userType
			},this);
		}
    },
    afterShow: function() {
	},
    beforeHide: function() {
        this.reportFilter.hideShortcut()
    },
    afterHide: function() {},
    readerBtn: function() {
        var self=this;
        var targetCalendar=self.reportFilter.getDate();
        var now=new Date();
        var ntime=new Date(now.getFullYear()+'/'+(now.getMonth()+1)+'/01');
        if(ntime.getTime()<=targetCalendar.getTime()) {
            self.$.find('.set_goalbtn').show();
            self.$.find('.am-header .right.button').show();
        } else {
            self.$.find('.set_goalbtn').hide();
            self.$.find('.am-header .right.button').hide();
        }
        //总部管理者不可以设定目标
        // var shopType=amGloble.metadata.userInfo.shopType;
        // if(shopType==0) {
        //     self.$.find('.set_goalbtn').hide();
        //     self.$.find('.am-header .right.button').hide();
        // }
        var days=30;
        var now=new Date();
        if([1,3,5,7,8,10,12].indexOf(now.getMonth()+1)!=-1) {
            days=31;
        }
        var percent1=now.getDate()/days;
        if(self.id&&percent1>0.5&&now.getMonth()==targetCalendar.getMonth()&&now.getFullYear()==targetCalendar.getFullYear()) {
            self.$.find('.set_goalbtn').hide();
            self.$.find('.am-header .right.button').hide();
        }
    },
    resetData: function resetData() {
		var ptop= $('.am-header').outerHeight() || 44;
        this.setStatus('pageLoading',"数据加载中……",{top:ptop});
        this.getLevels();
		this.getData();
    },
    readerBar: function(arr,flag) {
        var self=this;
        var rebuildArr = [];
        rebuildArr = arr.filter(function(item) {
            if(self.targetTypes.indexOf(","+item.type)==-1) {
                return false;
            }
            return true;
        })
        var ChartContainerWidth = ($(window).width() - 30) / 2;
        var goalChartWrapperWdith = rebuildArr.length  * ChartContainerWidth + 30;
        self.$goalChartWrapper.width(goalChartWrapperWdith).find('.goal-chart-container').remove();
        var targetCalendar=self.reportFilter.getDate();
        var targetMonth=targetCalendar.format('mm');
        var days=30;
        var now=new Date();

        if (rebuildArr.length > 2) {
            this.$indicateRight.show();
            this.maxIndicateIndex = rebuildArr.length - 2;
        }

        if([1,3,5,7,8,10,12].indexOf(now.getMonth()+1)!=-1) {
            days=31;
        }
        $.each(rebuildArr,function(i,item) {
            if(self.targetTypes.indexOf(","+item.type)==-1) {
                return;
            }
            var chartContainer=self.$goalChartContainer.width(ChartContainerWidth).clone();
            chartContainer.find('.goal_tit>.text').text('目标'+(item.target? item.target:0));
            chartContainer.find('.goal_tit>.icon').addClass( self.defaultArrMap[item.type].icon );

            self.$goalChartWrapper.append(chartContainer);
            var achi=item.achi? parseFloat(item.achi.toFixed(2)):0;
            var opt;
            if(!achi&&parseInt(targetMonth)!=now.getMonth()+1&&!flag) {
                opt={
                    bigger: true,
                    color0: themeSetting.themeConfig ? themeSetting.themeConfig.dark : themeSetting.color.dark,
                    percent1: 0,
                    single: true,
                    text2: self.defaultArrMap[item.type].name
                };
                self.$.find('.not_start_box').show();
            } else if(!item.target) {
                opt={
                    bigger: true,
                    percent1: 0,
                    percent2: 0,
                    text2: self.defaultArrMap[item.type].name + '<br><strong style=\'font-size:18px;\'>'+achi+'</strong>'
                };
                self.$.find('.not_start_box').hide();
            } else {
                var percent1 = now.getDate()/days
                opt={
                    bigger: true,
                    percent1: Math.round( percent1 * 100),
                    percent2: achi/item.target*100,
                    text1: '预期' + Math.round( percent1 * item.target),
                    text2: self.defaultArrMap[item.type].name + '<br><strong style=\'font-size:18px;\'>'+achi+'</strong>'
                };
                self.$.find('.not_start_box').hide();
			}
            var chart=new ChartBar({
                target: chartContainer.find('.goal-chart'),
                vertical: true,
                config: {
					color0: "#e4e4e4", // 一级颜色 目标底色
					color1: "#F25822", // 二级颜色 目标未达标
					color2: "#FDCC40", // 三级颜色 目标未达标且超过阈值
					color3: "#3DC995", // 四级颜色 目标已达标
					color4: "#2AAC7C", // 五级颜色 超出目标
                    // color0: themeSetting.themeConfig ? themeSetting.themeConfig.dark : themeSetting.color.dark,
                },
                datasets: [opt]
            });
            chart.animation();
        });

        this.$chartScroll.refresh();
        this.$chartScroll.scrollTo('top')
    },
    getLevels: function getLevels() {
        var self=this;
        var shop=this.reportFilter.getShop();
        if(!shop) {
            return;
        }
        var parentShopId=shop.parentShopId;
        // if(shop.softgenre==3){
        //     parentShopId=shop.baseId;
        // }
        amGloble.api.empdutyMetadata.exec({
            'parentShopId': parentShopId
        },function(ret) {
            if(ret.code==0) {
                var data=ret.content;
                self.empRoles=data.employeeRoles;
                self.empLevels=data.employeeLevels;
            } else {
                amGloble.msg('数据加载失败,点击重试!');
            }
        });
    },
    //检查是否有员工未设置业绩
    checkDot: function(flag2) {
        var now=new Date();
        var targetCalendar=this.reportFilter.getDate();
        var ntime=new Date(now.getFullYear()+'/'+(now.getMonth()+1)+'/01');
        var flag=true;
        var flag1=targetCalendar.getTime()>ntime.getTime();
        for(var j=0;j<this.empTargets.length;j++) {
            var ele=this.empTargets[j];
            if(!ele.id) {
                flag=false;
            }
        }
        if(!flag&&!flag2) {
            this.$jump_btn.find('.jump_text').addClass('dot');
        } else {
            this.$jump_btn.find('.jump_text').removeClass('dot');
        }

        //如果有员工未设置业绩
        if(flag1) {
            this.$jump_btn.find('.jump_text').html("员工目标设置");
        } else {
            this.$jump_btn.find('.jump_text').html("员工完成情况");

        }
    },
    renderTitle: function() {
        var mtxt=[];
        var nowm=new Date().getMonth();
        for(var index=0;index<12;index++) {
            if(index==nowm) {
                mtxt.push('本')
                continue;
            }
            mtxt.push(index+1)
        }
        var targetCalendar=this.reportFilter.getDate();
        var shop=this.reportFilter.getShop();
        this.$header.find(".title").text(shop.osName+mtxt[targetCalendar.getMonth()]+"月目标完成进度")
    },
    renderData: function() {
        var self=this;
        self.renderTitle();
        var targetCalendar=self.reportFilter.getDate();
        var now=new Date();
        var ntime=new Date(now.getFullYear()+'/'+(now.getMonth()+1)+'/01');
        //如果已经过去的月份
        var passFlag=(targetCalendar.getTime()<ntime.getTime());
        self.$.find('.not_start_box').text("未开始")
        self.$.find('.not_start_box').show()
        if(self.id!=null||passFlag) {
            self.readerBar(self.targets,passFlag);
            self.$content_wrap.show();
            self.$jump_btn.show();
            self.$goal_notset.hide();
			self.$.find(".tipList").show();
            self.checkDot(passFlag);
            if(passFlag&&self.id==null){
                self.$.find('.not_start_box').show();
                self.$.find('.not_start_box').text("未设置")
            }
        } else {
            self.$content_wrap.hide();
			self.$goal_notset.show();
            self.$jump_btn.hide();
			self.$.find(".tipList").hide();
        }
        self.readerBtn();
	},
    getData: function() {
        var self=this;
        var shop=this.reportFilter.getShop();
        if(!shop) {
            self.setStatus('normal');
            return;
        }
        var shopId=shop.shopId;
        var parentShopId=shop.parentShopId;
        if(shop.softgenre==3){
            parentShopId=shop.baseId;
		}
        var targetCalendar=this.reportFilter.getDate();
        var targetYear=targetCalendar.format('yyyy');
        var targetMonth=targetCalendar.format('mm');
        amGloble.api.queryShopTarget.exec({
            'shopId': shopId,
            'parentShopId': parentShopId,
            'targetYear': targetYear,
            'targetMonth': targetMonth
        },function(ret) {
            if(ret.code==0) {
                var data=ret.content;
                self.empTargets=data.empTargets;
                self.targets=data.targets;
                self.targetTypes=","+data.targetTypes;
                self.id=data.id;
				self.renderData();
            } else {
                amGloble.msg('数据加载失败,点击重试!');
            }
            self.setStatus('normal');
		});
	},
	//目标提醒
	getTip: function(opt,self){
		var val = new Date(self.reportFilter.getDate());
		if(val.getMonth() != new Date().getMonth()){
			self.$.find(".tipList ul").hide();
		}else{
			self.$.find(".tipList ul").show();
		}
		var tip = [
			'经理已为您设置下月的业绩目标，点击查看',
			'请为门店设置下月业绩目标，去设置',
			'请为员工设置下月业绩目标，去设置',
			'部分员工下月业绩未设置，去设置',
			'部分员工本月业绩未设置，去设置',
		];
		amGloble.api.targetTip.exec(opt,function(res){
			if(res.code == 0 && res.content){
				if(res.content.type == undefined || amGloble.metadata.userInfo.newRole == 3) return;
				var $li = $('<li class="am-clickable"><i class="iconfont icon-horn"></i><span class="tipTxt">' + tip[res.content.type-1] + '</span><i class="iconfont icon-guanbi am-clickable"></i></li>').data("type",res.content.type);
				self.$.find(".tipList ul").html($li);
			}else{
				amGloble.msg(res.message || '数据获取失败,请重试!');
			}
		});
	}
});
