/*
上传作品

    amGloble.photoManager.takePhoto("show", {
        parentShopId: 30000,
        catigoryId: 1234,
        authorId: 3333
    }, function() {
        console.log("succ");
    }, function() {
        console.log("fail");
    });

*/

(function() {

    var times = 0;

    var uploadPhoto = function(opt, scb, fcb) {
        var params = JSON.parse(JSON.stringify(opt));
        params.name = (params.name=="uuid" ? (Math.uuid()+".jpg") : params.name);
        amGloble.api.base64Upload.exec(params, function(ret) {
            if (ret.code == 0) {
                scb && scb(params.name);
            } else {
                $.am.debug.log("uploadPhoto error: " + JSON.stringify(ret));
                fcb && fcb(ret);
            }
        }, true, 120000);
    }

    var uploadPhotoBase64 = function(base64, opt, scb, fcb) {
        var self = this;
        amGloble.loading.show("正在上传,请稍候...");
        uploadPhoto(opt, function(result) {
            times++;
            amGloble.loading.hide();
            scb && scb(result);
            times = 0;
        }, function(ret) {
            times++;
            amGloble.loading.hide();
            if (ret.code == 20220915) {
                atMobile.nativeUIWidget.confirm({
                    caption: "照片上传失败",
                    description: "系统检测到您上传的图片违规，请检查后重试",
                    okCaption: '确定',
                    cancelCaption: '',
                })
                return;
            }
            if (times > 1) {
                atMobile.nativeUIWidget.confirm({
                    caption: "照片上传失败",
                    description: "照片上传失败,是否重新上传?",
                    okCaption: "重试",
                    cancelCaption: "取消"
                }, function() {
                    uploadPhotoBase64(base64, opt, scb, fcb);
                }, function() {
                    times = 0;
                });
            } else {
                uploadPhotoBase64(base64, opt, scb, fcb);
            }
        })
    };
    // $p 照片图片容器
    // e true-编辑照片,false-新增照片
    var photoManager = {
        uploadPhotoBase64: uploadPhotoBase64,
        multipleUploadPhoto: function(type, itemData, options, beforeFn, successFn, failFn) {
            if (window.device.platform == "iOS") {
                window.Keyboard && window.Keyboard.hide();
            }
            var opt = imageConfig.getOptionObj(type, itemData);
            delete opt.size;
            delete opt.variations;
            var uploadFunction = function(base64Url, $dom) {
                opt.imageBase64 = base64Url;
                opt.name = 'uuid';
                var $dom = $dom || (beforeFn ? beforeFn(base64Url) : null);
                $dom && $dom.append('<div class="multiple_upload_loading"><i class="iconfont icon-up_img"></i><span>上传中...</span></div>');
                uploadPhoto(opt, function(ret) {
                    $.am.debug.log("uploadPhoto success: " + ret);
                    $dom && $dom.find('.multiple_upload_loading').remove();
                    successFn(ret, $dom);
                }, function(ret) {
                    if ($dom) {
                        var message = ret.code == 20220915 ? '图片违规' : '上传失败';
                        $dom && $dom.find('.multiple_upload_loading').remove();
                        $dom.append('<div class="multiple_upload_error am-clickable"><i class="iconfont icon-r_up_img"></i><span>' + message +'</span></div>');
                        $dom.find('.multiple_upload_error').on('vclick', function() {
                            $(this).remove();
                            uploadFunction(base64Url, $dom);
                        })
                    }
                    failFn && failFn($dom);
                })
            }
            atMobile.getPictures(options, function(listData) {
                try {
                    $.am.debug.log('listData length: ' + String(listData.length));
                } catch (error) {
                    
                }
                for (var i = 0; i < listData.length; i ++) {
                    (function() {
                        var index = i;
                        var base64Url = listData[index];
                        uploadFunction(base64Url);
                    })()
                }
            }, function(error) {
                $.am.debug.log("getPictures error: " + JSON.stringify(error));
                $.am.debug.log("getPictures error: " + error);
            })
        },
        selectPhoto: function(type, itemData, scb, fcb, insertResolution) {
            this.getPicture(type, itemData, scb, fcb);
        },
        takePhoto: function(type, itemData, scb, fcb, insertResolution) {
            var self = this;
            var opt = imageConfig.getOptionObj(type, itemData);
            $.am.debug.log("takePhoto: " + JSON.stringify(opt));
            // var trim = "";
            // if (opt.size && opt.size.length && opt.size.length == 2) {
            //     trim = opt.size[0] > opt.size[1] ? opt.size[0] : opt.size[1];
            // }

            // $.am.debug.log("imagePicker: " + trim);

            //为了解决安卓和ios容器实现的不一致，例如传入1024，安卓实现为1024px，ios实现为1024kb
            var trim = "350";
            if (window.device && window.device.platform == "Android") {
                trim = "1024";
            }
            navigator.appplugin.imagePicker("All", [
                opt.size
            ], "1", "jpg", trim, function(result) {
                delete opt.variationList;
                delete opt.size;
                opt.imageBase64 = result;
                if (insertResolution) {
                    var $tempImg = $("<img />").attr("src", 'data:image/jpeg;base64,' + result);
                    var w = $tempImg[0].width;
                    var h = $tempImg[0].height;
                    var names = opt.name.split(".");
                    names[0] += "_" + w + "x" + h;
                    opt.name = names.join(".");
                }
                // console.log("w", w, "h", h);
                uploadPhotoBase64(result, opt, function(ret) {
                    scb && scb(ret);
                    // $.am.debug.log("uploadPhotoBase64: " + JSON.stringify(ret));
                    var usertype = 0,
                        userid;
                    switch (type) {
                        case 'artisan':
                            usertype = 2;
                            userid = itemData.employeeId;
                            break;
                        case 'manager':
                            usertype = 3;
                            userid = itemData.employeeId;
                            break;
                        case 'customer':
                            usertype = 1;
                            userid = itemData.customerId;
                            break;
                        default:

                    }
                    if (usertype > 0) {
                        amGloble.api.modifyPhotoUpdateTime.exec({
                            "usertype": usertype,
                            "userid": userid,
                            "lastName": amGloble.now().getTime() // 可选，默认时间戳
                        }, function(ret) {
                            $.am.debug.log("update time succ");
                        });
                    }
                }, fcb);
                $.am.debug.log("base64 URI length:" + result.length);
            }, function(result) {
                // $.am.debug.log(msg);
                fcb && fcb(result);
            });
        },
        getPhotoUrl: function(type, itemData, filename, suffix) {
            var url = type =='customerFile' ? (config.customerFileUrl || config.filesMgr) : config.filesMgr;
            if (itemData.updateTs) {
                return url + imageConfig.getImageUrl(type, itemData, filename, suffix) + "?ts=" + itemData.updateTs;
            } else {
                return url + imageConfig.getImageUrl(type, itemData, filename, suffix)+ "?ts=" + new Date().getTime();
            }
        },
        createImage: function(type, itemData, filename, suffix) {
            var $img = $('<img src="' + this.getPhotoUrl(type, itemData, filename, suffix) + '">').hide();
            $img.attr("data-load","")
            $img.load(function() {
                // console.log("load");
                $img.show();
                $img.attr("data-load","success");
            });
            return $img;
        }
    };

    amGloble.photoManager = photoManager;

})();