
$(function() {

    amGloble.popup.list = {
        init: function() {
            var self = this;
            this.$ = $("#popup-list");
            this.$mask = this.$.find('.c-popup-mask').vclick(function(event) {
                self.fcb && self.fcb();
                self.hide();
            })
            this.$title = this.$.find(".title");
            this.$content = this.$.find(".content");
            this.$close = this.$title.children(".close").vclick(function() {
                self.fcb && self.fcb();
                self.hide();
			});
			this.$ulWrap = this.$.find('.list_wrap');
            this.$ul = this.$.find(".list").on("vclick", "li", function() {
                self.scb && self.scb($(this).data("item"));
                self.hide();
            });
			this.$li = this.$ul.children(":first");
			this.scrollview=new $.am.ScrollView({
				$wrap: this.$ulWrap,
				$inner: this.$ul
			});
        },
        show: function(opt) {
            var self = this;
            var keys = opt.shownKeys;
            this.scb = opt.scb;
            this.fcb = opt.fcb;

            this.$title.html(opt.title);
            if (opt.content) {
                this.$content.html(opt.content);
                this.$content.show();
            } else {
                this.$content.hide();
            }

            var $ul = this.$ul.empty();
            $.each(opt.data, function(i, item) {
                var $li = self.$li.clone(true, true);
                var type = item.userType == 1 ? "artisan" : "manager";
                var avatar = amGloble.photoManager.createImage(type, {
                    parentShopId: item.parentShopId,
                    updateTs: item.lastphotoupdatetime
                }, item.userId + ".jpg", "s");
                var str = ""
                if (keys.length > 1) {
                    str += "<p class='line1'>" + (item[keys[0]] || "") + "</p>";
                    str += "<p class='line2'>" + (item[keys[1]] || "") + " " + (item[keys[2]] || "") + "</p>";
                    str += "<p class='line2'>" + (item[keys[3]] || "租户名称未设置") + "</p>";
                } else {
                    str = item[keys[0]];
                }
                var $avatarWrap = $('<span class="popup_avatar"></span>');
                if (item.sex === 'F') {
                    $avatarWrap.addClass('female');
                }
                $avatarWrap.html(avatar)
                $li.html(str);
                $li.prepend($avatarWrap);
                $li.data("item", item);
                $ul.append($li);
			});
            this.$.show();
			this.scrollview.refresh();

        },
        hide: function() {
            this.$.hide();
            this.$ul.empty();
            delete this.scb;
            delete this.fcb;
        }
    };

    amGloble.popup.list.init();

});
