(function(){
    var getDom = {
        createBgImg(url, errorUrl, cb) {
            var img = document.createElement("img");
            img.src = url;
            var falg = true;
            img.onload = function(res) {
              //图片加载成功
              cb();
            };
            img.onerror = function(res) {
              if (falg) {
                falg = false;
                img.src = errorUrl;
              }
            };
            return img;
        },
        getShareDom: function(mallData,className,callback) {
            this.$ = $(className).show();
            this.$.find('.title').text(mallData.name || mallData.itemName);
            this.$.find('.des').text(mallData.quickdescription);
            if(mallData.endtime){
                var start = new Date(mallData.starttime).format('yyyy年mm月dd日')
                var end = new Date(mallData.endtime).format('yyyy年mm月dd日')
                this.$.find('.time').show().text('活动仅限' + start + '至' + end);
            }else {
                this.$.find('.time').hide().text('');
            }
            this.$.find('.main .cardfee').html(mallData.price);
            if(mallData.presentFee){
                this.$.find('.main .present-label').show();
                this.$.find('.main .presentfee').show().text(mallData.presentFee);
            }else {
                this.$.find('.main .present-label').hide();
                this.$.find('.main .presentfee').hide();
            }
            //img
            this.$.find('.img img').attr('src',mallData.images);
            //奖励
            var $list = this.$.find('.list').empty();
            var $item = $('<li class="item"><img><div class="right"><p class="r-title">面部清理净护</p><p class="r-price">商城售价<span>99元</span></p><div class="num">1</div> </div></li>');
            if(mallData.redPacks){
                var redPacksObj = {};
                for(var i=0;i<mallData.redPacks.length;i++){
                    var id = mallData.redPacks[i].id;
                    if(!redPacksObj[id]){
                        redPacksObj[id] = [];
                    }
                    redPacksObj[id].push(mallData.redPacks[i]);
                }
                this.$.find('.middle').show();
                for(var key in redPacksObj){
                    var redPack = redPacksObj[key][0];
                    var rule = JSON.parse(redPack.rule);
                    if(rule && rule.extraRule){
                        var _item = $item.clone();
                        _item.find('img').attr('src','css/img/redpackage.png');
                        _item.find('.r-title').text(redPack.title);
                        if(rule.extraRule.type==2){
                            _item.find('.r-price').html('<span>'+rule.extraRule.discount+'折</span>');
                        }else if(rule.extraRule.type==1){
                            _item.find('.r-price').html('<span>'+rule.extraRule.minMoney+'-'+rule.extraRule.maxMoney+'元</span>');
                        }else if(rule.extraRule.type==0 && rule.extraRule.customType && !Number(rule.extraRule.money)) {
                            _item.find('.r-price').html('<span>资格红包</span>');
                        }else {
                            _item.find('.r-price').html('<span>'+rule.extraRule.money+'元</span>');
                        }
                        if(redPacksObj[key].length >= 1){
                            _item.find('.num').text('x'+redPacksObj[key].length);
                        }
                        $list.append(_item);
                    }
                }
            }else {
                this.$.find('.middle').hide();
            }

            var user = amGloble.metadata.userInfo;
            var $head;
            if (user.userType != 1) {
                $head = amGloble.photoManager.getPhotoUrl("manager", {
                    parentShopId: user.parentShopId
                }, user.userId + ".jpg", "s");
            } else {
                $head = amGloble.photoManager.getPhotoUrl("artisan", {
                    parentShopId: user.parentShopId
                }, user.userId + ".jpg", "s");
            }

            //img
            var commonMiniproPrefix = amGloble.metadata.userInfo.mgjVersion == 6 ? `com@${window.config.parentShopId}@` : '';
            var qrImgSrc = config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/mall/index&scene=" + commonMiniproPrefix + "2@" + (mallData.id || mallData.itemId) + "@" + user.userType + "@" + user.userId;
            this.$.find('.qrImg').attr("src", qrImgSrc);

            var osName = (user.osName ? user.osName.trim() : null) || user.shopName;
            var userName = user.userName;
            this.$.find('.user_name').text(osName + '-' + userName);

            this.$.find('.avatar_box .avatar_img').html(
                this.createBgImg($head, 'css/img/MYK/head_male.png', function() {
                    var shareDom = $(className).get(0);
                    callback(shareDom)
                })
            );
        }
    };

    var rechargeMallItemTemplateSelctor = {
        init: function(){
            var _this = this;
            this.$ = $('#rechargeMallItemTemplateSelctor');
            this.$carrouselInner = this.$.find('.am-carrousel-inner');
            this.$count = this.$.find('.count');
            this.$prev = this.$.find('.prev').vclick(function(){
                var current = _this.carrousel.current;
                current --;
                if(current < 0){
                    current = 2;
                }
                _this.carrousel.show(current);
            });
            this.$next = this.$.find('.next').vclick(function(){
                var current = _this.carrousel.current;
                current ++;
                if(current > 2){
                    current = 0;
                }
                _this.carrousel.show(current)
            });
            this.$share = this.$.find('.share').vclick(function(){
                var current = _this.carrousel.current;
                var src = _this.$carrouselInner.find('li').eq(current).find('img').attr('src');
                _this.callback(src,$(shareRecharge.renderTemplates[current]).get(0));
                _this.hide();
            });
            this.$cancel = this.$.find('.cancel').vclick(function(){
                _this.hide();
            });
            this.carrousel = new $.am.Carrousel({
                id: 'template_carrousel',
                autoSwitch: 0,
                onchange: function (i) {
                    _this.$count.find('li').removeClass('active').eq(i).addClass('active');
                }
            });
        },
        show: function(opt){
            if(!this.$){
                this.init();
            }
            var list = opt.list;
            this.$carrouselInner.empty();
            this.$count.empty();
            if(opt.withReward){
                this.$carrouselInner.addClass('withReward');
            }else {
                this.$carrouselInner.removeClass('withReward');
            }
            for(var i=0;i<list.length;i++){
                var $li = $('<li><img src="' + list[i] + '"></li>');
                var $cli = $('<li></li>');
                this.$carrouselInner.append($li);
                this.$count.append($cli);
            }
            this.callback = opt.callback;
            this.$.show();
            this.carrousel.refresh();
        },
        hide: function(){
            this.$.hide();
        }
    }

    var shareRecharge = {
        share: function(mallData,select){
            var _this = this;
            this.enabledMinipro(function(enabled){
                if (enabled) {
                    _this.getShareRechargeMallItemdUrl(mallData,function(templatesBase64Url){
                        if(templatesBase64Url.length == 1){
                            select(templatesBase64Url[0],$(_this.renderTemplates[0]).get(0));
                            return;
                        }
                        rechargeMallItemTemplateSelctor.show({
                            list: templatesBase64Url,
                            withReward: mallData.redPacks ? 1 : 0,
                            callback: function(src,dom){
                                select(src,dom);
                            }
                        });
                    });
                } else {
                    amGloble.msg('未开通小程序');
                }
            });
        },
        templates: ['.rechargeMallItemSharePhoto.template1','.rechargeMallItemSharePhoto.template2','.rechargeMallItemSharePhoto.template3'],
        customTemplates: ['.rechargeMallItemSharePhoto.template'],
        templatesBase64Url: [],
        getShareRechargeMallItemdUrl: function(mallData,callback){
            this.templatesBase64Url = [];
            this.getShareRechargeMallItemdDom(mallData,0,function(templatesBase64Url){
                callback(templatesBase64Url)
            })
        },
        getShareRechargeMallItemdDom: function(mallData,index,callback){
            var _this = this;
            this.renderTemplates = this.templates;
            var configJson = mallData.configJson ? JSON.parse(mallData.configJson) : {};
            if(configJson.shareImage){
                this.renderTemplates = this.customTemplates;
                $(this.renderTemplates[0]).find('.shareImage').html(amGloble.photoManager.createImage('mallShareImage', {
                    parentShopId: amGloble.metadata.userInfo.parentShopId,
                }, configJson.shareImage))
                getDom.createBgImg(amGloble.photoManager.getPhotoUrl('mallShareImage', {
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                }, configJson.shareImage),'',function(){
                    if(index >= _this.renderTemplates.length){
                        callback(_this.templatesBase64Url);
                    }else {
                        _this.getShareRechargeMallItemdDomFn(mallData,index,function(base64Url){
                            _this.templatesBase64Url.push(base64Url);
                            index ++;
                            _this.getShareRechargeMallItemdDom(mallData,index,callback);
                        }); 
                    }
                })
                return;
            }
            if(index >= this.renderTemplates.length){
                callback(this.templatesBase64Url);
            }else {
                this.getShareRechargeMallItemdDomFn(mallData,index,function(base64Url){
                    _this.templatesBase64Url.push(base64Url);
                    index ++;
                    _this.getShareRechargeMallItemdDom(mallData,index,callback);
                }); 
            }
        },
        getShareRechargeMallItemdDomFn: function(mallData,index,callback){
            amGloble.loading.show("正在生成图片");
            getDom.getShareDom(mallData,this.renderTemplates[index],function(shareDom) {
                shareImageUtils.getImageByDOM(shareDom).then(function(img) {
                    amGloble.loading.hide();
                    callback(img.src);
                });
            })
        },
        enabledMinipro: function(callback){
            amGloble.api.getSmallAppInfo.exec({
                id: amGloble.metadata.userInfo.parentShopId
            }, function (ret) {
                if(ret && ret.code == 0){
                    var result = ret.content && ret.content.isSmallPro ? true : false;
                    callback(result);
                }else {
                    amGloble.msg("数据获取失败,请重试!");
                }
            });
        }
    }
    amGloble.shareRecharge = shareRecharge;
})();