(function() {
	var mobileApi = {
		nativeUIWidget : {
			showMessageBox : function(opt, successCallback, failedCallback) {
				navigator.notification.alert(opt.content, successCallback, opt.title, '确定');

			},
			popupWebsite : function(opt, successCallback, failedCallback) {
				// $.am.debug.log(opt.url);
				window.open(opt.url, '_blank', 'location=no');

			},
			showPopupMenu : function(opt, successCallback, failedCallback) {
				// $.am.debug.log(opt.items);

				var options = {
					//'androidTheme' : window.plugins.actionsheet.ANDROID_THEMES.THEME_HOLO_LIGHT, // default is THEME_TRADITIONAL
					'title' : opt.title,
					'buttonLabels' : opt.items,
					'addCancelButtonWithLabel' : '取消'
				};

			    try{
			        options.androidTheme = window.plugins.actionsheet.ANDROID_THEMES.THEME_HOLO_LIGHT;
			    } catch (e) {

			    }

				var callback = function(buttonIndex) {
					setTimeout(function() {
						// alert('button index clicked: ' + buttonIndex);
						successCallback && successCallback(buttonIndex - 1);
					});
				};
				console.log(options);
				window.plugins.actionsheet.show(options, callback);

			},
			confirm : function(opt, successCallback, failedCallback) {
				// $.am.debug.log(opt.description);

				navigator.notification.confirm(opt.description, function(buttonIndex) {
					if (buttonIndex == 1) {
						successCallback && successCallback();
					} else {
						failedCallback && failedCallback();
					}
				}, opt.caption, [opt.okCaption, opt.cancelCaption]);
			},
			openUrl : function(opt, successCallback, failedCallback) {
				window.open(opt.url, '_system', 'location=no');
			}
		},
		appManager : {
			exitApp : function(opt, successCallback, failedCallback) {
				navigator.app.exitApp();
			}
		},
		compressVideo: function(options, scb, fcb) {
			if (!window.imagePicker || !window.imagePicker.compressVideo) {
				fcb({
					code: -1,
					message: '方法不存在'
				})
			} else {
				window.imagePicker.compressVideo(scb, fcb, $.extend({}, options));
			}
		},
		uploadVideo: function(options, scb, fcb) {
			if (!window.imagePicker || !window.imagePicker.uploadVideo) {
				fcb({
					code: -1,
					message: '方法不存在'
				})
			} else {
				window.imagePicker.uploadVideo(scb, fcb, $.extend({}, options));
			}
		},
		getVideo: function(options, scb, fcb) {
			if (!window.imagePicker || !window.imagePicker.getVideo) {
				fcb({
					code: -1,
					message: '方法不存在'
				})
			} else {
				window.imagePicker.getVideo(scb, fcb, $.extend({maxSize: 200 * 1024 * 1024}, options));
			}
		},
		getPictures: function(options, scb, fcb) {
			if (!window.imagePicker || !window.imagePicker.getPictures) {
				fcb({
					code: -1,
					message: '方法不存在',
				})
				return;
			}
			var opt = $.extend({
				maximumImagesCount: 9,//最大选择数
				width: 2048, //输出时的宽，根据这个值做图片压缩，只设宽的话，高会等比缩小
				outputType:1, //0是文件路径，1是base64
				quality: 100, // 图片质量压缩
			}, options)
			window.imagePicker.getPictures(scb, fcb, opt);
		},
		saveBase64Image: function(params, scb, fcb) {
			if (window.imageSaver && window.imageSaver.saveBase64Image) {
				window.imageSaver.saveBase64Image(params, scb, fcb)
			} else {
				fcb && fcb();
			}
		},
		social : {
			shareTo : function(content, title, image, url, scb, fcb, wxTimeline) {
				navigator.appplugin.share(content, title, image, url, function(msgCode) {
					scb && scb(msgCode);
				}, function(msgCode) {
					fcb && fcb(msgCode);
				}, wxTimeline ? ["wxsession","wxfriends","wxtimeline"] : ['wxsession', 'wxfriends', 'wxtimeline', 'qq', 'qzone']);
			},
			shareImage: function(title,imgContent,onSuccess,onError) {
				navigator.appplugin.shareImage(title, imgContent, function(msg) {
					onSuccess && onSuccess(msg);
				}, function(msg) {
					onError && onError(msg);
				}, ['wxsession', 'wxfriends', 'wxtimeline', 'qq', 'qzone']);
			},
			shareText:function(text,scb, fcb){
				navigator.appplugin.shareText(text, function(msgCode) {
					scb && scb(msgCode);
				}, function(msgCode) {
					fcb && fcb(msgCode);
				},['wxtimeline','wxsession']);
			}
		},

		getMetadata : function(opt, successCallback, failedCallback) {

			navigator.appplugin.appMetadata(function(msgCode) {
				try {
					var ret = JSON.parse(msgCode);
					successCallback && successCallback(ret);
				} catch(e) {
					failedCallback && failedCallback("Parse json error");
				}

			}, function(msg) {
				failedCallback && failedCallback(msg);
			});
		},

		startPush : function() {
			$.am.debug.log("startPush");
			setTimeout(function() {
				navigator.appplugin.startPush();
			}, 100);
		},

		payment : {
			alipay : function(payString, scb, fcb) {
				navigator.alipay.pay({
					"payString" : payString
				}, function(msg) {
					scb && scb(msg);
				}, function(msg) {
					fcb && fcb(msg);
				});
			},
			wechat : function(payString, scb, fcb) {
				navigator.weixin.sendPayReq({
					"payJson" : payString
				}, function(msg) {
					$.am.debug.log("wexinpay success" + msg);
					scb && scb(msg);
				}, function(msg) {
					$.am.debug.log("wexinpay failed" + msg);
					fcb && fcb(msg);
				});

			}
		},

		setExtInfo: function(value, scb, fcb) {
			if (navigator.appplugin.setExtInfo) {
				navigator.appplugin.setExtInfo(value, scb, fcb);
			} else {
				fcb && fcb({
					errorMsg: '容器暂不支持此方法',
				});
			}
		},

		loadFile: function(fileName, scb, fcb) {
			if (navigator.appplugin.loadFile) {
				navigator.appplugin.loadFile(fileName, function(ret) {
					var data = ret ? JSON.parse(ret) : null;
					scb && scb(data);
				}, fcb)
			} else {
				$.getJSON(fileName, scb).error(function() {
					fcb && fcb();
				})
			}
		} 
	};
	window.atMobile = mobileApi;

})();