// var themeConfigJSON = {
// 	// so hair 皮肤定制
// 	'1179011': {
// 		standard: '#825c25',
// 		dark: '#6b4e24',
// 		active: '#4D6950',
// 		light: '#37dbdb',
// 		selected: '#825c25',
// 		activeColor: '#4D6950',
// 		customerColor: '#3c7ba3',
// 		arrangeColor: '#9F7841',
// 		arrangeColor1: '#9F7841',
//         arrangeColor2: '#FFD42A', //排班考勤 里面迟到早退按钮颜色替换
//         arrangeColor3: "#825c25", //底部今日排班提示
//         arrangeColor4: '#fff', //考勤记录打卡时间
//         timePicker: '#ffff',
//         timePickerFastBt1: '#554123',
//         timePickerFastBt2: '#4c391e',
//         buttonBg: '#6b4e24',
//         buttonLightBg: '#9F7841', //底部footer 背景
//         snsBtnActive: '#825c25',
//         commissionBtnBg: '#6b4e24',
//         commissionBtnColor: '#fff',
//         empGoalCheckColor1: '#825c25',
//         empGoalCheckColor2: '#825c25',
//         tradePandectColor1: '#fff', //生意总览顶部数字颜色
// 		headeBg: 'http://img.meiguanjia.net/ka/sohair/imgs/login-headBg.png',
// 		loginLogo: 'http://img.meiguanjia.net/ka/sohair/imgs/login-logo.jpg',
// 		educationLogo: 'http://img.meiguanjia.net/ka/timeplan/imgs/educationLogo.png',
// 		loading: 'http://img.meiguanjia.net/ka/timeplan/imgs/blueloading-small.png',
// 		educationTabText: '学堂'
// 	}
// }
var themeSetting = {
	OEM_Path: 'http://img.meiguanjia.net/OEM/businessApp/',
	tenantIdCacheKey: 'themeTenantId',
    url: 'css/theme.css',
    color: {
        standard: '#213f83',
		dark: '#102c6c',
		active: '#193472',
		light: '#6497d0',
		selected: '#2dbd84',
		activeColor: '#17a96f',
		customerColor: '#546ba0',
		arrangeColor: '#7dc8ab',
		arrangeColor1: '#e9f6f1',
        arrangeColor3: "#8992A5", //底部今日排班提示
        arrangeColor4: '#213F83', //考勤记录打卡时间
        timePicker: '@{timepicker}',
        buttonBg: '#3b465f',
        buttonLightBg: '#586075',
        timePickerFastBt1: '#575d6a',
        timePickerFastBt2: '#5c626e',
        snsBtnActive: '#00bc86',
        commissionBtnBg: '#2F3950',
        commissionBtnColor: '#8C91A0',
        empGoalCheckColor1: '#40C9C9',
        empGoalCheckColor2: '#222',
        tradePandectColor1: '#e3e765', //生意总览顶部数字颜色
	},
	images: {
		headeBg: "css/img/login-headBg.jpg",
		loginLogo: "css/img/login-logo.gif",
		educationLogo: "css/img/education/logo.png",
		loading: "libs/am/images/blueloading-small.png",
	},
    set: function(tenantId, themeConfigKey){
		var _this = this;
		var lastTenantId = localStorage.getItem(this.tenantIdCacheKey);
		if (tenantId || lastTenantId) {
			this.updateStyle(tenantId || lastTenantId, themeConfigKey);
			return;
		}
		try {
			setTimeout(function() {
				navigator.appplugin.getAppInfo(function(ret) {
					var APPINFO = JSON.parse(ret);
					if (!APPINFO.tenantid) {
						APPINFO.tenantid = lastTenantId;
                    }
                    _this.updateStyle(APPINFO.tenantid, themeConfigKey);
				});
                    // _this.updateStyle(8888);
			}, 100)
		} catch (error) {
			this.loadStyle();
		}
	},
	updateStyle: function(tenantId, themeConfigKey) {
		var _this = this;
		this.getThemeConfig({ parentShopId: tenantId, themeConfigKey: themeConfigKey },function(themeConfig){
			var educationTabText = '学堂';
			if (themeConfig) {
				var visibility = themeConfig.themeConfigKey && themeConfig.themeConfigKey != 'themeColor1' ? 'visible' : 'hidden';
				document.querySelector('.footerBtns').style.visibility = visibility;
				document.querySelector('#page-login-mgjtips').style.visibility = visibility;
				educationTabText = themeConfig.educationTabText;
			} else {
				document.querySelector('.footerBtns').style.visibility = 'visible';
				document.querySelector('#page-login-mgjtips').style.visibility = 'visible';
			}
			// if (educationTabText) {
			// 	$('.education_tab_text').text(educationTabText);
			// }
			_this.loadStyle();
		});
		
		if (tenantId) {
			localStorage.setItem(this.tenantIdCacheKey, tenantId);
		}
    },
    getThemeConfig: function(params,callback){
		var parentShopId = params.parentShopId;
		var themeConfigKey = params.themeConfigKey;
		var themeConfigDetail = localStorage.getItem('themeConfigDetail') ? JSON.parse(localStorage.getItem('themeConfigDetail')) : null;
        if(themeConfigDetail && themeConfigDetail.parentShopId == parentShopId && (!themeConfigKey || themeConfigDetail.themeConfigKey == themeConfigKey)){
            this.themeConfig = themeConfigDetail;
            callback && callback(themeConfigDetail);
            return;
        }
        var _this = this;
		_this.reTryTimes = 0;
		_this.getConfigAjax(function (ret) {
			if(ret && (ret[themeConfigKey] || ret[parentShopId])){
				var themeConfig = ret[themeConfigKey] || ret[parentShopId];
				_this.themeConfig = themeConfig;
				_this.themeConfig.parentShopId = parentShopId;
				if (themeConfigKey) {
					_this.themeConfig.themeConfigKey = themeConfigKey;
				}
				callback && callback(themeConfig);
				localStorage.setItem('themeConfigDetail',JSON.stringify(_this.themeConfig));
			}else {
				_this.themeConfig = null;
				callback && callback();
			}
		})
    },
	getConfigAjax: function (callback) {
        var _this = this;
        $.ajax({
            url: _this.OEM_Path + "theme.json",
            dataType: "json",
            contentType: "application/json",
            success: function(ret) {
                callback && callback(ret)
            },
            error: function() {
                _this.reTryTimes ++;
                if(_this.reTryTimes < 5){
                    _this.getConfigAjax(callback);
                }else {
                    callback && callback();
                }
            }
        });
    },
    loadStyle: function(){
        this.removeStyle();
        var _this = this;
        atMobile.loadFile(this.url, function(responseText) {
			var styleContent = _this.changeStyle(responseText);
			var style = document.createElement('style');
			style.setAttribute('path',_this.url);
			style.innerHTML = styleContent.trim();
			document.head.appendChild(style);
		})
    },
    removeStyle: function(){
        var styles = document.getElementsByTagName('style');
        for(var i=0;i<styles.length;i++){
            var href = styles[i].getAttribute('path');
            if(href == this.url){
                document.head.removeChild(styles[i]);
                break;
            }
        }
    },
    changeStyle: function(style){
		if (!this.themeConfig) return style;
		for (var colorKey in this.color) {
			if (this.color.hasOwnProperty(colorKey)) {
				style = style.replace(RegExp(this.color[colorKey],'g'),this.themeConfig[colorKey]);
			}
		}
		var standardRgb = this.hexToRgb(this.color.standard);
		var themeStandardRgb = this.hexToRgb(this.themeConfig.standard);
		if (standardRgb) {
			for(var i = 1; i < 10; i ++) {
				var rgbArray = JSON.parse(JSON.stringify(standardRgb));
				var themeRgbArray = JSON.parse(JSON.stringify(themeStandardRgb));
				themeRgbArray.push(i / 10);
				var rgba = 'rgba('+ rgbArray.join(',') +',.'+i+')';
				var themeRgba = 'rgba('+ themeRgbArray.join(',') +')';
				style = style.replace(rgba, themeRgba);

			}
		}
		for (var key in this.images) {
			var defaultValue = this.images[key];
			var themeValue = this.themeConfig[key];
			if (themeValue) {
				console.log('themeValue', themeValue, 'defaultValue', defaultValue);
				var themeConfig = this.themeConfig;
				style = style.replace(RegExp(defaultValue,'g'), this.OEM_Path + (themeConfig.themeConfigKey && themeConfig.themeConfigKey != 'themeColor1' ? themeConfig.themeConfigKey : themeConfig.parentShopId) + '/'+themeValue);
			}

		}
        return style;
	},
	hexToRgb: function (hex) {
		var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
		hex = hex.replace(shorthandRegex, function (m, r, g, b) {
			return r + r + g + g + b + b;
		});

		var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
		return result ? [
			parseInt(result[1], 16),
			parseInt(result[2], 16),
			parseInt(result[3], 16)
		] : null;
	}
}
